package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainPopEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainPopResponse;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainResponse;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainUserEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.UserWeekListEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.service.NewWorkerTrainService;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.widgets.MMessageDisplay;

import java.util.Date;
import java.util.List;

/**
 * 入职培训导师分配
 */
public class NewWorkerDistributionActivity extends BaseParentAct implements NewWorkerDistributionAdapter.ClickListener {
    String branchTitle;
    Long branchID;
    String ids;
    String staffId;
    String staffName;
    String trainMentorStaffId;
    String wgmfWorkDate;
    ListView mListView;
    NewWorkerDistributionAdapter newWorkerTrainEditAdapter;
    NewWorkerTrainUserEntity newWorkerTrainUserEntity;
    TextView newWorkerTrainTip;
    TextView newWorkerTrainHeaderStaffName;
    TextView newWorkerTrainHeaderStaffTime;
    TextView newWorkerTrainItemManageRevaluationTime;
    LinearLayout newWorkerTrainItemManageRevaluationLl;
    EditText newWorkerTrainItemManageRevaluationTv;
    LinearLayout reportContentConfirmLl;
    Button reportContentModifyBtn;
    Button reportContentConfirmBtn;
    boolean isFirstTime = true;

    @Override
    protected void initTitle() {
        super.initTitle();
        ids = getIntent().getStringExtra("ids");
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        wgmfWorkDate = getIntent().getStringExtra("wgmfWorkDate");
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        trainMentorStaffId = userInfo.getStaffId();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.new_worker_train_edit_activity);
        initTitle();
        initView();
        getWorkerTrainInfo();
    }

    private void getWorkerTrainInfo() {
        showDialog();
        if (null != ids) {
            queryWorkerTrainInfo("trainStartTime=" + wgmfWorkDate + "&ids=" + ids);
            return;
        }
        queryWorkerTrainInfo("trainStartTime=" + wgmfWorkDate);
    }

    @Override
    public void onDialogResult(int tag) {
        wgmfWorkDate = newWorkerTrainHeaderStaffTime.getText().toString().trim();
        //查询接口
        getWorkerTrainInfo();
    }

    private void initView() {
        reportContentConfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);
        reportContentConfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        newWorkerTrainTip = (TextView) findViewById(R.id.new_worker_train_tip);
        newWorkerTrainHeaderStaffName = (TextView) findViewById(R.id.new_worker_train_header_staff_name);
        newWorkerTrainHeaderStaffTime = (TextView) findViewById(R.id.new_worker_train_header_staff_time);
        newWorkerTrainItemManageRevaluationLl = (LinearLayout) findViewById(R.id.manage_revaluation_ll);
        newWorkerTrainItemManageRevaluationTime = (TextView) findViewById(R.id.new_worker_manage_revaluation_time);
        newWorkerTrainItemManageRevaluationTv = (EditText) findViewById(R.id.new_worker_manage_revaluation_tv);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        mListView.setVisibility(View.VISIBLE);
        reportContentModifyBtn.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setVisibility(View.VISIBLE);
        if (null != staffName) {
            newWorkerTrainHeaderStaffName.setText(staffName);
        }
        if (null != wgmfWorkDate) {
            newWorkerTrainHeaderStaffTime.setText(wgmfWorkDate);
        } else {
            wgmfWorkDate = DateUtil.format(new Date(), "yyyy-MM-dd");
            newWorkerTrainHeaderStaffTime.setText(wgmfWorkDate);
        }
        newWorkerTrainUserEntity = new NewWorkerTrainUserEntity();
        reportContentModifyBtn.setText(R.string.temp_btn_txt);
        reportContentConfirmBtn.setText(R.string.save_btn_txt);
        reportContentConfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
        reportContentModifyBtn.setTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
        reportContentConfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_selector));
        reportContentModifyBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_photo_cancel_sharp_selector));
        //提交标志：0暂存，1保存 ,
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                uploadNewWorkerData("1");
            }
        });
        reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                uploadNewWorkerData("0");
            }
        });
        if (null == ids && staffId == null) {
            //如果是新添加顾问，可以点击输入姓名
            newWorkerTrainHeaderStaffName.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //填写顾问姓名
                    final NewWorkerTrainEdtDialog.Builder builder = new NewWorkerTrainEdtDialog.Builder(NewWorkerDistributionActivity.this);
                    builder.setTitle(getString(R.string.employ_ability_header_staff_name));
                    builder.setContentVisibility(false);
                    builder.setPositiveButton(new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            newWorkerTrainHeaderStaffName.setText(builder.getProNum());
                            dialog.dismiss();
                        }
                    });
                    builder.setNegativeButton(
                            new DialogInterface.OnClickListener() {
                                @Override
                                public void onClick(DialogInterface dialog, int which) {
                                    dialog.dismiss();
                                }
                            });
                    builder.create().show();
                }
            });
            newWorkerTrainHeaderStaffTime.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //填写顾问入职时间
                    DialogHelper.AlertDatePicker(NewWorkerDistributionActivity.this, NewWorkerDistributionActivity.this, newWorkerTrainHeaderStaffTime);
                }
            });
        } else {
            newWorkerTrainHeaderStaffName.setBackground(null);
            newWorkerTrainHeaderStaffTime.setBackground(null);
        }
    }

    /**
     * 校验是否填写姓名
     *
     * @return 是否通过
     */
    private boolean checkReportName() {
        //校验框架
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(newWorkerTrainHeaderStaffName, StaticScheme.Required(), ValueScheme.NotEquals("点击填写").msgOnFail("请填写顾问姓名"));

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("请填写顾问姓名");
            inputs.clear();
            return false;
        }
    }

    private void uploadNewWorkerData(String submitFlag) {
        if (checkReportName()) {
            List<UserWeekListEntity> reportModuleItemEntities = newWorkerTrainEditAdapter.getUploadData();
            if (!reportModuleItemEntities.isEmpty() && null != reportModuleItemEntities.get(0).getWeekTitleList() && !reportModuleItemEntities.get(0).getWeekTitleList().isEmpty()) {
                newWorkerTrainUserEntity.setManagerWithTrainTime(reportModuleItemEntities.get(0).getWeekTitleList().get(0).getTitleTime());
            }
            newWorkerTrainUserEntity.setCreateTrainStaffId(userInfo.getStaffId());
            newWorkerTrainUserEntity.setCreateTrainStaffName(userInfo.getName());
            newWorkerTrainUserEntity.setWorkerStaffId(staffId);
            newWorkerTrainUserEntity.setWorkerStaffName(newWorkerTrainHeaderStaffName.getText().toString());
            newWorkerTrainUserEntity.setWorkerEntryTime(newWorkerTrainHeaderStaffTime.getText().toString());
            newWorkerTrainUserEntity.setTrainSubmitFlag(submitFlag);
            newWorkerTrainUserEntity.setUserWeekList(reportModuleItemEntities);
            String content = new Gson().toJson(newWorkerTrainUserEntity);
            Log.d(TAG, content);
            if (checkReportContent(content)) {
                //如果有填写培训内容则允许提交数据，否则提示填写培训内容
                showDialog();
                NewWorkerTrainService.getInstance().requestSaveWorkerTrainBean(content, NewWorkerDistributionActivity.this);
            } else {
                showMsg("请至少填写一条培训内容！");
            }
        }
    }

    private boolean checkReportContent(String content) {
        if (content.contains("itemTrainShopName")
                || content.contains("trainMentorStaffName")
                || content.contains("titleTime")) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * "ids=" + ids + "&trainStartTime=" + trainStartTime;
     */
    private void queryWorkerTrainInfo(String params) {
        showDialog();
        NewWorkerTrainService.getInstance().requestQueryWorkerTrainInfo(params, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.EmployAbility.MSG_ON_QUERY_WORKER_TRAIN_CONTENT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        NewWorkerTrainPopResponse newWorkerTrainPopResponse = new Gson().fromJson(msg, NewWorkerTrainPopResponse.class);
                        Log.d(TAG, "newWorkerTrainPopResponse" + newWorkerTrainPopResponse);
                        if (null != newWorkerTrainPopResponse && ConstantParams.CONSTANT_PARAMS_0.equals(newWorkerTrainPopResponse.retCode)) {
                            if (null != newWorkerTrainPopResponse.getResultList()
                                    && !newWorkerTrainPopResponse.getResultList().isEmpty()) {
                                List<NewWorkerTrainPopEntity> newWorkerTrainPopEntities = newWorkerTrainPopResponse.getResultList();
                                //显示培训内容
                                NewWorkerTrainPop newWorkerTrainPop = new NewWorkerTrainPop(this, newWorkerTrainPopEntities);
                                if (!newWorkerTrainPop.isShowing()) {
                                    newWorkerTrainPop.show(this.findViewById(R.id.title));
                                }
                            } else {
                                showMsg("没有培训内容提示信息");
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_QUERY_WORKER_TRAIN_INFO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        NewWorkerTrainResponse newWorkerTrainResponse = new Gson().fromJson(msg, NewWorkerTrainResponse.class);
                        Log.d(TAG, "newWorkerTrainResponse" + newWorkerTrainResponse);
                        if (null != newWorkerTrainResponse && null != newWorkerTrainResponse.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(newWorkerTrainResponse.retCode)) {
                            newWorkerTrainUserEntity = newWorkerTrainResponse.getResult();
                            //如果是第一次进入，取接口的入职日期，否则取用户选择的入职日期
                            if (isFirstTime) {
                                newWorkerTrainEditAdapter = new NewWorkerDistributionAdapter(this, this, branchID, trainMentorStaffId, newWorkerTrainUserEntity);
                                newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
                                mListView.setAdapter(newWorkerTrainEditAdapter);
                                if (null != ids) {
                                    //如果非新添加接口则有入职日期，否则没有
                                    newWorkerTrainHeaderStaffTime.setText(newWorkerTrainUserEntity.getWorkerEntryTime());
                                }
                            } else {
                                newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
                                newWorkerTrainEditAdapter.notifyDataSetChanged();
                            }
                            isFirstTime = false;
                            reportContentConfirmLl.setVisibility(View.VISIBLE);
                            if ("1".equals(newWorkerTrainUserEntity.getTrainSubmitFlag())) {
                                //如果该记录已提交，则不能继续做暂存操作
                                reportContentModifyBtn.setVisibility(View.GONE);
                            }
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_SAVE_WORKER_TRAIN_BEAN: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                NewWorkerDistributionActivity.this.finish();
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    private int position = 0;

    private static final int TRANSFER_SHOP = 0;
    private static final int TRANSFER_MENTOR = 1;

    @Override
    public void trainItemShopClick(int position) {
        this.position = position;
        Intent intent = new Intent();
        intent.setClass(this, SelectorStoreByFlagActivity.class);
        intent.putExtra("branchTitle", "选择门店");
        intent.putExtra("branchID", branchID);
        startActivityForResult(intent, TRANSFER_SHOP);
    }

    @Override
    public void trainItemMentorClick(int position) {
        this.position = position;
        Intent intent = new Intent();
        intent.setClass(this, SelectorMentorStaffActivity.class);
        intent.putExtra("branchTitle", "选择导师");
        intent.putExtra("branchID", branchID);
        startActivityForResult(intent, TRANSFER_MENTOR);
    }

    @Override
    public void trainItemDateClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity) {
        newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
        newWorkerTrainEditAdapter.notifyDataSetChanged();
    }

    @Override
    public void trainItemTimeClick(NewWorkerTrainUserEntity newWorkerTrainUserEntity) {
        newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
        newWorkerTrainEditAdapter.notifyDataSetChanged();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case TRANSFER_SHOP:
                try {
                    String shopId = data.getStringExtra("shopId");
                    String shopName = data.getStringExtra("shopName");
                    newWorkerTrainUserEntity.getUserWeekList().get(position).setItemTrainShopId(shopId);
                    newWorkerTrainUserEntity.getUserWeekList().get(position).setItemTrainShopName(shopName);
                    newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
                    newWorkerTrainEditAdapter.notifyDataSetChanged();
                } catch (Exception e) {
                    Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                }
                break;
            case TRANSFER_MENTOR:
                try {
                    String mentorStaffId = data.getStringExtra("mentorStaffId");
                    String mentorStaffName = data.getStringExtra("mentorStaffName");
                    newWorkerTrainUserEntity.getUserWeekList().get(position).setTrainMentorStaffId(mentorStaffId);
                    newWorkerTrainUserEntity.getUserWeekList().get(position).setTrainMentorStaffName(mentorStaffName);
                    newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
                    newWorkerTrainEditAdapter.notifyDataSetChanged();
                } catch (Exception e) {
                    Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                }
                break;
            default:
                break;
        }
    }
}