package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainResponse;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.NewWorkerTrainUserEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.model.UserWeekListEntity;
import com.wgmf.yxgj.module.business.employability.newworkertrain.service.NewWorkerTrainService;

import java.util.Date;
import java.util.List;

/**
 * 入职评估填写页面
 */
public class NewWorkerEvaluateActivity extends BaseParentAct {
    String branchTitle;
    Long branchID;
    String ids;
    String staffId;
    String staffName;
    String trainMentorStaffId;
    String userPostLevel;
    String wgmfWorkDate;
    ListView mListView;
    NewWorkerEvaluateAdapter newWorkerTrainEditAdapter;
    NewWorkerTrainUserEntity newWorkerTrainUserEntity;
    TextView newWorkerTrainTip;
    TextView newWorkerTrainHeaderStaffName;
    TextView newWorkerTrainHeaderStaffTime;
    TextView newWorkerManageRevaluationTime;
    EditText newWorkerManageRevaluationTv;
    LinearLayout newWorkerManageRevaluationLl;
    LinearLayout reportContentConfirmLl;
    Button reportContentModifyBtn;
    Button reportContentConfirmBtn;
    String officeEvaluatedTime;

    @Override
    protected void initTitle() {
        super.initTitle();
        ids = getIntent().getStringExtra("ids");
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        wgmfWorkDate = getIntent().getStringExtra("wgmfWorkDate");
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        trainMentorStaffId = userInfo.getStaffId();
        userPostLevel = userInfo.getUserPostLevel();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.new_worker_train_edit_activity);
        initTitle();
        initView();
        getWorkerTrainInfo();
    }

    private void getWorkerTrainInfo() {
        showDialog();
        queryWorkerTrainInfoList("ids=" + ids);
    }

    @Override
    public void onDialogResult(int tag) {
        wgmfWorkDate = newWorkerTrainHeaderStaffTime.getText().toString().trim();
        //查询接口
        getWorkerTrainInfo();
    }

    private void initView() {
        reportContentConfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);
        reportContentConfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        newWorkerTrainTip = (TextView) findViewById(R.id.new_worker_train_tip);
        newWorkerTrainHeaderStaffName = (TextView) findViewById(R.id.new_worker_train_header_staff_name);
        newWorkerTrainHeaderStaffTime = (TextView) findViewById(R.id.new_worker_train_header_staff_time);
        newWorkerManageRevaluationLl = (LinearLayout) findViewById(R.id.manage_revaluation_ll);
        newWorkerManageRevaluationTime = (TextView) findViewById(R.id.new_worker_manage_revaluation_time);
        newWorkerManageRevaluationTv = (EditText) findViewById(R.id.new_worker_manage_revaluation_tv);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        mListView.setVisibility(View.VISIBLE);
        reportContentModifyBtn.setVisibility(View.VISIBLE);
        reportContentConfirmBtn.setVisibility(View.VISIBLE);
        if (null != staffName) {
            newWorkerTrainHeaderStaffName.setText(staffName);
        }
        newWorkerTrainUserEntity = new NewWorkerTrainUserEntity();
        reportContentConfirmBtn.setText(R.string.save_btn_txt);
        reportContentModifyBtn.setText(R.string.cancel_btn_txt);
        reportContentConfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
        reportContentModifyBtn.setTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
        reportContentConfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_selector));
        reportContentModifyBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_photo_cancel_sharp_selector));
        newWorkerTrainHeaderStaffName.setBackground(null);
        newWorkerTrainHeaderStaffTime.setBackground(null);
        //提交标志：0暂存，1保存 ,
        reportContentModifyBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                NewWorkerEvaluateActivity.this.finish();
            }
        });
        reportContentConfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                uploadNewWorkerEvaluation();
            }
        });
        if (userInfo != null && (userPostLevel.equals(ConstantParams.CONSTANT_PARAMS_5))) {
            //主管
            newWorkerManageRevaluationLl.setVisibility(View.VISIBLE);
            if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluation())) {
                newWorkerManageRevaluationTv.setText(newWorkerTrainUserEntity.getOfficeEvaluation());
                //经理评价时间
                if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluatedTime())) {
                    newWorkerManageRevaluationTime.setText(newWorkerTrainUserEntity.getOfficeEvaluatedTime());
                }
            }
            newWorkerManageRevaluationTv.addTextChangedListener(null);
            newWorkerManageRevaluationTv.setFocusable(false);
        } else if (userInfo != null && (userPostLevel.equals(ConstantParams.CONSTANT_PARAMS_4))) {
            //经理
            newWorkerManageRevaluationLl.setVisibility(View.VISIBLE);
            if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluation())) {
                newWorkerManageRevaluationTv.setText(newWorkerTrainUserEntity.getOfficeEvaluation());
            }
            //经理评价时间
            if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluatedTime())) {
                newWorkerManageRevaluationTime.setText(newWorkerTrainUserEntity.getOfficeEvaluatedTime());
            } else {
                newWorkerManageRevaluationTime.setText(DateUtil.format(new Date(), "yyyy-MM-dd"));
            }
            newWorkerManageRevaluationTv.addTextChangedListener(new TextWatcher() {
                @Override
                public void beforeTextChanged(CharSequence s, int start, int count, int after) {

                }

                @Override
                public void onTextChanged(CharSequence s, int start, int before, int count) {

                }

                @Override
                public void afterTextChanged(Editable s) {
                    if (!TextUtils.isEmpty(s)) {
                        //将经理评估填充到数据列表中
                        newWorkerTrainUserEntity.setOfficeEvaluation(s.toString());
                        newWorkerTrainUserEntity.setOfficeEvaluatedTime(newWorkerManageRevaluationTime.getText().toString());
                    }
                }
            });
        }
    }

    private void setContent() {
        if (null != wgmfWorkDate) {
            newWorkerTrainHeaderStaffTime.setText(wgmfWorkDate);
        } else {
            newWorkerTrainHeaderStaffTime.setText(newWorkerTrainUserEntity.getWorkerEntryTime());
        }
        if (userInfo != null && (userPostLevel.equals(ConstantParams.CONSTANT_PARAMS_5))) {
            //主管
            newWorkerManageRevaluationLl.setVisibility(View.VISIBLE);
            if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluation())) {
                newWorkerManageRevaluationTv.setHint(newWorkerTrainUserEntity.getOfficeEvaluation());
                //经理评价时间
                if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluatedTime())) {
                    newWorkerManageRevaluationTime.setText(newWorkerTrainUserEntity.getOfficeEvaluatedTime());
                }
            } else {
                newWorkerManageRevaluationTv.setHint("经理未评价");
            }
            newWorkerManageRevaluationTv.addTextChangedListener(null);
            newWorkerManageRevaluationTv.setFocusable(false);
        } else if (userInfo != null && (userPostLevel.equals(ConstantParams.CONSTANT_PARAMS_4))) {
            //经理
            newWorkerManageRevaluationLl.setVisibility(View.VISIBLE);
            if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluation())) {
                newWorkerManageRevaluationTv.setText(newWorkerTrainUserEntity.getOfficeEvaluation());
            }
            //经理评价时间
            newWorkerManageRevaluationTime.setText(officeEvaluatedTime);
        }
    }

    private void uploadNewWorkerEvaluation() {
        showDialog();
        List<UserWeekListEntity> reportModuleItemEntities = newWorkerTrainEditAdapter.getUploadData();
        newWorkerTrainUserEntity.setUserWeekList(reportModuleItemEntities);
        newWorkerTrainUserEntity.setOfficeEvaluatedTime(null);
        String content = new Gson().toJson(newWorkerTrainUserEntity);
        Log.d(TAG, content);
        NewWorkerTrainService.getInstance().requestSaveWorkerTrainEvaluation(content, NewWorkerEvaluateActivity.this);
    }

    /**
     * "ids=" + ids + "&trainStartTime=" + trainStartTime;
     */
    private void queryWorkerTrainInfoList(String params) {
        showDialog();
        NewWorkerTrainService.getInstance().requestQueryWorkerTrainInfoList(params, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.EmployAbility.MSG_ON_QUERY_WORKER_TRAIN_INFO_LIST: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        NewWorkerTrainResponse newWorkerTrainResponse = new Gson().fromJson(msg, NewWorkerTrainResponse.class);
                        Log.d(TAG, "newWorkerTrainResponse" + newWorkerTrainResponse);
                        if (null != newWorkerTrainResponse && null != newWorkerTrainResponse.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(newWorkerTrainResponse.retCode)) {
                            newWorkerTrainUserEntity = newWorkerTrainResponse.getResult();
                            newWorkerTrainEditAdapter = new NewWorkerEvaluateAdapter(this, branchID, trainMentorStaffId, userPostLevel, newWorkerTrainUserEntity);
                            newWorkerTrainEditAdapter.setData(newWorkerTrainUserEntity);
                            mListView.setAdapter(newWorkerTrainEditAdapter);
                            if (StringUtil.isNotNullAndNotEmpty(newWorkerTrainUserEntity.getOfficeEvaluatedTime())) {
                                officeEvaluatedTime = newWorkerTrainUserEntity.getOfficeEvaluatedTime();
                            } else {
                                officeEvaluatedTime = DateUtil.format(new Date(), "yyyy-MM-dd");
                            }
                            reportContentConfirmLl.setVisibility(View.VISIBLE);
                            setContent();
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_SAVE_WORKER_TRAIN_EVALUATION: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                NewWorkerEvaluateActivity.this.finish();
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }
}