package com.wgmf.yxgj.module.business.employability.newworkertrain.ui;

import android.os.Bundle;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.ui.EmployAbilityPersonListFragment;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.ui.EmployAbilityShopListFragment;

import java.util.ArrayList;
import java.util.List;

public class NewWorkerListFragment extends BaseBackHandledFragment {

    private String branchTitle;
    private Long branchID;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        branchTitle = getArguments().getString("branchTitle");
        branchID = getArguments().getLong("branchID", 0);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.activity_new_worker_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        refreashShopFragment();
        return view;
    }

    /**
     * 加载内容
     *
     * @param tag      标签
     * @param fragment 内容
     */
    public void loadFragment(String tag, BaseBackHandledFragment fragment) {
        FragmentTransaction ft = getActivity().getSupportFragmentManager().beginTransaction();
        ft.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
        ft.replace(R.id.report_module_list_fl, fragment);
        ft.addToBackStack(tag);
        ft.commit();
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    private void refreashShopFragment() {
        NewWorkerTrainListFragment newWorkerTrainListFragment = new NewWorkerTrainListFragment();
        Bundle bundle = new Bundle();
        bundle.putString("branchTitle", branchTitle);
        bundle.putLong("branchID", branchID);
        newWorkerTrainListFragment.setArguments(bundle);
        loadFragment("newWorkerTrainListFragment", newWorkerTrainListFragment);
    }
}