package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployItemsTrainRecordsEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.EmployItemsTrainRecordsResponse;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.wgmf.yxgj.widgets.MMessageDisplay;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 员工培训记录填写页面
 */
public class EmployAbilityRecordEditActivity extends BaseParentAct {
    String titleId;
    String titleName;
    String branchTitle;
    Long branchID;
    String staffId;
    String staffName;
    String level;
    String itemsId;
    String infoItemsQualified;
    //thisWirteItemsQualified (string, optional):项目是否合格(填写能力是否合格)：0合格；1不合格 ,
    String thisWirteItemsQualified;
    String trainRecordsItmesName;
    String infoItemsType;
    int infoItemsTypeNo;
    TextView employAbilityHeaderStaffName;
    TextView employAbilityHeaderStaffRank;
    EditText employAbilityNowadaysAssess;
    ListViewForScrollView mListView;
    LinearLayout employAbilityRecordFooterViewLl;
    EmployAbilityPopAdapter employAbilityPopAdapter;
    List<EmployItemsTrainRecordsEntity> employItemsTrainRecordsEntities;

    @Override
    protected void initTitle() {
        super.initTitle();
        titleId = getIntent().getStringExtra("titleId");
        titleName = getIntent().getStringExtra("titleName");
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        level = getIntent().getStringExtra("level");
        itemsId = getIntent().getStringExtra("itemsId");
        infoItemsType = getIntent().getStringExtra("infoItemsType");
        infoItemsTypeNo = getIntent().getIntExtra("itemsTypeNo", 0);
        trainRecordsItmesName = getIntent().getStringExtra("trainRecordsItmesName");
        infoItemsQualified = getIntent().getStringExtra("infoItemsQualified");
        thisWirteItemsQualified = infoItemsQualified;
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle + "-" + trainRecordsItmesName);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.employ_ability_record_edit_activity);
        initTitle();
        initView();
        findEmployAbilityRecords();
    }

    private void initView() {
        mListView = (ListViewForScrollView) findViewById(R.id.public_list_view_lv);
        employAbilityNowadaysAssess = (EditText) findViewById(R.id.employ_ability_nowadays_assess);
        employAbilityHeaderStaffName = (TextView) findViewById(R.id.employ_ability_header_staff_name);
        employAbilityHeaderStaffRank = (TextView) findViewById(R.id.employ_ability_header_staff_rank);
        TextView employRecordFooterLeftBtn = (TextView) findViewById(R.id.employ_record_footer_left_btn);
        TextView employRecordFooterRightBtn = (TextView) findViewById(R.id.employ_record_footer_right_btn);
        employAbilityRecordFooterViewLl = (LinearLayout) findViewById(R.id.employ_ability_record_footer_view_ll);
        employRecordFooterLeftBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_photo_cancel_sharp_selector));
        employRecordFooterRightBtn.setVisibility(View.VISIBLE);
        employAbilityRecordFooterViewLl.setVisibility(View.VISIBLE);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        employItemsTrainRecordsEntities = new ArrayList<>();
        employAbilityPopAdapter = new EmployAbilityPopAdapter(employItemsTrainRecordsEntities, this);
        mListView.setAdapter(employAbilityPopAdapter);
        employAbilityHeaderStaffName.setText(staffName);
        employAbilityHeaderStaffRank.setText(level);
        employAbilityHeaderStaffName.setBackground(null);
        employAbilityHeaderStaffRank.setBackground(null);

        employRecordFooterLeftBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
        employRecordFooterRightBtn.setTextColor(ContextCompat.getColor(this, R.color.important_txt_color));
        employRecordFooterLeftBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_selector));
        employRecordFooterRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_photo_cancel_sharp_selector));

        final TextView employAbilityNowadaysAssessCb = (TextView) findViewById(R.id.employ_ability_nowadays_assess_cb);
        final Drawable drawableDown = ContextCompat.getDrawable(this, R.drawable.square_orange);
        drawableDown.setBounds(0, 0, drawableDown.getMinimumWidth(), drawableDown.getMinimumHeight());
        final Drawable drawableUp = ContextCompat.getDrawable(this, R.drawable.square_gray);
        drawableUp.setBounds(0, 0, drawableUp.getMinimumWidth(), drawableUp.getMinimumHeight());

        if ("1".equals(thisWirteItemsQualified)) {
            //不合格
            employAbilityNowadaysAssessCb.setCompoundDrawables(null, null, drawableUp, null);
        } else if ("0".equals(thisWirteItemsQualified)) {
            //合格
            employAbilityNowadaysAssessCb.setCompoundDrawables(null, null, drawableDown, null);
        }
        employAbilityNowadaysAssessCb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                setCheckbox(employAbilityNowadaysAssessCb, drawableDown, drawableUp);
            }
        });
        employRecordFooterRightBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                EmployAbilityRecordEditActivity.this.finish();
            }
        });
        employRecordFooterLeftBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //检查必填项
                if (!checkProgressData()) {
                    dismissDialog();
                    return;
                }
                showDialog();
                EmployItemsTrainRecordsEntity uploadEntity = new EmployItemsTrainRecordsEntity();
                uploadEntity.setTrainStaffId(userInfo.getStaffId());
                uploadEntity.setTrainStaffName(userInfo.getName());
                uploadEntity.setTrainRecordsItmesId(itemsId);
                uploadEntity.setAssessmentContent(employAbilityNowadaysAssess.getText().toString());
                //项目是否合格(填写能力是否合格)：0合格；1不合格 ,
                uploadEntity.setThisWirteItemsQualified(thisWirteItemsQualified);
                uploadEntity.setInfoItemsQualified(infoItemsQualified);
                uploadEntity.setTitleId(titleId);
                uploadEntity.setTitleName(titleName);
                uploadEntity.setTrainRecordsStaffId(staffId);
                uploadEntity.setTrainRecordsStaffName(staffName);
                uploadEntity.setTrainRecordsItmesName(trainRecordsItmesName);
                uploadEntity.setInfoItemsType(infoItemsType);
                uploadEntity.setItemsTypeNo(infoItemsTypeNo);
                uploadEntity.setTrainTime(DateUtil.format(new Date(), "yyyy-MM-dd"));
                String content = new Gson().toJson(uploadEntity);

                Log.d(TAG, content);
                EmployAbilityService.getInstance().requestSaveEmployItemsTrainRecords(content, EmployAbilityRecordEditActivity.this);
            }
        });
    }

    private void setCheckbox(TextView employAbilityNowadaysAssessCb, Drawable drawableDown, Drawable drawableUp) {
        if ("1".equals(thisWirteItemsQualified)) {
            //合格
            thisWirteItemsQualified = "0";
            employAbilityNowadaysAssessCb.setCompoundDrawables(null, null, drawableDown, null);
        } else if ("0".equals(thisWirteItemsQualified)) {
            //不合格
            thisWirteItemsQualified = "1";
            employAbilityNowadaysAssessCb.setCompoundDrawables(null, null, drawableUp, null);
        }
    }

    private boolean checkProgressData() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        //课程评估
        inputs.add(employAbilityNowadaysAssess, StaticScheme.Required(), ValueScheme.NotEquals(getString(R.string.empty_etb_hint_txt)).msgOnFail("未填写课程评估"));

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            ToastUtil.show(this, "填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    private void findEmployAbilityRecords() {
        showDialog();
        EmployAbilityService.getInstance().requestFindEmployItemsTrainRecords(staffId, itemsId, titleName, this);
    }


    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.EmployAbility.MSG_ON_FIND_EMPLOY_ITEMS_TRAIN_RECORDS: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            EmployItemsTrainRecordsResponse employItemsTrainRecordsResponse = new Gson().fromJson(msg, EmployItemsTrainRecordsResponse.class);
                            Log.d(TAG, "employItemsTrainRecordsResponse=" + employItemsTrainRecordsResponse.toString());
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(employItemsTrainRecordsResponse.retCode) && (null != employItemsTrainRecordsResponse.getResultList())) {
                                employItemsTrainRecordsEntities = employItemsTrainRecordsResponse.getResultList();
                                employAbilityPopAdapter = new EmployAbilityPopAdapter(employItemsTrainRecordsEntities, this);
                                mListView.setAdapter(employAbilityPopAdapter);
                            }
                        }
                    }
                }
                break;
                case BusinessID.EmployAbility.MSG_ON_SAVE_EMPLOY_ITEMS_TRAIN_RECORDS: {
                    if (result.isSuccessed()) {
                        final String msg = result.getInfo();
                        if (result.isSuccessed()) {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                EmployAbilityRecordEditActivity.this.finish();
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }
}