package com.wgmf.yxgj.module.business.employability.oldworkertrain.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseBackHandledFragment;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.employability.R;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.model.UserInfoListEntity;
import com.wgmf.yxgj.module.business.employability.oldworkertrain.service.EmployAbilityService;
import com.wgmf.yxgj.publics.model.ShopDataEntity;
import com.wgmf.yxgj.publics.model.ShopDataListEntity;
import com.wgmf.yxgj.publics.service.PublicService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;

import java.util.ArrayList;
import java.util.List;

public class EmployAbilityShopListFragment extends BaseBackHandledFragment implements EmployAbilityShopListAdapter.ClickListener, EmployAbilityPersonListAdapter.ClickListener {
    String branchTitle;
    Long branchID;
    /**
     * 0:门店查询/1:顾问查询
     */
    int type;
    private TextView farAddHeaderTv;
    private LinearLayout farAddHeaderLl;
    private ClearEditText storeNameEt;
    private ListView mListView;
    private EmployAbilityShopListAdapter employAbilityShopListAdapter;
    private EmployAbilityPersonListAdapter employAbilityPersonListAdapter;
    private List<ShopDataEntity> shopDataEntities;
    private List<ShopDataEntity> shopDataEntitiesShow;
    private List<UserInfoEntity> userInfoEntities;
    private List<UserInfoEntity> userInfoEntitiesShow;

    private String storeLatitudes;
    private String storeLongitudes;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        branchTitle = getArguments().getString("branchTitle");
        branchID = getArguments().getLong("branchID", 0);
    }

    /**
     * 经理查询直属门店标识：1表示查询直属；不传表示全部
     */
    private void getData() {
        if (null != userInfo) {
            if ("4".equals(userInfo.getUserPostLevel())) {
                getShopData("", "1");
            } else {
                getShopData("", "");
            }
        }
    }

    /**
     * @param keyWords
     * @param zsShopFlag
     */
    private void getShopData(String keyWords, String zsShopFlag) {
        type = 0;
        showDialog();
        farAddHeaderTv.setHint(getString(R.string.employ_ability_by_shop_title));
        storeNameEt.setHint(getString(R.string.report_module_by_shop_search));
        String url = NetworkParams.URL_SHOP_GET_NEAREST;
        String orgCode = userInfo.getOrganizationCode();
        String currentPage = "1";
        String pageSize = "10000";
        String lat = LocationParams.Latitude;
        String lng = LocationParams.Longitude;

        // 发送管理门店数据请求
        PublicService.getInstance().requestgetNearestShopByZSFlag(url, zsShopFlag, "", keyWords, orgCode, currentPage, pageSize, lng, lat, this);
    }

    /**
     * get /employAbility/findUserList 查询营养顾问信息
     */
    private void getPersonData(String shopId) {
        if (null != userInfo) {
            type = 1;
            showDialog();
            EmployAbilityService.getInstance().requestFindInStoreUserList(shopId, this);
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_report_module_project_list, container, false);
        // 防止点击穿透，底层的fragment响应上层点击触摸事件
        view.setClickable(true);
        initView(view);
        getData();
        return view;
    }

    private void initView(View view) {
        mListView = (ListView) view.findViewById(R.id.public_list_view_lv);
        farAddHeaderLl = (LinearLayout) view.findViewById(R.id.far_add_header_ll);
        farAddHeaderTv = (TextView) view.findViewById(R.id.far_add_header_tv);
        storeNameEt = (ClearEditText) view.findViewById(R.id.store_name_et);
        TextView dataEmpty = (TextView) view.findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        storeNameEt.setVisibility(View.VISIBLE);
        farAddHeaderLl.setVisibility(View.VISIBLE);
        setListener();
    }

    protected void setListener() {
        storeNameEt.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        if (type == 0) {
            if (null == shopDataEntitiesShow) {
                shopDataEntitiesShow = new ArrayList<>();
            }
            String itemId = storeNameEt.getText().toString().trim();
            if (TextUtils.isEmpty(itemId)) {
                shopDataEntitiesShow.clear();
                if (null != shopDataEntities) {
                    shopDataEntitiesShow.addAll(shopDataEntities);
                }

            } else {
                shopDataEntitiesShow.clear();
                if (null != shopDataEntities) {
                    for (ShopDataEntity p : shopDataEntities) {
                        if (null != p.getStoreName()) {
                            if (p.getStoreName().contains(itemId)) {
                                shopDataEntitiesShow.add(p);
                            }
                        }
                    }
                }
            }
            employAbilityShopListAdapter = new EmployAbilityShopListAdapter(getActivity(), this, shopDataEntitiesShow);
            mListView.setAdapter(employAbilityShopListAdapter);
        } else if (type == 1) {
            if (null == userInfoEntitiesShow) {
                userInfoEntitiesShow = new ArrayList<>();
            }
            String itemId = storeNameEt.getText().toString().trim();
            if (TextUtils.isEmpty(itemId)) {
                userInfoEntitiesShow.clear();
                if (null != userInfoEntities) {
                    userInfoEntitiesShow.addAll(userInfoEntities);
                }

            } else {
                userInfoEntitiesShow.clear();
                if (null != userInfoEntities) {
                    for (UserInfoEntity p : userInfoEntities) {
                        if (null != p.getName()) {
                            if (p.getName().contains(itemId)) {
                                userInfoEntitiesShow.add(p);
                            }
                        }
                    }
                }
            }
            employAbilityPersonListAdapter = new EmployAbilityPersonListAdapter(getActivity(), this, userInfoEntitiesShow, branchID);
            mListView.setAdapter(employAbilityPersonListAdapter);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.Publics.MSG_ON_SHOP_GET_NEAREST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    ShopDataListEntity reportModuleShopResultEntity = new Gson().fromJson(msg, ShopDataListEntity.class);
                    Log.d(TAG, "reportModuleShopResultEntity" + reportModuleShopResultEntity);
                    if (null != reportModuleShopResultEntity && null != reportModuleShopResultEntity.getData() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleShopResultEntity.retCode)) {
                        shopDataEntities = reportModuleShopResultEntity.getData();
                        employAbilityShopListAdapter = new EmployAbilityShopListAdapter(getActivity(), this, shopDataEntities);
                        mListView.setAdapter(employAbilityShopListAdapter);
                    }
                }
            } else if (id == BusinessID.EmployAbility.MSG_ON_FIND_INSTORE_USER_LIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    UserInfoListEntity reportModuleProjectListResultEntity = new Gson().fromJson(msg, UserInfoListEntity.class);
                    Log.d(TAG, "reportModuleProjectListResultEntity" + reportModuleProjectListResultEntity);
                    if (null != reportModuleProjectListResultEntity && null != reportModuleProjectListResultEntity.getResultList() && ConstantParams.CONSTANT_PARAMS_0.equals(reportModuleProjectListResultEntity.retCode)) {
                        farAddHeaderTv.setHint(getString(R.string.employ_ability_by_person_title));
                        storeNameEt.setHint(getString(R.string.report_module_by_person_search));
                        userInfoEntities = reportModuleProjectListResultEntity.getResultList();
                        employAbilityPersonListAdapter = new EmployAbilityPersonListAdapter(getActivity(), this, userInfoEntities, branchID);
                        mListView.setAdapter(employAbilityPersonListAdapter);
                    }
                }
            }
        }
    }

    @Override
    public boolean onBackPressed() {
        return false;
    }

    @Override
    public void employAbilityAdapterClick(ShopDataEntity reportShopListEntity, int position) {
        storeLatitudes = reportShopListEntity.getLat() + "";
        storeLongitudes = reportShopListEntity.getLng() + "";
        // 查询驻店营养顾问信息
        getPersonData(reportShopListEntity.getStoreId());
    }

    @Override
    public void employAbilityPersonAdapterClick(UserInfoEntity data, int position) {
        Intent intent = new Intent();
        intent.setClass(getActivity(), EmployAbilityTitleListActivity.class);
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchID", branchID);
        intent.putExtra("staffId", data.getStaffId());
        intent.putExtra("staffName", data.getName());
        intent.putExtra("storeLatitudes", storeLatitudes);
        intent.putExtra("storeLongitudes", storeLongitudes);
        startActivity(intent);
    }
}