package com.wgmf.yxgj.module.business.managecapital.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsDetailsEntity;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsDetailsList;
import com.wgmf.yxgj.module.business.managecapital.service.CapitalManagerService;
import com.wgmf.yxgj.pop.GoodsReceiptsSuccessPop;
import com.wgmf.yxgj.pop.PublicThreeSecondsPop;
import com.xp.arouter.RouterCommonUtil;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 资材收货:（第二页） 资材收货详情页
 *
 * @author XiePing
 */

public class CapitalReceiptsDetailsActivity extends BaseParentAct implements PublicThreeSecondsPop.ThreeSecondsPopListener, GoodsReceiptsSuccessPop.GoodsReceiptsSuccessPopListener {

    private CapitalReceiptsDetailsAdapter adapter;
    private List<CapitalReceiptsDetailsEntity> list = new ArrayList<>();
    private Button reportContentComfirmBtn;
    private int capitalReceiptsId;
    private String isNotOeDBFlag;
    private String mTip;
    private GoodsReceiptsSuccessPop goodsReceiptsSuccessPop;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initContet();
        getShopData();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        isNotOeDBFlag = getIntent().getStringExtra("isNotOeDBFlag");
        if (isNotOeDBFlag.equals("other")) {
            homeTitleText.setText("资产收货");
            mTip = getString(R.string.dispatch_tip);
        } else {
            homeTitleText.setText("调拨收货");
            mTip = getString(R.string.allot_tip);
        }
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void getShopData() {
        showDialog();
        if (null != userInfo) {
            capitalReceiptsId = getIntent().getIntExtra("capitalReceiptsId", 0);
            String storeNo = getIntent().getStringExtra("shopId");
            CapitalManagerService.getInstance().requestFindCapitalReceiptsDetail(capitalReceiptsId + "", storeNo, isNotOeDBFlag, CapitalReceiptsDetailsActivity.this);
        }
    }

    private void initContet() {
        EventBus.getDefault().register(this);
        list = new ArrayList<>();
        ListView mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);

        adapter = new CapitalReceiptsDetailsAdapter(list, CapitalReceiptsDetailsActivity.this);
        mListView.setAdapter(adapter);
        LinearLayout onclickTitleLl = (LinearLayout) findViewById(R.id.onclick_title_ll);
        TextView onclickName = (TextView) findViewById(R.id.onclick_name);
        TextView onclickTitle = (TextView) findViewById(R.id.onclick_title);

        onclickTitleLl.setVisibility(View.VISIBLE);
        onclickTitle.setVisibility(View.VISIBLE);
        onclickName.setVisibility(View.VISIBLE);
        onclickName.setText("资材名称");
        onclickTitle.setText("数量");
    }

    private void parseFootData() {
        LinearLayout reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmLl.setVisibility(View.VISIBLE);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        TextView reportContentComfirmTipTxt = (TextView) findViewById(R.id.report_content_comfirm_tip_txt);
        reportContentComfirmTipTxt.setVisibility(View.VISIBLE);
        reportContentComfirmTipTxt.setText(mTip);
    }

    @Subscribe
    public void onEventMainThread(CapitalReceiptsDetailsList item) {
        list.clear();//清空数据，保证每次显示的都是接口返回的数据
        if (item != null && !item.getResultList().isEmpty()) {
            list.addAll(item.getResultList());
            adapter.notifyDataSetChanged();
            parseFootData();
            initListener();
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.CapitalManager.MSG_ON_FIND_CAPITAL_RECEIPTS_DETAIL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        CapitalReceiptsDetailsList mCapitalReceiptsDetailsList = new Gson().fromJson(msg, CapitalReceiptsDetailsList.class);
                        Log.d(TAG, "mCapitalReceiptsDetailsList=" + mCapitalReceiptsDetailsList.toString());
                        if (!mCapitalReceiptsDetailsList.getResultList().isEmpty()) {
                            //显示从接口返回的数据
                            EventBus.getDefault().post(mCapitalReceiptsDetailsList);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.CapitalManager.MSG_ON_UPDATE_CAPITAL_RECEIPTS: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg,
                                    BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());

                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                showSuccessWindow();
                            }
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 弹出跳转选项窗
     */
    private void showSuccessWindow() {
        if (null == goodsReceiptsSuccessPop) {
            goodsReceiptsSuccessPop = new GoodsReceiptsSuccessPop(this, this);
        }
        if (!goodsReceiptsSuccessPop.isShowing()) {
            goodsReceiptsSuccessPop.show(this.findViewById(R.id.title));
        }
    }

    private void initListener() {
        reportContentComfirmBtn.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                if (list == null || list.isEmpty()) {
                    return;
                }
                uploadCommitOper();//提交数据
            }
        });
    }

    /**
     * 上传订货审核数据
     */
    private void uploadCommitOper() {
        if (userInfo != null) {
            showDialog();
            String operateStaffId = userInfo.getStaffId();
            CapitalManagerService.getInstance().requestUpdateCapitalReceipts(capitalReceiptsId + "", operateStaffId, isNotOeDBFlag, CapitalReceiptsDetailsActivity.this);
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }

    @Override
    public void onTimingFinish() {
        showSuccessWindow();
    }

    @Override
    public void toReportFeedback() {
        Bundle mBundle = new Bundle();
        mBundle.putString("branchTitle", "反馈直通车");
        RouterCommonUtil.startFunctionActivity(this, 0, 66L, mBundle);
        this.finish();
    }

    @Override
    public void toGoodsLibQuery() {
        toActivity(CapitalStockDetailsActivity.class);
    }

    @Override
    public void backToHomepage() {
        Bundle mBundle = new Bundle();
        RouterCommonUtil.startFunctionActivity(this, -3, 0L, mBundle);
        this.finish();
    }

    private void toActivity(Class<?> cls) {
        Intent intent = new Intent();
        intent.setClass(this, cls);
        intent.putExtra("branchTitle", "");
        intent.putExtra("branchID", (Long) 0L);
        String shopId = getIntent().getStringExtra("shopId");
        String storeName = getIntent().getStringExtra("storeName");
        intent.putExtra("storeNo", shopId);
        intent.putExtra("storeName", storeName);
        startActivity(intent);
        this.finish();
    }
}