package com.wgmf.yxgj.module.business.managecapital.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsEntity;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsList;
import com.wgmf.yxgj.module.business.managecapital.service.CapitalManagerService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 资材收货:（第一页） 资材收货门店列表
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_CAPITALRECEIPTSLISTACTIVITY)
public class CapitalReceiptsListActivity extends BaseParentAct implements CapitalReceiptsListAdapter.onAdapterItemClick {

    private List<CapitalReceiptsEntity> list1 = new ArrayList<>();
    private List<CapitalReceiptsEntity> list2 = new ArrayList<>();
    private ListViewForScrollView goodsReceiptsShopLv1;
    private ListViewForScrollView goodsReceiptsShopLv2;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_goods_receipts_shop);
        initTitle();
        initContent();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getShopData();
    }

    private void getShopData() {
        if (null != userInfo) {
            showDialog();
            String staffId = userInfo.getStaffId();
            CapitalManagerService.getInstance().requestFindCapitalReceipts(staffId, CapitalReceiptsListActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        ClearEditText storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameEt.setVisibility(View.GONE);

        goodsReceiptsShopLv1 = (ListViewForScrollView) findViewById(R.id.activity_goods_receipts_shop_lv1);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        goodsReceiptsShopLv1.setEmptyView(emptyView);

        View headerView1 = getLayoutInflater().inflate(R.layout.receipts_goods_header_view, null);
        goodsReceiptsShopLv1.addHeaderView(headerView1);
        headerView1.setOnClickListener(null);
        TextView receiptsGoodsHeaderTv = (TextView) findViewById(R.id.receipts_goods_header_tv);
        receiptsGoodsHeaderTv.setText(R.string.receipts_goods_header_shop_tv1);

        goodsReceiptsShopLv2 = (ListViewForScrollView) findViewById(R.id.activity_goods_receipts_shop_lv2);
        View headerView2 = getLayoutInflater().inflate(R.layout.receipts_goods_header_view2, null);
        goodsReceiptsShopLv2.addHeaderView(headerView2);
        headerView2.setOnClickListener(null);
        TextView receiptsGoodsHeaderTv2 = (TextView) findViewById(R.id.receipts_goods_header_tv2);
        receiptsGoodsHeaderTv2.setText(R.string.receipts_goods_header_shop_tv2);
//        goodsReceiptsShopLv2.setEmptyView(emptyView);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.CapitalManager.MSG_ON_FIND_CAPITAL_RECEIPTS) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    CapitalReceiptsList mCapitalReceiptsList = new Gson().fromJson(msg, CapitalReceiptsList.class);
                    Log.d(TAG, "mCapitalReceiptsList=" + mCapitalReceiptsList.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mCapitalReceiptsList.retCode)) {
                        if (null!=mCapitalReceiptsList.getResultList()&&!mCapitalReceiptsList.getResultList().isEmpty()) {
                            list1 = new ArrayList<>();
                            list2 = new ArrayList<>();
                            for (CapitalReceiptsEntity capitalReceiptsEntity : mCapitalReceiptsList.getResultList()) {
                                if (capitalReceiptsEntity.getIsNotOeDBFlag().equals("other")) {
                                    list1.add(capitalReceiptsEntity);
                                } else {
                                    list2.add(capitalReceiptsEntity);
                                }
                            }
                            refreshListView();
                        }
                    } else {
                        showMsg(mCapitalReceiptsList.retInfo);
                    }
                }
            }
        }
    }

    private void refreshListView() {
        CapitalReceiptsListAdapter goodsReceiptsShopAdapter1 = new CapitalReceiptsListAdapter(list1, this, this);
        CapitalReceiptsListAdapter goodsReceiptsShopAdapter2 = new CapitalReceiptsListAdapter(list2, this, this);
        goodsReceiptsShopLv1.setAdapter(goodsReceiptsShopAdapter1);
        goodsReceiptsShopLv2.setAdapter(goodsReceiptsShopAdapter2);
        goodsReceiptsShopAdapter1.notifyDataSetChanged();
        goodsReceiptsShopAdapter2.notifyDataSetChanged();
//        ListViewUtil.setListViewHeight(goodsReceiptsShopLv1);
//        ListViewUtil.setListViewHeight(goodsReceiptsShopLv2);
    }

    @Override
    public void onAdapterItemClick(CapitalReceiptsEntity mapitalReceiptsEntity) {
        Intent intent = new Intent(CapitalReceiptsListActivity.this, CapitalReceiptsDetailsActivity.class);
        intent.putExtra("capitalReceiptsId", mapitalReceiptsEntity.getCapitalReceiptsId());
        intent.putExtra("shopId", mapitalReceiptsEntity.getShop().getShopId());
        intent.putExtra("storeName", mapitalReceiptsEntity.getShop().getShopName());
        intent.putExtra("isNotOeDBFlag", mapitalReceiptsEntity.getIsNotOeDBFlag());
        startActivity(intent);
    }
}