package com.wgmf.yxgj.module.business.managecapital.ui;

import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsEntity;

import java.util.List;
@SuppressWarnings("all")
class CapitalReceiptsListAdapter extends BaseAdapter {
    private List<CapitalReceiptsEntity> list;
    private BaseActivity context;
    private onAdapterItemClick lisener;

    public interface onAdapterItemClick {
        void onAdapterItemClick(CapitalReceiptsEntity mapitalReceiptsEntity);
    }

    CapitalReceiptsListAdapter(List<CapitalReceiptsEntity> list, BaseActivity context, onAdapterItemClick lisener) {
        this.list = list;
        this.context = context;
        this.lisener = lisener;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.goods_receipts_list_item, null);
            viewHolder = new ViewHolder();
            viewHolder.receiptsListLl = (LinearLayout) convertView.findViewById(R.id.goods_receipts_list_item_ll);
            viewHolder.store = (TextView) convertView.findViewById(R.id.goods_receipts_list_item_store_txt);
            viewHolder.dispatchNo = (TextView) convertView.findViewById(R.id.goods_receipts_list_item_dispatch_no);
            viewHolder.dispatchDate = (TextView) convertView.findViewById(R.id.goods_receipts_list_item_dispatchdate);
            viewHolder.dispatchNum = (TextView) convertView.findViewById(R.id.goods_receipts_list_item_dispatchnum);
            viewHolder.dispatchPerson = (TextView) convertView.findViewById(R.id.goods_receipts_list_item_dispatchperson);
            viewHolder.isExamine = (TextView) convertView.findViewById(R.id.is_examine);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        final CapitalReceiptsEntity ent = list.get(position);

        if (ent.getIsNotOeDBFlag().equals("other")) {
            viewHolder.store.setText(context.getString(R.string.goods_receipts_list_item_dispatch_shop) + ent.getShop().getShopName() + "");
            viewHolder.dispatchNo.setText(context.getString(R.string.goods_receipts_list_item_dispatch_no) + ent.getDispatchNo() + "");
            viewHolder.dispatchDate.setText(context.getString(R.string.goods_receipts_list_item_dispatch_date) + ent.getDispatchDate() + "");
            viewHolder.dispatchNum.setText(context.getString(R.string.goods_receipts_list_item_dispatch_number) + ent.getDispatchNum() + "");
        } else {
            viewHolder.store.setText(context.getString(R.string.goods_receipts_list_item_dispatch_shop) + ent.getShop().getShopName() + "");
            viewHolder.dispatchNo.setText(context.getString(R.string.goods_receipts_list_item_allot_no) + ent.getDispatchNo() + "");
            viewHolder.dispatchDate.setText(context.getString(R.string.goods_receipts_list_item_allot_date) + ent.getDispatchDate() + "");
            viewHolder.dispatchNum.setText(context.getString(R.string.goods_receipts_list_item_allot_number) + ent.getDispatchNum() + "");
            viewHolder.dispatchPerson.setText(context.getString(R.string.goods_receipts_list_item_allot_person) + ent.getOrganiser() + "");
            viewHolder.dispatchPerson.setVisibility(View.VISIBLE);
        }
        viewHolder.isExamine.setText("收货");
        viewHolder.isExamine.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
        viewHolder.receiptsListLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                lisener.onAdapterItemClick(ent);
            }
        });
        return convertView;
    }

    class ViewHolder {
        LinearLayout receiptsListLl;
        TextView store;
        TextView dispatchNo;
        TextView dispatchDate;
        TextView dispatchNum;
        TextView dispatchPerson;
        TextView isExamine;
    }
}