package com.wgmf.yxgj.module.business.managecapital.ui;

import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsDetailsEntity;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsDetailsList;
import com.wgmf.yxgj.module.business.managecapital.service.CapitalManagerService;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 资材库存查询详情列表
 */
@SuppressWarnings("all")
public class CapitalStockDetailsActivity extends BaseParentAct {

    private List<CapitalReceiptsDetailsEntity> list;
    private CapitalReceiptsDetailsAdapter adapter;
    private ListView mListView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initContent();
        getShopData();
    }

    private void getShopData() {
        if (null != userInfo) {
            showDialog();
            list.clear();//清空数据，保证每次显示的都是接口返回的数据
            adapter.notifyDataSetChanged();
            String storeNo = getIntent().getStringExtra("storeNo");
            CapitalManagerService.getInstance().requestFindCapitalStockDetail(storeNo, CapitalStockDetailsActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("资材库存查询");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        EventBus.getDefault().register(this);
        list = new ArrayList<>();
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        adapter = new CapitalReceiptsDetailsAdapter(list, this);
        mListView.setAdapter(adapter);
        LinearLayout publicTopContentLl = (LinearLayout) findViewById(R.id.public_top_content_ll);
        TextView storeNameTv = (TextView) findViewById(R.id.store_name_tv);
        publicTopContentLl.setGravity(Gravity.START);
        publicTopContentLl.setVisibility(View.VISIBLE);
        storeNameTv.setVisibility(View.VISIBLE);
        String storeName = getIntent().getStringExtra("storeName");
        storeNameTv.setText(storeName);
        LinearLayout onclickTitleLl = (LinearLayout) findViewById(R.id.onclick_title_ll);
        TextView onclickName = (TextView) findViewById(R.id.onclick_name);
        TextView onclickTitle = (TextView) findViewById(R.id.onclick_title);
        onclickTitleLl.setVisibility(View.VISIBLE);
        onclickTitle.setVisibility(View.VISIBLE);
        onclickName.setVisibility(View.VISIBLE);
        onclickName.setText("资材名称");
        onclickTitle.setText("数量");
    }

    @Subscribe
    public void onEventMainThread(CapitalReceiptsDetailsList item) {
        if (item != null && !item.getResultList().isEmpty()) {
            list.clear();//清空数据，保证每次显示的都是接口返回的数据
            list.addAll(item.getResultList());
            adapter = new CapitalReceiptsDetailsAdapter(list, this);
            mListView.setAdapter(adapter);
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id==BusinessID.CapitalManager.MSG_ON_FIND_CAPITAL_STOCK_DETAIL) {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        CapitalReceiptsDetailsList mCapitalReceiptsDetailsList = new Gson().fromJson(msg, CapitalReceiptsDetailsList.class);
                        Log.d(TAG, "mCapitalReceiptsDetailsList=" + mCapitalReceiptsDetailsList.toString());
                        if (!mCapitalReceiptsDetailsList.getResultList().isEmpty()) {
                            EventBus.getDefault().post(mCapitalReceiptsDetailsList);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
            }
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}