package com.wgmf.yxgj.module.business.managecapital.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalStockShopList;
import com.wgmf.yxgj.module.business.managecapital.service.CapitalManagerService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.ShopEntityWithTime;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.xp.arouter.RouterParams;

/**
 * 资材库存查询门店列表
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_CAPITALSTOCKSHOPLISTACTIVITY)
public class CapitalStockShopListActivity extends SelectorBaseActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getShopData();
    }

    private void getShopData() {
        if (null != userInfo) {
            showDialog();
            //清空数据，保证每次显示的都是接口返回的数据
            listShow.clear();
            String staffId = userInfo.getStaffId();
            CapitalManagerService.getInstance().requestFindCapitalStockSearch(staffId, CapitalStockShopListActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("资材库存查询");
    }

    @Override
    protected void initContent() {
        super.initContent();
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent intent = new Intent(CapitalStockShopListActivity.this, CapitalStockDetailsActivity.class);
                intent.putExtra("storeNo", listShow.get(position).getSelectorId());
                intent.putExtra("storeName", listShow.get(position).getSelectorName());
                startActivity(intent);
            }
        });
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id==BusinessID.CapitalManager.MSG_ON_FIND_CAPITAL_STOCK_SEARCH){
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        CapitalStockShopList mCapitalStockShopList = new Gson().fromJson(msg, CapitalStockShopList.class);
                        Log.d(TAG, "mCapitalStockShopList=" + mCapitalStockShopList.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mCapitalStockShopList.retCode)) {
                            if (mCapitalStockShopList.getResultList() != null && !mCapitalStockShopList.getResultList().isEmpty()) {
                                listShow.clear();
                                for (ShopEntityWithTime mIbeaconShopEntity : mCapitalStockShopList.getResultList()) {
                                    BaseSelectorEntity mBaseSelectorEntity = new BaseSelectorEntity();
                                    mBaseSelectorEntity.setSelectorId(mIbeaconShopEntity.getShop().getShopId());
                                    mBaseSelectorEntity.setSelectorName(mIbeaconShopEntity.getShop().getShopName());
                                    mBaseSelectorEntity.setSelectorCode(mIbeaconShopEntity.getAddTime());
                                    listShow.add(mBaseSelectorEntity);
                                }
                                mAdapter.notifyDataSetChanged();
                                search();
                            }
                        } else {
                            showMsg(mCapitalStockShopList.retInfo);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
            }
        }
    }
}