package com.wgmf.yxgj.module.business.managecapital.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.FixedProductListEntity;
import com.wgmf.yxgj.module.business.managecapital.R;
import com.wgmf.yxgj.module.business.managecapital.model.CapitalReceiptsDetailsEntity;
import com.wgmf.yxgj.module.business.managecapital.model.ProductTransferredInAndOutNumListEntity;
import com.wgmf.yxgj.module.business.managecapital.model.ProductTransferredInAndOutNumLists;
import com.wgmf.yxgj.module.business.managecapital.service.CapitalManagerService;
import com.wgmf.yxgj.pop.PublicThreeSecondsPop;
import com.wgmf.yxgj.publics.ui.SelectorStoreGetNearestActivity;
import com.wgmf.yxgj.widgets.ListView.SlideDeleteListView;
import com.xp.arouter.RouterParams;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

/**
 * 资材调入调出
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_CAPITALTRANSFERREDINOROUTACTIVITY)
public class CapitalTransferredInOrOutActivity extends BaseParentAct implements View.OnClickListener ,PublicThreeSecondsPop.ThreeSecondsPopListener{

    private static final int SELECT_CAPITAL = 0;
    private static final int TRANSFER_OUT_SHOP = 1;
    private static final int TRANSFER_IN_SHOP = 2;
    private String storeidOut;
    private String storeidIn;
    /**
     * 资材调入调出功能选择门店,暂定为产品调入调出ID
     */
    private Long branchID;
    private TextView transferOutShopNameTxt;
    private TextView transferInShopNameTxt;
    private TextView submit;
    /**
     * 已选择的调拨数据
     */
    private List<CapitalReceiptsDetailsEntity> listData;
    private CapitalTransferredInOrOutAdapter adapter;
    private SlideDeleteListView slv;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_transfer_goods);
        initTitle();
        initView();
        initContent();
    }

    private void initContent() {
        listData = new ArrayList<>();
        slv = (SlideDeleteListView) findViewById(R.id.listview);
        TextView dataEmpty = (TextView) findViewById(R.id.data_empty);
        slv.setEmptyView(dataEmpty);
        adapter = new CapitalTransferredInOrOutAdapter(listData, CapitalTransferredInOrOutActivity.this);
        slv.setAdapter(adapter);
        //3秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(submit).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                if (TextUtils.isEmpty(storeidOut)) {
                    showMsg("请选择调出门店");
                } else if (TextUtils.isEmpty(storeidIn)) {
                    showMsg("请先选择调入门店");
                } else if (storeidIn.equals(storeidOut)) {
                    showMsg("调入调出门店不能相同");
                } else {
                    showDialog();
                    uploadCommitOper();//提交数据
                }
            }
        });
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initView() {
        LinearLayout transferOutShopNameLl = (LinearLayout) findViewById(R.id.transfer_out_shop_name_ll);
        LinearLayout transferInShopNameLl = (LinearLayout) findViewById(R.id.transfer_in_shop_name_ll);
        transferOutShopNameTxt = (TextView) findViewById(R.id.transfer_out_shop_name_txt);
        transferInShopNameTxt = (TextView) findViewById(R.id.transfer_in_shop_name_txt);
        TextView selectProductsTxt = (TextView) findViewById(R.id.select_products_txt);
        selectProductsTxt.setText("选择资材");
        TextView selectDateTxt = (TextView) findViewById(R.id.select_date_txt);
        selectDateTxt.setVisibility(View.GONE);

        submit = (TextView) findViewById(R.id.submit);
        transferOutShopNameLl.setOnClickListener(this);
        transferInShopNameLl.setOnClickListener(this);
        selectProductsTxt.setOnClickListener(this);
        submit.setOnClickListener(this);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case TRANSFER_OUT_SHOP:
                try {
                    storeidOut = data
                            .getStringExtra("shopId");
                    String shopNameOut = data
                            .getStringExtra("shopName");
                    transferOutShopNameTxt.setText(shopNameOut);
                } catch (Exception e) {
                    Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                }
                break;
            case TRANSFER_IN_SHOP:
                try {
                    storeidIn = data
                            .getStringExtra("shopId");
                    String shopNameIn = data
                            .getStringExtra("shopName");
                    transferInShopNameTxt.setText(shopNameIn);
                } catch (Exception e) {
                    Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                }
                break;
            case SELECT_CAPITAL:
                try {
                    listData = (List<CapitalReceiptsDetailsEntity>) data.getSerializableExtra("listData");
                    if (!listData.isEmpty() && listData.size() > 0) {
                        submit.setVisibility(View.VISIBLE);
                        adapter = new CapitalTransferredInOrOutAdapter(listData, CapitalTransferredInOrOutActivity.this);
                        slv.setAdapter(adapter);
                    }
                } catch (Exception e) {
                    Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                }
                break;
            default:
                break;
        }
    }

    /**
     * 上传订货审核数据
     */
    private void uploadCommitOper() {
        showDialog();
        ProductTransferredInAndOutNumLists mProductTransferredInAndOutNumList = new ProductTransferredInAndOutNumLists();
        List<ProductTransferredInAndOutNumListEntity> mProductTransferredInAndOutNumListEntitys = new ArrayList<>();
        for (int i = 0; i < listData.size(); i++) {
            if (listData.get(i).getOrderNum() > 0) {
                //如果调入调出数量>0，则提交
                ProductTransferredInAndOutNumListEntity mProductTransferredInAndOutNumListEntity = new ProductTransferredInAndOutNumListEntity();
                //调入调出数量
                mProductTransferredInAndOutNumListEntity.setTransferredInAndOutNum(listData.get(i).getOrderNum());
                //产品BillCode/资材调拨时用
                mProductTransferredInAndOutNumListEntity.setProductBillCode(listData.get(i).getCapitalReceiptProductBillCode());
                //产品库存
                mProductTransferredInAndOutNumListEntity.setProductSock(listData.get(i).getProductNum());
                FixedProductListEntity mFixedProductListEntity = new FixedProductListEntity();
                //产品编码
                mFixedProductListEntity.setProductCode(listData.get(i).getFixedProduct().getProductCode());
                //产品名称
                mFixedProductListEntity.setProductName(listData.get(i).getFixedProduct().getProductName());
                mProductTransferredInAndOutNumListEntity.setFixedProduct(mFixedProductListEntity);
                mProductTransferredInAndOutNumListEntitys.add(mProductTransferredInAndOutNumListEntity);
            }
        }
        mProductTransferredInAndOutNumList.setUserInfo(userInfo);
        mProductTransferredInAndOutNumList.setTransferredInStoreId(storeidIn);
        mProductTransferredInAndOutNumList.setTransferredOutStoreId(storeidOut);
        mProductTransferredInAndOutNumList.setProductTransferredInAndOutNumList(mProductTransferredInAndOutNumListEntitys);

        String content = new Gson().toJson(mProductTransferredInAndOutNumList);
        Log.d(TAG, content);
        CapitalManagerService.getInstance().requestSaveCapitalStockTransferred(content, CapitalTransferredInOrOutActivity.this);
    }

    @Override
    public void onClick(View v) {
        Intent intent = new Intent();
        if (v.getId() == R.id.transfer_out_shop_name_ll) {
            //调出门店
            intent.setClass(CapitalTransferredInOrOutActivity.this,
                    SelectorStoreGetNearestActivity.class);
            intent.putExtra("branchTitle", "选择门店");
            intent.putExtra("branchID", branchID);
            startActivityForResult(intent, TRANSFER_OUT_SHOP);
        } else if (v.getId() == R.id.transfer_in_shop_name_ll) {
            //调入门店
            intent.setClass(CapitalTransferredInOrOutActivity.this,
                    SelectorStoreGetNearestActivity.class);
            intent.putExtra("branchTitle", "选择门店");
            intent.putExtra("branchID", branchID);
            startActivityForResult(intent, TRANSFER_IN_SHOP);
        } else if (v.getId() == R.id.select_products_txt) {
            //选择产品
            if (TextUtils.isEmpty(storeidOut)) {
                showMsg("请先选择调出门店");
            } else {
                intent.setClass(CapitalTransferredInOrOutActivity.this, CapitalTransferredInOrOutCapitalListActivity.class);
                intent.putExtra("storeNo", storeidOut);
                intent.putExtra("listData", (Serializable) listData);
                startActivityForResult(intent, SELECT_CAPITAL);
            }
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id==BusinessID.CapitalManager.MSG_ON_SAVE_CAPITAL_STOCK_TRANSFERRED) {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        try {
                            BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                            Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                            showMsg(mBaseResponse.retInfo);
                            if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                                //弹出提示进度条,等待OE返回
                                showPopwindow();
                            }
                        } catch (Exception e) {
                            showMsg(getString(R.string.request_data_fail));
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
        }
    }

    /**
     * 弹出延时窗
     */
    @SuppressWarnings("all")
    private void showPopwindow() {
        PublicThreeSecondsPop publicThreeSecondsPop = new PublicThreeSecondsPop(this, this);
        if (!publicThreeSecondsPop.isShowing()) {
            publicThreeSecondsPop.show(this.findViewById(R.id.title));
        }
    }

    @Override
    public void onTimingFinish() {
        CapitalTransferredInOrOutActivity.this.finish();
    }
}