package com.wgmf.yxgj.module.business.manageproduct.model;

import com.wgmf.yxgj.model.CommonUserinfoBean;

import java.util.List;

/**
 * @author xiep  on 2016/11/30 10:41
 *         productTransferredInAndOutNumList (Array[ProductTransferredInAndOutNum], optional): 调入调出产品和数量 ,
 *         transferredInOrOutDate (string, optional): 调入调出时间 ,
 *         transferredInStoreId (string, optional): 调入门店Id ,
 *         transferredOutStoreId (string, optional): 调出门店Id ,
 *         userInfo (UserInfo, optional): 用户信息 -传调入调出人工号
 *         }
 *         ProductTransferredInAndOutNum {
 *         fixedProduct (FixedProduct, optional): 产品-传 产品id,产品编码,产品价格,产品名称,产品单位,产品单位id ,
 *         productBillCode (string, optional): 产品BillCode/资材调拨时用 ,
 *         productSock (integer, optional): 产品库存 ,
 *         transferredInAndOutNum (number, optional): 调入调出数量
 *         }
 *         UserInfo {
 *         code1 (string, optional): 销售组织编码 ,
 *         createTime (string, optional): 创建时间 ,
 *         entryStatus (string, optional): 入职状态：1-待审核，2-审批不通过，3-待入职，4-入职 ,
 *         expectZzDate (string, optional): 预计转正时间 ,
 *         insertTime (string, optional): 插入时间 ,
 *         mobilePhone (string, optional): 手机号 ,
 *         name (string, optional): 员工姓名 ,
 *         opType (string, optional): 员工类型 ,
 *         partnerId (integer, optional): 合作者ID ,
 *         password (string, optional): 密码 ,
 *         positiveReason (string, optional): 转正原因 ,
 *         roleStatus (string, optional): 角色（1.营养顾问2.流动营养顾问3.促销主管4.机修5.办事处文员6.终端经理7.区域经理8.大区经理9.人事经理10.推广经理11.培训经理12.KA经理13.终端主任）('14','总部人员 15','店长'),('16','流动队长'),('17','金牌导师(驻店)'),('18','金牌导师(流动) ,
 *         saleOrganization (integer, optional): 销售组织ID ,
 *         sex (string, optional): 性别 ,
 *         shopId (integer, optional): 门店ID ,
 *         staffId (string, optional): 员工工号 ,
 *         status (string, optional): 状态 ,
 *         userInfoId (integer, optional): 主键 ,
 *         wgmfLzDate (string, optional): 离职日期 ,
 *         wgmfRegularName (string, optional): 转正审核人 ,
 *         wgmfRegularOper (string, optional): 转正审核人id ,
 *         wgmfStatus (string, optional): 是否离职（1.离职，0.在职） ,
 *         wgmfWorkDate (string, optional): 入职日期 ,
 *         wgmfZzdate (string, optional): 转正日期
 *         }
 *         FixedProduct {
 *         pdBillCode (string, optional): 盘点单号 ,
 *         pdId (integer, optional): 盘点ID ,
 *         proId (integer, optional): 产品ID ,
 *         productBigType (string, optional): 产品大类 ,
 *         productBoxNum (number, optional): 产品箱装数量 ,
 *         productCd (string, optional): 产品是否可冲顶 ,
 *         productCode (string, optional): 产品编码 ,
 *         productDh (string, optional): 产品是否可订货 ,
 *         productName (string, optional): 产品名称 ,
 *         productPack (number, optional): 产品规格 ,
 *         productPd (string, optional): 产品是否可盘点 ,
 *         productPrice (number, optional): 产品价格 ,
 *         productSc (string, optional): 产品是否可试吃 ,
 *         productStatus (string, optional): 产品状态 ,
 *         productType (string, optional): 产品类别 ,
 *         productUnit (string, optional): 产品单位 ,
 *         productUnitId (integer, optional): 产品单位id ,
 *         productXs (string, optional): 产品是否可销售
 *         }
 */
@SuppressWarnings("all")
public class ProductTransferredInAndOutNumLists {
    private List<ProductTransferredInAndOutNumListEntity> productTransferredInAndOutNumList;

    private String transferredInOrOutDate;

    private String transferredInAndOutDate;

    private String transferredInStoreId;

    private String transferredInStoreName;

    private String transferredOutStoreId;

    private String transferredOutStoreName;

    private String transferredPerson;

    private CommonUserinfoBean userInfo;

    public void setProductTransferredInAndOutNumList(List<ProductTransferredInAndOutNumListEntity> productTransferredInAndOutNumList) {
        this.productTransferredInAndOutNumList = productTransferredInAndOutNumList;
    }

    public List<ProductTransferredInAndOutNumListEntity> getProductTransferredInAndOutNumList() {
        return this.productTransferredInAndOutNumList;
    }

    public void setTransferredInOrOutDate(String transferredInOrOutDate) {
        this.transferredInOrOutDate = transferredInOrOutDate;
    }

    public String getTransferredInAndOutDate() {
        return transferredInAndOutDate;
    }

    public void setTransferredInStoreId(String transferredInStoreId) {
        this.transferredInStoreId = transferredInStoreId;
    }

    public void setTransferredOutStoreId(String transferredOutStoreId) {
        this.transferredOutStoreId = transferredOutStoreId;
    }

    public void setUserInfo(CommonUserinfoBean userInfo) {
        this.userInfo = userInfo;
    }

    public CommonUserinfoBean getUserInfo() {
        return this.userInfo;
    }

    public String getTransferredInStoreName() {
        return transferredInStoreName;
    }

    public String getTransferredOutStoreName() {
        return transferredOutStoreName;
    }

    public String getTransferredPerson() {
        return transferredPerson;
    }

    public String getTransferredInOrOutDate() {
        return transferredInOrOutDate;
    }

    public void setTransferredInAndOutDate(String transferredInAndOutDate) {
        this.transferredInAndOutDate = transferredInAndOutDate;
    }

    public String getTransferredInStoreId() {
        return transferredInStoreId;
    }

    public void setTransferredInStoreName(String transferredInStoreName) {
        this.transferredInStoreName = transferredInStoreName;
    }

    public String getTransferredOutStoreId() {
        return transferredOutStoreId;
    }

    public void setTransferredOutStoreName(String transferredOutStoreName) {
        this.transferredOutStoreName = transferredOutStoreName;
    }

    public void setTransferredPerson(String transferredPerson) {
        this.transferredPerson = transferredPerson;
    }
}