package com.wgmf.yxgj.module.business.manageproduct.ui

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.widget.TextView
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.gson.Gson
import com.wgmf.library.utils.JsonDominator
import com.wgmf.yxgj.base.BaseParentAct
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.GoodsAddOrderStoreListEntity
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService
import com.wgmf.yxgj.widgets.EditText.ClearEditText
import com.xp.arouter.RouterParams
import kotlinx.android.synthetic.main.activity_add_order_store.*
import java.util.*

/**
 * @author Sasuke on 2020-4-27 0027.
 * 订货加单 入口界面
 */
@Route(path = RouterParams.URL_GOODSADDORDERENTRYLISTACTIVITY)
class GoodsAddOrderEntryListActivity : BaseParentAct() {

    val branchTitle by lazy { intent.getStringExtra("branchTitle") }

    var loadWait: LoadWaitDominator? = null
    var listShow: MutableList<GoodsAddOrderStoreListEntity.ShopInfo>? = ArrayList<GoodsAddOrderStoreListEntity.ShopInfo>()
    var mListStore: List<GoodsAddOrderStoreListEntity.ShopInfo>? = ArrayList<GoodsAddOrderStoreListEntity.ShopInfo>()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_add_order_store)
        initTitle()
        initView()
        queryData()
    }

    fun queryData() {
        loadWait?.show(LoadWaitDominator.LOADING)
        userInfo?.let {
            GoodsManagerService.getInstance().requestAddOrderStores(it.staffId) {
                loadWait?.dismissAll()
                if (!isFinishing && it.isSuccessed) {
                    var entity = Gson().fromJson(it.info, GoodsAddOrderStoreListEntity::class.java)
                    JsonDominator.loadFromSD(GoodsAddOrderStoreListEntity::class.java)?.let {
                        entity = it
                    }
                    if (entity.resultList.isNullOrEmpty()) loadWait?.show(LoadWaitDominator.NO_DATA)
                    mListStore = entity.resultList
                    addOrderStoreRv.adapter = GoodsAddOrderEntryAdapter(this, entity.resultList)
                    return@requestAddOrderStores
                }
                loadWait?.show(LoadWaitDominator.NET_ERROR)
            }
        }
    }

    fun initView() {
        loadWait = LoadWaitDominator(this, containerLayout)
        addOrderStoreRv.layoutManager = LinearLayoutManager(this)
    }

    override fun initTitle() {
        super.initTitle()
        homeTitleText.text = branchTitle
        homeTitleBackLl.visibility = View.VISIBLE
        listTitleTv.findViewById<TextView>(R.id.auditing_goods_header_tv2)
                .text = getString(R.string.add_order_shop_no)
        store_name_et.findViewById<ClearEditText>(R.id.store_name_et) as ClearEditText
        store_name_et.visibility = View.VISIBLE
        store_name_et.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {

            }

            override fun afterTextChanged(s: Editable) {
                textChanged()
            }
        })
    }

    fun textChanged() {
        val itemId = store_name_et.getText().toString().trim({ it <= ' ' })
        if (TextUtils.isEmpty(itemId)) {
            listShow!!.clear()
            for (p in mListStore!!) {
                listShow!!.add(p)
            }
        } else {
            listShow!!.clear()
            if (null != mListStore) {
                for (p in mListStore!!) {
                    if (null != p.shopName) {
                        if (p.shopName!!.contains(itemId)) {
                            listShow!!.add(p)
                        }
                    }
                }
            }
        }
        if (null != addOrderStoreRv.adapter) {
            addOrderStoreRv.adapter = GoodsAddOrderEntryAdapter(this, listShow)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        when (resultCode) {
            Activity.RESULT_OK -> finish()
        }
    }
}