package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.view.ViewPager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.db.GreenDaoManager;
import com.wgmf.yxgj.db.OrderGoodsAuditDetailDao;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.model.OrderGoodsAuditDetail;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductAndSuggestOrderGoodsList;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductParamEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductParamListEntity;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import static android.support.design.widget.TabLayout.MODE_SCROLLABLE;


/**
 * 订货审核:（第四页） 继续添加订货产品页
 *
 * @author XiePing
 */
public class GoodsAuditingAddProductsActivity extends BaseParentAct implements ViewPager.OnPageChangeListener, View.OnClickListener {
    private List<ProductParamEntity> list = new ArrayList<>();
    private Button salesCont;
    private TabLayout mTablayout;
    private ViewPager mViewPager;
    /**
     * TabLayout中的tab标题
     */
    private List<String> mTitles;
    /**
     * 填充到ViewPager中的Fragment
     */
    private List<Fragment> fragmentList;

    private OrderGoodsAuditDetailDao mOrderGoodsAuditDetailDao;
    /**
     * 订货待审核数据
     */
    private List<OrderGoodsAuditDetail> mOrderGoodsAuditDetailData;
    /**
     * 初始订货审核条数
     */
    private int initCouonts;
    /**
     * 订货审核id
     */
    private int orderGoodsAuditId;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tablayout);
        initTitle();
        initContent();
        getShopData();
    }

    private void getShopData() {
        if (null != userInfo) {
            showDialog();
            String urlDH = NetworkParams.URL_FIND_PRODUCT_LIST;
            String urlCPML = NetworkParams.URL_FIND_IN_OUT_PRODUCT_LIST;
            String storeNoOut = getIntent().getStringExtra("storeNo");//调出门店
            String storeNoIn = getIntent().getStringExtra("inStoreNo");//调入门店
            //type ='ZC' 表示固定资产，type='DH'表示订货审核的产品
            String type = getIntent().getStringExtra("type");
            String orderBrandId = getIntent().getStringExtra("orderBrandId");
            Log.d(TAG, "brandList: " + brandList);
            String brandLists = "{\"brandList\":" + new Gson().toJson(brandList) + "}";
            if ("DH".equals(type)) {
                //请求订货审核的产品数据
                GoodsManagerService.getInstance().requestFindProductList(urlDH, storeNoOut, type, orderBrandId, brandLists, GoodsAuditingAddProductsActivity.this);
            } else {
                //请求调入调出的产品数据
                GoodsManagerService.getInstance().requestFindInOutProductList(urlCPML, storeNoIn, storeNoOut, type, brandLists, GoodsAuditingAddProductsActivity.this);
            }
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("继续添加");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        EventBus.getDefault().register(this);
        mTablayout = (TabLayout) findViewById(R.id.tab_layout);
        mViewPager = (ViewPager) findViewById(R.id.viewpager);
        salesCont = (Button) findViewById(R.id.public_comfirm_btn_total_left_btn);
        Button confirm = (Button) findViewById(R.id.public_comfirm_btn_total_right_btn);
        confirm.setOnClickListener(this);

        mOrderGoodsAuditDetailDao = GreenDaoManager.getInstance().getDaoSession(this).getOrderGoodsAuditDetailDao();
        mOrderGoodsAuditDetailData = mOrderGoodsAuditDetailDao.loadAll();
        initCouonts = mOrderGoodsAuditDetailData.size();
        orderGoodsAuditId = getIntent().getIntExtra("orderGoodsAuditId", 0);
        LinearLayout publicComfirmBtnTotalLl = (LinearLayout) findViewById(R.id.public_comfirm_btn_total_ll);
        publicComfirmBtnTotalLl.setVisibility(View.VISIBLE);
    }

    private void configViews() {
        // 初始化ViewPager的适配器，并设置给它
        AddProductsTablayoutViewPagerAdapter mViewPagerAdapter = new AddProductsTablayoutViewPagerAdapter(getSupportFragmentManager(), mTitles, fragmentList);
        mViewPager.setAdapter(mViewPagerAdapter);
        // 设置ViewPager最大缓存的页面个数
        mViewPager.setOffscreenPageLimit(5);
        // 给ViewPager添加页面动态监听器（为了让Toolbar中的Title可以变化相应的Tab的标题）
        mViewPager.addOnPageChangeListener(this);

        mTablayout.setTabMode(MODE_SCROLLABLE);
        // 设置TabLayout的指示器高度为0，即达到了隐藏Indicator的目的
        mTablayout.setSelectedTabIndicatorHeight(0);
        mTablayout.setBackgroundColor(getResources().getColor(R.color.white));
        // 将TabLayout和ViewPager进行关联，让两者联动起来
        mTablayout.setupWithViewPager(mViewPager);
        // 设置Tablayout的Tab显示ViewPager的适配器中的getPageTitle函数获取到的标题
        mTablayout.setTabsFromPagerAdapter(mViewPagerAdapter);

    }

    @Override
    public void onPageSelected(int position) {
        mTablayout.newTab().setText(mTitles.get(position));
    }

    @Override
    public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

    }

    @Override
    public void onPageScrollStateChanged(int state) {

    }

    /**
     * 已选添加审核产品数
     *
     * @param item 产品列表
     */
    @Subscribe
    public void onEventMainThread(List<ProductAndSuggestOrderGoodsList> item) {
        mOrderGoodsAuditDetailData.clear();
        if (item != null && !item.isEmpty()) {
            for (int i = 0; i < item.size(); i++) {
                if (item.get(i).getFixedProduct().isChoice()) {
                    // 审核提交的订货单
                    OrderGoodsAuditDetail listbill = new OrderGoodsAuditDetail();
                    // 创建时间
                    listbill.setCreateTime(item.get(i).getCreateTime());
                    //产品BillCode/资材调拨时用
                    listbill.setProductBillCode(item.get(i).getProductBillCode());
                    //产品库存
                    listbill.setProductCapitalReceiptsStock(item.get(i).getProductCapitalReceiptsStock());

                    if (null != item.get(i).getProductSuggestOrderGoodsNum()) {
                        //订货审核Id
                        listbill.setOrderGoodsAuditId(orderGoodsAuditId);
                        // 最大建议订货量
                        listbill.setMaxSuggestOrderGoodsNum(item.get(i).getProductSuggestOrderGoodsNum().getProductMaxSOrderGoodsNum());
                        // 审核数量
                        listbill.setOrderGoodsAuditNum(item.get(i).getProductSuggestOrderGoodsNum().getOrderGoodsAuditNum());
                        //产品前30天销售数量
                        listbill.setProductLastMonthSaleNum(item.get(i).getProductSuggestOrderGoodsNum().getProductLastMonthSaleNum());
                        //产品库存数量
                        listbill.setProductStockNum(item.get(i).getProductSuggestOrderGoodsNum().getProductStockNum());
                        //建议订货量
                        listbill.setSuggestOrderGoodsNum(item.get(i).getProductSuggestOrderGoodsNum().getProductSOrderGoodsNum());
                        //已提交数量
                        listbill.setProductAlreadyOrderNum(item.get(i).getProductSuggestOrderGoodsNum().getProductAlreadyOrderNum());
                        //产品在途数量
                        listbill.setProductFutureNum(item.get(i).getProductSuggestOrderGoodsNum().getProductFutureNum());
                        //近30天已订货数量
                        listbill.setProductLastMonthOrderNum(item.get(i).getProductSuggestOrderGoodsNum().getProductLastMonthOrderNum());
                        //产品大类父类
                        listbill.setProductBigFatherType(item.get(i).getProductSuggestOrderGoodsNum().getProductBigFatherType());
                        //产品大类
                        listbill.setProductBigType(item.get(i).getProductSuggestOrderGoodsNum().getProductBigType());
                        //产品图片
                        listbill.setProductImage(item.get(i).getProductSuggestOrderGoodsNum().getProductImage());
                        //类型（是UPDATE =0 或 INSERT =1）
                        listbill.setType(1);
                        //新添加的产品原订货数量为0
                        // 订货金额
                        listbill.setOrderGoodsAmount("0");
                        //订货数量
                        listbill.setOrderGoodsNum(0);
                        //处理人工号
                        listbill.setUserNo(userInfo.getStaffId());
                    }
                    if (null != item.get(i).getFixedProduct()) {
                        //类型（是UPDATE =0 或 INSERT =1）
                        listbill.setType(1);
                        //产品箱装数量
                        listbill.setProductBoxNum(item.get(i).getFixedProduct().getProductPack());
                        //产品编码
                        listbill.setProductCode(item.get(i).getFixedProduct().getProductCode());
                        //产品Id
                        listbill.setProductId(item.get(i).getFixedProduct().getProId());
                        //产品名称
                        listbill.setProductName(item.get(i).getFixedProduct().getProductName());
                        //产品价格
                        listbill.setProductPrice(item.get(i).getFixedProduct().getProductPrice());
                        //产品单位
                        listbill.setProductUnit(item.get(i).getFixedProduct().getProductUnit());
                        //产品单位Id
                        listbill.setProductUnitId(item.get(i).getFixedProduct().getProductUnitId());
//                        //产品大类
//                        listbill.setProductBigType(item.get(i).getFixedProduct().getProductBigType());
//                        //产品大类父类
//                        listbill.setProductBigFatherType(item.get(i).getFixedProduct().getProductBigFatherType());
                        //产品类别
                        listbill.setProductType(item.get(i).getFixedProduct().getProductType());
                        //产品规格
                        listbill.setProductPack(item.get(i).getFixedProduct().getProductPack());
                        //产品图片
                        listbill.setProductImage(item.get(i).getFixedProduct().getProductImage());
                    }
//                    Log.d(TAG, "订货审核添加后：" + listbill.toString());
                    mOrderGoodsAuditDetailDao.insertOrReplaceInTx(listbill);
                } else {
                    mOrderGoodsAuditDetailDao.deleteByKey(item.get(i).getFixedProduct().getProId());
                }
            }
        }
        //        加载订货待审核数据
        mOrderGoodsAuditDetailData = mOrderGoodsAuditDetailDao.loadAll();
        int checkedCouonts = mOrderGoodsAuditDetailData.size();
        //显示选中的条目数
        salesCont.setText("已选（" + (checkedCouonts - initCouonts) + "）");
    }

    public void setData(ProductParamListEntity item) {
        list.clear();
        if (item != null && !item.getResultList().isEmpty()) {
            list.addAll(item.getResultList());
        }
        //初始化标题
        mTitles = new ArrayList<>();
        //初始化填充到ViewPager中的Fragment集合
        fragmentList = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            mTitles.add(list.get(i).getProductType());
            Bundle mBundle = new Bundle();
            mBundle.putInt("flag", i);
            mBundle.putString("productType", list.get(i).getProductType());
            mBundle.putSerializable("productAndSuggestOrderGoodsList", (Serializable) list.get(i).getProductAndSuggestOrderGoodsList());
            AddProductsTablayoutListFragment mFragment = new AddProductsTablayoutListFragment();
            mFragment.setData(mBundle);
//            mFragment.setArguments(mBundle);
            fragmentList.add(i, mFragment);
        }
        configViews();
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.GoodsManager.MSG_ON_FIND_PRODUCT_LIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    ProductParamListEntity mProductParamListEntity = new Gson().fromJson(msg, ProductParamListEntity.class);
                    Log.d(TAG, "mProductParamListEntity=" + mProductParamListEntity.toString());
                    //将已经在订货审核列表的产品项移除
                    if (null != mProductParamListEntity.getResultList() && !mProductParamListEntity.getResultList().isEmpty()) {
                        for (int i = 0; i < mProductParamListEntity.getResultList().size(); i++) {
                            if (null != mProductParamListEntity.getResultList().get(i).getProductAndSuggestOrderGoodsList() && !mProductParamListEntity.getResultList().get(i).getProductAndSuggestOrderGoodsList().isEmpty()) {
                                List<ProductAndSuggestOrderGoodsList> mProductAndSuggestOrderGoodsList = mProductParamListEntity.getResultList().get(i).getProductAndSuggestOrderGoodsList();
                                for (int k = 0; k < mOrderGoodsAuditDetailData.size(); k++) {
                                    for (int j = 0; j < mProductAndSuggestOrderGoodsList.size(); j++) {
                                        if (null != mProductAndSuggestOrderGoodsList.get(j).getFixedProduct() && mOrderGoodsAuditDetailData.get(k).getProductId().equals(mProductAndSuggestOrderGoodsList.get(j).getFixedProduct().getProId())) {
                                            mProductAndSuggestOrderGoodsList.remove(j);
                                            j--;
                                        }
                                    }
                                }
                            }
                        }
                        //将已订产品移除后的产品列表显示在界面上
                        setData(mProductParamListEntity);
                    }
                }
            }
        }
    }

    @Override
    public void onClick(View v) {
        //点击确认按钮，将添加后的产品返回给订货列表
        if (v.getId() == R.id.public_comfirm_btn_total_right_btn) {
            //将添加后的数据表发送到订货审核页面
            EventBus.getDefault().post(mOrderGoodsAuditDetailData);
            this.finish();
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}