package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditStoreGroupEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditStoreGroupListEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditStoreList;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsShopEntity;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 订货审核:（第一页） 门店名称+待审核订单数
 *
 * @author XiePing
 */
@Route(path = RouterParams.URL_GOODSAUDITINGSHOPLISTACTIVITY)
public class GoodsAuditingShopListActivity extends BaseParentAct {

    private static final String ORDER_LIST = "orderList";
    private static final String NOT_ORDER_LIST = "notOrderList";

    private String branchTitle;
    private TextView onclickName;
    private ClearEditText clearEditText;

    private ListViewForScrollView goodsAuditingShopLv1;
    private ListViewForScrollView goodsAuditingShopLv2;

    private GoodsAuditingShopListAdapter goodsAuditingShopListAdapter1;
    private GoodsAuditingShopListAdapter2 goodsAuditingShopListAdapter2;

    private List<OrderGoodsAuditStoreList> orderList;
    private List<OrderGoodsShopEntity> notOrderList;

    private List<BaseSelectorEntity> mListStore;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_goods_auditing_shop);
        initTitle();
        initContent();
        setListener();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getShopData();
    }

    private void getShopData() {
        showDialog();
        if (null != userInfo) {
            String staffId = userInfo.getStaffId();
            GoodsManagerService.getInstance().requestFindOrderGoodsAuditStore(staffId, GoodsAuditingShopListActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    public void initContent() {
        EventBus.getDefault().register(this);
        orderList = new ArrayList<>();
        notOrderList = new ArrayList<>();
        initView();
        initListView1();
        initListView2();
        setListAdapter1();
        setListAdapter2();
    }

    private void initView() {
        LinearLayout onclickTitleLl = (LinearLayout) findViewById(R.id.onclick_title_ll);
        onclickTitleLl.setVisibility(View.VISIBLE);
        onclickName = (TextView) findViewById(R.id.onclick_name);
        clearEditText = (ClearEditText) findViewById(R.id.store_name_et);
        clearEditText.setVisibility(View.VISIBLE);
    }

    /**
     * 初始化已提交订货单门店列表
     */
    private View initListView1() {
        goodsAuditingShopLv1 = (ListViewForScrollView) findViewById(R.id.public_list_view_lv);
        View headerView1 = getLayoutInflater().inflate(
                R.layout.auding_goods_header_view, null);
        goodsAuditingShopLv1.addHeaderView(headerView1);
        headerView1.setOnClickListener(null);
        TextView auditingGoodsHeaderTv = (TextView) findViewById(R.id.auditing_goods_header_tv);
        auditingGoodsHeaderTv.setText(R.string.auding_goods_shop_yes);
        return headerView1;
    }

    /**
     * 初始化当前不能订货门店列表
     */
    private void initListView2() {
        goodsAuditingShopLv2 = (ListViewForScrollView) findViewById(R.id.activity_goods_auditing_shop_lv);
        View headerView2 = getLayoutInflater().inflate(
                R.layout.auding_goods_header_view2, null);
        goodsAuditingShopLv2.addHeaderView(headerView2);
        headerView2.setOnClickListener(null);
        TextView auditingGoodsHeaderTv2 = (TextView) findViewById(R.id.auditing_goods_header_tv2);
        auditingGoodsHeaderTv2.setText(R.string.auding_goods_shop_no);
    }

    /**
     * 设置已提交订货单门店列表Adapter
     */
    private void setListAdapter1() {
        goodsAuditingShopListAdapter1 = new GoodsAuditingShopListAdapter(orderList, this);
        goodsAuditingShopLv1.setAdapter(goodsAuditingShopListAdapter1);
        goodsAuditingShopLv1.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Intent intent = new Intent(GoodsAuditingShopListActivity.this, GoodsAuditingStatusActivity.class);
                intent.putExtra("storeNo", orderList.get(position - 1).getShop().getShopId());
                intent.putExtra("branchTitle", branchTitle);
                startActivity(intent);
            }
        });
    }

    /**
     * 设置当前不能订货门店列表Adapter
     */
    private void setListAdapter2() {
        goodsAuditingShopListAdapter2 = new GoodsAuditingShopListAdapter2(notOrderList, this);
        goodsAuditingShopLv2.setAdapter(goodsAuditingShopListAdapter2);
    }

    @Subscribe
    public void onEventMainThread(OrderGoodsAuditStoreGroupListEntity item) {
        if (item != null && !item.getResultList().isEmpty()) {
            OrderGoodsAuditStoreGroupEntity resultData = item.getResultList().get(0);
            //总门店数
            int sumStoreNum = resultData.getSumStoreNum();
            //订单门店数
            int orderStoreNum = resultData.getOrderStoreNum();
            //没有订单门店数
            int noOrderStoreNum = resultData.getNoOrderStoreNum();

            onclickName.setVisibility(View.VISIBLE);
            onclickName.setGravity(Gravity.CENTER);

            onclickName.setText("总门店数:" + sumStoreNum + "  " + "当前应订货门店数:" + orderStoreNum + "\n未提交订单门店数：" + +noOrderStoreNum + "  ");

            if (null != resultData.getOrderGoodsAuditStoreList() && !resultData.getOrderGoodsAuditStoreList().isEmpty()) {
                orderList = resultData.getOrderGoodsAuditStoreList();
            }
            if (null != resultData.getNotOrderStoreList() && !resultData.getNotOrderStoreList().isEmpty()) {
                notOrderList = resultData.getNotOrderStoreList();
            }
            refreshListView();
        }
        search();
    }

    protected void search() {
        mListStore = new ArrayList<>();
        if (null != orderList && !orderList.isEmpty()) {
            for (OrderGoodsAuditStoreList mOrderGoodsAuditStoreListEntity : orderList) {
                BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
                baseSelectorEntity.setSelectorId(mOrderGoodsAuditStoreListEntity.getShop().getShopId());
                baseSelectorEntity.setSelectorName(mOrderGoodsAuditStoreListEntity.getShop().getShopName());
                baseSelectorEntity.setAuditOrderNum(mOrderGoodsAuditStoreListEntity.getAuditOrderNum());
                baseSelectorEntity.setAlreadyAuditOrderNum(mOrderGoodsAuditStoreListEntity.getAlreadyAuditOrderNum() + "");
                baseSelectorEntity.setSelectorCode(ORDER_LIST);
                mListStore.add(baseSelectorEntity);
            }
        }
        if (null != notOrderList && !notOrderList.isEmpty()) {
            for (OrderGoodsShopEntity mOrderGoodsShopEntity : notOrderList) {
                BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
                baseSelectorEntity.setSelectorId(mOrderGoodsShopEntity.getShopId());
                baseSelectorEntity.setSelectorName(mOrderGoodsShopEntity.getShopName());
                baseSelectorEntity.setSelectorCode(NOT_ORDER_LIST);
                mListStore.add(baseSelectorEntity);
            }
        }
    }

    protected void setListener() {
        clearEditText.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                textChanged();
            }
        });
    }

    public void textChanged() {
        String itemName = clearEditText.getText().toString().trim();
        orderList.clear();
        notOrderList.clear();
        if (null != mListStore && !mListStore.isEmpty()) {
            for (BaseSelectorEntity p : mListStore) {
                if (!TextUtils.isEmpty(itemName)) {
                    if (p.getSelectorName().contains(itemName)) {
                        addClassifyData(p);
                    }
                } else {
                    addClassifyData(p);
                }
            }
        }
        refreshListView();
    }

    private void addClassifyData(BaseSelectorEntity p) {
        if (ORDER_LIST.equals(p.getSelectorCode())) {
            OrderGoodsAuditStoreList mOrderGoodsAuditStoreList = new OrderGoodsAuditStoreList();
            OrderGoodsShopEntity mOrderGoodsShopEntity = new OrderGoodsShopEntity();
            mOrderGoodsShopEntity.setShopId(p.getSelectorId());
            mOrderGoodsShopEntity.setShopName(p.getSelectorName());
            mOrderGoodsAuditStoreList.setAlreadyAuditOrderNum(Integer.valueOf(p.getAlreadyAuditOrderNum()));
            mOrderGoodsAuditStoreList.setAuditOrderNum(p.getAuditOrderNum());
            mOrderGoodsAuditStoreList.setShop(mOrderGoodsShopEntity);
            orderList.add(mOrderGoodsAuditStoreList);
        } else {
            OrderGoodsShopEntity mOrderGoodsShopEntity = new OrderGoodsShopEntity();
            mOrderGoodsShopEntity.setShopId(p.getSelectorId());
            mOrderGoodsShopEntity.setShopName(p.getSelectorName());
            notOrderList.add(mOrderGoodsShopEntity);
        }
    }

    /**
     * 刷新列表数据
     */
    private void refreshListView() {
        goodsAuditingShopListAdapter1 = new GoodsAuditingShopListAdapter(orderList, this);
        goodsAuditingShopListAdapter2 = new GoodsAuditingShopListAdapter2(notOrderList, this);
        goodsAuditingShopLv1.setAdapter(goodsAuditingShopListAdapter1);
        goodsAuditingShopLv2.setAdapter(goodsAuditingShopListAdapter2);
        goodsAuditingShopListAdapter1.notifyDataSetChanged();
        goodsAuditingShopListAdapter2.notifyDataSetChanged();
//        ListViewUtil.setListViewHeight(goodsAuditingShopLv1);
//        ListViewUtil.setListViewHeight(goodsAuditingShopLv2);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.GoodsManager.MSG_ON_FIND_ORDERGOODS_AUDIT_STORE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        OrderGoodsAuditStoreGroupListEntity mOrderGoodsAuditStoreGroupListEntity = new Gson().fromJson(msg, OrderGoodsAuditStoreGroupListEntity.class);
                        Log.d(TAG, "mOrderGoodsAuditStoreGroupListEntity=" + mOrderGoodsAuditStoreGroupListEntity.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mOrderGoodsAuditStoreGroupListEntity.retCode)) {
                            if (!mOrderGoodsAuditStoreGroupListEntity.getResultList().isEmpty()) {
                                EventBus.getDefault().post(mOrderGoodsAuditStoreGroupListEntity);
                            }
                        } else {
                            showMsg(mOrderGoodsAuditStoreGroupListEntity.retInfo);
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}