package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.base.BaseActivity;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditStoreList;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

class GoodsAuditingShopListAdapter extends BaseAdapter {
    private List<OrderGoodsAuditStoreList> list;
    private BaseActivity context;

    GoodsAuditingShopListAdapter(List<OrderGoodsAuditStoreList> mlist, BaseActivity context) {
        this.list = mlist;
        this.context = context;
        //按订单数量倒序排序
        Collections.sort(mlist, new Comparator<OrderGoodsAuditStoreList>() {

            @Override
            public int compare(OrderGoodsAuditStoreList lhs, OrderGoodsAuditStoreList rhs) {

                if (lhs.getAuditOrderNum() > rhs.getAuditOrderNum()) {
                    return -1;
                } else if (lhs.getAuditOrderNum() == rhs.getAuditOrderNum()) {
                    return 0;
                } else {
                    return 1;
                }
            }
        });
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.auditing_goods_shop_item, null);
            viewHolder = new ViewHolder();
            viewHolder.store = (TextView) convertView.findViewById(R.id.auditing_store);
            viewHolder.itemCount = (TextView) convertView.findViewById(R.id.pingxiang_dnum);
            viewHolder.itemCount2 = (TextView) convertView.findViewById(R.id.pingxiang_dnum2);
            viewHolder.auditstoreLy = (LinearLayout) convertView.findViewById(R.id.find_ordergoods_auditstore_ll);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        OrderGoodsAuditStoreList ent = list.get(position);
        viewHolder.store.setText(ent.getShop().getShopName());
        viewHolder.itemCount.setText("" + ent.getAuditOrderNum() + "");
        viewHolder.itemCount2.setText("" + ent.getAlreadyAuditOrderNum() + "");
        viewHolder.auditstoreLy.setBackgroundResource(R.drawable.selector_white_bar);
        viewHolder.itemCount.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
        return convertView;
    }

    class ViewHolder {
        TextView store;
        TextView itemCount;
        TextView itemCount2;
        LinearLayout auditstoreLy;
    }
}
