package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditListEntity;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.wgmf.yxgj.widgets.PullToRefresh.PullToRefreshListView;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 订货审核:（第二页） 选中门店后审核订单状态
 *
 * @author XiePing
 */
@SuppressWarnings("all")
public class GoodsAuditingStatusActivity extends BaseParentAct implements View.OnClickListener, GoodsAuditingStatusAdapter.onAdapterItemClick {
    private String branchTitle;
    private List<OrderGoodsAuditEntity> list;
    private GoodsAuditingStatusAdapter adapter;
    private String storeNo;
    private int tabPosition;
    /**
     * 下标集合
     */
    private List<TextView> textViews;
    /**
     * tab集合
     */
    private List<ImageView> imageViews;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_report_search);
        initTitle();
        initContent();
        initTab(tabPosition);// 初始化tab
    }

    @Override
    protected void onResume() {
        super.onResume();
        getShopData((tabPosition + 1) + "");
    }

    private void getShopData(String type) {
        list.clear();
        adapter.notifyDataSetChanged();
        if (null != userInfo) {
            showDialog();
            storeNo = getIntent().getStringExtra("storeNo");
            String userName = userInfo.getName();
            String userNameLevel = userInfo.getUserPostLevel();
            GoodsManagerService.getInstance().requestFindOrderGoodsAudit(type, storeNo, userName, userNameLevel, GoodsAuditingStatusActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        EventBus.getDefault().register(this);
        LinearLayout mReportSearchAll = (LinearLayout) findViewById(R.id.ll_report_search_all);
        LinearLayout mReportSearchNo = (LinearLayout) findViewById(R.id.ll_report_search_no);
        LinearLayout mReportSearchYes = (LinearLayout) findViewById(R.id.ll_report_search_yes);
        //  声明标题栏的tab
        TextView mReportSearchAllTxt = (TextView) findViewById(R.id.report_search_all_txt);
        TextView mReportSearchNoTxt = (TextView) findViewById(R.id.report_search_no_txt);
        TextView mReportSearchYesTxt = (TextView) findViewById(R.id.report_search_yes_txt);
        mReportSearchAllTxt.setText("待审核");
        mReportSearchNoTxt.setText("待复核");
        mReportSearchYesTxt.setText("已作废");
        // 标题栏的下标
        ImageView mReportSearchAllImg = (ImageView) findViewById(R.id.report_search_all_img);
        ImageView mReportSearchNoImg = (ImageView) findViewById(R.id.report_search_no_img);
        ImageView mReportSearchYesImg = (ImageView) findViewById(R.id.report_search_yes_img);
        mReportSearchAll.setOnClickListener(this);
        mReportSearchNo.setOnClickListener(this);
        mReportSearchYes.setOnClickListener(this);
        // 装载控件到集合
        textViews = new ArrayList<>();
        textViews.add(mReportSearchAllTxt);
        textViews.add(mReportSearchNoTxt);
        textViews.add(mReportSearchYesTxt);
        imageViews = new ArrayList<>();
        imageViews.add(mReportSearchAllImg);
        imageViews.add(mReportSearchNoImg);
        imageViews.add(mReportSearchYesImg);

        PullToRefreshListView ptrlv = (PullToRefreshListView) findViewById(R.id.prsv);
        ListView mListView = (ListView) findViewById(R.id.public_list_view_lv);
        TextView dataEmpty = (TextView) findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        ptrlv.setVisibility(View.GONE);

        list = new ArrayList<>();
        adapter = new GoodsAuditingStatusAdapter(list, brandList, this, this);
        mListView.setAdapter(adapter);
    }

    private void initTab(int tabPosition) {
        textViews.get(tabPosition).setTextColor(ContextCompat.getColor(this, R.color.normal_color));
        imageViews.get(tabPosition).setVisibility(View.VISIBLE);
        imageViews.get(tabPosition).setImageResource(R.color.normal_color);
    }

    @Subscribe
    public void onEventMainThread(OrderGoodsAuditListEntity item) {
        list.clear();//清空数据，保证每次显示的都是接口返回的数据
        if (item != null && !item.getResultList().isEmpty()) {
            list.addAll(item.getResultList());
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.GoodsManager.MSG_ON_FIND_ORDERGOODS_AUDIT) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    OrderGoodsAuditListEntity mOrderGoodsAuditListEntity = new Gson().fromJson(msg, OrderGoodsAuditListEntity.class);
                    Log.d(TAG, "mOrderGoodsAuditListEntity=" + mOrderGoodsAuditListEntity.toString());
                    if (mOrderGoodsAuditListEntity.getResultList() != null && !mOrderGoodsAuditListEntity.getResultList().isEmpty()) {
                        EventBus.getDefault().post(mOrderGoodsAuditListEntity);
                    }
                }
            }
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }

    private void setSelectedItem(int position) {
        for (int i = 0; i < imageViews.size(); i++) {
            imageViews.get(i).setImageResource(R.color.black);
            textViews.get(i).setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            imageViews.get(position).setVisibility(View.GONE);
        }
        imageViews.get(position).setVisibility(View.VISIBLE);
        imageViews.get(position).setImageResource(R.color.normal_color);
        textViews.get(position).setTextColor(ContextCompat.getColor(this, R.color.normal_color));
        textViews.get(position).getPaint().setFakeBoldText(true);
    }

    @Override
    public void onClick(View view) {
        if (view.getId() == R.id.ll_report_search_all) {
            tabPosition = 0;
            this.setSelectedItem(tabPosition);
            getShopData(ConstantParams.CONSTANT_PARAMS_1);
        } else if (view.getId() == R.id.ll_report_search_no) {
            tabPosition = 1;
            this.setSelectedItem(tabPosition);
            getShopData(ConstantParams.CONSTANT_PARAMS_2);
        } else if (view.getId() == R.id.ll_report_search_yes) {
            tabPosition = 2;
            this.setSelectedItem(tabPosition);
            getShopData(ConstantParams.CONSTANT_PARAMS_3);
        }
    }

    @Override
    public void onAdapterItemClick(int position, boolean clickable) {
        if (clickable) {
            Intent intent = new Intent(GoodsAuditingStatusActivity.this, GoodsAuditingDetailsActivity.class);
            intent.putExtra("branchTitle", branchTitle);
            intent.putExtra("storeNo", storeNo);
            intent.putExtra("orderBrandId", list.get(position).getOrderBrandId());
            intent.putExtra("mOrderGoodsAuditEntity", list.get(position));
            startActivity(intent);
        }
    }
}