package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.yxgj.model.BrandList;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.OrderGoodsAuditEntity;

import java.util.List;

class GoodsAuditingStatusAdapter extends BaseAdapter {
    private List<OrderGoodsAuditEntity> list;
    private List<BrandList> brandList;
    private Context context;
    private onAdapterItemClick listener;

    public interface onAdapterItemClick {
        void onAdapterItemClick(int position, boolean clickable);
    }

    GoodsAuditingStatusAdapter(List<OrderGoodsAuditEntity> list, List<BrandList> brandList, Context context, onAdapterItemClick listener) {
        this.list = list;
        this.brandList = brandList;
        this.context = context;
        this.listener = listener;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.second_auditing_goods_item, null);
            viewHolder = new ViewHolder();
            viewHolder.itemly = (LinearLayout) convertView.findViewById(R.id.second_auditinggoods_item_ll);
            viewHolder.store = (TextView) convertView.findViewById(R.id.auditing_store);
            viewHolder.status = (TextView) convertView.findViewById(R.id.auditing_status);
            viewHolder.addOrderStatus = convertView.findViewById(R.id.add_order_status);
            viewHolder.itemCount = (TextView) convertView.findViewById(R.id.pingxiang_dnum);
            viewHolder.amount = (TextView) convertView.findViewById(R.id.auditing_price);
            viewHolder.lastSales = (TextView) convertView.findViewById(R.id.last_sales);
            viewHolder.date = (TextView) convertView.findViewById(R.id.auditing_date);
            viewHolder.condition = (TextView) convertView.findViewById(R.id.auditing_condition);
            viewHolder.bill = (TextView) convertView.findViewById(R.id.auditing_num);
            viewHolder.isExamine = (TextView) convertView.findViewById(R.id.is_examine);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        OrderGoodsAuditEntity ent = list.get(position);
        viewHolder.store.setText(ent.getStoreName());
        viewHolder.itemCount.setText("品项数  " + ent.getTypeNum() + "");
        viewHolder.amount.setText("订货金额  ￥" + ent.getOrderGoodsAuditAmount() + "");
        viewHolder.lastSales.setText("近30天销售  ￥" + ent.getSaleAmount() + "");
        viewHolder.date.setText("制单日期  " + ent.getSetOrderDate() + "");
        viewHolder.bill.setText("订单单号  " + ent.getOrderGoodsBillCode() + "'");
        viewHolder.condition.setText(ent.getOrderGoodsAuditState());

        if (2 == list.get(position).getOrderstate()){//1正常订货  2加单
            viewHolder.addOrderStatus.setVisibility(View.VISIBLE);
            viewHolder.addOrderStatus.setText("加单");
        }else{
            viewHolder.addOrderStatus.setVisibility(View.GONE);
        }
        viewHolder.addOrderStatus.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_orange_round_fill_nomal));


        if ("8".equals(list.get(position).getOrderBrandId())) {
            viewHolder.status.setText("磨粉");
        } else if ("15".equals(list.get(position).getOrderBrandId())) {
            viewHolder.status.setText("食补集");
        } else {
            viewHolder.status.setText("未知");
        }
        if ("待审核".equals(list.get(position).getOrderGoodsAuditState())) {
            viewHolder.isExamine.setText("去审核");
            viewHolder.condition.setText("待审核");
        } else {
            viewHolder.isExamine.setText("查看详情");
            if (list.get(position).getOrderGoodsAuditState().contains("作废")) {
                viewHolder.condition.setText("已作废");
            } else {
                viewHolder.condition.setText("待复核");
            }
        }
        //判断当前用户的所属品牌，只能审核自己品牌的订货单
        if (new Gson().toJson(brandList).contains(list.get(position).getOrderBrandId())) {
            viewHolder.status.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_orange_round_fill_nomal));
            viewHolder.itemly.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    listener.onAdapterItemClick(position, true);
                }
            });
        } else {
            viewHolder.status.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_gary_round_fill_nomal));
            viewHolder.isExamine.setBackground(ContextCompat.getDrawable(context, R.drawable.btn_gary_round_fill_nomal));
            if ("待审核".equals(list.get(position).getOrderGoodsAuditState())) {
                viewHolder.isExamine.setVisibility(View.INVISIBLE);
            }
            viewHolder.itemly.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    listener.onAdapterItemClick(position, false);
                }
            });
        }
        return convertView;
    }

    class ViewHolder {
        LinearLayout itemly;
        TextView store;
        TextView status;
        TextView addOrderStatus;//加单
        TextView itemCount;
        TextView amount;
        TextView lastSales;
        TextView date;
        TextView condition;
        TextView bill;
        TextView isExamine;
    }
}