package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.content.ContextCompat;
import android.support.v4.view.ViewPager;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.AssetsUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckDetailsList;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckDetailsListEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsDetailsGroup;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

import static android.support.design.widget.TabLayout.MODE_SCROLLABLE;

/**
 * 货品管理--存货盘点：（第二页）明细
 */
@SuppressWarnings("all")
public class GoodsStockCheckDetailsActivity extends BaseParentAct implements ViewPager.OnPageChangeListener, GoodsStockCheckTablayoutListFragment.OnTestListener {
    private List<StockGoodsDetailsGroup> stockGoodsDetailsGroups;
    private TextView submitModifyTv;
    private TextView submitConformTv;
    private TextView pdAmountTv;
    private TextView pdDiffNumTv;
    private LinearLayout submitLl;

    private TabLayout mTablayout;
    private ViewPager mViewPager;
    /**
     * TabLayout中的tab标题
     */
    private List<String> mTitles;
    /**
     * 填充到ViewPager中的Fragment
     */
    private List<Fragment> fragmentList;
    /**
     * 0，五谷磨房；1，食补集
     */
    private int type;
    private int pdId;
    /**
     * 盘点图片
     */
    private String inventoryImages;
    private String pdBillCode;
    /**
     * 盘点状态:OE
     */
    private String pdState;
    /**
     * 盘点状态
     */
    private String checkFlag;
    /**
     * 是否可以修改盘点按钮:1可修改/2不可修改
     */
    private String isOrNotUpdateFlag;
    /**
     * 是否可以修改盘点按钮提示
     */
    private String isOrNotUpdateDesc;
    /**
     * 查询的月份
     */
    private String yearMonth;
    /**
     * 选中的月份
     */
    private String checkoutYM;
    /**
     * 0，查询；1，可修改；2，正在编辑
     */
    private int editMode;

    private String storeName;

    private String mPdAmount;
    private String mPdDiffAmount;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.good_stock_check_detail_view);
        initTitle();
        initData();
        initContent();
        getShopData();
//        getDataFromLocal();
    }

    private void getDataFromLocal() {
        String msg = AssetsUtil.getFromAssets(this, "GoodsCheckListVIewData.json");
        StockGoodsCheckDetailsListEntity mGoodsCheckListVIewData = new Gson().fromJson(msg, StockGoodsCheckDetailsListEntity.class);
        Log.d(TAG, "GoodsCheckListVIewData=" + mGoodsCheckListVIewData.toString());
        if (!mGoodsCheckListVIewData.getResultList().isEmpty()) {
            setData(mGoodsCheckListVIewData);
        }
    }

    private void getShopData() {
        showDialog();
        if (null != userInfo) {
            pdId = getIntent().getIntExtra("pdId", 0);
            pdBillCode = getIntent().getStringExtra("pdBillCode");
            String url = NetworkParams.URL_FIND_STOCKGOODS_CHECK_DEATILS;
            GoodsManagerService.getInstance().requestFindStockGoodsCheckDeatils(url, pdId + "", GoodsStockCheckDetailsActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("门店盘点明细");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        LinearLayout titleMoreLl = (LinearLayout) findViewById(R.id.title_more_ll);
        titleMoreLl.setVisibility(View.VISIBLE);
        TextView reportDetailTitle = (TextView) findViewById(R.id.report_detail_title);
        TextView reportDetailDate = (TextView) findViewById(R.id.report_detail_date);
        submitLl = (LinearLayout) findViewById(R.id.submit_ll);
        submitModifyTv = (TextView) findViewById(R.id.submit_modify_tv);
        submitConformTv = (TextView) findViewById(R.id.submit_conform_tv);
        pdAmountTv = (TextView) findViewById(R.id.pd_amount_tv);
        pdDiffNumTv = (TextView) findViewById(R.id.pd_diff_num_tv);
        reportDetailTitle.setVisibility(View.VISIBLE);
        reportDetailDate.setVisibility(View.VISIBLE);
        storeName = "" + storeName + "|";
        reportDetailTitle.setText(storeName);
        checkoutYM = "" + (yearMonth.substring(0, 4) + "年" + yearMonth.substring(4, 6)) + "月";
        reportDetailDate.setText(checkoutYM);
        submitConformTv.setText("下一步");
        //3秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(submitModifyTv).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                checkMode();
                //所有fragment刷新一遍
                for (int i = 0; i < stockGoodsDetailsGroups.size(); i++) {
                    ((GoodsStockCheckTablayoutListFragment) fragmentList.get(i)).refreash(editMode);
                }
            }
        });
        //5秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(submitConformTv).throttleFirst(5, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                stockGoodsCheck();
            }
        });
        mTablayout = (TabLayout) findViewById(R.id.tab_layout);
        mViewPager = (ViewPager) findViewById(R.id.viewpager);
        mViewPager.setOffscreenPageLimit(3);
    }

    private void initData() {
        storeName = getIntent().getStringExtra("storeName");
        yearMonth = getIntent().getStringExtra("yearMonth");
        checkFlag = getIntent().getStringExtra("checkFlag");
        pdState = getIntent().getStringExtra("pdState");
        isOrNotUpdateFlag = getIntent().getStringExtra("isOrNotUpdateFlag");
        isOrNotUpdateDesc = getIntent().getStringExtra("isOrNotUpdateDesc");
        inventoryImages = getIntent().getStringExtra("inventoryImages");
        editMode = checkMode(isOrNotUpdateFlag);
    }


    private void setData(StockGoodsCheckDetailsListEntity item) {
        //初始化标题
        mTitles = new ArrayList<>();
        //初始化填充到ViewPager中的Fragment集合
        fragmentList = new ArrayList<>();
        //盘点数据
        stockGoodsDetailsGroups = item.getResultList();
        if (null != stockGoodsDetailsGroups && !stockGoodsDetailsGroups.isEmpty()) {
            //合计
            countTotal(stockGoodsDetailsGroups);
            //初始化模式
            editMode = checkMode();
            if (stockGoodsDetailsGroups.size() < 2) {
                mTablayout.setVisibility(View.GONE);
            }
            for (int i = 0; i < stockGoodsDetailsGroups.size(); i++) {
                if (StringUtil.isNullString(stockGoodsDetailsGroups.get(i).getProBrandName())) {
                    mTitles.add("其它");
                } else {
                    mTitles.add(stockGoodsDetailsGroups.get(i).getProBrandName());
                }
                Bundle mBundle = new Bundle();
                mBundle.putInt("flag", i);
                mBundle.putInt("editMode", editMode);
                mBundle.putString("yearMonth", yearMonth);
                GoodsStockCheckTablayoutListFragment mFragment = new GoodsStockCheckTablayoutListFragment();
                mFragment.setAllData(stockGoodsDetailsGroups);
                mFragment.setArguments(mBundle);
                fragmentList.add(i, mFragment);
            }
            // 对各种控件进行设置、适配、填充数据
            configViews();
        }
    }

    private void configViews() {
        // 初始化ViewPager的适配器，并设置给它
        AddProductsTablayoutViewPagerAdapter mViewPagerAdapter = new AddProductsTablayoutViewPagerAdapter(getSupportFragmentManager(), mTitles, fragmentList);
        mViewPager.setAdapter(mViewPagerAdapter);
        // 设置ViewPager最大缓存的页面个数
        mViewPager.setOffscreenPageLimit(3);
        // 给ViewPager添加页面动态监听器（为了让Toolbar中的Title可以变化相应的Tab的标题）
        mViewPager.addOnPageChangeListener(this);

        mTablayout.setTabMode(MODE_SCROLLABLE);
        // 设置TabLayout的指示器高度为0，即达到了隐藏Indicator的目的
        mTablayout.setSelectedTabIndicatorHeight(0);
        mTablayout.setBackgroundColor(getResources().getColor(R.color.white));
        // 将TabLayout和ViewPager进行关联，让两者联动起来
        mTablayout.setupWithViewPager(mViewPager);
        // 设置Tablayout的Tab显示ViewPager的适配器中的getPageTitle函数获取到的标题
        mTablayout.setTabsFromPagerAdapter(mViewPagerAdapter);
    }

    @Override
    public void onPageSelected(int position) {
        mTablayout.newTab().setText(mTitles.get(position));
    }

    @Override
    public void onPageScrolled(int position, float positionOffset, int positionOffsetPixels) {

    }

    @Override
    public void onPageScrollStateChanged(int state) {

    }

    /**
     * 选择模式转换
     */
    private int checkMode() {
        if (editMode == 0) {
            submitLl.setVisibility(View.VISIBLE);
            submitModifyTv.setVisibility(View.VISIBLE);
            submitModifyTv.setText("不可修改");
            submitModifyTv.setBackgroundColor(ContextCompat.getColor(this, R.color.bg_color));
            submitConformTv.setVisibility(View.GONE);
            showTipDialog(isOrNotUpdateDesc);
        } else if (editMode == 1) {
            submitLl.setVisibility(View.VISIBLE);
            submitModifyTv.setVisibility(View.VISIBLE);
            submitConformTv.setVisibility(View.GONE);
            editMode = 2;
        } else if (editMode == 2) {
            submitLl.setVisibility(View.VISIBLE);
            submitModifyTv.setVisibility(View.GONE);
            submitConformTv.setVisibility(View.VISIBLE);
            editMode = checkMode(isOrNotUpdateFlag);
        }
        return editMode;
    }

    private void showTipDialog(String isOrNotUpdateDesc) {
        final PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
        builder.setMessage(isOrNotUpdateDesc);
        builder.setTitle("提示");
        builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    /**
     * 如果是已盘点状态，当月的盘点当月任意时间都可改,每月5日前可修改上月盘点，可以修改盘点数量
     *
     * @param isOrNotUpdateFlag 是否可以修改盘点按钮:1可修改/2不可修改
     * @return 返回编辑模式 0，查询；1，可修改；2，正在编辑
     */
    private int checkMode(String isOrNotUpdateFlag) {
        return ConstantParams.CONSTANT_PARAMS_1.equals(isOrNotUpdateFlag) ? 1 : 0;
    }

    /**
     * 组装盘点修改数据
     *
     * @param mStockGoodsCheckDetailsList 盘点修改数据
     */
    private void stockGoodsCheck() {
        //数据转换
        List<StockGoodsCheckDetailsList> mStockGoodsCheckDetailsList = new ArrayList<>();
        if (null != stockGoodsDetailsGroups && !stockGoodsDetailsGroups.isEmpty()) {
            for (int i = 0; i < stockGoodsDetailsGroups.size(); i++) {
                mStockGoodsCheckDetailsList.addAll(stockGoodsDetailsGroups.get(i).getStockGoodsCheckDetailsList());
            }
        }
        List<StockGoodsCheckDetailsList> mUpdataStockGoodsCheckDetailsList = new ArrayList<>();
        for (int i = 0; i < mStockGoodsCheckDetailsList.size(); i++) {
            if (!TextUtils.isEmpty(mStockGoodsCheckDetailsList.get(i).getPdAlterNum())) {
                mStockGoodsCheckDetailsList.get(i).setUserNo(userInfo.getStaffId());
                mStockGoodsCheckDetailsList.get(i).setPdStatus(pdState);
                mUpdataStockGoodsCheckDetailsList.add(mStockGoodsCheckDetailsList.get(i));
                if (TextUtils.isEmpty(mStockGoodsCheckDetailsList.get(i).getPdUpdateReson())) {
                    showMsg("填写数量后，修改原因必须填写哦!");
                    return;
                }
            }
        }
        //将盘点数据传入下个盘点图片选择页面
        Intent intent = new Intent(GoodsStockCheckDetailsActivity.this, GoodsStockCheckPicturesActivity.class);
        intent.putExtra("storeName", storeName);
        intent.putExtra("yearMonth", checkoutYM);
        intent.putExtra("mPdAmount", mPdAmount);
        intent.putExtra("mPdDiffAmount", mPdDiffAmount);
        intent.putExtra("pdState", pdState);
        intent.putExtra("pdId", pdId);
        intent.putExtra("pdBillCode", pdBillCode);
        intent.putExtra("inventoryImages", inventoryImages);
        intent.putExtra("stockGoodsDetailsGroups", (Serializable) stockGoodsDetailsGroups);
        startActivity(intent);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.GoodsManager.MSG_ON_FIND_STOCKGOODS_CHECK_DEATILS: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        StockGoodsCheckDetailsListEntity mStockGoodsCheckDetailsListEntity = new Gson().fromJson(msg, StockGoodsCheckDetailsListEntity.class);
                        Log.d(TAG, "mStockGoodsCheckDetailsListEntity=" + mStockGoodsCheckDetailsListEntity.toString());
                        if (!mStockGoodsCheckDetailsListEntity.getResultList().isEmpty()) {
                            setData(mStockGoodsCheckDetailsListEntity);
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void showError(String error) {
        showMsg(error);
    }

    @Override
    public void countTotal(List<StockGoodsDetailsGroup> mlist) {
        double pdAmount = 0;
        double pdDiffAmount = 0;
        for (int i = 0; i < mlist.size(); i++) {
            for (int j = 0; j < mlist.get(i).getStockGoodsCheckDetailsList().size(); j++) {
                pdAmount += mlist.get(i).getStockGoodsCheckDetailsList().get(j).getPdAmount();
                pdDiffAmount += mlist.get(i).getStockGoodsCheckDetailsList().get(j).getPdDiffAmount();
            }
        }
        mPdAmount = "实盘金额：" + StringUtil.formatDouble(pdAmount, "0.00") + "";
        mPdDiffAmount = "差异金额：" + StringUtil.formatDouble(pdDiffAmount, "0.00") + "";
        pdAmountTv.setText(mPdAmount);
        pdDiffNumTv.setText(mPdDiffAmount);
    }
}