package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Intent;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckList;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckListEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckshopListEntity;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.widgets.Dialog.DatePickerYearMonthDialog;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.List;

/**
 * 货品管理--存货盘点（第一页）：门店列表
 */
@Route(path = RouterParams.URL_GOODSSTOCKCHECKSHOPLISTACTIVITY)
public class GoodsStockCheckShopListActivity extends SelectorBaseActivity implements View.OnClickListener {

    private List<StockGoodsCheckList> list;
    private GoodsStockCheckShopListAdapter adapter;
    private TextView audingGoodsTitle;
    private TextView onclickTitle;
    /**
     * 用来显示选择月份
     */
    private String yearMonth;
    /**
     * 盘点状态
     */
    private String checkFlag;

    @Override
    protected void onResume() {
        super.onResume();
        getShopData(yearMonth);
    }

    /**
     * 查询指定日期的盘点门店数据
     *
     * @param date 待查询的日期
     */
    private void getShopData(String date) {
        audingGoodsTitle.setText("");
        showDialog();
        if (null != userInfo) {
            //清空数据，保证每次显示的都是接口返回的数据
            list.clear();
            adapter.notifyDataSetChanged();
            String url = NetworkParams.URL_FIND_STOCKGOODS_CHECK_STORE;
            String staffId = userInfo.getStaffId();
            //将显示"yyyy年M月"日期格式转化为请求接口需要的"yyyyMM"格式
            yearMonth = date;
            GoodsManagerService.getInstance().requestFindStockGoodsCheckStore(url, staffId, yearMonth, GoodsStockCheckShopListActivity.this);
        }
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("盘点查询");
    }

    @Override
    protected void initContent() {
        EventBus.getDefault().register(this);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        storeNameEt = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameEt.setVisibility(View.VISIBLE);
        audingGoodsTitle = (TextView) findViewById(R.id.onclick_name);
        audingGoodsTitle.setGravity(Gravity.CENTER);
        LinearLayout titleMoreLl = (LinearLayout) findViewById(R.id.title_more_ll);
        titleMoreLl.setVisibility(View.VISIBLE);
        TextView onclickName = (TextView) findViewById(R.id.report_detail_title);
        onclickTitle = (TextView) findViewById(R.id.report_detail_date);
        LinearLayout onclickTitleLl = (LinearLayout) findViewById(R.id.onclick_title_ll);
        storeNameEt.setVisibility(View.GONE);
        onclickName.setVisibility(View.VISIBLE);
        onclickTitle.setVisibility(View.VISIBLE);
        audingGoodsTitle.setVisibility(View.VISIBLE);
        onclickTitleLl.setVisibility(View.VISIBLE);
        if (null != userInfo) {
            onclickName.setText("" + userInfo.getName() + "|全部门店|");
        }
        yearMonth = DateUtil.getFormatMonth("yyyyMM", -1);
        String mDate = (yearMonth.substring(0, 4) + "年" + yearMonth.substring(4, 6)) + "月";
        //默认条件查上个月的
        onclickTitle.setText(mDate);
        titleMoreLl.setOnClickListener(this);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        list = new ArrayList<>();
        adapter = new GoodsStockCheckShopListAdapter(list, this);
        mListView.setAdapter(adapter);
        mListView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                //盘点状态
                checkFlag = list.get(position).getCheckFlag();
                Intent intent = new Intent(GoodsStockCheckShopListActivity.this, GoodsStockCheckDetailsActivity.class);
                intent.putExtra("pdId", list.get(position).getPdId());
                intent.putExtra("pdBillCode", list.get(position).getPdBillCode());
                intent.putExtra("storeName", list.get(position).getStoreName());
                intent.putExtra("pdState", list.get(position).getPdState());
                intent.putExtra("isOrNotUpdateFlag", list.get(position).getIsOrNotUpdateFlag());
                intent.putExtra("isOrNotUpdateDesc", list.get(position).getNotUpdateReasonDesc());
                intent.putExtra("inventoryImages", list.get(position).getInventoryImages());
                intent.putExtra("yearMonth", yearMonth);
                intent.putExtra("checkFlag", checkFlag);
                startActivity(intent);
            }
        });
    }

    @Subscribe
    public void onEventMainThread(StockGoodsCheckListEntity item) {
        if (item != null && !item.getResultList().isEmpty()) {
            StockGoodsCheckshopListEntity resultData = item.getResultList().get(0);
            //总门店数
            int sumStoreNum = resultData.getSumStoreNum();
            //已经盘点门店数
            int alreadyStoreNum = resultData.getAlreadyStoreNum();
            //未盘点门店数
            int noTStoreNum = resultData.getNoTStoreNum();
            audingGoodsTitle.setVisibility(View.VISIBLE);
            audingGoodsTitle.setText("总门店数:" + sumStoreNum + "  " + "已盘点:" + alreadyStoreNum + "  " + "未盘点:" + noTStoreNum + "  ");
            //清空数据，保证每次显示的都是接口返回的数据
            list.clear();
            list.addAll(resultData.getStockGoodsCheckList());
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.GoodsManager.MSG_ON_FIND_STOCKGOODS_CHECK_STORE: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        StockGoodsCheckListEntity mStockGoodsCheckListEntity = new Gson().fromJson(msg, StockGoodsCheckListEntity.class);
                        Log.d(TAG, "mStockGoodsCheckListEntity=" + mStockGoodsCheckListEntity.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mStockGoodsCheckListEntity.retCode)) {
                            if (!mStockGoodsCheckListEntity.getResultList().isEmpty()) {
                                EventBus.getDefault().post(mStockGoodsCheckListEntity);
                            }
                        } else {
                            showMsg(mStockGoodsCheckListEntity.retInfo);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.title_more_ll) {
            //选择日期
            orderDatePickFrom();
        }
    }

    /**
     * 选择日期
     */
    public void orderDatePickFrom() {
        new DatePickerYearMonthDialog(this, new DatePickerYearMonthDialog.OnDateSetListener() {
            @Override
            public void onDateSet(int year, int monthOfYear) {
                //这里月份要发送出去的，格式上要2位数
                yearMonth = String.format("%04d%02d", year, monthOfYear + 1);
                String mDate = (yearMonth.substring(0, 4) + "年" + yearMonth.substring(4, 6)) + "月";
                onclickTitle.setText(mDate);
                //当用户选择完年月之后，进行查询操作
                getShopData(yearMonth);
            }
        }).show();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}
