package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsCheckList;

import java.util.List;

class GoodsStockCheckShopListAdapter extends BaseAdapter {

    private List<StockGoodsCheckList> list;
    private Context context;

    GoodsStockCheckShopListAdapter(List<StockGoodsCheckList> mlist, Context context) {
        this.list = mlist;
        this.context = context;
    }

    @Override
    public int getCount() {

        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {

        return list == null ? null : list.get(position);
    }

    @Override
    public long getItemId(int position) {

        return position;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.stockgoods_shop_item, null);
            viewHolder = new ViewHolder();
            viewHolder.store = (TextView) convertView.findViewById(R.id.stockgoods_check_store);
            viewHolder.examine = (TextView) convertView.findViewById(R.id.stockgoods_check_is_examine);
            viewHolder.pdAmount = (TextView) convertView.findViewById(R.id.stockgoods_check_pdbillcode);
            viewHolder.pdNum = (TextView) convertView.findViewById(R.id.stockgoods_check_pdamount);
            viewHolder.diffamount = (TextView) convertView.findViewById(R.id.stockgoods_check_diffamount);
            viewHolder.deductmarks = (TextView) convertView.findViewById(R.id.stockgoods_check_deductmarks);
            viewHolder.row = (ImageView) convertView.findViewById(R.id.stockgoods_check_row);

            viewHolder.stockgoodsCheckDeitailsLl1 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll1);
            viewHolder.stockgoodsCheckDeitailsLl2 = (LinearLayout) convertView.findViewById(R.id.stockgoods_check_deitails_ll2);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        StockGoodsCheckList ent = list.get(position);
        viewHolder.store.setText(ent.getStoreName());

        //CheckFlag标志：1,未盘点;2,已盘点;3,生效;4,不可盘点
        //PdState状态：草稿、待审核、生效
        if (ConstantParams.CONSTANT_PARAMS_1.equals(ent.getCheckFlag())) {
            viewHolder.examine.setText("未盘点");
            viewHolder.row.setVisibility(View.INVISIBLE);
            viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.GONE);
            viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.GONE);
            viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.red));
        } else {
            if (ConstantParams.CONSTANT_PARAMS_2.equals(ent.getCheckFlag())) {
                viewHolder.examine.setText("已盘点");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.assist_green_txt));
            } else if (ConstantParams.CONSTANT_PARAMS_3.equals(ent.getCheckFlag())) {
                viewHolder.examine.setText("生效");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.normal_color));
            } else if (ConstantParams.CONSTANT_PARAMS_4.equals(ent.getCheckFlag())) {
                viewHolder.examine.setText("不可盘点");
                viewHolder.examine.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
            }
            viewHolder.stockgoodsCheckDeitailsLl1.setVisibility(View.VISIBLE);
            viewHolder.stockgoodsCheckDeitailsLl2.setVisibility(View.VISIBLE);
            viewHolder.row.setVisibility(View.VISIBLE);
            viewHolder.pdAmount.setText("实盘总金额:" + ent.getPdAmount() + "");
            viewHolder.pdNum.setText("实盘总数量:" + ent.getPdNum() + "");
            viewHolder.diffamount.setText("本期盈亏金额:" + ent.getDiffAmount() + "");
            viewHolder.deductmarks.setText("扣分:" + ent.getDeductMarks() + "");
        }
        return convertView;
    }

    class ViewHolder {
        ImageView row;
        TextView store;
        /**
         * 盘点状态
         */
        TextView examine;
        /**
         * 实盘总金额
         */
        TextView pdAmount;
        /**
         * 实盘总数量
         */
        TextView pdNum;
        /**
         * 本期盈亏金额
         */
        TextView diffamount;
        /**
         * 扣分
         */
        TextView deductmarks;
        LinearLayout stockgoodsCheckDeitailsLl1;
        LinearLayout stockgoodsCheckDeitailsLl2;
    }
}
