package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;

import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.StockGoodsDetailsGroup;

import java.util.List;

/**
 * 订货审核添加产品分页
 *
 * @author XiePing
 */
public class GoodsStockCheckTablayoutListFragment extends Fragment implements GoodsStockCheckDetailsListAdapter.ModifyNumClickListener {
    private ListView orderListLv;//界面的展示列表
    private GoodsStockCheckDetailsListAdapter goodsStockCheckDetailsListAdapter;
    private List<StockGoodsDetailsGroup> stockGoodsDetailsGroups;
    private String yearMonth;
    private int editMode;
    private int flag;
    private OnTestListener mCallback;

    public interface OnTestListener {
        void showError(String error);

        void countTotal(List<StockGoodsDetailsGroup> mlist);
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        yearMonth = (String) getArguments().get("yearMonth");
        editMode = (int) getArguments().get("editMode");
        flag = (int) getArguments().get("flag");
    }

    @Override
    public void onActivityCreated(@Nullable Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        mCallback = (OnTestListener) getActivity();
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.list_check_goods_tab, null);
        orderListLv = (ListView) view.findViewById(R.id.product_view_lv);
        goodsStockCheckDetailsListAdapter = new GoodsStockCheckDetailsListAdapter(stockGoodsDetailsGroups, getActivity(), this, yearMonth);
        orderListLv.setAdapter(goodsStockCheckDetailsListAdapter);
        goodsStockCheckDetailsListAdapter.setAdapterMode(editMode);
        goodsStockCheckDetailsListAdapter.setAdapterData(stockGoodsDetailsGroups, flag);
        return view;
    }

    @Override
    public void onModifyNumClickListener(List<StockGoodsDetailsGroup> mlist) {
        mCallback.countTotal(mlist);
    }

    @Override
    public void onModifyNumClickListener(String error) {
        mCallback.showError(error);
    }

    public void setAllData(List<StockGoodsDetailsGroup> stockGoodsDetailsGroups) {
        this.stockGoodsDetailsGroups = stockGoodsDetailsGroups;
    }

    public void refreash(int editMode) {
        goodsStockCheckDetailsListAdapter = new GoodsStockCheckDetailsListAdapter(stockGoodsDetailsGroups, getActivity(), this, yearMonth);
        orderListLv.setAdapter(goodsStockCheckDetailsListAdapter);
        goodsStockCheckDetailsListAdapter.setAdapterMode(editMode);
        goodsStockCheckDetailsListAdapter.setAdapterData(stockGoodsDetailsGroups, flag);
        goodsStockCheckDetailsListAdapter.notifyDataSetChanged();
    }
}