package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutNumLists;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutNumListEntity;

import java.util.List;

/**
 * 货品调入调出查询明细
 */
class GoodsTransferredInOrOutDetailsAdapter extends BaseExpandableListAdapter {
    private List<ProductTransferredInAndOutNumLists> list;
    private Context context;

    GoodsTransferredInOrOutDetailsAdapter(
            List<ProductTransferredInAndOutNumLists> list, Context context) {
        this.list = list;
        this.context = context;
    }

    @Override
    public int getGroupCount() {
        return list == null ? 0 :list.size();
    }

    @Override
    public int getChildrenCount(int groupPosition) {
        return list.get(groupPosition).getProductTransferredInAndOutNumList() == null ? 0 :list.get(groupPosition).getProductTransferredInAndOutNumList().size();
    }

    @Override
    public Object getGroup(int groupPosition) {
        return groupPosition;
    }

    @Override
    public Object getChild(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public long getGroupId(int groupPosition) {
        return groupPosition;
    }

    @Override
    public long getChildId(int groupPosition, int childPosition) {
        return childPosition;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
        final GroupViewHolder groupViewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_goods_transferred_inorout_details_view1, null);
            groupViewHolder = new GroupViewHolder();
            groupViewHolder.tansferedDate = (TextView) convertView.findViewById(R.id.tansfered_date_tv);
            groupViewHolder.tansferedPeople = (TextView) convertView.findViewById(R.id.tansfered_people_tv);
            groupViewHolder.storeIn = (TextView) convertView.findViewById(R.id.transfer_in_shop_name_txt);
            groupViewHolder.storeOut = (TextView) convertView.findViewById(R.id.transfer_out_shop_name_txt);
            convertView.setTag(groupViewHolder);
        } else {
            groupViewHolder = (GroupViewHolder) convertView.getTag();
        }
        ProductTransferredInAndOutNumLists ent = list.get(groupPosition);
        groupViewHolder.tansferedDate.setText(ent.getTransferredInAndOutDate());
        groupViewHolder.tansferedPeople.setText(ent.getTransferredPerson());
        groupViewHolder.storeIn.setText(ent.getTransferredInStoreName());
        groupViewHolder.storeOut.setText(ent.getTransferredOutStoreName());
        return convertView;
    }

    @Override
    public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView, ViewGroup parent) {
        final ChildViewHolder childViewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_item_goods_transferred_inorout_details_view2, null);
            childViewHolder = new ChildViewHolder();
            childViewHolder.tansferedPro = (TextView) convertView.findViewById(R.id.tansfered_pro_tv);
            childViewHolder.tansferedProNum = (TextView) convertView.findViewById(R.id.tansfered_pro_num_tv);
            convertView.setTag(childViewHolder);
        } else {
            childViewHolder = (ChildViewHolder) convertView.getTag();
        }
        ProductTransferredInAndOutNumListEntity ent = list.get(groupPosition).getProductTransferredInAndOutNumList().get(childPosition);
        childViewHolder.tansferedPro.setText(ent.getFixedProduct().getProductName() + "(" + ent.getFixedProduct().getProductCode() + ")");
        childViewHolder.tansferedProNum.setText("" + ent.getTransferredInAndOutNum() + "");
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int groupPosition, int childPosition) {
        return true;
    }

    class GroupViewHolder {
        TextView tansferedDate;
        TextView tansferedPeople;
        TextView storeIn;
        TextView storeOut;
    }

    class ChildViewHolder {
        TextView tansferedPro;
        TextView tansferedProNum;
    }
}