package com.wgmf.yxgj.module.business.manageproduct.ui;

import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.module.business.manageproduct.R;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutShopEntity;
import com.wgmf.yxgj.module.business.manageproduct.model.ProductTransferredInAndOutShopList;
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService;
import com.xp.arouter.RouterParams;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 调入调出查询门店列表
 * 作者：xiep on 2016/12/1 14:41
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_GOODSTRANSFERREDINOROUTSHOPLISTACTIVITY)
public class GoodsTransferredInOrOutShopListActivity extends BaseParentAct implements AdapterView.OnItemClickListener {

    private static final int STATUS_NO = 1;
    private List<ProductTransferredInAndOutShopEntity> list;
    private GoodsTransferredInOrOutShopLisAdapter adapter;
    private TextView textQuireResault;
    private PopupWindow pw;
    private View showColor;
    private TextView orderdatefrom;
    private TextView orderdateto;
    private String beginTime;
    private String endTime;
    private boolean hasQuery = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_query_order_goods);
        initTitle();
        initView();
        queryAllotGoods();
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText("调入调出查询");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initView() {
        EventBus.getDefault().register(this);
        list = new ArrayList<>();
        textQuireResault = (TextView) findViewById(R.id.text_quire_resault);
        ListView mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        String date = DateUtil.getDate(new Date());
        beginTime = DateUtil.getFormatNowMonthBegin();
        endTime = date;
        textQuireResault.setText("全部门店" + "|" + beginTime + "至" + endTime);
        adapter = new GoodsTransferredInOrOutShopLisAdapter(list, this);
        mListView.setAdapter(adapter);
        mListView.setOnItemClickListener(this);
    }

    /**
     * 初始化popwindow
     *
     * @param v
     */
    private void initWindow(View v) {
        showColor = v.findViewById(R.id.out_view);
        orderdatefrom = (TextView) v.findViewById(R.id.order_date_from);
        orderdateto = (TextView) v.findViewById(R.id.order_date_to);
        TextView ordernum = (TextView) v.findViewById(R.id.order_num);
        String date = DateUtil.getDate(new Date());
        beginTime = date;
        endTime = date;
        orderdatefrom.setText(beginTime);
        orderdateto.setText(endTime);
    }

    /**
     * 显示popwindow
     */
    private void showPopWindow() {
        if (pw == null) {
            View v2 = getLayoutInflater().inflate(R.layout.order_goods_quire, null);
            initWindow(v2);
            pw = new PopupWindow(v2, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, true);
            pw.setFocusable(false);
            pw.setBackgroundDrawable(new BitmapDrawable());
            pw.setOutsideTouchable(false);
            showColor.setOnClickListener(new View.OnClickListener() {

                @Override
                public void onClick(View v) {
                    if (!hasQuery) {
                        return;
                    }
                    if (pw != null && pw.isShowing()) {
                        pw.dismiss();
                    }
                }
            });
        } else if (hasQuery) {
            showColor.setBackgroundColor(GoodsTransferredInOrOutShopListActivity.this.getResources().getColor(R.color.result_view));
        }
        pw.showAsDropDown(homeTitleText);
    }

    /**
     * 查询条件popwindow
     *
     * @param view
     */
    public void reQuire(View view) {
        try {
            showPopWindow();
        } catch (Exception e) {
            Log.e(TAG, "showPopWindow error");
        }
    }

    /**
     * 查询按钮
     *
     * @param view
     */
    public void storeOrderQuire(View view) {
        query();
    }

    /**
     * 显示查询条件布局
     */
    private void toSecondView() {
        hasQuery = true;
        if (pw != null && pw.isShowing()) {
            pw.dismiss();
        }
        beginTime = orderdatefrom.getText().toString();
        endTime = orderdateto.getText().toString();

        textQuireResault.setText("全部门店" + "|" + beginTime + "至" + endTime);
        textQuireResault.setVisibility(View.VISIBLE);
    }

    /**
     * 查询数据
     */
    private void query() {
        toSecondView();
        queryAllotGoods();
    }

    @Subscribe
    public void onEventMainThread(ProductTransferredInAndOutShopList item) {
        if (item != null && !item.getResultList().isEmpty()) {
            //清空数据，保证每次显示的都是接口返回的数据
            list.clear();
            list.addAll(item.getResultList());
            adapter.notifyDataSetChanged();
        }
    }

    /**
     * 调拨查询
     */
    private void queryAllotGoods() {
        list.clear();
        adapter.notifyDataSetChanged();

        if (userInfo != null) {
            showDialog();
            String url = NetworkParams.URL_FIND_TRANSFERRED_INANDOUT;
            String staffId = userInfo.getStaffId();
            GoodsManagerService.getInstance().requestFindTransferredInAndOut(url, staffId, beginTime, endTime, GoodsTransferredInOrOutShopListActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.GoodsManager.MSG_ON_FIND_TRANSFERRED_INANDOUT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ProductTransferredInAndOutShopList mProductTransferredInAndOutShopList = new Gson().fromJson(msg, ProductTransferredInAndOutShopList.class);
                        Log.d(TAG, "mProductTransferredInAndOutShopList=" + mProductTransferredInAndOutShopList.toString());
                        if (null!=mProductTransferredInAndOutShopList.getResultList()&&!mProductTransferredInAndOutShopList.getResultList().isEmpty()) {
                            EventBus.getDefault().post(mProductTransferredInAndOutShopList);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 查询起始日期
     *
     * @param view
     */
    public void orderDatePickFrom(View view) {
        DialogHelper.AlertDatePicker(this, this, orderdatefrom);
    }

    /**
     * 查询结束日期
     *
     * @param view
     */
    public void orderDatePickTo(View view) {
        DialogHelper.AlertDatePicker(this, this, orderdateto);
    }

    @Override
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        //调拨状态
        int status = list.get(position).getTransferredInOutFlag();
        Intent intent = new Intent(GoodsTransferredInOrOutShopListActivity.this, GoodsTransferredInOrOutDetailsActivity.class);
        intent.putExtra("storeNo", list.get(position).getShop().getShopId());
        intent.putExtra("storeName", list.get(position).getShop().getShopName());
        intent.putExtra("startDate", beginTime);
        intent.putExtra("endDate", endTime);
        intent.putExtra("status", status);

        // 如果有调拨，跳入下一级页面
        if (STATUS_NO != status) {
            startActivity(intent);
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }
}