package com.wgmf.yxgj.module.business.manageproduct.ui

import android.content.Context
import android.graphics.Color
import android.os.Bundle
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.alibaba.android.arouter.launcher.ARouter
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.HomeStockDetailEntity
import com.xp.arouter.RouterParams
import java.text.DecimalFormat

/**
 * @author Sasuke on 2020/5/5.
 *
 */
class HomeStockDetailAdapter(val context: Context, val data: HomeStockDetailEntity.Result?, val showLevel: Int/*1全国，3大区，4办事处，5主管*/) : RecyclerView.Adapter<HomeStockDetailAdapter.HomeStockHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup?, viewType: Int): HomeStockDetailAdapter.HomeStockHolder {
        return HomeStockHolder(LayoutInflater.from(context).inflate(R.layout.home_stock_detail_item, parent, false))
    }

    override fun getItemCount(): Int {
        return data?.homebusinessStockList?.size ?: 0
    }

    override fun onBindViewHolder(holder: HomeStockDetailAdapter.HomeStockHolder, position: Int) {
        val item = data?.homebusinessStockList?.get(position)
        holder.apply {
            rootLayout.setBackgroundColor(if (position % 2 != 0) Color.parseColor("#f9f9f9") else Color.WHITE)
            rightArrow.visibility = if (showLevel != 5 && position != itemCount - 1) View.VISIBLE else View.GONE

            storeNameTv.text = item?.orgName
            totalStockTv.text = DecimalFormat("0.##").format(item?.totalStock)
            instantStockTv.text = DecimalFormat("0.##").format(item?.instantStock)
            ontheWayStockTv.text = DecimalFormat("0.##").format(item?.ontheWayStock)

            if (showLevel != 5 && position != itemCount - 1){//主管是最后一级了，不需要点击跳转；最后一项是合计，也不需要点击
                rootLayout.setOnClickListener {
                    ARouter.getInstance().build(RouterParams.URL_HOMESTOCKDETAILACT)
                            .with(Bundle().apply {
                                putInt("showLevel",when(showLevel){//跳到下一级，就需要更新 showLevel
                                    1 -> 3
                                    3 -> 4
                                    4 -> 5
                                    else -> -1
                                })//1全国，3大区，4办事处，5主管
                                putString("productCode",data?.proNo)
                                putString("markeName",data?.marketName)
                                putString("code1",item?.code1)
                                putString("intentTitleProd",data?.proName)
                                putString("intentTitleStore","${data?.orgName ?:""}"
                                        +if (item?.orgName.isNullOrBlank())"" else ", ${item?.orgName ?:""}")//拼接上去
                            })
                            .navigation()
                }
            }
        }
    }

    class HomeStockHolder(view: View) : RecyclerView.ViewHolder(view) {
        val rootLayout = view.findViewById<LinearLayout>(R.id.rootLayout)
        val storeNameTv = view.findViewById<TextView>(R.id.storeNameTv)
        val totalStockTv = view.findViewById<TextView>(R.id.totalStockTv)
        val instantStockTv = view.findViewById<TextView>(R.id.instantStockTv)
        val ontheWayStockTv = view.findViewById<TextView>(R.id.ontheWayStockTv)
        var rightArrow = view.findViewById<ImageView>(R.id.rightArrow)

    }
}