package com.wgmf.yxgj.module.business.manageproduct.ui

import android.app.Activity
import android.app.AlertDialog
import android.content.DialogInterface
import android.content.Intent
import android.os.Bundle
import android.support.v4.view.ViewPager
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.gson.Gson
import com.wgmf.library.base.BaseResponse
import com.wgmf.library.utils.Arith
import com.wgmf.library.utils.Log
import com.wgmf.yxgj.base.BaseActivityTap
import com.wgmf.yxgj.dialog.LoadWaitDominator
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.DingHuoOplQtyEntity
import com.wgmf.yxgj.module.business.manageproduct.model.OrderSubmitReqBean
import com.wgmf.yxgj.module.business.manageproduct.service.GoodsManagerService
import com.wgmf.yxgj.utils.StringUtils
import com.wgmf.yxgj.utils.ViewUtil
import com.wgmf.yxgj.utils.helper.NetHelper
import com.wgmf.yxgj.widgets.AutoRadioGroup
import com.wgmf.yxgj.widgets.MyPagerAdapter
import com.xp.arouter.RouterParams
import kotlinx.android.synthetic.main.ordergoods_submit_act.*
import org.jetbrains.anko.find
import pro.xp.com.indexbar.IndexbarConfig
import java.text.MessageFormat
import java.text.SimpleDateFormat
import java.util.*
import kotlin.collections.ArrayList

/**
 * @author Sasuke on 2019/4/5.
 */
@Route(path = RouterParams.URL_ORDERGOODSSUBMITACT)
class OrderGoodsSubmitAct : BaseActivityTap() {
    var loadWait: LoadWaitDominator? = null
    var tapRadio: LinearLayout? = null
    var brandRadioGroup: AutoRadioGroup? = null
    var colRadioGroupList: MutableList<AutoRadioGroup> = mutableListOf()
    var pagerList: MutableList<View> = mutableListOf()
    var resultCache: DingHuoOplQtyEntity.ResultInfo? = null
    val WGMF_BRAND_ID = 8
    val XDY_BRAND_ID = 15

    //    val shopId:String ="0110005"
    val shopId by lazy { intent.getStringExtra("shopId") }
    val shopName by lazy { intent.getStringExtra("shopName") }

    //加单原因
    var mReason: String = ""

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.ordergoods_submit_act)
        init()
        query()
    }


    fun init() {
        titleLayout.find<TextView>(R.id.home_title_text).text = "订货加单"
        storeTv.text = "订货门店: ${shopName}"
        initBack()
        tapRadio = tapLayout.find(R.id.title_container_ll)
        brandRadioGroup = AutoRadioGroup(tapRadio!!)
        loadWait = LoadWaitDominator(this, containerLayout)
        submitBtn.setOnClickListener {
            val inputText = LayoutInflater.from(this@OrderGoodsSubmitAct).inflate(R.layout.alert_dialog_input, null)
            AlertDialog.Builder(this@OrderGoodsSubmitAct).setTitle("提醒")
                    .setView(inputText)
                    .setNegativeButton("取消", null)
                    .setPositiveButton("确定") { dialogInterface, i ->
                        val reason = inputText.findViewById<EditText>(R.id.inputText).text.toString().trim()
                        if (reason.isBlank()) {
                            showMsg("请填写加单原因！")
                            return@setPositiveButton
                        }
                        mReason = reason
                        checkBeforeSubmit()
                    }.show()


        }
    }

    fun query() {
        loadWait?.show(LoadWaitDominator.LOADING)
        GoodsManagerService.getInstance().requestAddOrderProductList(userInfo.staffId, shopId) {
            loadWait?.dismissAll()
            if (!isFinishing && it.isSuccessed) {
                var entity = Gson().fromJson(it.info, DingHuoOplQtyEntity::class.java)
                showOrderList(entity.result)
                return@requestAddOrderProductList
            }
            loadWait?.show(LoadWaitDominator.NET_ERROR)
        }
    }

    fun refreshUI(resultInfo: DingHuoOplQtyEntity.ResultInfo?) {
        //先存一份
        if (resultInfo?.list == null) return
        resultCache = resultInfo
        //初始化最顶栏
        titleLayout.visibility = if (resultInfo?.brandPage?.size == 1) View.VISIBLE else View.GONE
        tapLayout.visibility = if (resultInfo?.brandPage?.size == 1) View.GONE else View.VISIBLE
        //品牌大标签 只有一个品牌的情况
        if (resultInfo?.brandPage?.size == 1) {
            titleLayout.find<TextView>(R.id.home_title_text).text = resultInfo?.brandPage?.get(0)?.title
        }
        //先清一下（其实如果只走一遍好像也无所谓
        brandRadioGroup?.removeAllChild()
        colRadioGroupList?.forEach { it.removeAllChild() }
        viewpager.removeAllViews()
        pagerList.clear()
        //初始化顶部品牌标签+内容页（循环）=========================
        resultInfo?.brandPage?.forEach { brandItem ->
            //品牌大标签显示
            var radio: RadioButton = (layoutInflater.inflate(R.layout.tap_title_radio_btn, tapRadio, false) as RadioButton)
            brandRadioGroup?.addViewWithLayoutParams(radio, brandItem.title, 0, RadioGroup.LayoutParams.MATCH_PARENT) { pos -> viewpager.setCurrentItem(pos) }
            //数据内容页显示
            pagerList?.add(LayoutInflater.from(this).inflate(R.layout.ordergoods, null).apply {
                //                val dataList = mutableListOf<DingHuoOplQtyEntity.DinghuoDetail>().apply { addAll(resultInfo.list.filter { it.brandId == brandItem.type }) }
                //分类标签(只有 五谷磨房 才有小分类)
                var colRadioGroup = AutoRadioGroup(find(R.id.labelGroup))
                if (brandItem.type == WGMF_BRAND_ID) {
                    resultInfo.col.forEach { colItem ->
                        val radioButton = layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
                        colRadioGroup.addView(radioButton, colItem.title, { pos ->
                            //                            Log.i("SasukeLog","brandItem.type=${brandItem.type},colItem.type=${colItem.type }")
                            refreshRvByLabel(brandItem.type, colItem.type)//各标签的点击监听。
                        })
                    }
                }
                //加一个“全部”标签（无论什么品牌都要加）
                val radioButton = layoutInflater.inflate(R.layout.add_sell_radio_button, null) as RadioButton
                colRadioGroup?.addView(radioButton, "全部", {
                    refreshRvByLabel(brandItem.type, -1)
                })
                colRadioGroupList.add(colRadioGroup!!)
                //列表
                find<RecyclerView>(R.id.proLv).apply {
                    itemAnimator = null//一定要设，否则在 notifyItemChanged 刷新的时候会导致崩溃 https://blog.csdn.net/ming_ruo_xiao_xi/article/details/89499375
                    layoutManager = LinearLayoutManager(this@OrderGoodsSubmitAct)
                    adapter = OrderGoodsTradeAdapter(this@OrderGoodsSubmitAct, listOf()) { refreshPriceShow() }
                }
            })
        }
        //END 初始化顶部品牌标签+内容页（循环）=========================

        viewpager.adapter = MyPagerAdapter(this, ArrayList(pagerList))
        viewpager.setCurrentItem(0)
        viewpager.addOnPageChangeListener(object : ViewPager.OnPageChangeListener {
            override fun onPageScrollStateChanged(p0: Int) {}
            override fun onPageScrolled(p0: Int, p1: Float, p2: Int) {}
            override fun onPageSelected(pos: Int) {
                brandRadioGroup?.setChildChecked(pos)
            }
        })

        brandRadioGroup?.setChildChecked(0)
        colRadioGroupList.forEach { it.setChildChecked(0) }//要放在最后check，因为前面构造的时候，还没有添加到pager里面，直接check会崩。
    }

    /**
     * 根据上面的标签分类来过滤显示对应的列表
     */
    fun refreshRvByLabel(brand: Int, type: Int) {
        val currentPager = pagerList.get(resultCache?.brandPage?.indexOfFirst { it.type == brand }
                ?: 0)
        val currRv = currentPager.find<RecyclerView>(R.id.proLv)
        val adapter = currRv.adapter as OrderGoodsTradeAdapter
        adapter.notifyProByLabel(resultCache, brand, type)

        val indexbarConfig = IndexbarConfig(this,
                currentPager.find(R.id.product_index_bar),
                currentPager.find(R.id.tvSideBarHint),
                currRv,
                adapter.orderList).configDefault()
        indexbarConfig.toggleShowIndexBar(type == -1)//-1表示“全部”标签
        refreshPriceShow()
    }


    /**
     * 刷新价格显示
     */
    fun refreshPriceShow() {
        var invalidCount = 0
        var count = 0.0
        var countPrice = 0.0

        resultCache?.list?.forEach {
            if (it.isInvalid) invalidCount++
            count = Arith.add(count, it.getTQTY())
            countPrice = Arith.add(countPrice, it.getAmount())
        }
        totalCountTv.setText(StringUtils.formatDouble(count, "0.00"))
        totalPriceTv.setText(StringUtils.formatDouble(countPrice, "0.00"))
        if (invalidCount > 0) {
            submitBtn.isEnabled = false
            submitBtn.text = "您有 ${invalidCount} 条信息输入不合格,请重输！"
        } else {
            if (!submitBtn.isEnabled) {
                submitBtn.isEnabled = true
                submitBtn.text = "提交"
            }
        }
    }

    fun showOrderList(resultInfo: DingHuoOplQtyEntity.ResultInfo?) {
        if (isFinishing || resultInfo?.brandPage == null || resultInfo?.brandPage.isEmpty()) return
        refreshUI(resultInfo.apply { list.forEach { it.isShowAlert = true } })
    }

    /**
     * 提交前的校验
     */
    fun checkBeforeSubmit() {
        val choiceList = resultCache?.list?.filter { it.tqty > 0 } ?: listOf()
        val choiceWgmfList = resultCache?.list?.filter { it.tqty > 0 && it.brandId == WGMF_BRAND_ID }
                ?: listOf()
        val choiceXdyList = resultCache?.list?.filter { it.tqty > 0 && it.brandId == XDY_BRAND_ID }
                ?: listOf()

        if (!checkNumLimit(choiceList)) {
            AlertDialog.Builder(this)
                    .setMessage("六方订货总量必须是6的整数倍，请调整数量后重新提交！")
                    .setPositiveButton("我知道了", null)
                    .create().show()
            return
        }
        if (choiceList.isEmpty()) {
            showMsg("您没有选择任何订货产品!")
            return
        }
        //真正提交
        val info = "请确认是否提交整单订货！"
        val builder = AlertDialog.Builder(this)
        builder.setTitle("重要提示").setMessage(info).setNegativeButton("提交", DialogInterface.OnClickListener { dialog, which ->
            if (!NetHelper.IsHaveInternet(this@OrderGoodsSubmitAct)) {
                showMsg("当前为离线模式，无法订货！")
                return@OnClickListener
            }
            submitBtn.isEnabled = false
            orderSubmit(packedSubmitData())

        }).setPositiveButton("取消") { dialog, which -> submitBtn.isEnabled = true }.create().show()
    }

    /**上传订单*/
    private fun orderSubmit(bean: OrderSubmitReqBean) {
        ViewUtil.showProgress(this, "请稍等", "正在上传订单")
        GoodsManagerService.getInstance().saveOrderGoodsAuditions(Gson().toJson(bean)) {
            ViewUtil.dismissProgress()
            if (!isFinishing && it.isSuccessed) {
                var entity = Gson().fromJson(it.info, BaseResponse::class.java)

                if (entity.retCode.equals("0") && entity.msgCode.equals("0")) {
                    showMsg("提交成功")
                    setResult(Activity.RESULT_OK)
                    finish()
                    //跳订货审核页面1
                    startActivity(Intent(this, GoodsAuditingShopListActivity::class.java).apply {
                        putExtra("branchTitle", "订货审核")
                    })
                    //跳订货审核页面2
                    startActivity(Intent(this, GoodsAuditingStatusActivity::class.java).apply {
                        putExtra("storeNo", shopId)
                        putExtra("branchTitle", "订单审核")
                    })
                    return@saveOrderGoodsAuditions
                }
                showMsg(entity.retInfo)
                submitBtn.isEnabled = true
                return@saveOrderGoodsAuditions
            }
            showMsg("提交失败")
        }
    }


    /**
     * 组装提交的数据
     */
    private fun packedSubmitData(): OrderSubmitReqBean {
        var brandTemp = ""
        brandList?.forEach { brandTemp += "${it.brandId}," }
        Log.i("SasukeLog", "userInfo.brand=${brandList?.get(0)?.brandId}")
        if (brandTemp.endsWith(",")) brandTemp = brandTemp.substring(0, brandTemp.length - 1)

        val date = Date()
        //    orderSubmitReqBean.setBillCode(SystemHelper.LoginOrganId + DateUtil.format(date, "yyMMddHHmmss"));
        /*新订单号规则：门店编号+顾问ID+时间戳到秒+2位随机数，例如：0110074+75598659+170301092423+12；
    顾问ID长度最多为8位，不够的前面补0；*/
        val orderSubmitReqBean = OrderSubmitReqBean().apply {
            billCode = makeBillCode()
            brands = brandTemp
            firstOrder = resultCache?.firstOrder ?: false
            staffNo = userInfo.staffId
            storeNo = shopId
            dhReark = mReason
        }

        val detailBeans = ArrayList<OrderSubmitReqBean.DetailsBean>()
        resultCache?.list?.filter { it.tqty > 0 }?.forEach { choice ->
            detailBeans.add(
                    OrderSubmitReqBean.DetailsBean().apply {
                        brandId = choice.brandId.toString()
                        proAmount = choice.getAmount().toString()
                        proBoxQty = choice.getBox_qty().toString()
                        proCode = choice.itemid
                        proDHQty = choice.getTQTY().toString()
                        proId = choice.oe_pro_id
                        proLastMonthQty = choice.lastMonth_qty
                        proMaxQty = choice.max_opl_qty.toString()
                        proName = choice.itemName
                        proOplQty = choice.opl_qty
                        proPrice = choice.itemPrice.toString()
                        proSYQty = choice.sy_opl_qty.toString()
                        proStockQty = choice.stock_Qty
                        proUOM = choice.itemUOM
                        proUOMID = choice.itemUOM_id
                    }
            )
        }
        orderSubmitReqBean.details = detailBeans
        return orderSubmitReqBean
    }

    fun initBack() {
        arrayOf(titleLayout.find<TextView>(R.id.home_title_back), tapLayout.find<ImageButton>(R.id.back_ll)).forEach {
            it.setOnClickListener { finish() }
        }
    }

    fun showIsLoading() {
        loadWait?.show(LoadWaitDominator.LOADING)
    }

    fun showError(errorMsg: String?) {
        loadWait?.show(errorMsg ?: "netError")
    }

    fun showState(loadWaitState: Int) {
        loadWait?.show(loadWaitState)
    }

    fun showDismissAll() {
        loadWait?.dismissAll()
    }


    /*新订单号规则：门店编号+顾问ID+时间戳到秒+2位随机数，例如：0110074+75598659+170301092423+12；
    顾问ID长度最多为8位，不够的前面补0；*/
    fun makeBillCode(): String {
        val tempId = if (userInfo.staffId.length >= 8) userInfo.staffId.substring(0, 8)
        else "00000000".substring(userInfo.staffId.length) + userInfo.staffId
        return MessageFormat.format("{0}{1}{2}{3}",
                shopId,
                tempId,
                SimpleDateFormat("yyMMddHHmmss").format(Date()),
                String.format(Locale.CHINA, "%02d", Random().nextInt(100)))
    }
}