package com.wgmf.yxgj.module.business.manageproduct.ui

import android.content.Context
import android.graphics.Color
import android.os.Handler
import android.os.Looper
import android.support.v7.app.AlertDialog
import android.support.v7.app.AppCompatActivity
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.*
import android.widget.*
import com.squareup.picasso.Picasso
import com.wgmf.library.utils.Arith
import com.wgmf.yxgj.module.business.manageproduct.R
import com.wgmf.yxgj.module.business.manageproduct.model.DingHuoOplQtyEntity
import com.wgmf.yxgj.utils.DensityUtil
import com.wgmf.yxgj.utils.MyToast
import com.wgmf.yxgj.utils.StringUtils
import com.wgmf.yxgj.widgets.NumberKeyboard
import org.jetbrains.anko.find


/**
 * @author Sasuke on 2018/9/24.
 *
 * 这个是从OrderGoodsTradeAdapter0改过来的。。。
 */
class OrderGoodsTradeAdapter(val context: Context, dataList: List<DingHuoOplQtyEntity.DinghuoDetail>?, val notifyPriceShow: () -> Unit) : RecyclerView.Adapter<OrderGoodsTradeAdapter.OrderGoodsHolder>() {
    val orderList: MutableList<DingHuoOplQtyEntity.DinghuoDetail> = mutableListOf()

    val handler = Handler(Looper.getMainLooper())
    //为了用外层的最大库存天数字段，专门把整个entity传进来缓存起来。
    var entityCache: DingHuoOplQtyEntity.ResultInfo? = null

    init {
        dataList?.let {
            orderList.clear()
            orderList.addAll(dataList)
        }
    }

    val keyboard: NumberKeyboard by lazy {
        NumberKeyboard.newInstance(null)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): OrderGoodsHolder {
        return OrderGoodsHolder(LayoutInflater.from(context).inflate(R.layout.second_ordergoodsmenu_item3, parent, false))
    }

    override fun getItemCount(): Int {
        return orderList.size
    }

    override fun onBindViewHolder(holder: OrderGoodsHolder, position: Int) {
    }

    override fun onBindViewHolder(holder: OrderGoodsHolder, pos: Int, payloads: List<Any?>) {
//        if (orderList == null) return
        val data = orderList[pos]
        holder.apply {
            //用于局部刷新viewImageTv这一个组件
            payloads.takeIf { it.isNotEmpty() && it[0] == "viewImageTv" }?.let {
                viewImageTv.visibility = if (orderList[pos].isShowImageTv) View.VISIBLE else View.INVISIBLE
                return
            }
            count.tag = pos
            name.text = data.itemName
            CalculatorCyl(data, data.tqty)//计算库存率
            tv_cyl.text = String.format("库存天数:%s天", StringUtils.formatDouble(data.getCyl(), "0.##"))
            //是辅料就不显示“库存天数”
            tv_cyl.visibility = if (data.accessory) View.GONE else View.VISIBLE
            //辅料只显示在途:
            tv_kucun.text = String.format("%s%s", if (data.accessory) "在途:" else "库存+在途:", data.stock_Qty)
            pro_today_dhqty.text = String.format("已提交数量:%s", data.pro_today_dhqty)
            tv_xiaoliang.text = String.format("月用量:%s  单价：%s元", data.lastMonth_qty, data.itemPrice)
            oe_pro_mode.text = data.oe_pro_mode
            //工厂缺货提醒字样
            is_stock_out.visibility = if (data.isStockout) View.VISIBLE else View.INVISIBLE
            oe_pro_dh_qty.text = String.format("近30天已订货数量:%s", data.oe_pro_dh_qty)
            oe_pro_dh_qty.visibility = if (data.accessory) View.VISIBLE else View.GONE//只有辅料和试吃类型才添加近30天已订货数量
            unit.text = String.format("(%s %s)", data.itemUOM, data.itemid)
            count.setTextColor(if (data.isInvalid) Color.RED else Color.BLACK)
            count.setText(StringUtils.formatDouble(data.tqty, "0.00"))
            qtyCount.text = data.opl_qty
            //减号逻辑===============
            if (data.tqty == 0.0) {
                holder.reduce.isEnabled = false
                holder.reduce.setImageResource(R.drawable.btn_xjian_un)
            } else {
                holder.reduce.isEnabled = true
                holder.reduce.setImageResource(R.drawable.btn_xjian_can)
            }
            //加号逻辑===============
            holder.add.isEnabled = true
            holder.add.setImageResource(R.drawable.btn_xjia_can)
            viewImageTv.setOnClickListener { imageShowDetail(it, orderList[pos]) }
            //默认不可见，根据图片链接可用性来控制可见与否。
            viewImageTv.visibility = if (orderList[pos].isShowImageTv) View.VISIBLE else View.INVISIBLE
            //通过Picasso先判断图片链接可用性，如果无效链接，则不显示“查看图片”按钮
            if (!orderList[pos].isShowImageTv) {//只有在标记为false的时候，才去检查链接可用性。
                Picasso.with(context).load(orderList[pos].picUrl)
                        .into(tempImg, object : com.squareup.picasso.Callback {
                            override fun onSuccess() {
                                if (pos >= orderList.size) return//防溢出
                                orderList[pos].isShowImageTv = true
                                //只刷新这个组件
                                handler.post { notifyItemChanged(pos, "viewImageTv") }
                            }

                            override fun onError() {
                                if (pos >= orderList.size) return//防溢出
                                orderList[pos].isShowImageTv = false
                            }
                        })
            }

            //加号点击监听================================
            holder.add.setOnClickListener {
                val cell = orderList[pos]
                var d = 0.0
                //【if】getPack==0情况下默认加一；
                //【else】getPack>0情况下以Box_qty为标准
                cell.dhPack = if (cell.getPack() == 0.0) 1.0 else cell.pack

                d = Arith.add(cell.getTQTY(), cell.getDHPack())
                //如果再加就超过最大值了，那就拦截点击后面的操作
                if (d > 500 && cell.isShowAlert) {
                    cell.isShowAlert = false
                    AlertDialog.Builder(context).setMessage("当前产品输入的订货数量已超过500，请确认！")
                            .setPositiveButton("我知道了", null)
                            .show()
                }
                cell.tqty = d
                cell.amount = Arith.mul(d, cell.itemPrice)
                holder.count.setText(StringUtils.formatDouble(d, "0.00"))
                CalculatorCyl(cell, d)
                holder.tv_cyl.text = String.format("库存天数:%s天", StringUtils.formatDouble(cell.getCyl(), "0.##"))
                if (d < 0) {
                    cell.isInvalid = true
                    holder.count.setTextColor(Color.RED)
                    holder.reduce.isEnabled = false
                    holder.reduce.setImageResource(R.drawable.btn_xjian_un)
                } else {
                    if (0.0 != cell.getDHPack() && 0.0 != d && d % cell.getDHPack() != 0.0) {
                        cell.isInvalid = true
                        holder.count.setTextColor(Color.RED)
                    } else {
                        cell.isInvalid = false
                        holder.count.setTextColor(Color.BLACK)
                    }
                    holder.reduce.isEnabled = true
                    holder.reduce.setImageResource(R.drawable.btn_xjian_can)
                }
                notifyPriceShow.invoke()
            }

            //减号点击监听================================
            holder.reduce.setOnClickListener {
                val cell = orderList[pos]
                var d = 0.0
                //【if】getPack==0情况下默认加一；
                //【else】getPack>0情况下以getPack为标准
                cell.dhPack = if (cell.getPack() == 0.0) 1.0 else cell.pack
                d = Arith.sub(cell.getTQTY(), cell.getDHPack())
                cell.tqty = d
                cell.amount = Arith.mul(d, cell.itemPrice)
                holder.count.setText(StringUtils.formatDouble(d, "0.00"))
                if (d <= 0) {
                    holder.reduce.isEnabled = false
                    holder.reduce.setImageResource(R.drawable.btn_xjian_un)
                }
                CalculatorCyl(cell, d)
                holder.tv_cyl.text = String.format("库存天数:%s天", StringUtils.formatDouble(cell.getCyl(), "0.##"))
                if (d < 0) {
                    cell.isInvalid = true
                    holder.count.setTextColor(Color.RED)
                    holder.add.isEnabled = true
                    holder.add.setImageResource(R.drawable.btn_xjia_can)
                } else {
                    if (0.0 != cell.getDHPack() && 0.0 != d && d % cell.getDHPack() != 0.0) {
                        cell.isInvalid = true
                        holder.count.setTextColor(Color.RED)
                    } else {
                        cell.isInvalid = false
                        holder.count.setTextColor(Color.BLACK)
                    }
                    holder.add.isEnabled = true
                    holder.add.setImageResource(R.drawable.btn_xjia_can)
                }
//                (context as BaseActivity).doResult(pos)
                notifyPriceShow.invoke()
            }
            //数量点击监听================================
            holder.count.setSelectAllOnFocus(true)
            holder.count.setOnClickListener {
                keyboard.show(holder.count, (context as AppCompatActivity).supportFragmentManager, null)
                        .setDecimal(2)
                        .selectAll().setOnDismissListener {
                            if (orderList.size > pos) {
                                val cell = orderList[pos]
                                cell.dhPack = cell.getPack()
                                val input = holder.count.text.toString()
                                var d = 0.0
                                try {
                                    d = input.toDouble()
                                } catch (e: NumberFormatException) {
                                    d = 0.0
                                }
                                cell.tqty = d
                                holder.count.setText(StringUtils.formatDouble(d, "0.00"))
                                var temp = ""
                                if (d <= 0) {
                                    if (d < 0) {
                                        temp = "必须输入有效的数字！"
                                    }
                                    holder.reduce.isEnabled = false
                                    holder.reduce.setImageResource(R.drawable.btn_xjian_un)
                                }
                                if (d > 500 && cell.isShowAlert) {
                                    cell.isShowAlert = false
                                    AlertDialog.Builder(context).setMessage("当前产品输入的订货数量已超过500，请确认！")
                                            .setPositiveButton("我知道了", null)
                                            .show()
                                }

                                if (0.0 != cell.getDHPack() && 0.0 != d) {
                                    if (d % cell.getDHPack() != 0.0) {
                                        temp = "数量必须是" + cell.getDHPack() + "倍数"
                                        data.tqty = data.tqty.toInt() / cell.getDHPack().toInt() * cell.getDHPack()// 非法规格输入调整
                                        d = data.tqty
                                    }
                                    cell.amount = Arith.mul(d, cell.itemPrice)//价格一定要放在最后来算，因为前面的校验会改数量

                                    if (!TextUtils.isEmpty(temp)) {
                                        MyToast.show(context, temp, Toast.LENGTH_LONG)
                                        cell.isInvalid = true
                                        holder.count.setTextColor(Color.RED)
                                    } else {
                                        cell.isInvalid = false
                                        holder.add.isEnabled = true
                                        holder.reduce.isEnabled = true
                                        holder.reduce.setImageResource(R.drawable.btn_xjian_can)
                                        holder.add.setImageResource(R.drawable.btn_xjia_can)
                                        holder.count.setTextColor(Color.BLACK)
                                    }
                                    notifyPriceShow.invoke()
                                }
                            }
                        }
            }
            // 当商品‘缺货‘时，这个商品不能增加和输入商品数量，加号和数量显示为灰色，且不可点击
            if (data.isStockout) {
                holder.add.isEnabled = false
                holder.add.setImageResource(R.drawable.btn_xjia_un)
                holder.add.setOnClickListener(null)
                holder.count.setOnClickListener(null)
            }
        }
    }

    class OrderGoodsHolder(view: View) : RecyclerView.ViewHolder(view) {
        var name: TextView
        var unit: TextView
        var qtyCount: TextView
        var maxqtyCount: TextView
        var tv_kucun: TextView
        var pro_today_dhqty: TextView
        var tv_xiaoliang: TextView
        var tv_cyl: TextView
        var oe_pro_mode: TextView
        var is_stock_out: TextView
        var oe_pro_dh_qty: TextView
        var count: TextView
        var add: ImageButton
        var reduce: ImageButton
        // ImageView iv_go;
        var ll_show_detail: LinearLayout
        var top_title_ll: LinearLayout
        var viewImageTv: TextView
        var tempImg: ImageView

        init {
            name = view.find(R.id.goods_name) as TextView
            unit = view.find(R.id.goods_unit) as TextView
            qtyCount = view.find(R.id.qty_count) as TextView
            maxqtyCount = view.find(R.id.max_qty_count) as TextView
            tv_kucun = view.find(R.id.tv_kucun) as TextView
            pro_today_dhqty = view.find(R.id.pro_today_dhqty) as TextView
            tv_xiaoliang = view.find(R.id.tv_xiaoliang) as TextView
            tv_cyl = view.find(R.id.tv_cyl) as TextView
            oe_pro_mode = view.find(R.id.oe_pro_mode) as TextView
            is_stock_out = view.find(R.id.is_stock_out) as TextView
            oe_pro_dh_qty = view.find(R.id.oe_pro_dh_qty) as TextView
            count = view.find(R.id.goods_count) as TextView
            add = view.find(R.id.goods_plus) as ImageButton
            reduce = view.find(R.id.goods_decrease) as ImageButton
            // ImageView iv_go;
            ll_show_detail = view.find(R.id.ll_show_detail) as LinearLayout
            top_title_ll = view.find(R.id.top_title_ll) as LinearLayout
            viewImageTv = view.find(R.id.viewImageTv) as TextView
            tempImg = view.find(R.id.tempImg) as ImageView
        }
    }

    /**
     * 显示弹窗显示商品图片
     */
    private fun imageShowDetail(v: View, dingHuoOplQtyEntity: DingHuoOplQtyEntity.DinghuoDetail) {
        val content = LayoutInflater.from(context).inflate(R.layout.item_order_trade_popup, null)
        val imageView = content.findViewById(R.id.popup_order_trade_iv) as ImageView
        val tempW = DensityUtil.getScreenW(context) - 20
        Picasso.with(context).load(dingHuoOplQtyEntity.picUrl).placeholder(R.drawable.img_loading).resize(tempW, tempW).into(imageView)
        val pw = PopupWindow(content, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, true)
        pw.isFocusable = true
        pw.isOutsideTouchable = true
        pw.showAtLocation(v, Gravity.CENTER, 0, 0)
        (content.findViewById(R.id.popup_order_trade_root_ll) as LinearLayout).setOnClickListener {
            if (pw.isShowing) {
                pw.dismiss()
            }
        }
        val product_name_id_tv = content.findViewById(R.id.product_name_id_tv) as TextView
        product_name_id_tv.text = dingHuoOplQtyEntity.itemName + "(" + dingHuoOplQtyEntity.itemid + ")"
    }

    /**
     * 计算库存率
     */
    private fun CalculatorCyl(data: DingHuoOplQtyEntity.DinghuoDetail, counts: Double): Double {
        // 库存率=（订货数量+（库存+在途））/最近30天用量*
        var cyl: Double
        if (data.lastMonth_qty.toDouble() == 0.0 || (counts + data.stock_Qty.toDouble()) == 0.0) {
            cyl = 0.0
        } else {
            try {
                cyl = (data.tqty + data.stock_Qty.toDouble()) / data.lastMonth_qty.toDouble() * 30
            } catch (e: Exception) {
                cyl = 0.0
            }

        }
        data.cyl = cyl
        return cyl
    }


    fun refreshDataList(newList: List<DingHuoOplQtyEntity.DinghuoDetail>) {
        orderList.run {
            clear()
            addAll(newList)
        }
    }

    /**
     * 通过标签来过滤显示的列表（后来需求要分品牌了，所以加一个品牌区分）
     */
    fun notifyProByLabel(dataEntity: DingHuoOplQtyEntity.ResultInfo?, brand: Int, type: Int) {
        handler.removeCallbacksAndMessages(null)
        orderList.run {
            val allList = dataEntity?.list
            entityCache = dataEntity//传进来一份缓存起来，adapter里面要用到 maxStockLimit
            clear()
            if (allList.isNullOrEmpty()) {
                addAll(listOf())
            } else {
                addAll(if (type == -1) allList.filter { it.brandId == brand } else allList.filter { it.brandId == brand && it.type == type })
            }
        }
        notifyDataSetChanged()
    }
}