package com.wgmf.yxgj.module.business.managestaff.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.NutritionConsultantQueryResponse;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.module.business.managestaff.ui.staffinfo.StaffAmendActivity;

import java.util.List;

/**
 * 查询员工列表
 */
@SuppressWarnings("all")
public class SelectorConsultantActivity extends BaseParentAct implements SelectorConsultantAdapter.DataOnClickListener {
    LinearLayout staffQueryLl;
    ListView selectorStaffListViewLv;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.selector_staff_layout);
        initTitle();
        initView();
        queryListInfo();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("顾问列表");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initView() {
        selectorStaffListViewLv = (ListView) findViewById(R.id.selector_staff_list_view_lv);
        staffQueryLl = (LinearLayout) findViewById(R.id.staff_query_ll);
        staffQueryLl.setVisibility(View.GONE);
    }

    /**
     * 查询顾问列表
     */
    protected void queryListInfo() {
        //子类实现
        if (null != userInfo) {
            showDialog();
            String staffId = userInfo.getStaffId();
            String organizationId = userInfo.getOrganizationId();
            StaffManageService.getInstance().requestQueryNeedUpdateWorkersList(staffId, organizationId, SelectorConsultantActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_QUERY_NEED_UPDATE_WORKERS_LIST) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    NutritionConsultantQueryResponse mNutritionConsultantQueryResponse = new Gson().fromJson(msg, NutritionConsultantQueryResponse.class);
                    Log.d(TAG, "mNutritionConsultantQueryResponse=" + mNutritionConsultantQueryResponse);
                    if (null != mNutritionConsultantQueryResponse && ConstantParams.CONSTANT_PARAMS_0.equals(mNutritionConsultantQueryResponse.msgCode)) {
                        List<NutritionConsultant> mNutritionConsultants = mNutritionConsultantQueryResponse.getResult();
                        if (null != mNutritionConsultants && !mNutritionConsultants.isEmpty()) {
                            SelectorConsultantAdapter mAdapter = new SelectorConsultantAdapter(mNutritionConsultants, this, this);
                            selectorStaffListViewLv.setAdapter(mAdapter);
                        }
                    }
                }
                showMsg(result.getResultInfo());
            }
        }
    }

    @Override
    public void getNutritionConsultant(NutritionConsultant mNutritionConsultant) {
        Intent intent = new Intent();
        intent.putExtra("branchID", 541L);
        intent.putExtra("branchTitle", "员工资料查询/修改");
        intent.putExtra("personalId", mNutritionConsultant.getOperatorId());
        intent.setClass(SelectorConsultantActivity.this, StaffAmendActivity.class);
        startActivity(intent);
    }
}