package com.wgmf.yxgj.module.business.managestaff.ui;

import android.content.DialogInterface;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.MediaParams;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.YuanGongExitEntity;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.report.ui.ReportBaseDetailActivity;
import com.wgmf.yxgj.utils.helper.DialogHelper;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StaffDimissionDetailActivity extends ReportBaseDetailActivity implements View.OnClickListener, PublicSelectPop.ReportQuerySelectPopListener {
    private TextView dimissionDate;
    private TextView dissmissType;
    private String operName = "";//离职人姓名
    private String operatorId = "";//，离职人工号
    private String lzType = "01";//，离职类型:默认为主动离职
    private PublicSelectPop dissmissTypeSelectPop;

    @Override
    protected void initView() {
        super.initView();
        setContentView(R.layout.activity_staff_dissmiss);
    }

    @Override
    protected void initData() {
        super.initData();
        reportType = "LZ";//离职
        pickerMode = MediaParams.PARAMS_3;
        mPicSize = 5;//最多上传5张图片
        mPicDes = "最多只能上传" + mPicSize + "张图片!";
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("员工离职");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void initContent() {
        super.initContent();
        operName = getIntent().getStringExtra("operName");
        operatorId = getIntent().getStringExtra("operatorId");
        TextView staffNameTv = (TextView) findViewById(R.id.staff_name_tv);
        LinearLayout staffDissmissDateLl = (LinearLayout) findViewById(R.id.staff_dissmiss_date_ll);
        LinearLayout staffDissmissTypeLl = (LinearLayout) findViewById(R.id.staff_dissmiss_type_ll);
        dimissionDate = (TextView) findViewById(R.id.dimission_date);
        dissmissType = (TextView) findViewById(R.id.dissmiss_type);
        dissmissType.setText("主动离职");
        String text = "离职营养顾问：" + operName + "";
        staffNameTv.setText(text);
        staffDissmissDateLl.setOnClickListener(this);
        staffDissmissTypeLl.setOnClickListener(this);
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        reportContentComfirmBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                checkUploadData();
            }
        });
    }

    /**
     * 显示离职员工提示信息对话框
     */
    private void showNoticeDialog() {
        PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        builder.setMessage("员工:" + operName);
        builder.setTitle("是否确认要执行离职操作?");

        builder.setPositiveButton("取消",
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
        builder.setNegativeButton("确定",
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        showDialog();
                        uploadData();
                        dialog.dismiss();
                    }
                });
        builder.create().show();
    }

    /**
     * 提交离职信息
     */
    @Override
    protected void uploadData() {
        super.uploadData();
        showDialog();
        String lzreason = reportEdit.getText().toString();
        YuanGongExitEntity entExit = new YuanGongExitEntity();
        //离职员工工号
        entExit.setOperatorId(operatorId);
        if (null != userInfo) {
            entExit.setApprovalPerson(userInfo.getStaffId());
        }
        entExit.setLzDate(dimissionDate.getText().toString());
        entExit.setLzreason(lzreason);
        entExit.setLztype(lzType);

        if (null != urlLists) {
            entExit.setLzUrlList(urlLists);
        }
        String content = new Gson().toJson(entExit);
        Log.d(TAG, "员工离职:" + content);
        showDialog();
        StaffManageService.getInstance().requestResignNutritionConsultant(content, StaffDimissionDetailActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_RESIGN_NUTRITIONCONSULTANT) {
                final String msg = result.getInfo();
                if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                    BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                    showMsg(mBaseResponse.retInfo);
                    StaffDimissionDetailActivity.this.finish();
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }

    private void checkUploadData() {
        String temp = reportEdit.getText().toString();
        if (TextUtils.isEmpty(temp)) {
            showMsg("请输入离职原因!");
            return;
        }
        if (TextUtils.isEmpty(dimissionDate.getText().toString())) {
            showMsg("请选择离职时间!");
        } else {
            Date date = new Date();
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
            try {
                // 选中的日期
                Date date1 = formatter
                        .parse(dimissionDate.getText().toString());
                // 今天
                Date date2 = formatter.parse(formatter.format(date));
                if (!((DateUtil.daysBetween(date1, date2) >= -2) && (DateUtil.daysBetween(date1, date2) <= 2))) {
                    showMsg("您输入的离职日期有误，请输入当天前后两天的日期!");
                } else {
                    showNoticeDialog();
                }
            } catch (Exception e) {
                Log.e(TAG, "dimission:" + e);
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.staff_dissmiss_date_ll) {
            DialogHelper.AlertDatePicker(StaffDimissionDetailActivity.this, StaffDimissionDetailActivity.this, dimissionDate);
        } else if (v.getId() == R.id.staff_dissmiss_type_ll) {
            if (null == dissmissTypeSelectPop) {
                dissmissTypeSelectPop = new PublicSelectPop(this, this, getdissmissType());
            }
            if (!dissmissTypeSelectPop.isShowing()) {
                dissmissTypeSelectPop.show(this.findViewById(R.id.title));
            }
        }
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        dissmissType.setText(reportQuerys.get(position).getSelectorName());
        lzType = reportQuerys.get(position).getSelectorId();
    }

    private List<BaseSelectorEntity> getdissmissType() {
        List<BaseSelectorEntity> mBaseSelectorEntitys = new ArrayList<>();
        BaseSelectorEntity mBaseSelectorEntity0 = new BaseSelectorEntity();
        mBaseSelectorEntity0.setSelectorName("主动离职");
        mBaseSelectorEntity0.setSelectorId("01");
        mBaseSelectorEntitys.add(mBaseSelectorEntity0);
        BaseSelectorEntity mBaseSelectorEntity1 = new BaseSelectorEntity();
        mBaseSelectorEntity1.setSelectorName("被动离职");
        mBaseSelectorEntity1.setSelectorId("02");
        mBaseSelectorEntitys.add(mBaseSelectorEntity1);
        BaseSelectorEntity mBaseSelectorEntity2 = new BaseSelectorEntity();
        mBaseSelectorEntity2.setSelectorName("自离");
        mBaseSelectorEntity2.setSelectorId("03");
        mBaseSelectorEntitys.add(mBaseSelectorEntity2);
        return mBaseSelectorEntitys;
    }
}