package com.wgmf.yxgj.module.business.managestaff.ui.scheduling;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.NutConsultantScheduling;
import com.wgmf.yxgj.module.business.managestaff.model.NutConsultantSchedulingList;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.widgets.LinearLayout.CalendarBaseModelResponse;
import com.wgmf.yxgj.widgets.LinearLayout.DayTaskCalendar;
import com.xp.arouter.RouterCommonUtil;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * 作者：xiep on 2017/7/21 17:39
 * 邮箱：2975837870@qq.com
 */

public class SchedulingOneMonthActivity extends BaseParentAct implements PublicSelectPop.ReportQuerySelectPopListener, View.OnClickListener {

    public static final int SELECT_STORE = 3;// 选择门店 的返回。

    private TextView titleMonth;
    private ImageView titleLeft;
    private ImageView titleRight;
    private String choiceMonth;
    private DayTaskCalendar dayTaskCalendar;

    private LinearLayout comfirmLl;
    private Button comfirmBtn;

    private TextView echedulingOneMonthShopEt;
    private EditText echedulingOneMonthTargetEt;
    private TextView echedulingOneMonthWorkEt;

    private TextView echedulingOneMonthCheckedDate;

    private String staffId;
    private String staffName;


    private String shopId;
    private String shopName;

    private String target = "";

    private String msg = "";

    private boolean firstEntry;

    private PublicSelectPop publicSelectPop;

    private List<BaseSelectorEntity> echedulings;

    private List<NutConsultantScheduling> mNutConsultantSchedulings;//已设置事务数据

    private List<String> mSubmitDates;//待提交数据日期

    private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM");// 日期格式化

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.scheduling_one_month_activity);
        initData();
        initTitle();
        initContent();
        getOneMonthData();
    }

    private void initData() {
        mNutConsultantSchedulings = new ArrayList<>();
        echedulings = new ArrayList<>();
        mSubmitDates = new ArrayList<>();
        BaseSelectorEntity baseSelectorEntity1 = new BaseSelectorEntity();
        BaseSelectorEntity baseSelectorEntity2 = new BaseSelectorEntity();
        BaseSelectorEntity baseSelectorEntity3 = new BaseSelectorEntity();
        baseSelectorEntity1.setSelectorName("早班");
        baseSelectorEntity2.setSelectorName("中班");
        baseSelectorEntity3.setSelectorName("晚班");
        echedulings.add(baseSelectorEntity1);
        echedulings.add(baseSelectorEntity2);
        echedulings.add(baseSelectorEntity3);
    }

    private void getOneMonthData() {
        showDialog();
        StaffManageService.getInstance().requestFindOneMonthScheduling(staffId, choiceMonth, SchedulingOneMonthActivity.this);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        staffId = getIntent().getStringExtra("staffId");
        staffName = getIntent().getStringExtra("staffName");
        homeTitleText.setText(staffName);
    }

    private void initContent() {
        comfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        comfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);

        echedulingOneMonthShopEt = (TextView) findViewById(R.id.echeduling_one_month_shop_et);
        echedulingOneMonthTargetEt = (EditText) findViewById(R.id.echeduling_one_month_target_et);
        echedulingOneMonthWorkEt = (TextView) findViewById(R.id.echeduling_one_month_work_et);
        echedulingOneMonthCheckedDate = (TextView) findViewById(R.id.echeduling_one_month_checked_date);
        echedulingOneMonthCheckedDate.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));

        setSubmitBtnStatus(View.GONE, R.drawable.org_bg, R.color.common_txt_color, null);
        setEditStatus(false, null);

        dayTaskCalendar = (DayTaskCalendar) findViewById(R.id.day_task_calendar);
        choiceMonth = dayTaskCalendar.getChoiceMonth();

        titleMonth = (TextView) findViewById(R.id.title_month);
        titleMonth.setText(choiceMonth);
        titleLeft = (ImageView) findViewById(R.id.month_row_left);
        titleRight = (ImageView) findViewById(R.id.month_row_right);
        titleLeft.setOnClickListener(this);
        titleRight.setOnClickListener(this);

        dayTaskCalendar.setOnDaySelectListener(new DayTaskCalendar.OnDaySelectListener() {

            @Override
            public void onDaySelectListener(String date, List<String> choiceDates) {
                echedulingOneMonthCheckedDate.setText(date);
                NutConsultantScheduling mNutConsultantScheduling = finddata(date);

                if (null == mNutConsultantScheduling) {

                    echedulingOneMonthShopEt.setText("");
                    echedulingOneMonthTargetEt.setText("");
                    echedulingOneMonthWorkEt.setText("");

                    NutConsultantScheduling mNewNutConsultantScheduling = new NutConsultantScheduling();
                    if (null != userInfo) {
                        mNewNutConsultantScheduling.setAddPersonId(userInfo.getStaffId());
                    }
                    mNewNutConsultantScheduling.setSchedulingDay(date);
                    mNewNutConsultantScheduling.setSchedulingStaffId(staffId);
                    mNewNutConsultantScheduling.setSchedulingShopId(shopId);
                    mNutConsultantSchedulings.add(mNewNutConsultantScheduling);
                }
                dayTaskCalendar.gridViewAdapter.notifyDataSetChanged();

                if (getDevice(date) > 0) {//今天之前
                    comfirmLl.setVisibility(View.GONE);
                    setEditStatus(false, null);
                } else {//今天及今天之后
                    setSubmitBtnStatus(View.VISIBLE, R.drawable.org_bg, R.color.common_txt_color, null);
                    setEditStatus(true, SchedulingOneMonthActivity.this);
                }


                String txt = "";
                msg = "";
                mSubmitDates.clear();
                for (String choiceDate : choiceDates) {
                    mSubmitDates.add(choiceDate);
                    msg = msg + choiceDate + "\n";
                    Date yearMonthNow = DateUtil.string2Date(choiceDate, "yyyy-MM-dd");
                    choiceDate = DateUtil.format(yearMonthNow, "M月d日");
                    txt = txt + choiceDate + "  ";
                }

                if (!mSubmitDates.isEmpty()) {
                    echedulingOneMonthCheckedDate.setOnClickListener(SchedulingOneMonthActivity.this);
                    echedulingOneMonthCheckedDate.setVisibility(View.VISIBLE);
                    echedulingOneMonthCheckedDate.setText(txt);
                } else {
                    echedulingOneMonthCheckedDate.setVisibility(View.INVISIBLE);
                    echedulingOneMonthCheckedDate.setOnClickListener(null);
                }
            }
        });
    }

    /**
     * 日期比较
     *
     * @param date 待比较日期（和今日比较）
     * @return > 0//今天之前
     * ＝0//今日
     * <0//今日之后
     */
    private int getDevice(String date) {
        Date date1 = DateUtil.string2Date(date, "yyyy-MM-dd");
        Date date2 = DateUtil.string2Date(DateUtil.getFormatCurrentDate("yyyy-MM-dd"), "yyyy-MM-dd");
        return DateUtil.daysBetween(date1, date2);
    }

    /**
     * 提交按钮状态变更
     * 1,今日之前：View.GONE，不显示
     * 2,今日及今日之后：View.VISIBLE，已设置查看：背景灰色，不可点击
     * 3,今日及今日之后：View.VISIBLE，已设置修改：背景橙色，可点击
     */
    private void setSubmitBtnStatus(int visibility, int image, int color, View.OnClickListener listener) {
        comfirmBtn.setText("保存并提交");
        comfirmLl.setVisibility(visibility);
        comfirmBtn.setBackgroundResource(image);
        comfirmBtn.setTextColor(ContextCompat.getColor(SchedulingOneMonthActivity.this, color));
        comfirmBtn.setOnClickListener(listener);
    }

    /**
     * 填写控件状态变更
     * 1,已设置查看：字体灰色，不可点击
     * 2,已设置修改：字体黑色，可点击
     * 3，未设置：空白，可点击
     */
    private void setEditStatus(boolean enabled, View.OnClickListener listener) {
        echedulingOneMonthTargetEt.setEnabled(enabled);
        echedulingOneMonthShopEt.setOnClickListener(listener);
        echedulingOneMonthTargetEt.setOnClickListener(listener);
        echedulingOneMonthWorkEt.setOnClickListener(listener);
        echedulingOneMonthTargetEt.addTextChangedListener(targetTextWatcher);
    }

    TextWatcher targetTextWatcher = new TextWatcher() {
        @Override
        public void beforeTextChanged(CharSequence s, int start, int count, int after) {

        }

        @Override
        public void onTextChanged(CharSequence s, int start, int before, int count) {

        }

        @Override
        public void afterTextChanged(Editable s) {
            if (firstEntry && !target.equals(echedulingOneMonthTargetEt.getText().toString())) {
                setSubmitBtnStatus(View.VISIBLE, R.drawable.selector_update_btn, R.color.normal_color, SchedulingOneMonthActivity.this);
                setEditStatus(true, SchedulingOneMonthActivity.this);
            }
            firstEntry = true;
            target = s.toString();
        }
    };

    public NutConsultantScheduling finddata(String date) {
        for (NutConsultantScheduling mNutConsultantScheduling : mNutConsultantSchedulings) {
            if (date.equals(mNutConsultantScheduling.getSchedulingDay())) {
                String number = mNutConsultantScheduling.getPersonalSaleTarget();
                if ("0".equals(number)) {
                    echedulingOneMonthTargetEt.setText("");
                } else {
                    echedulingOneMonthTargetEt.setText(number);
                }
                shopId = mNutConsultantScheduling.getSchedulingShopId();
                shopName = mNutConsultantScheduling.getSchedulingShopName();

                echedulingOneMonthShopEt.setText(shopName);
                echedulingOneMonthWorkEt.setText("" + mNutConsultantScheduling.getWorkShift() + "");

                if (null != userInfo) {
                    mNutConsultantScheduling.setAddPersonId(userInfo.getStaffId());
                }
                mNutConsultantScheduling.setSchedulingStaffId(staffId);
                mNutConsultantScheduling.setSchedulingShopId(shopId);
                return mNutConsultantScheduling;
            }
        }
        return null;
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.StaffManage.MSG_ON_FIND_ONEMONTH_SCHEDULING: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        NutConsultantSchedulingList mNutConsultantSchedulingList = new Gson().fromJson(msg, NutConsultantSchedulingList.class);
                        Log.d(TAG, "mNutConsultantSchedulingList=" + mNutConsultantSchedulingList.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mNutConsultantSchedulingList.retCode)) {
                            if (!mNutConsultantSchedulingList.getResultList().isEmpty()) {
                                mNutConsultantSchedulings = mNutConsultantSchedulingList.getResultList();
                                setDaysHasThings(mNutConsultantSchedulings);
                            }
                        } else {
                            showMsg(mNutConsultantSchedulingList.retInfo);
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.StaffManage.MSG_ON_SAVEORUPDATE_SCHEDULING: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            this.finish();
                        }
                        showMsg(mBaseResponse.retInfo);
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 设置事务
     *
     * @param mNutConsultantSchedulingList 事务数据
     */
    private void setDaysHasThings(List<NutConsultantScheduling> mNutConsultantSchedulingList) {
        List<CalendarBaseModelResponse> daysHasThingList = new ArrayList<>();
        for (NutConsultantScheduling mNutConsultantScheduling : mNutConsultantSchedulingList) {
            CalendarBaseModelResponse mCalendarBaseModelResponse = new CalendarBaseModelResponse();
            mCalendarBaseModelResponse.setDayShowing(mNutConsultantScheduling.getSchedulingDay());
            mCalendarBaseModelResponse.setStateSaved(true); //已设置
            daysHasThingList.add(mCalendarBaseModelResponse);

            if (!firstEntry && getDevice(mNutConsultantScheduling.getSchedulingDay()) == 0) {//默认显示今日数据
                echedulingOneMonthShopEt.setText(mNutConsultantScheduling.getSchedulingShopName());
                String text = "" + mNutConsultantScheduling.getPersonalSaleTarget() + "";
                echedulingOneMonthTargetEt.setText(text);
                echedulingOneMonthWorkEt.setText(mNutConsultantScheduling.getWorkShift());
            }
        }
        dayTaskCalendar.setDaysHasThingList(daysHasThingList);
    }

    /**
     * 月份改变时刷新日历状态数据
     */
    private void setChangedCanlanderData(Calendar ca, String month) {
        try {
            ca.setTime(dateFormat.parse(month));
        } catch (ParseException e) {
            Log.e(TAG, "setChangedCanlanderData: ", e);
        }
        ca.set(Calendar.DATE, 1);
        dayTaskCalendar.setChoiceMonth(month);
        int tempSum = dayTaskCalendar.countNeedHowMuchEmpety(ca);// 获取当前月第一天为星期几
        int dayNumInMonth = dayTaskCalendar.getDayNumInMonth(ca);// 获取当前月有多少天
        dayTaskCalendar.setGvListData(tempSum, dayNumInMonth);
        dayTaskCalendar.gridViewAdapter.notifyDataSetChanged();
        getOneMonthData();
    }

    @Override
    public void onClick(View v) {
        Calendar ca = Calendar.getInstance();// 得到一个Calendar的实例
        Date date = DateUtil.string2Date(choiceMonth, "yyyy-MM");
        ca.setTime(date); // 设置时间为当前选中时间
        Date resultDate = ca.getTime(); // 结果
        choiceMonth = dateFormat.format(resultDate);

        Date nextDate = DateUtil.getNowMonthNext();//下月

        titleLeft.setVisibility(View.VISIBLE);
        titleRight.setVisibility(View.VISIBLE);

        if (v.getId() == R.id.month_row_left) {
            ca.add(Calendar.MONTH, -1);// 月份减1
            resultDate = ca.getTime(); // 结果
            choiceMonth = dateFormat.format(resultDate);
            titleMonth.setText(choiceMonth);
            setChangedCanlanderData(ca, choiceMonth);
        } else if (v.getId() == R.id.month_row_right) {
            ca.add(Calendar.MONTH, 1);// 月份加1
            resultDate = ca.getTime(); // 结果
            choiceMonth = dateFormat.format(resultDate);
            titleMonth.setText(choiceMonth);
            setChangedCanlanderData(ca, choiceMonth);

            if (DateUtil.daysBetween(nextDate, resultDate) > 0) {//填写只能到下月末
                titleRight.setVisibility(View.INVISIBLE);
            } else {
                titleRight.setVisibility(View.VISIBLE);
            }
        } else if (v.getId() == R.id.report_content_confirm_btn) {
            if (TextUtils.isEmpty(echedulingOneMonthCheckedDate.getText().toString())) {
                showMsg("请选择排班日期！");
                return;
            }
            if (checkUploadData()) {
                uploadData();
            }
        } else if (v.getId() == R.id.echeduling_one_month_shop_et) {
            Bundle mBundle = new Bundle();
            mBundle.putLong("branchID", 223);//223) {//流动营养顾问排班
            mBundle.putString("branchTitle", staffName);
            RouterCommonUtil.startFunctionActivityResult(this, -2, 223L, mBundle, SELECT_STORE);
        } else if (v.getId() == R.id.echeduling_one_month_work_et) {
            if (null == publicSelectPop) {
                publicSelectPop = new PublicSelectPop(this, this, echedulings);
            }
            if (!publicSelectPop.isShowing()) {
                publicSelectPop.show(this.findViewById(R.id.title));
            }
        } else if (v.getId() == R.id.echeduling_one_month_checked_date) {
            final PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
            builder.setTitle("选中日期");
            builder.setMessage(msg);
            builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int which) {
                    dialog.dismiss();
                }
            });
            builder.create().show();
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == SELECT_STORE && resultCode == SelectorBaseActivity.RESULTCODE) {
            try {
                shopId = data
                        .getStringExtra("shopId");
                shopName = data
                        .getStringExtra("shopName");

                if (!shopName.equals(echedulingOneMonthShopEt.getText().toString())) {
                    setSubmitBtnStatus(View.VISIBLE, R.drawable.selector_update_btn, R.color.normal_color, SchedulingOneMonthActivity.this);
                    setEditStatus(true, SchedulingOneMonthActivity.this);
                }
                echedulingOneMonthShopEt.setText(shopName);
            } catch (Exception e) {
                Log.e(TAG, "onActivityResult: data.getStringExtra error ");
            }
        }
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        String workName = reportQuerys.get(position).getSelectorName();
        if (!workName.equals(echedulingOneMonthWorkEt.getText().toString())) {
            setSubmitBtnStatus(View.VISIBLE, R.drawable.selector_update_btn, R.color.normal_color, SchedulingOneMonthActivity.this);
            setEditStatus(true, SchedulingOneMonthActivity.this);
        }
        echedulingOneMonthWorkEt.setText(workName);
    }

    private boolean checkUploadData() {
        if (TextUtils.isEmpty(echedulingOneMonthShopEt.getText().toString())) {
            showMsg("请选择排班门店");
            return false;
        } else if (TextUtils.isEmpty(echedulingOneMonthTargetEt.getText().toString())) {
            showMsg("请填写个人销售目标");
            return false;
        } else if (TextUtils.isEmpty(echedulingOneMonthWorkEt.getText().toString())) {
            showMsg("请选择班次");
            return false;
        } else {
            return true;
        }
    }

    private void uploadData() {
        List<NutConsultantScheduling> mUploadNutConsultantSchedulings = new ArrayList<>();
        for (int i = 0; i < mSubmitDates.size(); i++) {
            for (NutConsultantScheduling mNutConsultantScheduling : mNutConsultantSchedulings) {
                if (mSubmitDates.get(i).equals(mNutConsultantScheduling.getSchedulingDay())) {
                    NutConsultantScheduling mUploadNutConsultantScheduling = new NutConsultantScheduling();
                    if (null != mNutConsultantScheduling.getId()) {
                        mUploadNutConsultantScheduling.setId(mNutConsultantScheduling.getId());
                    }
                    mUploadNutConsultantScheduling.setAddPersonId(mNutConsultantScheduling.getAddPersonId());
                    mUploadNutConsultantScheduling.setSchedulingDay(mNutConsultantScheduling.getSchedulingDay());
                    mUploadNutConsultantScheduling.setSchedulingStaffId(staffId);
                    mUploadNutConsultantScheduling.setSchedulingShopId(shopId);
                    mUploadNutConsultantScheduling.setSchedulingShopName(shopName);
                    mUploadNutConsultantScheduling.setPersonalSaleTarget(Double.valueOf(echedulingOneMonthTargetEt.getText().toString()));
                    mUploadNutConsultantScheduling.setWorkShift(echedulingOneMonthWorkEt.getText().toString() + "");
                    mUploadNutConsultantSchedulings.add(mUploadNutConsultantScheduling);
                }
            }
        }
        String content = new Gson().toJson(mUploadNutConsultantSchedulings);
        Log.d(TAG, content);
        showDialog();
        StaffManageService.getInstance().requestSaveOrUpdateScheduling(content, SchedulingOneMonthActivity.this);
    }
}