package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.model.NutritionConsultantQueryResponse;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 查询员工列表
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_SELECTORSTAFFACTIVITY)
public class SelectorStaffActivity extends BaseParentAct implements View.OnClickListener, SelectorStaffAdapter.DataOnClickListener {
    ListView selectorStaffListViewLv;
    /**
     * 备注信息
     */
    LinearLayout staffEntryTipLl;
    TextView staffEntryTipTv;
    /**
     * 员工查询
     */
    LinearLayout staffQueryLl;
    ClearEditText staffNo;
    Button query;

    Long branchID;
    String branchTitle;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.selector_staff_layout);
        initTitle();
        initView();
        initLisener();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initView() {
        staffQueryLl = (LinearLayout) findViewById(R.id.staff_query_ll);
        query = (Button) findViewById(R.id.dimission_query);
        staffNo = (ClearEditText) findViewById(R.id.staff_no);
        selectorStaffListViewLv = (ListView) findViewById(R.id.selector_staff_list_view_lv);
        if (541 == branchID) {
            //员工查询/修改时
            staffEntryTipLl = (LinearLayout) findViewById(R.id.staff_entry_tip_ll);
            staffEntryTipTv = (TextView) findViewById(R.id.staff_entry_tip_tv);
            staffEntryTipTv.setText(getString(R.string.staff_amend_tip_tv));
            staffNo.setHint(getString(R.string.person_id_or_name));
            staffEntryTipLl.setVisibility(View.VISIBLE);
        }
    }

    private void initLisener() {
        query.setOnClickListener(this);//员工查询
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.StaffManage.MSG_ON_QUERY_NUTRITION_CONSULTANT) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    NutritionConsultantQueryResponse mNutritionConsultantQueryResponse = new Gson().fromJson(msg, NutritionConsultantQueryResponse.class);
                    Log.d(TAG, "mNutritionConsultantQueryResponse=" + mNutritionConsultantQueryResponse);
                    if (null != mNutritionConsultantQueryResponse && ConstantParams.CONSTANT_PARAMS_0.equals(mNutritionConsultantQueryResponse.msgCode)) {
                        List<NutritionConsultant> mNutritionConsultants = mNutritionConsultantQueryResponse.getResult();
                        List<NutritionConsultant> mNutritionConsultantsFilter = new ArrayList<>();
                        if (null != mNutritionConsultants && !mNutritionConsultants.isEmpty()) {
                            if (staffNo.getText().toString().trim().length() >= 15) {
                                //如果是身份证查询，只显示离职顾问
                                for (NutritionConsultant NutritionConsultant : mNutritionConsultants) {
                                    if (ConstantParams.CONSTANT_PARAMS_1.equals(NutritionConsultant.getStatus())) {
                                        mNutritionConsultantsFilter.add(NutritionConsultant);
                                    }
                                }
                                if (mNutritionConsultantsFilter.isEmpty()) {
                                    showMsg("查无此人");
                                    return;
                                }
                            } else {
                                mNutritionConsultantsFilter = mNutritionConsultants;
                            }
                            SelectorStaffAdapter mAdapter = new SelectorStaffAdapter(mNutritionConsultantsFilter, this, this);
                            selectorStaffListViewLv.setAdapter(mAdapter);
                        }
                    }
                }
                showMsg(result.getResultInfo());
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.dimission_query) {
            String barCode = staffNo.getText().toString().trim();
            if (TextUtils.isEmpty(barCode)) {
                showMsg(getString(R.string.staff_id_or_name));
            } else if (branchTitle.equals("员工离职")&&barCode.length()>=15){
                showMsg(getString(R.string.staff_id_or_name));
            } else{
                queryListInfo(barCode);
            }
        }
    }

    /**
     * 查询员工列表
     */
    protected void queryListInfo(String staffIdOrName) {
        //子类实现
        if (null != userInfo) {
            showDialog();
            String organizationId = userInfo.getOrganizationId();
            StaffManageService.getInstance().requestQueryNutritionConsultant(staffIdOrName, organizationId, SelectorStaffActivity.this);
        }
    }

    @Override
    public void getNutritionConsultant(NutritionConsultant mNutritionConsultant) {
        Bundle mBundle = new Bundle();
        mBundle.putLong("branchID", branchID);
        mBundle.putString("branchTitle", branchTitle);
        mBundle.putString("operatorId", mNutritionConsultant.getOperatorId());
        mBundle.putString("personalId", mNutritionConsultant.getPersonalId());
        RouterCommonUtil.startFunctionActivity(this, 0, branchID, mBundle);
    }
}