package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.TextView;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.db.BrandListDao;
import com.wgmf.yxgj.db.GreenDaoManager;
import com.wgmf.yxgj.db.NutritionConsultantDao;
import com.wgmf.yxgj.dialog.PublicConformTipDialog;
import com.wgmf.yxgj.dialog.PublicEdtDialog;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.global.OeRoleParams;
import com.wgmf.yxgj.model.BrandList;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.module.business.managestaff.graph.DaggerStaffInfoComponent;
import com.wgmf.yxgj.module.business.managestaff.graph.StaffInfoModule;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.module.business.managestaff.model.NutrSalaryProCityEntity;
import com.wgmf.yxgj.module.business.managestaff.model.Outsourced;
import com.wgmf.yxgj.model.SelectImageGroupList;
import com.wgmf.yxgj.module.business.managestaff.model.TrainTutorEntity;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;
import com.wgmf.yxgj.module.business.managestaff.service.StaffManageService;
import com.wgmf.yxgj.module.business.managestaff.ui.BrandSelectPop;
import com.wgmf.yxgj.module.business.managestaff.ui.SelectorChargeStaffActivity;
import com.wgmf.yxgj.module.business.managestaff.ui.SelectorProvinceCityActivity;
import com.wgmf.yxgj.module.business.managestaff.ui.SelectorSalaryCityActivity;
import com.wgmf.yxgj.module.business.managestaff.ui.SelectorStoreActivity;
import com.wgmf.yxgj.pop.PublicSelectPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.model.Shop;
import com.wgmf.yxgj.publics.ui.ReportTypeAdapter;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.io.Serializable;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.concurrent.TimeUnit;

import javax.inject.Inject;

import rx.functions.Action1;

/**
 * 员工管理公共类
 */
@SuppressWarnings("all")
public class StaffBaseActivity extends ReportWithPhotoBaseActivity implements StaffInfoView,
        View.OnClickListener, PublicSelectPop.ReportQuerySelectPopListener, ImagePickerLayout.ImagePicker,
        StaffSelectImageAdapter.LvListener, BrandSelectPop.ReportQuerySelectPopListener {

    private static final int SELECTOR_STORE = 1001;
    private static final int SELECTOR_PROVINCE = 1002;
    private static final int SELECTOR_BANKPROVINCE = 1003;
    private static final int SELECTOR_SALARYPROVINCE = 1004;

    protected static NutritionConsultantDao mNutritionConsultantDao;
    protected static BrandListDao mBrandListDao;
    private static final String JOB = "jobTv";// 岗位
    private static final String JOB1 = "jobTv1";// 岗位：只能选择驻店营养顾问
    private static final String EDU = "education";// 学历
    private static final String BANK = "bankTv";// 开户银行
    private static final String CHANNEL = "channel";// 招聘渠道
    private static final String SALARY = "SALARY";// 底薪增加值
    private static final String ALLOWANCE = "allowance";// 通讯补贴
    /**
     * 信息提交按钮
     */
    LinearLayout submitLl;
    Button submitRightBtn;
    Button submitLeftBrn;
    /**
     * 员工是否可入职备注信息
     */
    TextView staffEntryTipTv;
    LinearLayout staffEntryTipLl;
    LinearLayout staffInfoLl;

    /**
     * 离职信息
     */
    TextView dimissionInfoTv;
    /**
     * 基本信息
     */
    LinearLayout staffidLl;
    TextView staffid;
    EditText name;
    TextView jobTv;
    LinearLayout storePickLl;
    TextView storeOrSuperior;
    TextView store;
    EditText idCard;
    RadioButton man;
    RadioButton women;
    LinearLayout educationLl;
    TextView education;
    TextView province;
    LinearLayout addressLl;
    EditText address;
    TextView birthday;
    TextView entrydate;
    LinearLayout staffStatusLl;
    TextView staffStatusTxt;
    EditText phone;
    LinearLayout urgencyPersonLl;
    EditText urgencyPerson;
    LinearLayout urgencyPhoneLl;
    EditText urgencyPhone;
    LinearLayout recuitmentChannelLl;
    TextView recuitmentChannel;
    LinearLayout ifRelativesSelectorLl;
    RadioButton relativesYes;
    RadioButton relativesNo;
    LinearLayout relativesLl;
    EditText relatives;
    LinearLayout relativespostLl;
    EditText relativespost;
    LinearLayout trainTutorLl;
    TextView trainTutor;
    LinearLayout ifOutsourcingSelectorLl;
    RadioButton outsourcingYes;
    RadioButton outsourcingNo;
    LinearLayout outsourcingLl;
    TextView outsourcing;
    LinearLayout healthynoLl;
    EditText healthyno;
    LinearLayout mechanismnameLl;
    EditText mechanismname;
    LinearLayout medicaltimeLl;
    TextView medicaltime;
    LinearLayout healthytimeLl;
    TextView healthytime;
    TextView brandPick;
    /**
     * 是否可返聘信息
     */
    LinearLayout isRehireLl;
    LinearLayout lzTypeLl;
    LinearLayout lzReasonLl;
    LinearLayout workTimeLl;
    TextView isRehireTxt;
    TextView lzTypeTxt;
    TextView lzReasonTxt;
    TextView workTimeTxt;

    /**
     * 社保信息(只供查询，不可修改)
     */
    LinearLayout isSocialSecurityLl;
    LinearLayout socialSecurityCityLl;
    LinearLayout oaCodeLl;
    LinearLayout beginDateContractLl;
    LinearLayout endDateContractLl;
    LinearLayout termContractLl;
    TextView isSocialSecurity;
    TextView socialSecurityCity;
    TextView oaCode;
    TextView beginDateContract;
    TextView endDateContract;
    TextView termContract;
    /**
     * 薪资信息
     */
    TextView bankTv;
    EditText bankNo;
    TextView bankProvince;
    LinearLayout bankProvinceDetailLl;
    EditText bankProvinceDetail;
    TextView salary;
    TextView basicSalaryAdd;
    EditText jobSalary;
    TextView communicationAllowance;
    EditText trafficsubsidyAllowance;
    EditText loveSalary;
    LinearLayout trafficsubsidyAllowanceLl;
    LinearLayout basicSalaryAddLl;
    TextView liveCity;

    PublicSelectPop outsourcedSelectPop;
    BrandSelectPop brandSelectPop;

    @Inject
    StaffInfoPersenter staffInfoPersenter;

    /**
     * 1,带培督导 2，外包公司
     */
    int popType;
    /**
     * 员工工号
     */
    String operatorId;
    /**
     * 身份证号
     */
    String personalId;
    /**
     * 带培督导工号
     */
    String trainTutorId = "";
    /**
     * 外包公司编号
     */
    String outsourcingId = "";
    /**
     * 驻店营养顾问入职门店ID
     */
    String shopId = "";
    /**
     * 门店销售城市id（新增的时候 底薪对应省份市区）
     */
    Integer shopCityCountryId;
    /**
     * 门店集合
     */
    List<Shop> shopList = new ArrayList<>();
    /**
     * 顾问品牌
     */
    BrandList brandList = new BrandList();
    /**
     * 顾问品牌集合
     */
    List<BrandList> brandLists;
    /**
     * 流动营养顾问入职上级销售组织
     */
    String saleOrganization = "";

    List<String> stringArray;

    /**
     * 数据表Id
     */
    Long staffDbId = 0L;

    String branchTitle;

    Long branchID;
    /**
     * 编辑模式标志 false:查询模式；true:编辑模式
     */
    boolean editFlag = false;
    /**
     * 暂存功能标志 false：非暂存；true：暂存
     */
    boolean temporarySave;

    StaffSelectImageAdapter subjectAdapter;

    ListViewForScrollView staffEntryListViewLv;

    List<SelectImageGroupList> staffImageGroupLists = new ArrayList<>();

    NutritionConsultant nutritionConsultant = new NutritionConsultant();

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        checkStaff();
        setContentView(R.layout.staff_info_activity);
        initTitle();
        initContentView();
        initLayout();
        initLisener();
        initInjector();
        initData();
        initPictureDisplayView();
        initBrand();
    }

    private void initBrand() {
        //顾问品牌默认为从登录接口获取到的数组中的第一组数据
        brandLists = mBrandListDao.loadAll();
        brandList = brandLists.get(0);
        brandPick.setText(brandList.getBrandName());
    }

    private void initPictureDisplayView() {
        staffEntryListViewLv = (ListViewForScrollView) this.findViewById(R.id.staff_entry_list_view_lv);
        TextView emptyTv = (TextView) findViewById(R.id.staff_entry_list_view_empty_tv);
        staffEntryListViewLv.setEmptyView(emptyTv);
        // 从数据源获取一级和二级标题
        staffImageGroupLists = StaffInfoCheck.getSubjectItems(this);
        subjectAdapter = new StaffSelectImageAdapter(staffImageGroupLists, this, this);
        staffEntryListViewLv.setAdapter(subjectAdapter);
    }

    private void checkStaff() {
        operatorId = getIntent().getStringExtra("operatorId");
        personalId = getIntent().getStringExtra("personalId");
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        if (StringUtil.isNullOrEmpty(personalId) && (541 == branchID || 536 == branchID)) {
            //离职或查询/修改时，如果personalId为空，表示还进行员工信息查询，进入员工选择界面
            Intent intent = new Intent();
            intent.putExtra("branchTitle", branchTitle);
            intent.putExtra("branchID", branchID);
            intent.setClass(this, SelectorStaffActivity.class);
            startActivity(intent);
            this.finish();
        }
    }

    private void initInjector() {
        DaggerStaffInfoComponent.builder()
                .staffInfoModule(new StaffInfoModule(this))
                .build().inject(this);
    }

    /**
     * 初始化布局
     */
    private void initContentView() {
        initListView();
        initSubmitView();
    }

    private void initSubmitView() {
        submitLl = (LinearLayout) findViewById(R.id.submit_ll);
        submitRightBtn = (Button) findViewById(R.id.submit_right_btn);
        submitLeftBrn = (Button) findViewById(R.id.submit_left_btn);
    }

    private void initListView() {
        staffEntryTipLl = (LinearLayout) findViewById(R.id.staff_entry_tip_ll);
        staffEntryTipTv = (TextView) findViewById(R.id.staff_entry_tip_tv);

        staffInfoLl = (LinearLayout) findViewById(R.id.staff_info_ll);
        dimissionInfoTv = (TextView) findViewById(R.id.dimission_info_tv);
        //基本信息
        staffidLl = (LinearLayout) findViewById(R.id.staffid_ll);
        staffid = (TextView) findViewById(R.id.staffid);
        name = (EditText) findViewById(R.id.name);
        jobTv = (TextView) findViewById(R.id.job);
        storePickLl = (LinearLayout) findViewById(R.id.store_pick_ll);
        storeOrSuperior = (TextView) findViewById(R.id.store_or_superior);
        store = (TextView) findViewById(R.id.store_pick);
        idCard = (EditText) findViewById(R.id.id_card);
        man = (RadioButton) findViewById(R.id.man);
        women = (RadioButton) findViewById(R.id.women);
        educationLl = (LinearLayout) findViewById(R.id.education_ll);
        education = (TextView) findViewById(R.id.education);
        province = (TextView) findViewById(R.id.province);
        addressLl = (LinearLayout) findViewById(R.id.address_ll);
        address = (EditText) findViewById(R.id.address);
        birthday = (TextView) findViewById(R.id.birthday);
        entrydate = (TextView) findViewById(R.id.entrydate);
        entrydate.setText(DateUtil.getDate(new Date()));
        staffStatusLl = (LinearLayout) findViewById(R.id.staff_status_ll);
        staffStatusTxt = (TextView) findViewById(R.id.staff_status_txt);
        phone = (EditText) findViewById(R.id.phone);
        urgencyPersonLl = (LinearLayout) findViewById(R.id.urgency_person_ll);
        urgencyPerson = (EditText) findViewById(R.id.urgency_person);
        urgencyPhoneLl = (LinearLayout) findViewById(R.id.urgency_phone_ll);
        urgencyPhone = (EditText) findViewById(R.id.urgency_phone);
        recuitmentChannelLl = (LinearLayout) findViewById(R.id.recuitment_channel_ll);
        recuitmentChannel = (TextView) findViewById(R.id.recuitment_channel);
        ifRelativesSelectorLl = (LinearLayout) findViewById(R.id.if_relatives_selector_ll);
        relativesYes = (RadioButton) findViewById(R.id.relatives_yes);
        relativesNo = (RadioButton) findViewById(R.id.relatives_no);
        relativesLl = (LinearLayout) findViewById(R.id.relatives_ll);
        relatives = (EditText) findViewById(R.id.relatives);
        relativespostLl = (LinearLayout) findViewById(R.id.relativespost_ll);
        relativespost = (EditText) findViewById(R.id.relativespost);
        trainTutorLl = (LinearLayout) findViewById(R.id.train_tutor_ll);
        trainTutor = (TextView) findViewById(R.id.train_tutor);
        ifOutsourcingSelectorLl = (LinearLayout) findViewById(R.id.if_outsourcing_selector_ll);
        outsourcingYes = (RadioButton) findViewById(R.id.outsourcing_yes);
        outsourcingNo = (RadioButton) findViewById(R.id.outsourcing_no);
        outsourcingLl = (LinearLayout) findViewById(R.id.outsourcing_ll);
        outsourcing = (TextView) findViewById(R.id.outsourcing);
        healthynoLl = (LinearLayout) findViewById(R.id.healthyno_ll);
        healthyno = (EditText) findViewById(R.id.healthyno);
        mechanismnameLl = (LinearLayout) findViewById(R.id.mechanismname_ll);
        mechanismname = (EditText) findViewById(R.id.mechanismname);
        medicaltimeLl = (LinearLayout) findViewById(R.id.medicaltime_ll);
        medicaltime = (TextView) findViewById(R.id.medicaltime);
        healthytimeLl = (LinearLayout) findViewById(R.id.healthytime_ll);
        healthytime = (TextView) findViewById(R.id.healthytime);
        brandPick = (TextView) findViewById(R.id.brand_pick);
        isSocialSecurityLl = (LinearLayout) findViewById(R.id.is_social_security_ll);
        isSocialSecurity = (TextView) findViewById(R.id.is_social_security);
        socialSecurityCityLl = (LinearLayout) findViewById(R.id.social_security_city_ll);
        socialSecurityCity = (TextView) findViewById(R.id.social_security_city);
        oaCodeLl = (LinearLayout) findViewById(R.id.oa_code_ll);
        oaCode = (TextView) findViewById(R.id.oa_code);
        beginDateContractLl = (LinearLayout) findViewById(R.id.begin_date_contract_ll);
        beginDateContract = (TextView) findViewById(R.id.begin_date_contract);
        endDateContractLl = (LinearLayout) findViewById(R.id.end_date_contract_ll);
        endDateContract = (TextView) findViewById(R.id.end_date_contract);
        termContractLl = (LinearLayout) findViewById(R.id.term_contract_ll);
        termContract = (TextView) findViewById(R.id.term_contract);
        //是否可返聘信息
        isRehireLl = (LinearLayout) findViewById(R.id.is_rehire_ll);
        isRehireTxt = (TextView) findViewById(R.id.is_rehire_txt);
        lzTypeLl = (LinearLayout) findViewById(R.id.lz_type_ll);
        lzTypeTxt = (TextView) findViewById(R.id.lz_type_txt);
        lzReasonLl = (LinearLayout) findViewById(R.id.lz_reason_ll);
        lzReasonTxt = (TextView) findViewById(R.id.lz_reason_txt);
        workTimeLl = (LinearLayout) findViewById(R.id.work_time_ll);
        workTimeTxt = (TextView) findViewById(R.id.work_time_txt);
        //薪资信息
        bankTv = (TextView) findViewById(R.id.bank);
        basicSalaryAdd = (TextView) findViewById(R.id.basic_salary_add);
        bankNo = (EditText) findViewById(R.id.bank_no);
        bankProvince = (TextView) findViewById(R.id.bank_province);
        bankProvinceDetailLl = (LinearLayout) findViewById(R.id.bank_province_detail_ll);
        bankProvinceDetail = (EditText) findViewById(R.id.bank_province_detail);
        salary = (TextView) findViewById(R.id.basic_salary);
        jobSalary = (EditText) findViewById(R.id.job_salary);
        communicationAllowance = (TextView) findViewById(R.id.communication_allowance);
        trafficsubsidyAllowance = (EditText) findViewById(R.id.trafficsubsidy_allowance);
        loveSalary = (EditText) findViewById(R.id.love_salary);
        trafficsubsidyAllowanceLl = (LinearLayout) findViewById(R.id.trafficsubsidy_allowance_ll);
        basicSalaryAddLl = (LinearLayout) findViewById(R.id.basic_salary_add_ll);
        liveCity = (TextView) findViewById(R.id.live_city);

        relativesYes.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    relativesLl.setVisibility(View.VISIBLE);
                    relativespostLl.setVisibility(View.VISIBLE);
                } else {
                    relativesLl.setVisibility(View.GONE);
                    relativespostLl.setVisibility(View.GONE);
                }
            }
        });
        relativesNo.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    relativesLl.setVisibility(View.GONE);
                    relativespostLl.setVisibility(View.GONE);
                } else {
                    relativesLl.setVisibility(View.VISIBLE);
                    relativespostLl.setVisibility(View.VISIBLE);
                }
            }
        });
        outsourcingYes.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    outsourcingLl.setVisibility(View.VISIBLE);
                } else {
                    outsourcingLl.setVisibility(View.GONE);
                }
            }
        });
        outsourcingNo.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    outsourcingLl.setVisibility(View.GONE);
                } else {
                    outsourcingLl.setVisibility(View.VISIBLE);
                }
            }
        });
    }

    private void initLisener() {
        initListLisener();
        initSubmitLisener();
    }

    private void initListLisener() {
        idCard.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {

                String str = idCard.getText().toString().trim();
                if (str.length() == 18) {
                    //身份证号填写完毕
                    str = str.substring(6, 14);
                    StringBuilder sb = new StringBuilder(str);
                    sb.insert(4, "-");
                    sb.insert(7, "-");
                    birthday.setText(sb.toString());
                    //查询营养顾问是否存在
                    queryNutritionConsultan(idCard.getText().toString().trim());
                }
            }
        });
        medicaltime.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before,
                                      int count) {

            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count,
                                          int after) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!TextUtils.isEmpty(s)) {
                    String str = medicaltime.getText().toString().trim();
                    if (str.length() == 10) {
                        //体检日期填写完毕
                        try {
                            healthytime.setText(DateUtil.getNextYear(str));
                        } catch (Exception e) {
                            int year = Integer.parseInt(str.substring(0, 4));
                            // 当体检时间填写后，自动填写有效期，默认值是体检日期+1年。
                            StringBuilder sb = new StringBuilder();
                            sb.append(year + 1);
                            sb.append(str.substring(5, 7));
                            sb.append(str.substring(8, 10));
                            //日期格式：yyyy-MM-dd
                            sb.insert(4, "-");
                            sb.insert(7, "-");
                            healthytime.setText(sb.toString());
                        }
                    }
                }
            }
        });
    }

    /**
     * 查询营养顾问信息
     *
     * @param idCard 身份证号
     */
    protected void queryNutritionConsultan(String idCard) {
        //子类实现
    }

    /**
     * 查询单个营养顾问面试评估记录
     *
     * @param idCard 身份证号
     */
    protected void getStaffAuditionAppraise(String idCard) {
        //子类实现
    }

    private void initSubmitLisener() {
        //1秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(submitRightBtn).throttleFirst(1, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                submitRightBtnUpdata();
            }
        });
        submitLeftBrn.setOnClickListener(this);//审批不通过
    }

    protected void submitRightBtnUpdata() {
    }

    /**
     * 初始化数据
     */
    protected void initData() {
        super.initData();
        mNutritionConsultantDao = GreenDaoManager.getInstance().getDaoSession(this).getNutritionConsultantDao();
        mBrandListDao = GreenDaoManager.getInstance().getDaoSession(this).getBrandListDao();
    }

    /**
     * 员工信息布局显示
     */
    protected void initLayout() {
        submitLl.setVisibility(View.GONE);
        staffEntryTipLl.setVisibility(View.GONE);
        staffInfoLl.setVisibility(View.GONE);
        dimissionInfoTv.setVisibility(View.GONE);
    }

    /**
     * 模式标志 0：查询模式；1:编辑模式；2:部分输入修改模式；
     */
    protected void setItemLayout(int mode) {
        Drawable drawable = ContextCompat.getDrawable(this, R.drawable.go);
        drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());//必须设置图片大小，否则不显示
        //默认是查询模式：文字颜色黑色；图标不显示；不可点击，不可输入
        setQueryLayout();
        if (mode == 1) {
            //1是编辑模式：文字颜色黑色；图标显示；可点击，可输入
            setEditLayout(drawable);
        } else if (mode == 2) {
            //2是部分修改模式：部分文字颜色灰色；图标显示；可点击，可输入
            setModifyLayout(drawable);
        }
    }

    private void setModifyLayout(Drawable drawable) {
        setItemTextView(staffid, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(jobTv, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(staffStatusTxt, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(entrydate, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(birthday, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(bankProvince, ContextCompat.getColor(this, R.color.common_txt_color), null, null);

        setItemTextView(liveCity, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(idCard, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(bankTv, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemTextView(basicSalaryAdd, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemEditView(bankNo, ContextCompat.getColor(this, R.color.common_txt_color), null, false);
        setItemTextView(salary, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemEditView(loveSalary, ContextCompat.getColor(this, R.color.common_txt_color), null, false);
        setItemEditView(jobSalary, ContextCompat.getColor(this, R.color.common_txt_color), null, false);
        setItemTextView(communicationAllowance, ContextCompat.getColor(this, R.color.common_txt_color), null, null);
        setItemEditView(trafficsubsidyAllowance, ContextCompat.getColor(this, R.color.common_txt_color), null, false);

        setItemEditView(name, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemTextView(store, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(brandPick, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemEditView(idCard, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemTextView(province, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemEditView(address, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemTextView(education, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemEditView(phone, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(urgencyPhone, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(urgencyPerson, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemTextView(trainTutor, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(recuitmentChannel, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemEditView(healthyno, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(mechanismname, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemTextView(medicaltime, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(healthytime, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
    }

    private void setEditLayout(Drawable drawable) {
        //设置文字显示控件状态
        setItemTextView(entrydate, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(jobTv, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(bankTv, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);

        setItemTextView(education, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(recuitmentChannel, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(relatives, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(outsourcing, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(relativespost, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(store, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(province, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(bankProvince, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(bankProvinceDetail, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(medicaltime, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(healthytime, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(trainTutor, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(brandPick, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
//        setItemTextView(liveCity, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
        setItemTextView(basicSalaryAdd, ContextCompat.getColor(this, R.color.important_txt_color), null, this);
        setItemTextView(salary, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        //设置输入控件状态
        setItemEditView(name, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(phone, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(urgencyPhone, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(urgencyPerson, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(address, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(idCard, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(bankNo, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(healthyno, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(mechanismname, ContextCompat.getColor(this, R.color.important_txt_color), drawable, true);
        setItemEditView(loveSalary, ContextCompat.getColor(this, R.color.important_txt_color), null, true);
        setItemEditView(jobSalary, ContextCompat.getColor(this, R.color.important_txt_color), null, true);
        setItemTextView(communicationAllowance, ContextCompat.getColor(this, R.color.important_txt_color), null, this);
        setItemEditView(trafficsubsidyAllowance, ContextCompat.getColor(this, R.color.important_txt_color), null, true);
    }

    private void setQueryLayout() {
        //设置文字显示控件状态
        setItemTextView(entrydate, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(jobTv, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(bankTv, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(basicSalaryAdd, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(education, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(recuitmentChannel, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(relatives, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(outsourcing, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(relativespost, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(store, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(province, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(bankProvince, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(bankProvinceDetail, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(brandPick, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
//        setItemTextView(liveCity, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(medicaltime, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(healthytime, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(trainTutor, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemTextView(salary, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        //设置输入控件状态
        setItemEditView(name, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(phone, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(urgencyPhone, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(urgencyPerson, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(address, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(idCard, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(bankNo, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(healthyno, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(mechanismname, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(loveSalary, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemEditView(jobSalary, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
        setItemTextView(communicationAllowance, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
        setItemEditView(trafficsubsidyAllowance, ContextCompat.getColor(this, R.color.important_txt_color), null, false);
    }

    /**
     * @param color
     * @param image
     * @param listener
     */
    private void setItemTextView(TextView view, int color, Drawable image, View.OnClickListener listener) {
        view.setTextColor(color);
        view.setCompoundDrawables(null, null, image, null);
        view.setOnClickListener(listener);
    }

    /**
     * @param color
     * @param image
     * @param enabled
     */
    private void setItemEditView(EditText view, int color, Drawable image, boolean enabled) {
        view.setTextColor(color);
        view.setCompoundDrawables(null, null, image, null);
        view.setEnabled(enabled);
    }

    public void showReportType(final String type) {
        View v = getLayoutInflater().inflate(R.layout.report_type_popupwindow, null);
        final ListView listview = (ListView) v.findViewById(R.id.report_type_listview);
        View view1 = v.findViewById(R.id.report_type_cancel);
        final PopupWindow pw1 = new PopupWindow(v, WindowManager.LayoutParams.MATCH_PARENT,
                WindowManager.LayoutParams.MATCH_PARENT, true);
        pw1.setFocusable(true);
        pw1.setBackgroundDrawable(new BitmapDrawable());
        pw1.showAtLocation(this.findViewById(R.id.title), Gravity.BOTTOM, 0, 0);
        view1.setOnClickListener(this);

        if (EDU.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.education));
        } else if (JOB.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.job));
        } else if (JOB1.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.job1));
        } else if (BANK.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.bank));
        } else if (CHANNEL.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.channel));
        } else if (SALARY.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.salary));
        } else if (ALLOWANCE.equals(type)) {
            stringArray = Arrays.asList(getResources().getStringArray(R.array.communication_allowance));
        }
        stringArray = new ArrayList<>(stringArray);
        final ReportTypeAdapter reportTypeAdapter = new ReportTypeAdapter(stringArray, this);
        listview.setAdapter(reportTypeAdapter);
        ListViewUtil.setListViewHeight(listview);
        listview.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                if (EDU.equals(type)) {
                    education.setText(stringArray.get(position));
                } else if (JOB.equals(type) || JOB1.equals(type)) {
                    jobTv.setText(stringArray.get(position));
                    switchJob();
                } else if (BANK.equals(type)) {
                    bankTv.setText(stringArray.get(position));
                } else if (CHANNEL.equals(type)) {
                    recuitmentChannel.setText(stringArray.get(position));
                } else if (SALARY.equals(type)) {
                    basicSalaryAdd.setText(stringArray.get(position));
                } else if (ALLOWANCE.equals(type)) {
                    communicationAllowance.setText(stringArray.get(position));
                }
                pw1.dismiss();
            }
        });
    }

    /**
     * 顾问岗位选择
     */
    private void switchJob() {
        if (!TextUtils.isEmpty(jobTv.getText().toString().trim())) {
            if ("驻店营养顾问".equals(jobTv.getText().toString().trim()) || "店长".equals(jobTv.getText().toString().trim())) {
                storeOrSuperior.setText("所属门店");
                basicSalaryAddLl.setVisibility(View.GONE);
                trafficsubsidyAllowanceLl.setVisibility(View.GONE);
                storePickLl.setVisibility(View.VISIBLE);
                //清除底薪标准和所属门店数据
                liveCity.setText("");
                salary.setText("");
                //驻店营养顾问所在城市和底薪标准确定，不能修改
                liveCity.setOnClickListener(null);
                setItemTextView(liveCity, ContextCompat.getColor(this, R.color.important_txt_color), null, null);
            } else if ("流动营养顾问".equals(jobTv.getText().toString().trim())) {
                //流动营养顾问入职显示上级主管
                storeOrSuperior.setText("上级主管");
                basicSalaryAddLl.setVisibility(View.VISIBLE);
                trafficsubsidyAllowanceLl.setVisibility(View.VISIBLE);
                storePickLl.setVisibility(View.VISIBLE);
                //清除底薪标准和所属门店数据
                liveCity.setText("");
                salary.setText("");
                //流动营养顾问所在城市和底薪标准不确定，可选择
                liveCity.setOnClickListener(this);
                Drawable drawable = ContextCompat.getDrawable(this, R.drawable.go);
                drawable.setBounds(0, 0, drawable.getMinimumWidth(), drawable.getMinimumHeight());//必须设置图片大小，否则不显示
                setItemTextView(liveCity, ContextCompat.getColor(this, R.color.important_txt_color), drawable, this);
            }
            store.setText(R.string.empty_etb_hint_select_txt);
        }
    }

    private void getTrainTutorInfo(DialogInterface dialog, PublicEdtDialog.Builder builder) {
        trainTutor.setText("");
        trainTutorId = builder.getProNum();
        StaffManageService.getInstance().requestFindTrainTutor(trainTutorId, shopId, this);
        dialog.dismiss();
    }

    /**
     * 查询员工信息
     *
     * @param operId 员工ID
     */
    protected void queryInfo(String operId) {
        if (userInfo != null) {
            showDialog();
            String organizationId = userInfo.getOrganizationId();
            StaffManageService.getInstance().requestQueryNutritionConsultant(operId, organizationId, this);
        }
    }

    /**
     * 查询信息填充，不可点击
     */
    protected void fillData(NutritionConsultant item) {
        storePickLl.setVisibility(View.VISIBLE);
        store.setVisibility(View.VISIBLE);
        //对象转Json存储
        if (null != item.getBrandList() && !item.getBrandList().isEmpty()) {
            item.setBrandListString(new Gson().toJson(item.getBrandList()));
        }
        if (null != item.getShopList() && !item.getShopList().isEmpty()) {
            item.setShopListString(new Gson().toJson(item.getShopList()));
        }
        //员工Id
        staffid.setText(item.getOperatorId());
        //员工名字
        name.setText(item.getOperName());
        // 岗位
        if (StringUtil.isNotNullAndNotEmpty(item.getRoleStatus())) {
            jobTv.setText(StaffInfoCheck.getPosition(item.getRoleStatus()));
            switchJob();
        }
        //所属门店或上级主管
        if (ConstantParams.CONSTANT_PARAMS_2.equals(item.getRoleStatus())) {
            storeOrSuperior.setText("上级主管");
            store.setText(item.getOrgName());
            saleOrganization = item.getSaleOrganization() + "";
            shopCityCountryId = item.getShopCityCountryId();
            basicSalaryAddLl.setVisibility(View.VISIBLE);
            trafficsubsidyAllowanceLl.setVisibility(View.VISIBLE);
        } else if (ConstantParams.CONSTANT_PARAMS_1.equals(item.getRoleStatus()) || ConstantParams.CONSTANT_PARAMS_15.equals(item.getRoleStatus())) {
            //驻店顾问和店长可修改归属门店
            storeOrSuperior.setText("所属门店");
            //Json转对象
            Type listType = new TypeToken<List<Shop>>() {
            }.getType();
            List<Shop> resources = new Gson().fromJson(item.getShopListString(), listType);
            if (null != resources && !resources.isEmpty()) {
                if (StringUtil.isNotNullAndNotEmpty(resources.get(0).getShopName())) {
                    store.setText(StaffInfoCheck.getShopName(resources));
                    shopList = resources;
                }
            }
            basicSalaryAddLl.setVisibility(View.GONE);
            trafficsubsidyAllowanceLl.setVisibility(View.GONE);
        } else {
            storePickLl.setVisibility(View.GONE);
        }
        //身份证号码：此处填充会多次调用
        if (idCard.getText().toString().trim().length() < 18) {
            idCard.setText(item.getPersonalId());
        }
        //性别
        if (StringUtil.isNotNullAndNotEmpty(item.getSex())) {
            if ("N".equals(item.getSex()) || "男".equals(item.getSex())) {
                man.setChecked(true);
                women.setChecked(false);
            } else if ("V".equals(item.getSex()) || "女".equals(item.getSex())) {
                man.setChecked(false);
                women.setChecked(true);
            }
        }
        //籍贯
        province.setText(item.getRyjg());
        //出生日期
        birthday.setText(item.getBirthday());
        //入职日期
        entrydate.setText(item.getWorkDate());
        //联系电话
        phone.setText(item.getMobilePhone());
        //现住址
        address.setText(item.getNowAddress());
        addressLl.setVisibility(View.VISIBLE);
        //学历
        education.setText(StaffInfoCheck.getDegree(item.getXlId()));
        educationLl.setVisibility(View.VISIBLE);
        //紧急联系人
        urgencyPerson.setText(item.getEmergencyName());
        urgencyPersonLl.setVisibility(View.VISIBLE);
        //紧急联系电话
        urgencyPhone.setText(item.getPhone());
        //招聘来源
        recuitmentChannel.setText(StaffInfoCheck.getRecuitmentChannel(item.getZply()));
        recuitmentChannelLl.setVisibility(View.VISIBLE);
        //有无亲属在公司
        if ("Y".equals(item.getIfrelatives())) {
            relativesYes.setChecked(true);
            relativesNo.setChecked(false);
        } else if ("N".equals(item.getIfrelatives())) {
            relativesYes.setChecked(false);
            relativesNo.setChecked(true);
        }
        //亲属姓名
        relatives.setText(item.getRelatives());
        //亲属职位
        relativespost.setText(item.getRelativesPost());
        //是否外包
        if (!StringUtil.isNullOrEmpty(item.getOutsourcedNo())) {
            outsourcingYes.setChecked(true);
            outsourcingNo.setChecked(false);
        } else {
            outsourcingYes.setChecked(false);
            outsourcingNo.setChecked(true);
        }
        //外包公司
        outsourcingId = item.getOutsourcedNo();
        outsourcing.setText(item.getOutsourcedName());
        //带培导师工号
        trainTutorId = item.getTrainTutorId();
        //带培导师
        trainTutor.setText(item.getTrainTutorName());
        trainTutorLl.setVisibility(View.VISIBLE);
        //如果是已离职状态，则可查询是否可返聘
        if (ConstantParams.CONSTANT_PARAMS_1.equals(item.getStatus())) {
            //是否可返聘
            if (!item.isRehire()) {
                isRehireLl.setVisibility(View.GONE);
            } else {
                isRehireTxt.setText("是");
                isRehireLl.setVisibility(View.VISIBLE);
            }
            //离职类型
            if (StringUtil.isNullOrEmpty(item.getLztype())) {
                lzTypeLl.setVisibility(View.GONE);
            } else {
                lzTypeTxt.setText(StaffInfoCheck.gedissmissType(item.getLztype()));
                lzTypeLl.setVisibility(View.VISIBLE);
            }
            //离职原因
            lzReasonTxt.setText(item.getLzreason());
            lzReasonLl.setVisibility(View.VISIBLE);
            //离职时间
            if ((null != item.getLeavNutConWorkDataList() && !item.getLeavNutConWorkDataList().isEmpty())) {
                workTimeTxt.setText(StaffInfoCheck.getleavNutConWorkData(item));
                workTimeLl.setVisibility(View.VISIBLE);
            }
        }
        //是否购买社保
        isSocialSecurity.setText(item.isSocialSecurity() ? "是" : "否");
        isSocialSecurityLl.setVisibility(View.VISIBLE);
        //购买城市
        socialSecurityCity.setText(item.getSocialSecurityCity());
        socialSecurityCityLl.setVisibility(View.VISIBLE);
        //OA流水号
        oaCode.setText(item.getOaCode());
        oaCodeLl.setVisibility(View.VISIBLE);
        //劳动合同开始时间
        beginDateContract.setText(item.getBeginDateContract());
        beginDateContractLl.setVisibility(View.VISIBLE);
        endDateContract.setText(item.getEndDateContract());
        endDateContractLl.setVisibility(View.VISIBLE);
        //劳动合同期限
        termContract.setText(item.getTermContract());
        termContractLl.setVisibility(View.VISIBLE);
        //健康证编号
        healthyno.setText(item.getHealthyNo());
        healthynoLl.setVisibility(View.VISIBLE);
        //体检机构
        mechanismname.setText(item.getMechanismName());
        mechanismnameLl.setVisibility(View.VISIBLE);
        medicaltime.setText(item.getMedicalTime());
        medicaltimeLl.setVisibility(View.VISIBLE);
        healthytime.setText(item.getHealthyTime());
        healthytimeLl.setVisibility(View.VISIBLE);
        //开户银行
        bankTv.setText(item.getBankName());
        basicSalaryAdd.setText(item.getSalaryIncrease());
        //银行账号
        bankNo.setText(item.getAccountId());
        //开户省市
        bankProvince.setText(item.getBankCity());
        //开户行信息
        if (StringUtil.isNotNullAndNotEmpty(item.getBankCityDetail())) {
            bankProvinceDetail.setText(item.getBankCityDetail());
            bankProvinceDetailLl.setVisibility(View.VISIBLE);
        } else {
            bankProvinceDetailLl.setVisibility(View.GONE);
        }
        //所在城市
        liveCity.setText(item.getShopSlaryAdress());
        //基本工资
        salary.setText(item.getJbNet());
        //岗位工资
        jobSalary.setText(item.getGwNet());
        //通讯补贴
        communicationAllowance.setText(item.getCommSubsidy());
        //交通补贴
        trafficsubsidyAllowance.setText(item.getTrafficSubsidy());
        //爱心工资
        loveSalary.setText(item.getAxNet());
        //顾问品牌Json转对象
        Type listType = new TypeToken<List<BrandList>>() {
        }.getType();
        List<BrandList> resources = new Gson().fromJson(item.getBrandListString(), listType);
        if (null != resources && !resources.isEmpty()) {
            if (StringUtil.isNotNullAndNotEmpty(resources.get(0).getBrandName())) {
                brandPick.setText(StaffInfoCheck.getBrandName(resources));
                brandList = resources.get(0);
            }
        }
        //图片填充
        //身份证照片 逗号分隔多张图片
        if (!StringUtil.isNullString(item.getPersonalidImg())) {
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            if (item.getPersonalidImg().contains(",")) {
                String[] personalidImgs = item.getPersonalidImg().split(",");//中文或英文字符？
                for (int i = 0; i < personalidImgs.length; i++) {
                    if (!"null".equals(personalidImgs[i])) {
                        ImageItem item1 = new ImageItem();
                        item1.setImgneturl(personalidImgs[i]);
                        item1.setImagePath(personalidImgs[i]);
                        item1.setImageId(personalidImgs[i]);
                        item1.setUri(Uri.fromFile(new File(personalidImgs[i])));
                        item1.setType(1);
                        mImageselectList.add(item1);
                    }
                }
            } else {
                ImageItem item1 = new ImageItem();
                item1.setImgneturl(item.getPersonalidImg());
                item1.setImagePath(item.getPersonalidImg());
                item1.setImageId(item.getPersonalidImg());
                item1.setUri(Uri.fromFile(new File(item.getPersonalidImg())));
                item1.setType(1);
                mImageselectList.add(item1);
            }
            staffImageGroupLists.get(0).setStoreImageselectList(mImageselectList);
        }
        //个人生活照
        if (!StringUtil.isNullString(item.getLifePhotosUrl())) {
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            ImageItem item1 = new ImageItem();
            item1.setImgneturl(item.getLifePhotosUrl());
            item1.setImagePath(item.getLifePhotosUrl());
            item1.setImageId(item.getLifePhotosUrl());
            item1.setUri(Uri.fromFile(new File(item.getLifePhotosUrl())));
            item1.setType(1);
            mImageselectList.add(item1);
            staffImageGroupLists.get(1).setStoreImageselectList(mImageselectList);
        }
        //合同照片
        if (!StringUtil.isNullString(item.getContractImg())) {
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            ImageItem item1 = new ImageItem();
            item1.setImgneturl(item.getContractImg());
            item1.setImagePath(item.getContractImg());
            item1.setImageId(item.getContractImg());
            item1.setUri(Uri.fromFile(new File(item.getContractImg())));
            item1.setType(1);
            mImageselectList.add(item1);
            staffImageGroupLists.get(2).setStoreImageselectList(mImageselectList);
        }
        //健康证照片
        if (!StringUtil.isNullString(item.getHealthyImg())) {
            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
            ImageItem item1 = new ImageItem();
            item1.setImgneturl(item.getHealthyImg());
            item1.setImagePath(item.getHealthyImg());
            item1.setImageId(item.getHealthyImg());
            item1.setUri(Uri.fromFile(new File(item.getHealthyImg())));
            item1.setType(1);
            mImageselectList.add(item1);
            staffImageGroupLists.get(3).setStoreImageselectList(mImageselectList);
        }
        subjectAdapter = new StaffSelectImageAdapter(staffImageGroupLists, this, this);
        staffEntryListViewLv.setAdapter(subjectAdapter);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        staffInfoPersenter.switchService(result);
    }

    @Override
    public void onAdapterItemClick(int position, List<BaseSelectorEntity> reportQuerys) {
        if (popType == 1) {
            trainTutor.setText(reportQuerys.get(position).getSelectorName());
            trainTutorId = reportQuerys.get(position).getSelectorId();
        } else if (popType == 2) {
            outsourcing.setText(reportQuerys.get(position).getSelectorName());
            outsourcingId = reportQuerys.get(position).getSelectorId();
        }
    }

    @Override
    public void showTip(String msg) {
        if (branchID == 535 && null != msg && msg.contains("查无此人")) {
            return;
        }
        ToastUtil.show(this, msg);
    }

    @Override
    public void destoryView() {
        this.finish();
    }

    @Override
    public void sendMessageToJPush(String operatorId) {
        //子类实现
    }

    @Override
    public void findNutritionConsultant(NutritionConsultant nutritionConsultant) {
        this.nutritionConsultant = nutritionConsultant;//将查询到的顾问信息放入提交实体

//        String msgs = AssetsUtil.getFromAssets(this, "StaffData.json");
//        nutritionConsultant = new Gson().fromJson(msgs, NutritionConsultant.class);
        onFindNutritionConsultant(nutritionConsultant);
    }

    protected void onFindNutritionConsultant(NutritionConsultant nutritionConsultant) {
        //子类实现
    }

    @Override
    public void checkNutritionConsultant(boolean isSuccessed) {
        //子类实现
    }

    @Override
    public void findTrainTutor(TrainTutorEntity mTrainTutorEntitys) {
        trainTutor.setText(mTrainTutorEntitys.getTrainTutorName());
        trainTutorId = mTrainTutorEntitys.getTrainTutorId();
    }

    @Override
    public void findOutsourced(List<Outsourced> mOutsourced) {
        if (null == outsourcedSelectPop) {
            outsourcedSelectPop = new PublicSelectPop(this, this, staffInfoPersenter.getOutsourced(mOutsourced));
        }
        if (!outsourcedSelectPop.isShowing()) {
            outsourcedSelectPop.show(this.findViewById(R.id.title));
        }
    }

    @Override
    public void checkInterviewAssemnet(InterviewAssessmentEntity mInterviewAssessmentEntity) {
        //子类实现
    }

    @Override
    public void interviewIsSuccessed(boolean isSuccessed) {
        //子类实现
    }

    @Override
    public void enterInterview() {
        //查询员工不存在则进行面试评估校验
        getStaffAuditionAppraise(idCard.getText().toString().trim());
    }


    @Override
    public void reEmployNutritionConsultant(NutritionConsultant nutritionConsultant) {
        staffEntryTipLl.setVisibility(View.VISIBLE);
        staffEntryTipTv.setText(R.string.staff_rehire_tip_tv);
        if (nutritionConsultant.isRehire()) {
            //如果可返聘，进入返聘流程
            submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_week_normal_style));
            submitRightBtn.setTextColor(R.color.important_txt_color);
            submitRightBtn.setText("去返聘");
            submitRightBtn.setVisibility(View.VISIBLE);
            if (branchID == 535) {
                createReEmployDialog(nutritionConsultant);
            }
            submitLeftBrn.setVisibility(View.GONE);
        } else {
            //否则提示不可返聘
            staffEntryTipLl.setVisibility(View.GONE);
            homeTitleText.setText("员工返聘");
            submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_week_normal_style));
            submitRightBtn.setOnClickListener(null);
            submitRightBtn.setTextColor(R.color.common_txt_color);
            submitRightBtn.setText("不可返聘");
            submitRightBtn.setVisibility(View.VISIBLE);
            createConfirmDialog(nutritionConsultant);
            submitLeftBrn.setVisibility(View.GONE);
        }
    }

    /**
     * 进入返聘流程
     *
     * @param nutritionConsultant
     */
    protected void entryRehire(NutritionConsultant item) {
        operatorId = item.getOperatorId();
        staffidLl.setVisibility(View.VISIBLE);
        storePickLl.setVisibility(View.VISIBLE);
        store.setVisibility(View.VISIBLE);
        //员工Id
        staffid.setText(item.getOperatorId());
        //员工名字
        name.setText(item.getOperName());
        // 岗位
        jobTv.setText("驻店营养顾问");
        //所属门店或上级主管
        storeOrSuperior.setText("所属门店");
        store.setText("");
        shopList.clear();
//        shopId = item.getShopId() + "";
        //底薪增加值
        basicSalaryAddLl.setVisibility(View.GONE);
        //交通补贴
        trafficsubsidyAllowanceLl.setVisibility(View.GONE);
        //身份证号码：此处填充会多次调用
        if (idCard.getText().toString().trim().length() < 18) {
            idCard.setText(item.getPersonalId());
        }
        //性别
        if ("N".equals(item.getSex()) || "男".equals(item.getSex())) {
            man.setChecked(true);
            women.setChecked(false);
        } else if ("V".equals(item.getSex()) || "女".equals(item.getSex())) {
            man.setChecked(false);
            women.setChecked(true);
        }
        //籍贯
        province.setText(item.getRyjg());
        //出生日期
        birthday.setText(item.getBirthday());
        //入职日期
        entrydate.setText("");
        //联系电话
        phone.setText("");
        //现住址
        address.setText("");
        addressLl.setVisibility(View.VISIBLE);
        //学历
        education.setText(StaffInfoCheck.getDegree(item.getXlId()));
        educationLl.setVisibility(View.VISIBLE);
        //紧急联系人
        urgencyPerson.setText("");
        urgencyPersonLl.setVisibility(View.VISIBLE);
        //紧急联系电话
        urgencyPhone.setText("");
        //招聘来源
        recuitmentChannel.setText("");
        recuitmentChannelLl.setVisibility(View.VISIBLE);
        //有无亲属在公司
        ifRelativesSelectorLl.setVisibility(View.VISIBLE);
        relativesYes.setChecked(false);
        relativesNo.setChecked(true);
        //亲属姓名
        relatives.setText("");
        relativesLl.setVisibility(View.GONE);
        //亲属职位
        relativespost.setText("");
        relativespostLl.setVisibility(View.GONE);
        //是否外包
        ifOutsourcingSelectorLl.setVisibility(View.VISIBLE);
        outsourcingYes.setChecked(false);
        outsourcingNo.setChecked(true);
        //外包公司
        outsourcingId = "";
        outsourcing.setText("");
        outsourcingLl.setVisibility(View.GONE);
        //带培导师工号
        trainTutorId = "";
        //带培导师
        trainTutor.setText("");
        //顾问品牌
        brandPick.setText("");
        trainTutorLl.setVisibility(View.VISIBLE);
        //如果是已离职状态，则可查询是否可返聘
        //是否可返聘
        staffStatusLl.setVisibility(View.GONE);
        isRehireLl.setVisibility(View.GONE);
        lzTypeLl.setVisibility(View.GONE);
        lzReasonLl.setVisibility(View.GONE);
        //离职时间
        workTimeLl.setVisibility(View.GONE);
        //是否购买社保
        isSocialSecurityLl.setVisibility(View.GONE);
        socialSecurityCityLl.setVisibility(View.GONE);
        oaCodeLl.setVisibility(View.GONE);
        //劳动合同开始时间
        beginDateContractLl.setVisibility(View.GONE);
        //劳动合同结束时间
        endDateContractLl.setVisibility(View.GONE);
        //劳动合同期限
        termContractLl.setVisibility(View.GONE);
        //健康证编号
        healthyno.setText("");
        healthynoLl.setVisibility(View.VISIBLE);
        //体检机构
        mechanismname.setText("");
        mechanismnameLl.setVisibility(View.VISIBLE);
        //体检时间
        medicaltime.setText("");
        medicaltimeLl.setVisibility(View.VISIBLE);
        //健康证有效期
        healthytime.setText("");
        healthytimeLl.setVisibility(View.VISIBLE);
        //开户银行
        bankTv.setText("");
        //银行账号
        bankNo.setText("");
        //开户省市
        bankProvince.setText("");
        //开户行信息
        bankProvinceDetail.setText("");
        bankProvinceDetailLl.setVisibility(View.VISIBLE);
        //所在城市
        liveCity.setText("");
        //基本工资
        salary.setText("");
        // 底薪增加值:默认值200
        basicSalaryAdd.setText("200");
        //岗位工资
        jobSalary.setText("");
        //通讯补贴
        communicationAllowance.setText("");
        communicationAllowance.setHint(getString(R.string.empty_etb_hint_select_txt));
        //交通补贴
        trafficsubsidyAllowance.setText("");
        //爱心工资
        loveSalary.setText("");

        setItemLayout(1);
        //返聘不用清除照片信息
//        initPictureDisplayView();
    }

    @Override
    public void modifyNutritionConsultant(NutritionConsultant nutritionConsultant) {
        if ("入职办理".equals(homeTitleText.getText().toString())) {
            submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_week_normal_style));
            submitRightBtn.setOnClickListener(null);
            submitRightBtn.setTextColor(R.color.common_txt_color);
            submitRightBtn.setText("不可入职");
            submitLeftBrn.setVisibility(View.GONE);
            showTip("员工已在职，不可以入职");
        }
    }

    @Override
    public void showNutrSalaryProCity(List<NutrSalaryProCityEntity> nutrSalaryProCityEntitys) {
        if ("驻店营养顾问".equals(jobTv.getText().toString()) || "店长".equals(jobTv.getText().toString())) {
            liveCity.setText(nutrSalaryProCityEntitys.get(0).getProvinceName()
                    + nutrSalaryProCityEntitys.get(0).getCityName()
                    + nutrSalaryProCityEntitys.get(0).getCountyName());
            salary.setText(nutrSalaryProCityEntitys.get(0).getSalary() + "");
        } else {
            //流动营养顾问进入选择城市页面
            Intent intent = new Intent();
            intent.putExtra("entryNutrConBrand", brandList.getBrandId());
            intent.putExtra("nutrSalaryProCityEntitys", (Serializable) nutrSalaryProCityEntitys);
            intent.setClass(this, SelectorSalaryCityActivity.class);
            startActivityForResult(intent, SELECTOR_SALARYPROVINCE);
        }
    }

    /**
     * 选择门店
     *
     * @param mSelectorEntity 选中后返回的门店信息
     */
    @Override
    public void selectorStore(BaseSelectorEntity mSelectorEntity) {
        saleOrganization = mSelectorEntity.getSelectorCode();
        if ("驻店营养顾问".equals(jobTv.getText().toString()) || "店长".equals(jobTv.getText().toString())) {
            if (null != mSelectorEntity.getShopList() && !mSelectorEntity.getShopList().isEmpty()) {
                shopList = mSelectorEntity.getShopList();
                shopId = shopList.get(0).getShopId();
                shopCityCountryId = mSelectorEntity.getShopCityCountryID();
                store.setText(StaffInfoCheck.getShopName(shopList));
            }
            /*查询门店所在城市底薪*/
            showDialog();
            String url = NetworkParams.URL_GET_NUTR_CONSULTANT_SALARY
                    + "?staffId=" + userInfo.getStaffId()
                    + "&shopCityCountryId=" + shopCityCountryId
                    + "&entryNutrConBrand=" + brandList.getBrandId()
                    + "&inShopOrFlow=1";
            StaffManageService.getInstance().requestGetNutrConsultantSalary(url, this);
            /*查询带培导师*/
            trainTutorId = "";
            showDialog();
            StaffManageService.getInstance().requestFindTrainTutor(trainTutorId, shopId, this);
        } else {
            //流动营养顾问
            store.setText(mSelectorEntity.getSelectorName());
            shopId = mSelectorEntity.getSelectorId();
        }
    }

    /**
     * 籍贯信息
     *
     * @param mProvince 选中的省份
     * @param mCity     选中的市
     */
    @Override
    public void selectorProvince(String mProvince, String mCity) {
        String text = mProvince + mCity + "";
        province.setText(text);
    }

    /**
     * 银行信息
     *
     * @param mProvince 选中的省份
     * @param mCity     选中的市
     */
    @Override
    public void selectorBankprovince(String mProvince, String mCity) {
        String text = mProvince + mCity + "";
        bankProvince.setText(text);
    }

    @Override
    public void selectorSalaryCity(NutrSalaryProCityEntity nutrSalaryProCityEntity) {
        liveCity.setText(nutrSalaryProCityEntity.getProvinceName()
                + nutrSalaryProCityEntity.getCityName()
                + nutrSalaryProCityEntity.getCountyName());
        salary.setText(nutrSalaryProCityEntity.getSalary() + "");
        //流动营养顾问设置区域ID
        shopCityCountryId = nutrSalaryProCityEntity.getCountyId();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == SelectorBaseActivity.RESULTCODE) {
            switch (requestCode) {
                case SELECTOR_STORE:
                    staffInfoPersenter.selectorStore(data);
                    break;
                case SELECTOR_PROVINCE:
                    staffInfoPersenter.selectorProvince(data);
                    break;
                case SELECTOR_BANKPROVINCE:
                    staffInfoPersenter.selectorBankprovince(data);
                    break;
                case SELECTOR_SALARYPROVINCE:
                    staffInfoPersenter.selectorSalaryCity(data);
                    break;
                default:
                    break;
            }
        }
    }

    /**
     * 是否可上传
     *
     * @return true：校验不通过，不能上传；false：校验通过，可上传
     */
    private boolean isUpload() {
        // 健康证有效期，如果填写了健康证信息，需要上传健康证图片
        if (!TextUtils.isEmpty(healthytime.getText().toString()) || !TextUtils.isEmpty(healthyno.getText().toString())) {
            for (int i = 0; i < staffImageGroupLists.size(); i++) {
                staffImageGroupLists.get(i).setNecessaryChoice(true);
            }
        }
        for (int i = 0; i < staffImageGroupLists.size(); i++) {
            //如果非暂存与查询/修改功能，必选项未添加图片，提示并返回
            if (!temporarySave && staffImageGroupLists.get(i).isNecessaryChoice() && staffImageGroupLists.get(i).getStoreImageselectList().size() < 1) {
                ToastUtil.show(StaffBaseActivity.this, "请添加上报图片");
                dismissDialog();
                return true;
            }
            List<ImageItem> checkImgs = staffImageGroupLists.get(i).getStoreImageselectList();
            if (null != checkImgs && !checkImgs.isEmpty()) {
                //如果图片存在
                for (int k = 0; k < checkImgs.size(); k++) {
                    //将上传后的图片地址填充到上传图片集合中
                    if (i == 3) {
                        //健康证图片
                        //上传了健康证照片，必须填写健康证编号、健康证有效期，体检机构、体检时间；同理填写了健康证编号、健康证有效期，必须上传健康证照片，提交时校验，不满足给以弹框提示
                        // 体检时间
                        if (!temporarySave && TextUtils.isEmpty(medicaltime.getText().toString())) {
                            ToastUtil.show(StaffBaseActivity.this, "必须填写体检时间");
                            dismissDialog();
                            return true;
                        }
                        // 体检机构
                        else if (!temporarySave && TextUtils.isEmpty(mechanismname.getText().toString())) {
                            ToastUtil.show(StaffBaseActivity.this, "必须填写体检机构");
                            dismissDialog();
                            return true;
                        }
                        // 健康证有效期
                        else if (!temporarySave && TextUtils.isEmpty(healthytime.getText().toString())) {
                            ToastUtil.show(StaffBaseActivity.this, "必须填写健康证有效期");
                            dismissDialog();
                            return true;
                        }
                        // 健康证编号
                        else if (!temporarySave && TextUtils.isEmpty(healthyno.getText().toString())) {
                            ToastUtil.show(StaffBaseActivity.this, "必须填写健康证编号");
                            dismissDialog();
                            return true;
                        }
                    }
                }
            }
        }
        return false;
    }

    boolean notUpload = false;

    protected void setUploadData() {
        showDialog();
        notUpload = isUpload();
        //先上传图片
        if (!notUpload) {
            new uploadImageAsyncTask().execute();
        }
    }

    @Override
    public void onBrandPickClick(BrandList brandList) {
        if (null != brandList) {
            this.brandList = brandList;
            brandPick.setText(brandList.getBrandName());
        }
        if ("食补集".equals(brandPick.getText().toString())) {
            //如果品牌是食补集，不允许入职流动营养顾问
            //岗位默认为驻店营养顾问
            jobTv.setText("驻店营养顾问");
            switchJob();
        }
    }

    class uploadImageAsyncTask extends AsyncTask<String, Void, Boolean> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected Boolean doInBackground(String... params) {
            uploadImages();
            return notUpload;
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(Boolean isNotOk) {
            super.onPostExecute(isNotOk);
            if (!isNotOk) {
                //如果身份证个人生活照图片为空，提示添加图片
                if (!temporarySave && StringUtil.isNullString(nutritionConsultant.getPersonalidImg())) {
                    dismissDialog();
                    ToastUtil.show(StaffBaseActivity.this, "请检查身份证图片");
                    notUpload = true;
                    return;
                }
                if (!temporarySave && StringUtil.isNullString(nutritionConsultant.getLifePhotosUrl())) {
                    dismissDialog();
                    ToastUtil.show(StaffBaseActivity.this, "请检查个人照图片");
                    notUpload = true;
                    return;
                }
                if (!notUpload) {
                    if (!qiniuUrlLists.isEmpty()) {
                        showDialog();
                        if (null != handler && null != runnable) {
                            handler.postDelayed(runnable, 100);
                            count = 0;//初始化图片提交计数
                        }
                    } else {
                        uploadData();
                    }
                }
            }
        }
    }

    /**
     * 上传图片
     */
    private void uploadImages() {
        String personalidImg = "";
        //上传图片
        for (int i = 0; i < staffImageGroupLists.size(); i++) {
            List<ImageItem> checkImgs = staffImageGroupLists.get(i).getStoreImageselectList();
            if (null != checkImgs && !checkImgs.isEmpty()) {
                //如果图片存在
                for (int k = 0; k < checkImgs.size(); k++) {
                    //将上传后的图片地址填充到上传图片集合中
                    if (i == 3) {
                        if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                            //如果图片未上传则上传图片
                            reportType = "HealthyImg";
                            uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                            for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                if (qiniuUrlLists.get(j).contains(reportType)) {
                                    nutritionConsultant.setHealthyImg(qiniuUrlLists.get(j));
                                }
                            }
                            checkImgs.get(k).setType(1);
                        } else {
                            nutritionConsultant.setHealthyImg(checkImgs.get(k).getImgneturl());
                        }
                    } else if (i == 2) {
                        if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                            //如果图片未上传则上传图片
                            reportType = "ContractImg";
                            uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                            for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                if (qiniuUrlLists.get(j).contains(reportType)) {
                                    nutritionConsultant.setContractImg(qiniuUrlLists.get(j));
                                }
                            }
                            checkImgs.get(k).setType(1);
                        } else {
                            nutritionConsultant.setHealthyImg(checkImgs.get(k).getImgneturl());
                        }
                    } else if (i == 1) {
                        if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                            //如果图片未上传则上传图片
                            reportType = "LifePhotos";
                            uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                            for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                if (qiniuUrlLists.get(j).contains(reportType)) {
                                    nutritionConsultant.setLifePhotosUrl(qiniuUrlLists.get(j));
                                }
                            }
                            checkImgs.get(k).setType(1);
                        } else {
                            nutritionConsultant.setLifePhotosUrl(checkImgs.get(k).getImgneturl());
                        }
                    } else if (i == 0) {
                        //如果是身份证图片
                        if (checkImgs.size() > 1) {
                            //如果身份证图片大于1张
                            if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                                //如果图片未上传则上传图片
                                reportType = "personalidImg";
                                if (!personalidImg.contains(getQiniuKey(reportType))) {
                                    uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                                    for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                        if (qiniuUrlLists.get(j).contains(reportType) && !personalidImg.contains(qiniuUrlLists.get(j))) {
                                            //如果身份证照照片大于一张，添加分隔符
                                            personalidImg += qiniuUrlLists.get(j);
                                            if (k < checkImgs.size() - 1) {
                                                personalidImg += ",";
                                            }
                                        }
                                    }
                                    checkImgs.get(k).setType(1);
                                }
                            } else {
                                if (!personalidImg.contains(checkImgs.get(k).getImgneturl())) {
                                    personalidImg += checkImgs.get(k).getImgneturl();
                                    if (k < checkImgs.size() - 1) {
                                        personalidImg += ",";
                                    }
                                }
                            }
                        } else {
                            if (checkImgs.get(k).getType() != 1 || StringUtil.isNullString(checkImgs.get(k).getImgneturl())) {
                                //如果图片未上传则上传图片
                                reportType = "personalidImg";
                                if (!personalidImg.contains(getQiniuKey(reportType))) {
                                    uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                                    for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                        if (qiniuUrlLists.get(j).contains(reportType)) {
                                            //如果身份证照照片大于一张，添加分隔符
                                            personalidImg = qiniuUrlLists.get(j);
                                        }
                                    }
                                    checkImgs.get(k).setType(1);
                                }
                            } else {
                                personalidImg = checkImgs.get(k).getImgneturl();
                            }
                        }
                    }
                }
                nutritionConsultant.setPersonalidImg(personalidImg);
            } else {
                if (i == 0) {
                    nutritionConsultant.setPersonalidImg("");
                } else if (i == 1) {
                    nutritionConsultant.setLifePhotosUrl("");
                } else if (i == 2) {
                    nutritionConsultant.setHealthyImg("");
                }
            }
        }
        //身份证2张检验,只取2张照片
        String[] PersonalidImgs = nutritionConsultant.getPersonalidImg().split(",");
        if (PersonalidImgs.length > 2) {
            nutritionConsultant.setPersonalidImg(PersonalidImgs[0] + "," + PersonalidImgs[1]);
        }
    }

    /**
     * 获取到员工编号后，提交入职信息
     */
    protected NutritionConsultant setStaffDataUpload() {
        //员工修改添加工号
        nutritionConsultant.setOperatorId(operatorId);
        //再设置提交数据
        //staffDbId：对应唯一员工信息
        if (staffDbId != 0L) {
            nutritionConsultant.setId(staffDbId);
        } else {
            nutritionConsultant.setId(DateUtil.getMillis(new Date()));
        }
        //名字
        nutritionConsultant.setOperName(name.getText().toString().trim());
        if (jobTv.getText().toString().equals("驻店营养顾问")) {
            // 工作岗位:固定为 营养顾问
            nutritionConsultant.setRoleStatus(ConstantParams.CONSTANT_PARAMS_1);
            // 所属销售组织:驻店营养顾问传0
            nutritionConsultant.setSaleOrganization(0);
            if (null != shopList && !shopList.isEmpty()) {
                //所属门店名称
                nutritionConsultant.setShopList(shopList);
                //shopCityCountryId (integer, optional):门店销售城市id（新增的时候 底薪对应省份市区） ,
                nutritionConsultant.setShopCityCountryId(shopList.get(0).getShopCityCountryId());
            }
        } else if (jobTv.getText().toString().equals("流动营养顾问")) {
            //所属门店名称
            nutritionConsultant.setShopList(null);
            // 工作岗位：流动营养顾问
            nutritionConsultant.setRoleStatus(ConstantParams.CONSTANT_PARAMS_2);
            // 流动营养顾问拿sale_organization字段
            if (StringUtil.isNotNullAndNotEmpty(saleOrganization)) {
                nutritionConsultant.setSaleOrganization(Integer.parseInt(saleOrganization));
            }
            // 上级主管名字
            nutritionConsultant.setOrgName(store.getText().toString());
            //shopCityCountryId (integer, optional):门店销售城市id（新增的时候 底薪对应省份市区） ,
            if (null != shopCityCountryId && StringUtil.isNotNullAndNotEmpty(shopCityCountryId + "")) {
                nutritionConsultant.setShopCityCountryId(shopCityCountryId);
            }
        } else if (jobTv.getText().toString().equals("店长")) {
            // 工作岗位:店长
            nutritionConsultant.setRoleStatus(ConstantParams.CONSTANT_PARAMS_15);
            // 所属销售组织:驻店营养顾问传OrganizationId
            nutritionConsultant.setSaleOrganization(0);
            //所属门店名称
            if (null != shopList && !shopList.isEmpty()) {
                //所属门店名称
                nutritionConsultant.setShopList(shopList);
                //shopCityCountryId (integer, optional):门店销售城市id（新增的时候 底薪对应省份市区） ,
                nutritionConsultant.setShopCityCountryId(shopList.get(0).getShopCityCountryId());
            }
        }
        // 身份证号
        nutritionConsultant.setPersonalId(idCard.getText().toString().trim());
        // 性别
        if (man.isChecked()) {
            nutritionConsultant.setSex("N");
        } else if (women.isChecked()) {
            nutritionConsultant.setSex("V");
        }
        List<String> xLiDlist = Arrays.asList(getResources().getStringArray(R.array.education));
        int index = xLiDlist.indexOf(education.getText().toString().trim()) + 1;
        // 学历
        nutritionConsultant.setXlId("0" + index);
        // 籍贯
        nutritionConsultant.setRyjg(province.getText().toString());
        // 现住址
        nutritionConsultant.setNowAddress(address.getText().toString());
        // 出生日期
        nutritionConsultant.setBirthday(birthday.getText().toString());
        // 入职日期
        nutritionConsultant.setWorkDate(entrydate.getText().toString());
        // 录入日期
        nutritionConsultant.setAddDate(DateUtil.getDate(new Date()));
        // 入职,离职,审批,转正,修改,操作人id统一为approvalPerson
        nutritionConsultant.setApprovalPerson(userInfo.getStaffId());
        // 培训导师工号
        nutritionConsultant.setTrainTutorId(trainTutorId);
        // 培训导师名字
        nutritionConsultant.setTrainTutorName(trainTutor.getText().toString());
        // 联系电话
        nutritionConsultant.setMobilePhone(phone.getText().toString());
        // 紧急电话
        nutritionConsultant.setPhone(urgencyPhone.getText().toString());
        nutritionConsultant.setEmergencyName(urgencyPerson.getText().toString());
        // 1-待审核，2-审批不通过，3-待入职，4-入职"
        if (OeRoleParams.OE_ROLE_PARAMS_7.equals(userInfo.getOeRole())) {
            //区域经理入职提交后，状态直接变为已审核
            nutritionConsultant.setEntrystatus(ConstantParams.CONSTANT_PARAMS_3);
        } else {
            nutritionConsultant.setEntrystatus(ConstantParams.CONSTANT_PARAMS_1);
        }
        // 银行账号
        nutritionConsultant.setAccountId(bankNo.getText().toString().trim());
        // 开户省市
        nutritionConsultant.setBankCity(bankProvince.getText().toString());
        // 开户行信息
        nutritionConsultant.setBankCityDetail(bankProvinceDetail.getText().toString());
        // 开户银行
        nutritionConsultant.setBankName(bankTv.getText().toString());
        // 基本工资
        nutritionConsultant.setJbNet(salary.getText().toString().trim());
        if ("流动营养顾问".equals(jobTv.getText().toString().trim())) {
            // 底薪增加值
            nutritionConsultant.setSalaryIncrease(basicSalaryAdd.getText().toString().trim());
        }
        // 岗位工资
        nutritionConsultant.setGwNet(jobSalary.getText().toString());
        // 通讯补贴
        nutritionConsultant.setCommSubsidy(communicationAllowance.getText().toString());
        // 交通补贴
        if (!TextUtils.isEmpty(trafficsubsidyAllowance.getText().toString()))
            nutritionConsultant.setTrafficSubsidy(trafficsubsidyAllowance.getText().toString());
        // 爱心基金
        nutritionConsultant.setAxNet(loveSalary.getText().toString().trim());

        List<String> zply = Arrays.asList(getResources().getStringArray(R.array.channel));
        int indexzply = zply.indexOf(recuitmentChannel.getText().toString().trim()) + 1;
        // 招聘来源
        nutritionConsultant.setZply("0" + indexzply);
        // 有无亲属在本公司
        if (relativesYes.isChecked()) {
            nutritionConsultant.setIfrelatives("Y");
            // 亲属姓名
            nutritionConsultant.setRelatives(relatives.getText().toString());
            // 亲属职位
            nutritionConsultant.setRelativesPost(relativespost.getText().toString());
        } else if (relativesNo.isChecked()) {
            nutritionConsultant.setIfrelatives("N");
        }
        // 是否是外包
        if (outsourcingYes.isChecked()) {
            // 传编码，外包公司现有2家：易才（买社保），金桂（不买社保）；考虑到后续变更，建议后台配置
            nutritionConsultant.setOutsourcedNo(outsourcingId);
            nutritionConsultant.setOutsourcedName(outsourcing.getText().toString());
        }
        // 录入人办事处ID
        nutritionConsultant.setEntryOfficeId(userInfo.getOfficeId());
        // 上次保存时间
        nutritionConsultant.setNewStaffInductionTime(DateUtil.format(new Date(), "yyyy-MM-dd HH:mm:ss"));
        // 体检机构
        nutritionConsultant.setMechanismName(mechanismname.getText().toString());
        // 体检时间
        nutritionConsultant.setMedicalTime(medicaltime.getText().toString());
        // 健康证有效期
        nutritionConsultant.setHealthyTime(healthytime.getText().toString());
        // 健康证编号
        nutritionConsultant.setHealthyNo(healthyno.getText().toString());
        // 所在城市
        nutritionConsultant.setShopSlaryAdress(liveCity.getText().toString());
        // 顾问品牌
        List<BrandList> brandLists = new ArrayList<>();
        brandLists.add(brandList);
        nutritionConsultant.setBrandList(brandLists);
        nutritionConsultant.setBrandListString(new Gson().toJson(brandLists));
        nutritionConsultant.setShopListString(new Gson().toJson(shopList));
        Log.d(TAG, nutritionConsultant.toString());
        return nutritionConsultant;
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        //专柜位置上报功能只允许拍照上传
        this.idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        toPhotoPreviewFragment(i, arrayList);//大图显示
    }

    @Override
    protected void refreshAfterTakePicture(Intent data, ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        super.refreshAfterTakePicture(data, mImageselectList, idImagePickerContainer);
        subjectAdapter.refreshPicture(mImageselectList, idImagePickerContainer);
    }

    @Override
    protected void refreshAfterGetPicture(Intent data, ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        super.refreshAfterGetPicture(data, mImageselectList, idImagePickerContainer);
        subjectAdapter.refreshPicture(idImagePickerContainer.getmImageselectList(), idImagePickerContainer);
    }

    public void createConfirmDialog(NutritionConsultant nutritionConsultant) {
        final PublicConformTipDialog.Builder builder = new PublicConformTipDialog.Builder(this);
        builder.setTitle("该员工不可返聘！");
        builder.setMessage("离职类型：" + StaffInfoCheck.gedissmissType(nutritionConsultant.getLztype())
                + "\n"
                + "\n是否可返聘：否"
                + "\n"
                + "\n离职原因：" + nutritionConsultant.getLzreason()
                + "\n"
                + "\n曾工作时间："
                + "\n" + StaffInfoCheck.getleavNutConWorkData(nutritionConsultant)
                + "\n");
        builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                //退出到前一页
                StaffBaseActivity.this.finish();
            }
        });
        builder.create().show();
        //设置对话框样式
        builder.setTitleView(Gravity.CENTER, ContextCompat.getColor(this, R.color.red));
        builder.setMessageView(Gravity.LEFT, ContextCompat.getColor(this, R.color.important_txt_color));
    }

    private void createReEmployDialog(final NutritionConsultant nutritionConsultant) {
        final PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        builder.setTitle("该员工曾在公司工作过，工号已存在");
        builder.setMessage("离职类型：" + StaffInfoCheck.gedissmissType(nutritionConsultant.getLztype())
                + "\n"
                + "\n是否可返聘：是"
                + "\n"
                + "\n离职原因：" + nutritionConsultant.getLzreason()
                + "\n"
                + "\n曾工作时间："
                + "\n" + StaffInfoCheck.getleavNutConWorkData(nutritionConsultant)
                + "\n");
        builder.setNegativeButton("去返聘", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                staffEntryTipLl.setVisibility(View.GONE);
                homeTitleText.setText("员工返聘");
                submitRightBtn.setText("提交");
                submitRightBtn.setBackground(ContextCompat.getDrawable(StaffBaseActivity.this, R.drawable.selector_update_btn));
                submitRightBtn.setTextColor(getResources().getColor(R.color.normal_color));
                //进入返聘流程
                entryRehire(nutritionConsultant);
            }
        });
        builder.setPositiveButton("取消", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
        //设置对话框样式
        builder.setTitleView(Gravity.CENTER, ContextCompat.getColor(this, R.color.red));
        builder.setMessageView(Gravity.LEFT, ContextCompat.getColor(this, R.color.important_txt_color));
        builder.setDialogConfirmBtnView(ContextCompat.getColor(this, R.color.normal_color), ContextCompat.getColor(this, R.color.white));
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.brand_pick) {
            //第1步：品牌选择提前到岗位和门店/上级之前
            //弹出选择品牌弹框
            if (null == brandSelectPop) {
                brandSelectPop = new BrandSelectPop(this, this, brandLists);
            }
            if (!brandSelectPop.isShowing()) {
                brandSelectPop.show(this.findViewById(R.id.title));
            }
            //选择品牌后，需重新选择门店
            shopList.clear();
            shopId = "";
            shopCityCountryId = null;
            store.setText("");
            //非修改功能，更换品牌后城市底薪置空
            if (541 != branchID) {
                liveCity.setText("");
                salary.setText("");
            }
        } else if (v.getId() == R.id.job) {
            //第2步：选择岗位前，需先选择品牌
            if (StringUtil.isNullOrEmpty(brandPick.getText().toString()) || getString(R.string.empty_etb_hint_select_txt).equals(brandPick.getText().toString())) {
                showTip("请先选择品牌，再选择岗位！");
                return;
            }
            if ("食补集".equals(brandPick.getText().toString())) {
                //如果品牌是食补集，不允许入职流动营养顾问
                //岗位默认为驻店营养顾问
                jobTv.setText("驻店营养顾问");
                showReportType(JOB1);
            } else {
                showReportType(JOB);
            }
        } else if (v.getId() == R.id.store_pick) {
            //第3步：选择门店或上级前，需先选择品牌，再选择岗位
            if ("流动营养顾问".equals(jobTv.getText().toString())) {
                /*流动营养顾问选择上级主管*/
                if (StringUtil.isNullOrEmpty(brandPick.getText().toString()) || getString(R.string.empty_etb_hint_select_txt).equals(brandPick.getText().toString())) {
                    showTip("请先选择品牌，再选择上级主管！");
                    return;
                }
                if (StringUtil.isNullOrEmpty(jobTv.getText().toString())) {
                    showTip("请先选择岗位，再选择上级主管！");
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(this, SelectorChargeStaffActivity.class);
                startActivityForResult(intent, SELECTOR_STORE);
            } else {
                /*驻店营养顾问选择所属门店*/
                if (StringUtil.isNullOrEmpty(brandPick.getText().toString()) || getString(R.string.empty_etb_hint_select_txt).equals(brandPick.getText().toString())) {
                    showTip("请先选择品牌，再选择所属门店！");
                    return;
                }
                if (StringUtil.isNullOrEmpty(jobTv.getText().toString())) {
                    showTip("请先选择岗位，再选择所属门店！");
                    return;
                }
                Intent intent = new Intent();
                intent.setClass(this, SelectorStoreActivity.class);
                startActivityForResult(intent, SELECTOR_STORE);
            }
        } else if (v.getId() == R.id.birthday) {
            DialogHelper.AlertDatePicker(this, this, birthday);
        } else if (v.getId() == R.id.entrydate) {
            DialogHelper.AlertDatePicker(this, this, entrydate);
        } else if (v.getId() == R.id.education) {
            showReportType(EDU);
        } else if (v.getId() == R.id.recuitment_channel) {
            showReportType(CHANNEL);
        } else if (v.getId() == R.id.bank) {
            showReportType(BANK);
        } else if (v.getId() == R.id.basic_salary_add) {
            showReportType(SALARY);
        } else if (v.getId() == R.id.communication_allowance) {
            showReportType(ALLOWANCE);
        } else if (v.getId() == R.id.province) {
            Intent intent2 = new Intent(this, SelectorProvinceCityActivity.class);
            startActivityForResult(intent2, SELECTOR_PROVINCE);
        } else if (v.getId() == R.id.bank_province) {
            Intent intent4 = new Intent(this, SelectorProvinceCityActivity.class);
            startActivityForResult(intent4, SELECTOR_BANKPROVINCE);
        } else if (v.getId() == R.id.live_city) {
            //流动营养顾问进入选择城市页面
            Intent intent = new Intent();
            intent.putExtra("entryNutrConBrand", brandList.getBrandId());
            intent.setClass(this, SelectorSalaryCityActivity.class);
            startActivityForResult(intent, SELECTOR_SALARYPROVINCE);
        } else if (v.getId() == R.id.train_tutor) {
            popType = 1;
            final PublicEdtDialog.Builder builder = new PublicEdtDialog.Builder(this);
            builder.setTitle(getString(R.string.train_tutor_id_text));
            builder.setContentVisibility(false);
            builder.setPositiveButton(new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    dialog.dismiss();
                }
            });
            builder.setNegativeButton(
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            getTrainTutorInfo(dialog, builder);
                        }
                    });
            builder.create().show();
        } else if (v.getId() == R.id.outsourcing) {
            popType = 2;
            showDialog();
            StaffManageService.getInstance().requestFindOutsourced(this);
        } else if (v.getId() == R.id.medicaltime) {
            DialogHelper.AlertDatePicker(this, this, medicaltime);
        } else if (v.getId() == R.id.healthytime) {
            DialogHelper.AlertDatePicker(this, this, healthytime);
        }
    }
}