package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;


import android.content.Intent;
import android.support.v4.content.ContextCompat;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.publics.service.StaffInfoCheck;
import com.wgmf.yxgj.module.business.managestaff.ui.StaffDimissionDetailActivity;
import com.xp.arouter.RouterParams;

/**
 * 离职办理
 */
@Route(path = RouterParams.URL_STAFFDIMISSIONACTIVITY)
public class StaffDimissionActivity extends StaffBaseActivity {

    @Override
    protected void onResume() {
        super.onResume();
        if (null != operatorId)
            queryInfo(operatorId);
    }

    protected void submitRightBtnUpdata() {
        if (nutritionConsultant == null) {
            ToastUtil.show(this, "请先获取离职员工信息!");
            return;
        }
        if ("1".equals(nutritionConsultant.getStatus())) {
            ToastUtil.show(this, "该员工处于离职状态!\r\n无法继续操作!");
            return;
        }
        showDissmissDialog();
    }

    @Override
    protected void onFindNutritionConsultant(NutritionConsultant ent) {
        this.nutritionConsultant = ent;
        if (null != ent) {
//            fillData(ent);
//            staffInfoLl.setVisibility(View.VISIBLE);
            //查询的员工存在但已离职则不可离职
            staffInfoLl.setVisibility(View.GONE);
            dimissionInfoTv.setVisibility(View.VISIBLE);
            dimissionInfoTv.setText(staffInfoPersenter.getDimissionInfo(ent));
            //如果非已离职状态，可离职
            if (!"1".equals(ent.getStatus())) {
                submitLl.setVisibility(View.VISIBLE);
                submitLeftBrn.setVisibility(View.GONE);
                submitRightBtn.setVisibility(View.VISIBLE);
                submitRightBtn.setText("填写离职信息");
            } else {
                submitLl.setVisibility(View.VISIBLE);
                submitLeftBrn.setVisibility(View.GONE);
                submitRightBtn.setVisibility(View.VISIBLE);
                submitRightBtn.setText("不可操作");
                submitRightBtn.setOnClickListener(null);
                submitRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_week_normal_style));
                submitRightBtn.setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            }
        }
    }

    @Override
    protected void fillData(NutritionConsultant item) {
        super.fillData(item);
        staffStatusTxt.setText(StaffInfoCheck.getStatus(item.getStatus()));
    }

    private void showDissmissDialog() {
        Intent intent = new Intent(this, StaffDimissionDetailActivity.class);
        intent.putExtra("operName", nutritionConsultant.getOperName());
        intent.putExtra("operatorId", operatorId);
        startActivity(intent);
        this.finish();
    }
}