package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import com.wgmf.yxgj.model.NutritionConsultant;
import com.wgmf.yxgj.module.business.managestaff.model.InterviewAssessmentEntity;
import com.wgmf.yxgj.module.business.managestaff.model.NutrSalaryProCityEntity;
import com.wgmf.yxgj.module.business.managestaff.model.Outsourced;
import com.wgmf.yxgj.module.business.managestaff.model.TrainTutorEntity;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;

import java.util.List;

/**
 * 作者：xiep on 2017/9/11 13:11
 * 邮箱：2975837870@qq.com
 */
public interface StaffInfoView {
    /**
     * 显示提示信息
     *
     * @param msg 提示信息
     */
    void showTip(String msg);

    /**
     * 销毁页面
     */
    void destoryView();

    /**
     * 查询营养顾问信息
     *
     * @param nutritionConsultant 营养顾问信息
     */
    void findNutritionConsultant(NutritionConsultant nutritionConsultant);

    /**
     * 入职成功，发送Jpush入职消息
     *
     * @param operatorId 入职工号
     */
    void sendMessageToJPush(String operatorId);

    /**
     * 检验营养顾问是否可以入职
     *
     * @param isSuccessed true 可入职，false 不可入职
     */
    void checkNutritionConsultant(boolean isSuccessed);

    /**
     * 查询门店的督导或店长 又或营养顾问
     *
     * @param mTrainTutorEntitys 督导或店长 又或营养顾问信息
     */
    void findTrainTutor(TrainTutorEntity mTrainTutorEntitys);

    /**
     * 查询外包公司
     *
     * @param mOutsourced 外包公司信息
     */
    void findOutsourced(List<Outsourced> mOutsourced);

    /**
     * 检验是否已填写面试评估
     *
     * @param mInterviewAssessmentEntity 面试评估信息
     */
    void checkInterviewAssemnet(InterviewAssessmentEntity mInterviewAssessmentEntity);

    /**
     * 检验是否已填写面试评估
     *
     * @param isSuccessed true 已填写
     */
    void interviewIsSuccessed(boolean isSuccessed);

    /**
     * 该员工不存在，进入面试评估流程
     */
    void enterInterview();

    /**
     * 该员工离职，进入返聘流程
     */
    void reEmployNutritionConsultant(NutritionConsultant nutritionConsultant);

    /**
     * 该员工在职，进入修改流程
     */
    void modifyNutritionConsultant(NutritionConsultant nutritionConsultant);

    /**
     * 入职营养顾问底薪所在城市弹框
     */
    void showNutrSalaryProCity(List<NutrSalaryProCityEntity> nutrSalaryProCityEntitys);

    void selectorStore(BaseSelectorEntity mSelectorEntity);

    void selectorProvince(String mProvince, String mCity);

    void selectorBankprovince(String mProvince, String mCity);

    void selectorSalaryCity(NutrSalaryProCityEntity nutrSalaryProCityEntity);
}