package com.wgmf.yxgj.module.business.managestaff.ui.staffinfo;

import android.content.Context;
import android.content.DialogInterface;
import android.support.v7.app.AlertDialog;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.wgmf.yxgj.module.business.managestaff.R;
import com.wgmf.yxgj.model.SelectImageGroupList;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2017/7/3 13:36
 * 邮箱：2975837870@qq.com
 */
class StaffSelectImageAdapter extends BaseAdapter implements ImagePickerLayout.ImagePicker {

    private LayoutInflater inflater;
    private Context context;
    private List<SelectImageGroupList> ratingsReportGroupLists;
    private LvListener lvListener;
    private boolean isOpen = false;

    StaffSelectImageAdapter(List<SelectImageGroupList> list, Context context, LvListener lvListener) {
        this.context = context;
        this.inflater = LayoutInflater.from(context);
        this.ratingsReportGroupLists = list;
        this.lvListener = lvListener;
    }

    public List<SelectImageGroupList> getData() {
        return ratingsReportGroupLists;
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        lvListener.setSelectDialog(selectType, view);
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        lvListener.toPhotoPreview(i, arrayList);
    }

    interface LvListener {
        void setSelectDialog(int i, View view);

        void toPhotoPreview(int i, ArrayList<ImageItem> arrayList);
    }

    void refreshPicture(ArrayList<ImageItem> mImageSelectList, ImagePickerLayout idImagePickerContainer) {
        int position = (int) idImagePickerContainer.getTag();
        //在对应位置图片集合里加入拍照返回图片
        ratingsReportGroupLists.get(position).setStoreImageselectList(mImageSelectList);
    }

    @Override
    public int getCount() {
        return ratingsReportGroupLists.size();
    }

    @Override
    public Object getItem(int position) {
        return ratingsReportGroupLists.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        final SelectImageGroupList ratingsReportGroupList = ratingsReportGroupLists.get(position);
        final ViewHolder holder;
        convertView = null;
        if (convertView == null) {
            convertView = inflater.inflate(R.layout.staff_selecter_image_item, null);
            holder = new ViewHolder(convertView);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        if (ratingsReportGroupList.getPosition() == 0 || ratingsReportGroupList.getPosition() == 1) {
            holder.subjectTag.setVisibility(View.VISIBLE);
        } else {
            holder.subjectTag.setVisibility(View.GONE);
        }
        holder.subjectName.setText(ratingsReportGroupList.getName());

        if (ratingsReportGroupList.getPosition() == 1) {
            holder.subjectExample.setVisibility(View.VISIBLE);
            Glide.with(context).load(R.drawable.person_id).placeholder(R.drawable.pop_hone_qgwsr_default).error(R.drawable.pop_hone_qgwsr_default).into(holder.subjectExample);
            holder.subjectExample.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (!isOpen) {
                        AlertDialog.Builder builder = new AlertDialog.Builder(context);
                        builder.setTitle("示例图片");
                        builder.setView(R.layout.person_id_layout);
                        builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {

                            }
                        });
                        builder.setCancelable(false);
                        builder.show();
                    }
                    isOpen = !isOpen;
                }
            });
        } else if (ratingsReportGroupList.getPosition() == 2) {
            holder.subjectExample.setVisibility(View.VISIBLE);
            Glide.with(context).load(R.drawable.contract_img).placeholder(R.drawable.pop_hone_qgwsr_default).error(R.drawable.pop_hone_qgwsr_default).into(holder.subjectExample);
            holder.subjectExample.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if (!isOpen) {
                        AlertDialog.Builder builder = new AlertDialog.Builder(context);
                        builder.setTitle("示例图片");
                        builder.setView(R.layout.contract_img_layout);

                        builder.setNegativeButton("知道了", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {

                            }
                        });
                        builder.setCancelable(false);
                        builder.show();
                    }
                    isOpen = !isOpen;
                }
            });
        } else

        {
            holder.subjectExample.setVisibility(View.GONE);
        }
        holder.idImagePickerContainerImg.setmImageselectList(ratingsReportGroupList.getStoreImageselectList());
        holder.idImagePickerContainerImg.setImagePickerView(holder.idImagePickerContainerImg);
        holder.idImagePickerContainerImg.setMaxPhotoNum(ratingsReportGroupList.getNum());
        holder.idImagePickerContainerImg.setOlnyViewMode(holder.idImagePickerContainerImg.isOlnyViewMode());
        holder.idImagePickerContainerImg.refreshPhotoContentView(ratingsReportGroupList.getStoreImageselectList());
        holder.idImagePickerContainerImg.setTag(position);
        return convertView;
    }

    class ViewHolder {
        TextView subjectTag;
        TextView subjectName;
        ImageView subjectExample;
        ImagePickerLayout idImagePickerContainerImg;

        ViewHolder(View convertView) {
            subjectTag = (TextView) convertView.findViewById(R.id.subject_tag);
            subjectName = (TextView) convertView.findViewById(R.id.subject_name);
            subjectExample = (ImageView) convertView.findViewById(R.id.subject_example);
            idImagePickerContainerImg = (ImagePickerLayout) convertView.findViewById(R.id.id_image_picker_container_img);
            ArrayList<ImageItem> mImageSelectList = new ArrayList();
            idImagePickerContainerImg.setmImageselectList(mImageSelectList);
            idImagePickerContainerImg.setTitleVisibility(View.GONE);
            idImagePickerContainerImg.setTipVisibility(View.GONE);
            idImagePickerContainerImg.setOlnyViewMode(false);
            idImagePickerContainerImg.setImagePicker(StaffSelectImageAdapter.this);
            idImagePickerContainerImg.setSizePhotoNum(3);
            idImagePickerContainerImg.setImagePickerView(idImagePickerContainerImg);
        }
    }
}