package com.wgmf.yxgj.config;

/**
 * @author XiePing
 * 2016/5/13 17:55
 */
@SuppressWarnings("all")
public class BusinessID {

    /**
     * 每个业务分配消息大小
     */
    private static final int MSG_SECTION_SIZE = 100;

    /**
     * 登录相关
     */
    public static final class Login {

        private static final int MSG_BASE = 0;
        /**
         * 登陆
         */
        public static final int MSG_ON_USER_LOGIN = MSG_BASE + 1;
        /**
         * 前端显示登录页面
         * get /frontDisplay/loginImage
         */
        public static final int MSG_ON_FRONT_DISPLAY = MSG_BASE + 2;
    }

    /**
     * 升级相关
     */
    public static final class Update {

        private static final int MSG_BASE = MSG_SECTION_SIZE;
        /**
         * 升级
         */
        public static final int MSG_ON_USER_UPDATE = MSG_BASE + 1;
    }

    /**
     * 推送相关
     */
    public static final class JPush {

        private static final int MSG_BASE = 2 * MSG_SECTION_SIZE;
        /**
         * JPUSH设置
         */
        public static final int MSG_ON_SET_JPUSH = MSG_BASE + 1;
        /**
         * 发送JPUSH消息
         */
        public static final int MSG_ON_SEND_JPUSH = MSG_BASE + 2;
    }

    /**
     * 消息相关
     */
    public static final class Message {

        private static final int MSG_BASE = 3 * MSG_SECTION_SIZE;
        /**
         * 消息列表
         */
        public static final int MSG_ON_MSG_LIST = MSG_BASE + 1;
        /**
         * 消息已读未读状态
         */
        public static final int MSG_ON_MSG_UPDATE = MSG_BASE + 2;
    }

    /**
     * 公共类，如门店列表
     */
    public static final class Publics {

        private static final int MSG_BASE = 4 * MSG_SECTION_SIZE;
        /**
         * 查询同级主管信息
         */
        public static final int MSG_ON_MANAGER_INFO = MSG_BASE + 1;
        /**
         * 根据门店编号查找下面营养顾问
         */
        public static final int MSG_ON_WORKERS_INFO = MSG_BASE + 2;
        /**
         * 获取附近门店
         */
        public static final int MSG_ON_SHOP_GET_NEAREST = MSG_BASE + 3;
        /**
         * 获取七牛Token
         */
        public static final int MSG_ON_GET_QINIU_TOKEN = MSG_BASE + 4;
        /**
         * post /frontDisplay/adPage 前端显示首页弹出广告列表
         */
        public static final int MSG_ON_GET_AD_PAGE = MSG_BASE + 5;
    }

    /**
     * 首页相关
     */
    public static final class HomePage {

        private static final int MSG_BASE = 5 * MSG_SECTION_SIZE;

    }

    /**
     * 货品管理
     */
    public static final class GoodsManager {

        private static final int MSG_BASE = 6 * MSG_SECTION_SIZE;
        /**
         * GET /productManagement/findOrderGoodsAuditStore 订货审核门店
         */
        public static final int MSG_ON_FIND_ORDERGOODS_AUDIT_STORE = MSG_BASE + 1;
        /**
         * GET /productManagement/findOrderGoodsAudit 订货审核
         */
        public static final int MSG_ON_FIND_ORDERGOODS_AUDIT = MSG_BASE + 2;
        /**
         * GET /productManagement/findOrderGoodsAuditDeatil 订货审核明细
         */
        public static final int MSG_ON_FIND_ORDERGOODS_AUDIT_DEATIL = MSG_BASE + 3;
        /**
         * POST /productManagement/saveUpdateOrderGoodsAuditions 订货审核添加或修改
         */
        public static final int MSG_ON_SAVE_UPDATE_ORDERGOODS_AUDITIONS = MSG_BASE + 4;
        /**
         * GET /productManagement/findProductList 产品查询
         */
        public static final int MSG_ON_FIND_PRODUCT_LIST = MSG_BASE + 5;
        /**
         * GET /productManagement/findStockGoodsCheckStore 存货盘点门店
         */
        public static final int MSG_ON_FIND_STOCKGOODS_CHECK_STORE = MSG_BASE + 6;
        /**
         * GET /productManagement/findStockGoodsCheckDeatils 存货盘点明细
         */
        public static final int MSG_ON_FIND_STOCKGOODS_CHECK_DEATILS = MSG_BASE + 7;
        /**
         * POST /productManagement/updateStockGoodsCheck 修改存货盘点
         */
        public static final int MSG_ON_UPDATE_STOCKGOODS_CHECK = MSG_BASE + 8;
        /**
         * POST /productManagement/saveTransferredInOrOut 产品调入调出
         */
        public static final int MSG_ON_SAVE_TRANSFERRED_INOROUT = MSG_BASE + 9;
        /**
         * GET /productManagement/findTransferredInAndOut 调入调出查询
         */
        public static final int MSG_ON_FIND_TRANSFERRED_INANDOUT = MSG_BASE + 10;
        /**
         * GET /productManagement/findTransferredInAndOutDetail 调入调出查询明细
         */
        public static final int MSG_ON_FIND_TRANSFERRED_INANDOUT_DETAIL = MSG_BASE + 11;
    }

    /**
     * 资材管理
     */
    public static final class CapitalManager {

        private static final int MSG_BASE = 7 * MSG_SECTION_SIZE;
        /**
         * GET /productManagement/findCapitalReceipts 资材收货查询
         */
        public static final int MSG_ON_FIND_CAPITAL_RECEIPTS = MSG_BASE + 1;
        /**
         * GET /productManagement/findCapitalReceiptsDetail 资材收货明细查询
         */
        public static final int MSG_ON_FIND_CAPITAL_RECEIPTS_DETAIL = MSG_BASE + 2;
        /**
         * POST /productManagement/updateCapitalReceipts 资材收货确认
         */
        public static final int MSG_ON_UPDATE_CAPITAL_RECEIPTS = MSG_BASE + 3;
        /**
         * GET /productManagement/findCapitalStockSearch 资材库存查询
         */
        public static final int MSG_ON_FIND_CAPITAL_STOCK_SEARCH = MSG_BASE + 4;
        /**
         * GET /productManagement/findCapitalStockDetail 资材库存查询明细
         */
        public static final int MSG_ON_FIND_CAPITAL_STOCK_DETAIL = MSG_BASE + 5;
        /**
         * POST /capitalManagement/capitalStockTransferred 资材调拨
         */
        public static final int MSG_ON_SAVE_CAPITAL_STOCK_TRANSFERRED = MSG_BASE + 6;
    }

    /**
     * 员工管理相关
     */
    public static final class StaffManage {

        private static final int MSG_BASE = 8 * MSG_SECTION_SIZE;
        /**
         * 员工查询
         */
        public static final int MSG_ON_QUERY_NUTRITION_CONSULTANT = MSG_BASE + 1;
        /**
         * 入职
         */
        public static final int MSG_ON_ENTRY_NUTRITIONCONSULTANT = MSG_BASE + 2;
        /**
         * 离职
         */
        public static final int MSG_ON_RESIGN_NUTRITIONCONSULTANT = MSG_BASE + 3;
        /**
         * 入职审批
         */
        public static final int MSG_ON_APPROVE_NUTRITIONCONSULTANT = MSG_BASE + 4;
        /**
         * 营养顾问信息修改 POST /nutritionConsultant/updateNutritionConsultant
         */
        public static final int MSG_ON_UPDATE_NUTRITION_CONSULTANT = MSG_BASE + 5;
        /**
         * post /nutritionConsultant/updateUserRehire 营养顾问返聘
         */
        public static final int MSG_ON_UPDATE_USER_REHIRE = MSG_BASE + 6;
        /**
         * GET /nutritionConsultant/checkNutritionConsultant 检验营养顾问是否可以入职
         */
        public static final int MSG_ON_CHECK_NUTRITION_CONSULTANT = MSG_BASE + 7;
        /**
         * GET /nutritionConsultant/findNutConsultantScheduling 流动营养顾问排班查询
         */
        public static final int MSG_ON_FIND_NUTCONSULTANT_SCHEDULING = MSG_BASE + 8;
        /**
         * GET /nutritionConsultant/findThreeAndCurrentDayScheduling 流动营养顾问排班查询-当天和前三天
         */
        public static final int MSG_ON_FIND_THREEANDCURRENTDAY_SCHEDULING = MSG_BASE + 9;
        /**
         * GET /nutritionConsultant/findOneMonthScheduling 查询一个月的流动营养顾问排班查询
         */
        public static final int MSG_ON_FIND_ONEMONTH_SCHEDULING = MSG_BASE + 10;
        /**
         * POST /nutritionConsultant/saveOrUpdateScheduling 新增或者更新流动营养顾问排班
         */
        public static final int MSG_ON_SAVEORUPDATE_SCHEDULING = MSG_BASE + 11;
        /**
         * GET /nutritionConsultant/findTrainTutor 查询门店的督导或店长 又或营养顾问
         */
        public static final int MSG_ON_FIND_TRAIN_TUTOR = MSG_BASE + 12;
        /**
         * GET /nutritionConsultant/findOutsourced
         */
        public static final int MSG_ON_FIND_OUT_SOURCED = MSG_BASE + 13;
        /**
         * GET /nutritionConsultant/findStaffAuditionAppraiseList 查询营养顾问面试评估记录
         */
        public static final int MSG_ON_FIND_STAFF_AUDITION_APPRAISELIST = MSG_BASE + 14;
        /**
         * GET /nutritionConsultant/findStaffAuditionAppraise 查询单个营养顾问面试评估记录
         */
        public static final int MSG_ON_FIND_STAFF_AUDITION_APPRAISE = MSG_BASE + 15;
        /**
         * POST /nutritionConsultant/saveStaffAuditionAppraise 新增营养顾问面试评估
         */
        public static final int MSG_ON_SAVE_STAFF_AUDITION_APPRAISE = MSG_BASE + 16;
        /**
         * GET /nutritionConsultant/getNutrConsultantSalary 获取顾问底薪
         */
        public static final int MSG_ON_GET_NUTRCONSULTANT_SALARY = MSG_BASE + 17;
        /**
         * get /nutritionConsultant/queryNeedUpdateWorkersList 查询没有合同图片的顾问信息
         */
        public static final int MSG_ON_QUERY_NEED_UPDATE_WORKERS_LIST = MSG_BASE + 18;
    }

    /**
     * 销售管理
     */
    public static final class SalesManager {

        private static final int MSG_BASE = 9 * MSG_SECTION_SIZE;
        /**
         * GET /saleforecast/getSaleForecastShop 获取销售预测门店
         */
        public static final int MSG_ON_GET_SALEFORECAST_SHOP = MSG_BASE + 1;
        /**
         * GET /saleforecast/getSaleForecastProductInfo 填写销售预测前查询产品相关信息
         */
        public static final int MSG_ON_GET_SALEFORECAST_PRODUCT_INFO = MSG_BASE + 2;
        /**
         * POST /saleforecast/saveSaleForecast 新增销售预测
         */
        public static final int MSG_ON_SAVE_SALEFORECAST = MSG_BASE + 3;
        /**
         * GET /saleforecast/getShopHistorySale 获取以往销售
         */
        public static final int MSG_ON_GET_SHOP_HISTORY_SALE = MSG_BASE + 4;
        /**
         * GET /saleforecast/getShopProductHistorySale 获取以往销售-单品销售
         */
        public static final int MSG_ON_GET_SHOP_PRODUCT_HISTORY_SALE = MSG_BASE + 5;
    }

    /**
     * KA客户管理
     */
    public static final class KAManager {

        private static final int MSG_BASE = 10 * MSG_SECTION_SIZE;
        /**
         * GET /kacusmanager/findCustomerVisit 客户拜访查询
         */
        public static final int MSG_ON_FIND_CUSTOMER_VISIT = MSG_BASE + 1;
        /**
         * GET /kacusmanager/findSupermarketAndPoistion 查询商超系统和客户职位
         */
        public static final int MSG_ON_FIND_SUPERMARKET_AND_POISTION = MSG_BASE + 2;
        /**
         * POST /kacusmanager/saveCustomerVisit 客户拜访
         */
        public static final int MSG_ON_SAVE_CUSTOMER_VISIT = MSG_BASE + 3;
    }

    /**
     * 月总结与计划
     * /monthlyWeekReport/getPerformaceMonthlyReport
     */
    public static final class MonthlyWeekReport {

        private static final int MSG_BASE = 11 * MSG_SECTION_SIZE;
        /**
         * 全面绩效
         */
        public static final int MSG_ON_TOTAL_PERFOMANCE = MSG_BASE + 1;
        /**
         * 新增月报前查询
         */
        public static final int MSG_ON_QUERY_USERINFO = MSG_BASE + 2;
        /**
         * 新增/修改月报
         */
        public static final int MSG_ON_GETPERFORMACE_MONTHLYREPORT = MSG_BASE + 3;
        /**
         * 新增/修改月报
         */
        public static final int MSG_ON_SAVE_MONTHLYREPORT = MSG_BASE + 4;
        /**
         * 批复
         */
        public static final int MSG_ON_APPRIASE_MONTHLYREPORT = MSG_BASE + 5;
        /**
         * 新增/修改月报
         */
        public static final int MSG_ON_SAVE_MONTHLYREPORT_SUMMALY = MSG_BASE + 6;
    }

    /**
     * 上报反馈
     */
    public static final class ReportFeedback {

        private static final int MSG_BASE = 12 * MSG_SECTION_SIZE;
        /**
         * 问题上报获取物流电话信息
         */
        public static final int MSG_ON_STREAM_DEALPERSON = MSG_BASE + 1;
        /**
         * GET /question/product 获取产品:包括产品、问题类型、物流
         */
        public static final int MSG_ON_QUESTION_GET_SELECTLIST = MSG_BASE + 2;
        /**
         * POST /question/saveQuestion 保存问题上报
         */
        public static final int MSG_ON_QUESTION_SAVE_QUESTION = MSG_BASE + 3;
        /**
         * POST /OAworkflow/CreateAOGErrWorkFlow 到货误差流程提交
         */
        public static final int MSG_ON_CREATE_AOGERR_WORKFLOW = MSG_BASE + 4;
        /**
         * GET /OAworkflow/getAOGWorkFlowInfo 流程查询
         */
        public static final int MSG_ON_GET_AOGWORKFLOW_INFO = MSG_BASE + 5;
        /**
         * POST /OAworkflow/createQualityFBWorkFlow 质量问题反馈流程提交
         */
        public static final int MSG_ON_CREATE_QUALITY_FB_WORKFLOW = MSG_BASE + 6;
        /**
         * POST /OAworkflow/createComplaintWorkFlow 我要找督察，内部人员投诉流程
         */
        public static final int MSG_ON_CREATE_COMPLAINT_WORKFLOW = MSG_BASE + 7;
        /**
         * POST /OAworkflow/createCabinetWorkFlow 柜子流程提交
         */
        public static final int MSG_ON_CREATE_CABINET_WORKFLOW = MSG_BASE + 8;
        /**
         * POST /OAworkflow/createFeedbackWorkFlow 建议与意见流程
         */
        public static final int MSG_ON_CREATE_FEEDBACK_WORKFLOW = MSG_BASE + 9;
        /**
         * post /OAworkflow/submitPj 流程查询
         */
        public static final int MSG_ON_SUBMIT_PJ = MSG_BASE + 10;
        /**
         * get /machineOrder/findMachineRepairOper 查找机修人员信息
         */
        public static final int MSG_ON_FIND_MACHINE_REPAIR_OPER = MSG_BASE + 11;
        /**
         * get /machineOrder/findMachineOrderList 查找机修工单信息
         */
        public static final int MSG_ON_FIND_MACHINE_ORDER_LIST = MSG_BASE + 12;
        /**
         * get /machineOrder/findMachineOrderDetail 查找机修工单信息明细
         */
        public static final int MSG_ON_FIND_MACHINE_ORDER_DETAIL = MSG_BASE + 13;
        /**
         * post /machineOrder/saveOrUpdateMachineOrder 创建机修工单
         */
        public static final int MSG_ON_SAVE_OR_UPDATE_MACHINE_ORDER = MSG_BASE + 14;
        /**
         * post /machineOrder/updateMachineOrderMaintenance 评价机修工单维修
         */
        public static final int MSG_ON_UPDATE_MACHINE_ORDER_MAINTENANCE = MSG_BASE + 15;
    }

    /**
     * 活动上报
     */
    public static final class ActReport {

        private static final int MSG_BASE = 13 * MSG_SECTION_SIZE;
        /**
         * GET /specialactivity/querySpecialActivity 特殊活动上报查询
         */
        public static final int MSG_ON_QUERY_SPECIAL_ACTIVITY = MSG_BASE + 1;
        /**
         * 特殊活动上报保存
         */
        public static final int MSG_ON_SAVE_SPECIAL_ACTIVITY = MSG_BASE + 2;
        /**
         * GET /newcusactitycontroller/getNewCusActityType 查询新客拉新活动类型
         */
        public static final int MSG_ON_GET_NEWCUS_ACTITY_TYPE = MSG_BASE + 3;
        /**
         * GET /newcusactitycontroller/getNewCusActitySubject 查询新客拉新活动主题
         */
        public static final int MSG_ON_GET_NEWCUS_ACTITY_SUBJECT = MSG_BASE + 4;
        /**
         * GET /newcusactitycontroller/getNewCusActPromoProps 查询新客拉新活动推广道具
         */
        public static final int MSG_ON_GET_NEWCUS_ACT_PROMO_PROPS = MSG_BASE + 5;
        /**
         * POST /newcusactitycontroller/saveNewCusActityService 新客拉新活动上报
         */
        public static final int MSG_ON_SAVE_NEWCUS_ACTITY_SERVICE = MSG_BASE + 6;
    }

    /**
     * Ibeancon上报相关
     */
    public static final class IbeanconReport {

        private static final int MSG_BASE = 14 * MSG_SECTION_SIZE;
        /**
         * GET /ibeacon/getIbeacon ibeacon上报查询
         */
        public static final int MSG_ON_GET_IBEACON = MSG_BASE + 3;
        /**
         * GET /ibeacon/getIbeaconShop 门店ibeacon和上报时间查询
         */
        public static final int MSG_ON_GET_IBEACON_SHOP = MSG_BASE + 4;
        /**
         * POST /ibeacon/saveIbeacon ibeacon上报
         */
        public static final int MSG_ON_SAVE_IBEACON = MSG_BASE + 5;
    }

    /**
     * 评级上报
     */
    public static final class RatingsReport {

        private static final int MSG_BASE = 15 * MSG_SECTION_SIZE;
        /**
         * 评级上报查询门店等级
         */
        public static final int MSG_ON_QUERY_SHOPRATINGSRANK = MSG_BASE + 1;
        /**
         * 评级上报查询
         */
        public static final int MSG_ON_QUERY_RATINGSREPORT = MSG_BASE + 2;
        /**
         * 评级上报保存
         */
        public static final int MSG_ON_SAVE_RATINGS_REPORT = MSG_BASE + 3;
        /**
         * 评级上报审核
         */
        public static final int MSG_ON_APPROVE_RATINGS_REPORT = MSG_BASE + 4;

    }

    /**
     * 巡店辅导
     */
    public static final class TourShopReport {

        private static final int MSG_BASE = 16 * MSG_SECTION_SIZE;
        /**
         * GET /tourShop/findTourShop 从入口进入时显示界面调用
         */
        public static final int MSG_ON_FIND_TOURSHOP = MSG_BASE + 1;
        /**
         * POST /tourShop/saveTourShop 保存巡店上报
         */
        public static final int MSG_ON_SAVE_TOURSHOP = MSG_BASE + 2;
        /**
         * GET /tourShop/findTourShopType 查询巡店辅导类型
         */
        public static final int MSG_ON_FIND_TOURSHOP_TYPE = MSG_BASE + 3;

    }

    /**
     * 商超大数据
     */
    public static final class BigDataReport {

        private static final int MSG_BASE = 17 * MSG_SECTION_SIZE;
        /**
         * GET /supermarketData/getSupermarketBigDataShop 查询门店是否填写商超大数据
         */
        public static final int MSG_ON_GET_SUPERMARKET_BIGDATA_SHOP = MSG_BASE + 1;
        /**
         * GET /supermarketData/findStoreSupermarketBigData 查询门店商超大数据
         */
        public static final int MSG_ON_FIND_STORE_SUPERMARKET_BIGDATA = MSG_BASE + 2;
        /**
         * GET /supermarketData/getSupermarketBigDataReport 查询门店商超大数据
         */
        public static final int MSG_ON_GET_SUPERMARKET_BIGDATA_REPORT = MSG_BASE + 3;
        /**
         * POST /supermarketData/saveSupermarketBigData 新增商超大数据
         */
        public static final int MSG_ON_SAVE_SUPERMARKET_BIGDATA = MSG_BASE + 4;
    }

    /**
     * 人才库
     */
    public static final class TalentPoolReport {

        private static final int MSG_BASE = 18 * MSG_SECTION_SIZE;
        /**
         * GET /talentPool/findOrgTalentNum 组织下门店储备人数查询
         */
        public static final int MSG_ON_FIND_ORG_TALENT_NUM = MSG_BASE + 1;
        /**
         * GET /talentPool/findShopTalent 门店储备人才
         */
        public static final int MSG_ON_FIND_SHOP_TALENT = MSG_BASE + 2;
        /**
         * GET /talentPool/getTalentPoolByPhone 人才库查询-手机校验
         */
        public static final int MSG_ON_GET_TALENT_POOL_BY_PHONE = MSG_BASE + 3;
        /**
         * GET /talentPool/findShopTalentDetail 门店储备人才详情
         */
        public static final int MSG_ON_FIND_SHOP_TALENT_DETAIL = MSG_BASE + 4;
        /**
         * GET /talentPool/deleteTalentPool 删除储备人才
         */
        public static final int MSG_ON_DELETE_TALENT_POOL = MSG_BASE + 5;
        /**
         * POST /talentPool/saveTalentPool 新增/更新人才库
         */
        public static final int MSG_ON_SAVE_TALENT_POOL = MSG_BASE + 6;
    }

    /**
     * 低绩效预警
     */
    public static final class OpfthousAndShopnum {

        private static final int MSG_BASE = 19 * MSG_SECTION_SIZE;
        /**
         * GET /newcusactitycontroller/getSaleLessOPFThousandShopNum 主管下门店连续三个月销售小于1.5w记录
         */
        public static final int MSG_ON_GET_SALE_LESS_OPFTHOUS_AND_SHOPNUM = MSG_BASE + 1;
        /**
         * POST /newcusactitycontroller/saveSaleWariningMeasures 销售预警改善措施填写
         */
        public static final int MSG_ON_GET_SAVE_SALE_WARINING_MEASURES = MSG_BASE + 2;
    }

    /**
     * 会员日全员下店
     */
    public static final class MemberDay {

        private static final int MSG_BASE = 20 * MSG_SECTION_SIZE;
        /**
         * POST /memDaySign/checkCusDay 判断是否为会员日
         */
        public static final int MSG_ON_CHECK_CUS_DAY = MSG_BASE + 1;
        /**
         * POST /memDaySign/getSearchStoreByStaffId 根据工号获取该员工最近搜索的4家门店
         */
        public static final int MSG_ON_GET_SEARCH_STORE_BY_STAFFID = MSG_BASE + 2;
        /**
         * POST /memDaySign/memDaySignShow 会员日下店签到签退(销售金额,签到状态)
         */
        public static final int MSG_ON_MEM_DAY_SIGN_SHOW = MSG_BASE + 3;
        /**
         * POST /memDaySign/saveSearchStore 保存门店搜索记录
         */
        public static final int MSG_ON_SAVE_SEARCH_STORE = MSG_BASE + 4;
        /**
         * POST /memDaySign/memDaySign 签到保存
         */
        public static final int MSG_ON_MEM_DAY_SIGN = MSG_BASE + 5;
        /**
         * POST /memDaySign/saveSignOut 保存签退
         */
        public static final int MSG_ON_SAVE_SIGN_OUT = MSG_BASE + 6;
        /**
         * POST /memDaySign/getMemDaySign 会员日下店情况报表
         */
        public static final int MSG_ON_GET_MEM_DAY_SIGN = MSG_BASE + 7;
        /**
         * GET /memDaySign/getMemDaySignImgAndSaleCount 门店销售金额+会员日下店签到签退图片
         */
        public static final int MSG_ON_GET_SHOP_CUS_DAY_SALE_AMOUNT = MSG_BASE + 8;
    }

    /**
     * 兼职督察
     */
    public static final class PartTime {

        private static final int MSG_BASE = 21 * MSG_SECTION_SIZE;
        /**
         * GET /partTimeTourShop/getPartTimeTourShopCheck 判读该店是否检查过
         */
        public static final int MSG_ON_GET_PARTTIME_TOURSHOP_CHECK = MSG_BASE + 1;
        /**
         * GET /partTimeTourShop/getPartTimeTourShopModel 获取检查项的模型
         */
        public static final int MSG_ON_GET_PARTTIME_TOURSHOP_MODEL = MSG_BASE + 2;
        /**
         * GET /partTimeTourShop/getShopInfo 巡店门店搜索
         */
        public static final int MSG_ON_GET_SHOP_INFO = MSG_BASE + 3;
        /**
         * POST /partTimeTourShop/savePartTimeTourShop 保存兼职督查巡店检查
         */
        public static final int MSG_ON_SAVE_PARTTIME_TOURSHOP = MSG_BASE + 4;
        /**
         * POST /partTimeTourShop/savePartTimeTourShopDetail 提交检查
         */
        public static final int MSG_ON_SAVE_PARTTIME_TOURSHOP_DETAIL = MSG_BASE + 5;
        /**
         * GET /shopSchedule/getFetureShopSchedule 获取门店近七天排班
         */
        public static final int MSG_ON_GET_FETURE_SHOP_SCHEDULE = MSG_BASE + 6;
        /**
         * GET /partTimeTakeStock/getPartTimeTakeStock 当天是否锁定库存盘点
         */
        public static final int MSG_ON_GET_PARTTIME_TAKESTOCK = MSG_BASE + 7;
        /**
         * POST /partTimeTakeStock/savePartTimeTakeStock 锁定库存
         */
        public static final int MSG_ON_SAVE_PARTTIME_TAKESTOCK = MSG_BASE + 8;
        /**
         * GET /partTimeTakeStock/removePartTimeTakeStock 解除库存
         */
        public static final int MSG_ON_REMOVE_PARTTIME_TAKESTOCK = MSG_BASE + 9;
        /**
         * GET /partTimeTakeStock/getTakeStockByShopId 获取门店盘点信息
         */
        public static final int MSG_ON_GET_TAKESTOCK_BY_SHOPID = MSG_BASE + 10;
        /**
         * GET /partTimeTakeStock/getPartTimeTakeStockDetail 盘点信息详情
         */
        public static final int MSG_ON_GET_PARTTIME_TAKESTOCK_DETAIL = MSG_BASE + 11;
        /**
         * POST /partTimeTakeStock/batchSavePartTimeTakeStockDetail 批量盘点提交
         */
        public static final int MSG_ON_BATCH_SAVE_PARTTIME_TAKESTOCK_DETAIL = MSG_BASE + 12;
        /**
         * get /partTimeTourShop/cancelTourShop 兼职督察自己作废
         */
        public static final int MSG_ON_CANCEL_TOUR_SHOP = MSG_BASE + 13;
        /**
         * get /protocol/getProtocol 获取协议
         */
        public static final int MSG_ON_GET_PROTOCOL = MSG_BASE + 14;
        /**
         * post /protocol/saveProtocolRecord 保存用户协议记录
         */
        public static final int MSG_ON_SAVE_PROTOCOL_RECORD = MSG_BASE + 15;
    }

    /**
     * 专项配置
     */
    public static final class ModuleReport {

        private static final int MSG_BASE = 22 * MSG_SECTION_SIZE;
        /**
         * get /mkt/report/getReportByProject 项目(按项目查或门店下的项目)
         */
        public static final int MSG_ON_GET_REPORT_BY_PROJECT = MSG_BASE + 1;
        /**
         * get /mkt/report/getReportByShop 门店(按门店查或项目下的门店)
         */
        public static final int MSG_ON_GET_REPORT_BY_SHOP = MSG_BASE + 2;
        /**
         * get /mkt/report/getReportStandardModel 获取上报标准配置model
         */
        public static final int MSG_ON_GET_REPORT_STANDARD_MODEL = MSG_BASE + 3;
        /**
         * POST /reportmodule/saveModuleReport 保存专项配置上报
         */
        public static final int MSG_ON_SAVE_MODULE_REPORT = MSG_BASE + 4;
    }

    /**
     * 顾问培训
     */
    public static final class EmployAbility {

        private static final int MSG_BASE = 23 * MSG_SECTION_SIZE;
        /**
         * get /employAbility/findUserList 查询营养顾问信息
         */
        public static final int MSG_ON_FIND_USER_LIST = MSG_BASE + 1;
        /**
         * get /employAbility/findInStoreUserList 查询驻店营养顾问信息
         */
        public static final int MSG_ON_FIND_INSTORE_USER_LIST = MSG_BASE + 2;
        /**
         * get /employAbility/findEmployAbility 员工能力评估查询
         */
        public static final int MSG_ON_FIND_EMPLOY_ABILITY = MSG_BASE + 3;
        /**
         * get /employAbility/findEmpAbilityQualifiedAndUn 员工能力项合格和不合格查询
         */
        public static final int MSG_ON_FIND_EMPABILITY_QUALIFIED_ANDUN = MSG_BASE + 4;
        /**
         * get /employAbility/findEmployItemsTrainRecords 项目培训记录查询
         */
        public static final int MSG_ON_FIND_EMPLOY_ITEMS_TRAIN_RECORDS = MSG_BASE + 5;
        /**
         * post /employAbility/saveEmployAbilityBean 新增或修改能力评估
         */
        public static final int MSG_ON_SAVE_EMPLOY_ABILITY_BEAN = MSG_BASE + 6;
        /**
         * post /employAbility/saveEmployItemsTrainRecords 新增项目培训记录
         */
        public static final int MSG_ON_SAVE_EMPLOY_ITEMS_TRAIN_RECORDS = MSG_BASE + 7;
        /**
         * get /newWorkerTrain/queryWorkerTrainMain 入职培训导师分配顾问信息
         */
        public static final int MSG_ON_QUERY_WORKER_TRAIN_MAIN = MSG_BASE + 8;
        /**
         * get /newWorkerTrain/queryWorkerTrainInfo 查询顾问培训记录及培训项目
         */
        public static final int MSG_ON_QUERY_WORKER_TRAIN_INFO = MSG_BASE + 9;
        /**
         * get /newWorkerTrain/queryWorkerTrainInfo 查询顾问培训记录及培训项目
         */
        public static final int MSG_ON_QUERY_WORKER_TRAIN_INFO_LIST = MSG_BASE + 10;
        /**
         * get /newWorkerTrain/queryNotEvaluatedUser 入职未评估用户信息
         */
        public static final int MSG_ON_QUERY_NOT_EVALUATED_USER = MSG_BASE + 11;
        /**
         * get /newWorkerTrain/queryWorkerTrainContent 查询顾问培训内容
         */
        public static final int MSG_ON_QUERY_WORKER_TRAIN_CONTENT = MSG_BASE + 12;
        /**
         * post /newWorkerTrain/saveWorkerTrainBean 新增或修改顾问培训记录
         */
        public static final int MSG_ON_SAVE_WORKER_TRAIN_BEAN = MSG_BASE + 13;
        /**
         * post /newWorkerTrain/saveWorkerTrainEvaluation 顾问评估
         */
        public static final int MSG_ON_SAVE_WORKER_TRAIN_EVALUATION = MSG_BASE + 14;
        /**
         * get /employAbility/findEmployAbilityTitle 员工能力评估查询一级菜单
         */
        public static final int MSG_ON_FIND_EMPLOY_ABILITY_TITLE = MSG_BASE + 15;
    }

    /**
     * 人才评估
     */
    public static final class EmployTalents {

        private static final int MSG_BASE = 24 * MSG_SECTION_SIZE;
        /**
         * get /workerTalentEvaluate/findInStoreUserList 查询驻店营养顾问信息
         */
        public static final int MSG_ON_FIND_WORKER_TALENT_USER_LIST = MSG_BASE + 1;
        /**
         * get /workerTalentEvaluate/findUserList 查询营养顾问信息
         */
        public static final int MSG_ON_FIND_IN_STORE_USER_LIST = MSG_BASE + 2;
        /**
         * post /workerTalentEvaluate/saveWorkerTalentEvaluate 顾问人才评估
         */
        public static final int MSG_ON_SAVE_WORKER_TALENT_EVALUATE = MSG_BASE + 3;
    }

    /**
     * 终端陈列
     */
    public static final class TerminalDisplay {

        private static final int MSG_BASE = 25 * MSG_SECTION_SIZE;
        /**
         * get /terminalDisCorrective/findTerminalDisShop 查询终端陈列整改门店
         */
        public static final int MSG_ON_FIND_TERMINAL_DISSHOP = MSG_BASE + 1;
        /**
         * post /exhibit/queryMissionByStoreNo 查询门店陈列任务
         */
        public static final int MSG_ON_QUERY_MISSION_BY_STORENO = MSG_BASE + 2;
        /**
         * post /exhibit/addSubmition 新增提报数据
         */
        public static final int MSG_ON_ADD_SUBMITION = MSG_BASE + 3;
        /**
         * post /exhibit/updateSubmition 修改提报数据
         */
        public static final int MSG_ON_UPDATE_SUBMITION = MSG_BASE + 4;
    }
}