package com.wgmf.yxgj.model;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Generated;
import org.greenrobot.greendao.annotation.Transient;

import java.util.List;

/**
 * 登录用户信息实体
 *
 * @author xiep
 */
@Entity
@SuppressWarnings("all")
public class CommonUserinfoBean {
    /**
     * 白名单升级时使用,List不放入数据库
     */
    @Transient
    private List<AuthorityRoleIdBeanList> authorityRoleIdBeanList;
    /**
     * 白名单升级时使用，String放入数据库
     */
    private String authorityRoleIdBean;
    /**
     * 顾问品牌,List不放入数据库
     */
    @Transient
    private List<BrandList> brandList;
    /**
     * 顾问品牌,String放入数据库
     */
    private String brandListBean;
    /**
     * 员工工号
     */
    private String staffId;
    /**
     * 员工姓名
     */
    private String name;
    /**
     * 上级工号
     */
    private String workCode;
    /**
     * 员工OE角色:
     * 1：营养顾问 2：流动营养顾问 3：促销主管 4：机修 5：办事处文员 6：终端推广经理 7：区域经理  8：大区总监
     * 9：人事经理 10：推广经理 11：培训经理 12：KA经理 13：终端主任 14：总部人员 15：店长 16：流动队长 17：金牌导师（驻店）
     * 18：金牌导师（流动） 19：工厂人员 20：会员营销主任 21：KA主管 22：推广专员
     * 23：督导,24：片区经理，25：片区主管 26：兼职人员 27：兼职销售 28,29都是督导
     */
    private String oeRole;
    /**
     * 员工所属组织（总部、大区、办事处、主管）
     */
    private String organization;
    /**
     * 员工所属组织机构ID
     */
    private String organizationId;
    /**
     * 员工所属组织结构编码
     */
    private String organizationCode;
    /**
     * 大区ID
     */
    private String regionId;
    /**
     * 大区名称
     */
    private String regionName;
    /**
     * 办事处ID
     */
    private String officeId;
    /**
     * 办事处名称
     */
    private String officeName;

    /**
     * ehr编码，主管使用办事处的编码，其他人用自己的编码
     */
    @Transient
    private String hrCode;

    /**
     * 登录组织等级：1全国 2 事业部 ，3大区，4办事处 5，主管/直属门店 ,
     */
    private String level;

    /**
     * userPostLevel (string, optional):岗位级别：1/总部人员，3/总监，4/经理 ，5/主管,100/无职位 ,
     */
    private String userPostLevel;

    @Generated(hash = 1470208401)
    public CommonUserinfoBean(String authorityRoleIdBean, String brandListBean, String staffId,
            String name, String workCode, String oeRole, String organization, String organizationId,
            String organizationCode, String regionId, String regionName, String officeId,
            String officeName, String level, String userPostLevel) {
        this.authorityRoleIdBean = authorityRoleIdBean;
        this.brandListBean = brandListBean;
        this.staffId = staffId;
        this.name = name;
        this.workCode = workCode;
        this.oeRole = oeRole;
        this.organization = organization;
        this.organizationId = organizationId;
        this.organizationCode = organizationCode;
        this.regionId = regionId;
        this.regionName = regionName;
        this.officeId = officeId;
        this.officeName = officeName;
        this.level = level;
        this.userPostLevel = userPostLevel;
    }

    @Generated(hash = 477968112)
    public CommonUserinfoBean() {
    }

    public String getLevel() {
        return level;
    }

    public void setLevel(String level) {
        this.level = level;
    }

    public String getOfficeName() {
        return this.officeName;
    }

    public void setOfficeName(String officeName) {
        this.officeName = officeName;
    }

    public String getOfficeId() {
        return this.officeId;
    }

    public void setOfficeId(String officeId) {
        this.officeId = officeId;
    }

    public String getRegionName() {
        return this.regionName;
    }

    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }

    public String getRegionId() {
        return this.regionId;
    }

    public void setRegionId(String regionId) {
        this.regionId = regionId;
    }

    public String getOrganizationCode() {
        return this.organizationCode;
    }

    public void setOrganizationCode(String organizationCode) {
        this.organizationCode = organizationCode;
    }

    public String getOrganizationId() {
        return this.organizationId;
    }

    public void setOrganizationId(String organizationId) {
        this.organizationId = organizationId;
    }

    public String getOrganization() {
        return this.organization;
    }

    public void setOrganization(String organization) {
        this.organization = organization;
    }

    public String getOeRole() {
        return this.oeRole;
    }

    public void setOeRole(String oeRole) {
        this.oeRole = oeRole;
    }

    public String getWorkCode() {
        return this.workCode;
    }

    public void setWorkCode(String workCode) {
        this.workCode = workCode;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getStaffId() {
        if (this.staffId != null) {
            return this.staffId;
        } else {
            return "";
        }
    }

    public void setStaffId(String staffId) {
        this.staffId = staffId;
    }

    public String getHrCode() {
        return hrCode;
    }

    public void setHrCode(String hrCode) {
        this.hrCode = hrCode;
    }

    public List<AuthorityRoleIdBeanList> getAuthorityRoleIdBeanList() {
        return authorityRoleIdBeanList;
    }

    public void setAuthorityRoleIdBeanList(List<AuthorityRoleIdBeanList> authorityRoleIdBeanList) {
        this.authorityRoleIdBeanList = authorityRoleIdBeanList;
    }

    public String getAuthorityRoleIdBean() {
        return authorityRoleIdBean;
    }

    public void setAuthorityRoleIdBean(String authorityRoleIdBean) {
        this.authorityRoleIdBean = authorityRoleIdBean;
    }

    public List<BrandList> getBrandList() {
        return brandList;
    }

    public void setBrandList(List<BrandList> brandList) {
        this.brandList = brandList;
    }

    public String getUserPostLevel() {
        return userPostLevel;
    }

    public void setUserPostLevel(String userPostLevel) {
        this.userPostLevel = userPostLevel;
    }

    public String getBrandListBean() {
        return brandListBean;
    }

    public void setBrandListBean(String brandListBean) {
        this.brandListBean = brandListBean;
    }
}