package com.wgmf.yxgj.model;

import org.greenrobot.greendao.annotation.Entity;
import org.greenrobot.greendao.annotation.Id;
import org.greenrobot.greendao.annotation.Transient;

import java.io.Serializable;

import org.greenrobot.greendao.annotation.Generated;

/**
 * @author xiep  on 2016/9/27 15:41
 * maxSuggestOrderGoodsNum (number, optional):最大建议订货量 ,
 * orderGoodsAmount (number, optional):订货金额 ,
 * orderGoodsAuditId (integer, optional):订货审核Id ,
 * orderGoodsAuditNum (number, optional):审核数量 ,
 * orderGoodsNum (number, optional):订货数量 ,
 * orderGoodsNumINControl (string, optional):订货数量是否管控 ,
 * orderGoodsStoreWeekDayAndCycle (OrderGoodsStoreWeekDayAndCycle, optional):订货审核门店周期和星期 ,
 * pdBillCode (string, optional):盘点单号 ,
 * pdId (integer, optional):盘点ID ,
 * productAlreadyOrderNum (number, optional):已提交数量 ,
 * productBigFatherType (string, optional):产品大类父类 ,
 * productBigType (string, optional):产品大类 ,
 * productBoxNum (number, optional):产品箱装数量 ,
 * productCode (string, optional):产品编码 ,
 * productFutureNum (number, optional):产品在途数量 ,
 * productId (integer, optional):产品Id ,
 * productIsNotStock (boolean, optional):产品是否缺货： true/缺货，false/不缺 ,
 * productLastMonthOrderNum (number, optional):近30天已订货数量 ,
 * productLastMonthSaleNum (number, optional):产品前30天销售数量 ,
 * productName (string, optional):产品名称 ,
 * productPrice (string, optional):产品价格 ,
 * productStockNum (number, optional):产品库存数量 ,
 * productUnit (string, optional):产品单位 ,
 * productUnitId (integer, optional):产品单位id ,
 * suggestOrderGoodsNum (number, optional):建议订货量 ,
 * type (string, optional):类型（是UPDATE =0 或 INSERT =1） ,
 * userNo (string, optional):处理人工号
 */

@Entity
@SuppressWarnings("all")
public class OrderGoodsAuditDetail implements Serializable {
    /**
     *
     */
    private long createTime;

    @Transient
    static final long serialVersionUID = 1L;
    /**
     * 资材库存信息
     */
    private String productBillCode;
    private double productCapitalReceiptsStock;
    /**
     * 产品信息
     */
    private String productBigFatherType;
    private String productBigType;
    private String productType;
    private String productImage;
    private double productPack;
    private double productFutureNum;
    private double productAlreadyOrderNum;
    private double productLastMonthOrderNum;

    @Transient
    private OrderGoodsStoreWeekDayAndCycle orderGoodsStoreWeekDayAndCycle;

    private double maxSuggestOrderGoodsNum;

    private double suggestOrderGoodsNum;

    private double productLastMonthSaleNum;

    private double productBoxNum;

    private double productStockNum;

    private String productPrice;

    private int orderGoodsAuditId;

    private String productName;

    private String productCode;

    private String productUnit;

    private int productUnitId;
    /**
     * 产品id作为数据库id
     */
    @Id
    private Long productId;

    private boolean productIsNotStock;

    private double orderGoodsNum;

    private String orderGoodsAmount;

    private double orderGoodsAuditNum;

    private String orderGoodsNumINControl;

    private String userNo;

    private int type;
    /**
     * 是否选中（本地冗余字段）
     */
    private boolean isChoice;
    /**
     * 是否可点击（本地冗余字段）
     */
    private boolean invalid;
    /**
     * 超过次大订货量可以提交（本地冗余字段）
     */
    private boolean secondValid;
    /**
     * 库存率（本地冗余字段）
     */
    private double cyl;

    @Generated(hash = 1777157730)
    public OrderGoodsAuditDetail(long createTime, String productBillCode, double productCapitalReceiptsStock,
            String productBigFatherType, String productBigType, String productType, String productImage,
            double productPack, double productFutureNum, double productAlreadyOrderNum,
            double productLastMonthOrderNum, double maxSuggestOrderGoodsNum, double suggestOrderGoodsNum,
            double productLastMonthSaleNum, double productBoxNum, double productStockNum, String productPrice,
            int orderGoodsAuditId, String productName, String productCode, String productUnit, int productUnitId,
            Long productId, boolean productIsNotStock, double orderGoodsNum, String orderGoodsAmount,
            double orderGoodsAuditNum, String orderGoodsNumINControl, String userNo, int type, boolean isChoice,
            boolean invalid, boolean secondValid, double cyl) {
        this.createTime = createTime;
        this.productBillCode = productBillCode;
        this.productCapitalReceiptsStock = productCapitalReceiptsStock;
        this.productBigFatherType = productBigFatherType;
        this.productBigType = productBigType;
        this.productType = productType;
        this.productImage = productImage;
        this.productPack = productPack;
        this.productFutureNum = productFutureNum;
        this.productAlreadyOrderNum = productAlreadyOrderNum;
        this.productLastMonthOrderNum = productLastMonthOrderNum;
        this.maxSuggestOrderGoodsNum = maxSuggestOrderGoodsNum;
        this.suggestOrderGoodsNum = suggestOrderGoodsNum;
        this.productLastMonthSaleNum = productLastMonthSaleNum;
        this.productBoxNum = productBoxNum;
        this.productStockNum = productStockNum;
        this.productPrice = productPrice;
        this.orderGoodsAuditId = orderGoodsAuditId;
        this.productName = productName;
        this.productCode = productCode;
        this.productUnit = productUnit;
        this.productUnitId = productUnitId;
        this.productId = productId;
        this.productIsNotStock = productIsNotStock;
        this.orderGoodsNum = orderGoodsNum;
        this.orderGoodsAmount = orderGoodsAmount;
        this.orderGoodsAuditNum = orderGoodsAuditNum;
        this.orderGoodsNumINControl = orderGoodsNumINControl;
        this.userNo = userNo;
        this.type = type;
        this.isChoice = isChoice;
        this.invalid = invalid;
        this.secondValid = secondValid;
        this.cyl = cyl;
    }

    @Generated(hash = 376701132)
    public OrderGoodsAuditDetail() {
    }

    public String getProductBigFatherType() {
        return productBigFatherType;
    }

    public void setProductBigFatherType(String productBigFatherType) {
        this.productBigFatherType = productBigFatherType;
    }

    public double getProductFutureNum() {
        return productFutureNum;
    }

    public void setProductFutureNum(double productFutureNum) {
        this.productFutureNum = productFutureNum;
    }

    public double getProductAlreadyOrderNum() {
        return productAlreadyOrderNum;
    }

    public void setProductAlreadyOrderNum(double productAlreadyOrderNum) {
        this.productAlreadyOrderNum = productAlreadyOrderNum;
    }

    public double getProductLastMonthOrderNum() {
        return productLastMonthOrderNum;
    }

    public void setProductLastMonthOrderNum(double productLastMonthOrderNum) {
        this.productLastMonthOrderNum = productLastMonthOrderNum;
    }

    public void setOrderGoodsStoreWeekDayAndCycle(OrderGoodsStoreWeekDayAndCycle orderGoodsStoreWeekDayAndCycle) {
        this.orderGoodsStoreWeekDayAndCycle = orderGoodsStoreWeekDayAndCycle;
    }

    public boolean isChoice() {
        return isChoice;
    }

    public void setProductLastMonthSaleNum(double productLastMonthSaleNum) {
        this.productLastMonthSaleNum = productLastMonthSaleNum;
    }

    public double getProductLastMonthSaleNum() {
        return this.productLastMonthSaleNum;
    }

    public void setProductBoxNum(double productBoxNum) {
        this.productBoxNum = productBoxNum;
    }

    public double getProductBoxNum() {
        return this.productBoxNum;
    }

    public void setProductStockNum(double productStockNum) {
        this.productStockNum = productStockNum;
    }

    public double getProductStockNum() {
        return this.productStockNum;
    }

    public void setProductPrice(String productPrice) {
        this.productPrice = productPrice;
    }

    public String getProductPrice() {
        return this.productPrice;
    }

    public void setOrderGoodsAuditId(int orderGoodsAuditId) {
        this.orderGoodsAuditId = orderGoodsAuditId;
    }

    public int getOrderGoodsAuditId() {
        return this.orderGoodsAuditId;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getProductName() {
        return this.productName;
    }

    public void setProductCode(String productCode) {
        this.productCode = productCode;
    }

    public String getProductCode() {
        return this.productCode;
    }

    public String getProductUnit() {
        return productUnit;
    }

    public void setProductUnit(String productUnit) {
        this.productUnit = productUnit;
    }

    public void setProductUnitId(int productUnitId) {
        this.productUnitId = productUnitId;
    }

    public int getProductUnitId() {
        return this.productUnitId;
    }

    public void setProductId(Long productId) {
        this.productId = productId;
    }

    public Long getProductId() {
        return this.productId;
    }

    public void setOrderGoodsNum(double orderGoodsNum) {
        this.orderGoodsNum = orderGoodsNum;
    }

    public double getOrderGoodsNum() {
        return this.orderGoodsNum;
    }

    public void setOrderGoodsAmount(String orderGoodsAmount) {
        this.orderGoodsAmount = orderGoodsAmount;
    }

    public String getOrderGoodsAmount() {
        return this.orderGoodsAmount;
    }

    public void setOrderGoodsAuditNum(double orderGoodsAuditNum) {
        this.orderGoodsAuditNum = orderGoodsAuditNum;
    }

    public double getOrderGoodsAuditNum() {
        return this.orderGoodsAuditNum;
    }

    public void setOrderGoodsNumINControl(String orderGoodsNumINControl) {
        this.orderGoodsNumINControl = orderGoodsNumINControl;
    }

    public String getOrderGoodsNumINControl() {
        return this.orderGoodsNumINControl;
    }

    public void setType(int type) {
        this.type = type;
    }

    public int getType() {
        return this.type;
    }

    public boolean isInvalid() {
        return invalid;
    }

    public void setInvalid(boolean invalid) {
        this.invalid = invalid;
    }

    public double getMaxSuggestOrderGoodsNum() {
        return maxSuggestOrderGoodsNum;
    }

    public void setMaxSuggestOrderGoodsNum(double maxSuggestOrderGoodsNum) {
        this.maxSuggestOrderGoodsNum = maxSuggestOrderGoodsNum;
    }

    public double getSuggestOrderGoodsNum() {
        return suggestOrderGoodsNum;
    }

    public void setSuggestOrderGoodsNum(double suggestOrderGoodsNum) {
        this.suggestOrderGoodsNum = suggestOrderGoodsNum;
    }

    public String getUserNo() {
        return userNo;
    }

    public void setUserNo(String userNo) {
        this.userNo = userNo;
    }

    public double getCyl() {
        return cyl;
    }

    public void setCyl(double cyl) {
        this.cyl = cyl;
    }

    public boolean getInvalid() {
        return this.invalid;
    }

    public boolean getIsChoice() {
        return this.isChoice;
    }

    public void setIsChoice(boolean isChoice) {
        this.isChoice = isChoice;
    }

    public String getProductBigType() {
        return productBigType;
    }

    public void setProductBigType(String productBigType) {
        this.productBigType = productBigType;
    }

    public double getProductPack() {
        return productPack;
    }

    public void setProductPack(double productPack) {
        this.productPack = productPack;
    }

    public String getProductType() {
        return productType;
    }

    public void setProductType(String productType) {
        this.productType = productType;
    }

    public String getProductBillCode() {
        return productBillCode;
    }

    public void setProductBillCode(String productBillCode) {
        this.productBillCode = productBillCode;
    }

    public double getProductCapitalReceiptsStock() {
        return productCapitalReceiptsStock;
    }

    public void setProductCapitalReceiptsStock(double productCapitalReceiptsStock) {
        this.productCapitalReceiptsStock = productCapitalReceiptsStock;
    }

    public void setSecondValid(boolean secondValid) {
        this.secondValid = secondValid;
    }

    public boolean getSecondValid() {
        return this.secondValid;
    }

    public boolean isProductIsNotStock() {
        return productIsNotStock;
    }

    public void setProductIsNotStock(boolean productIsNotStock) {
        this.productIsNotStock = productIsNotStock;
    }

    public boolean getProductIsNotStock() {
        return this.productIsNotStock;
    }

    public OrderGoodsStoreWeekDayAndCycle getOrderGoodsStoreWeekDayAndCycle() {
        return orderGoodsStoreWeekDayAndCycle;
    }

    public long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(long createTime) {
        this.createTime = createTime;
    }

    public String getProductImage() {
        return productImage;
    }

    public void setProductImage(String productImage) {
        this.productImage = productImage;
    }
}