package com.wgmf.yxgj.publics.service;

/**
 * 根据resId执行功能跳转与图标显示
 *
 * @author xiep on 2016/9/9 13:38
 */
public class ToFunctionByResId {
    /**
     * 66：反馈直通车－－511
     * 131:总经理专线
     * 176：产品调入调出功能选择门店－－548
     * 192:资材调拨ID－－556
     * 223:营养顾问排班
     * 234:人才库－－508
     * 597:填写机修工单
     * 702:入职培训导师分配
     *
     * @param resId 资源ID
     * @return 根据资源ID检查是否销毁门店选择界面
     */
    public static boolean checkIsFinish(Long resId) {
        boolean isFinish = false;
        if (null != resId && (resId == 66 || resId == 131 || resId == 176 || resId == 192 || resId == 223 || resId == 234
                || resId == 511 || resId == 548 || resId == 556 || resId == 508 || resId == 597|| resId == 702)) {
            isFinish = true;
        }
        return isFinish;
    }

    /**
     * resId == 106 || resId == 122) {// "特殊活动上报"/评级上报(不用此接口)－－512
     * resId == 140) {//新巡店上报（巡店辅导）－－502
     * resId == 202) {//新客拉新上报－－515
     *
     * @param resId 资源ID
     * @return 根据资源ID检查是否需要先选择门店
     */
    public static boolean checkChoiceShop(Long resId) {
        boolean isChoice = false;
        if (null != resId && (resId == 106 || resId == 140 || resId == 202
                || resId == 512 || resId == 502 || resId == 515)) {
            isChoice = true;
        }
        return isChoice;
    }

    /**
     * 详情页面分发
     *
     * @param resId 资源ID
     * @return 详情页面type
     */
    public static int getType(Long resId) {
        int type = 0;
        if (resId == 545 || resId == 557 || resId == 527) {
            //Ibeacon查询\填写月计划\兼职督察门店检查\员工信息修改
            type = 0;
        } else if (resId == 544 || resId == 559 || resId == 526) {
            //Ibeacon上报\填写月总结\兼职督察盘点\员工离职
            type = 1;
        } else if (resId == 560) {
            //查询计划与总结\员工审批
            type = 2;
        }
        return type;
    }

    /**
     * 详情页面分发
     *
     * @param resId 资源ID
     * @return 详情页面type
     */
    public static int getMonthType(Long resId) {
        int type = 2;
        if (resId == 557) {
            //填写月计划
            type = 0;
        } else if (resId == 559) {
            //填写月总结
            type = 1;
        } else if (resId == 560) {
            //查询计划与总结\员工审批
            type = 2;
        }
        return type;
    }
}