package com.wgmf.yxgj.report.ui;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.Resources;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.PowerManager;
import android.provider.MediaStore;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.qiniu.android.http.ResponseInfo;
import com.qiniu.android.storage.UpCompletionHandler;
import com.qiniu.android.storage.UploadManager;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.Files;
import com.wgmf.library.utils.tools.DeviceHelper;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.base.R;
import com.wgmf.yxgj.dialog.PhotoSelectorPop;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.MediaParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.utils.PhotoUtils;
import com.wgmf.yxgj.widgets.ListView.HorizontialListView;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.pro.imagepickerlib.widgets.TipDialog;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.json.JSONObject;

import java.io.File;
import java.lang.ref.SoftReference;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import pro.xp.com.soundrecorderlib.recorder.Recorder;
import pro.xp.com.soundrecorderlib.recorder.ui.SoundRecorder;
import pro.xp.com.soundrecorderlib.seleteaudio.model.AudioBean;
import pro.xp.com.soundrecorderlib.seleteaudio.ui.AudioSelectAdapter;
import pro.xp.com.soundrecorderlib.seleteaudio.ui.SeleteAudioActivity;

import static android.support.v4.content.FileProvider.getUriForFile;
import static pro.xp.com.soundrecorderlib.recorder.Recorder.getAudioFile;
import static pro.xp.com.soundrecorderlib.seleteaudio.ui.SeleteAudioActivity.ANSWER_AUDIO_SELECT;
import static pro.xp.com.soundrecorderlib.seleteaudio.ui.SeleteAudioActivity.RESULT_AUDIO_SELECT;

/**
 * @author xiep
 */
@SuppressWarnings("all")
public class ReportBaseDetailActivity extends BaseParentAct implements PhotoSelectorPop.PhotoSelectorPopListener, AudioSelectAdapter.AudioItemClickListener, AudioSelectAdapter.AudioItemDeleteClickListener, Recorder.OnStateChangedListener {
    /**
     * 标题文字
     */
    protected String branchTitle;
    /**
     * 上报类型
     */
    protected String reportType = "UNKOWN";
    /**
     * 图片上传张数
     */
    protected int mPicSize;
    /**
     * 图片上传张数描述
     */
    protected String mPicDes;
    /**
     * 图片上传张数描述
     */
    protected String mPicTitleDes;
    /**
     * 图片名称
     */
    protected String picName = "";

    /**
     * 0x000000;
     * mode 0，否；1，是
     * 最低位:拍照标志；
     * 倒数第二位：选择相册标志；
     * 倒数第三位：录音标志；
     * 倒数第四位：选择音频标志
     * 默认不可用
     */
    protected int pickerMode = 0x000000;
    /**
     * 图片显示集合
     */
    protected List<String> piclist = new ArrayList<>();
    /**
     * 门店id 上传图片时需要
     */
    protected String shopId;
    /**
     * 门店id 上传图片时需要
     */
    protected String shopName;
    /**
     * 图片URL集合(上传)
     */
    protected List<String> urlLists = new ArrayList<>();
    /**
     * 图片七牛名称集合（未上传）
     */
    protected List<String> qiniuUrlLists = new ArrayList<>();

    protected PhotoSelectorPop photoSelectorPop;
    /**
     * 公共列表
     */
    protected ListView publicListViewLv;
    /**
     * 公共可扩展列表
     */
    protected ExpandableListView publicListViewElv;
    /**
     * 上报信息布局
     */
    protected LinearLayout titleMoreLl;
    /**
     * 上报门店或顾问信息
     */
    protected TextView reportDetailTitle;
    /**
     * 上报日期
     */
    protected TextView reportDetailDate;
    /**
     * 修改按钮
     */
    protected Button reportContentModifyBtn;
    /**
     * 确认按钮
     */
    protected Button reportContentComfirmBtn;
    /**
     * 确认按钮布局
     */
    protected LinearLayout reportContentComfirmLl;
    /**
     * 确认按钮提示信息
     */
    protected TextView reportContentComfirmTipTxt;
    /**
     * 上报图片状态
     */
    protected String imgStatus = "";
    /**
     * 图片列表
     */
    protected HorizontialListView publicTakePhotoHzLv;
    /**
     * 图片选择布局
     */
    protected LinearLayout publicTakePhotoLl;
    /**
     * 占位图片
     */
    protected TextView publicTakePhotoAddPictureImg;
    /**
     * 图片添加提示
     */
    protected TextView publicTakePhotoAddPictureTxt;
    /**
     * 图片添加提示标题
     */
    protected TextView publicTakePhotoTipsTv;
    /**
     * 总结标题
     */
    protected TextView tvSummary;
    /**
     * 上报输入框
     */
    protected EditText reportEdit;

    protected PopupWindow pw3;
    /**
     * 图片列表适配器
     */
    protected ReportPicAdapter reportPicAdapter;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initData();
        initView();
        initTitle();
        initContent();
        setContent();
        setLisener();
    }

    protected void initData() {
        //图片默认大小使用100K
        PrefTool.setIntSave(ReportBaseDetailActivity.this, Prefs.PRE_IMAGE_SIZE, 100);
        PrefTool.setBooleanSave(ReportBaseDetailActivity.this, Prefs.PRE_DIALOG_SHOWING, false);
    }

    protected void initView() {
        setContentView(R.layout.public_list_view);
        publicListViewLv = (ListView) findViewById(R.id.public_list_view_lv);
        publicListViewElv = (ExpandableListView) findViewById(R.id.public_list_view_elv);
        titleMoreLl = (LinearLayout) findViewById(R.id.title_more_ll);
        reportDetailTitle = (TextView) findViewById(R.id.report_detail_title);
        reportDetailDate = (TextView) findViewById(R.id.report_detail_date);
        EventBus.getDefault().register(this);
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
    }

    protected void initContent() {
    }

    protected void setContent() {
        setEmptyView();
        setListHeadAndFootView();
        setListAdapter();
        parseHeadData();
        parseFootData();
    }

    /**
     * 设置列表空布局
     */
    protected void setEmptyView() {

    }

    /**
     * 设置列表适配器
     */
    protected void setListAdapter() {
    }

    /**
     * 设置列表头和尾布局
     */
    protected void setListHeadAndFootView() {
        View footView = getLayoutInflater().inflate(
                R.layout.public_report_footview, null);
        publicListViewLv.addFooterView(footView);
    }

    protected void parseHeadData() {

    }

    protected void parseFootData() {
        mLvAudio = (ListViewForScrollView) findViewById(R.id.id_lv_audio_checked);
        publicTakePhotoHzLv = (HorizontialListView) findViewById(R.id.public_take_photo_hz_lv);
        publicTakePhotoLl = (LinearLayout) findViewById(R.id.public_take_photo_ll);
        publicTakePhotoAddPictureImg = (TextView) findViewById(R.id.public_take_photo_add_picture_img);
        publicTakePhotoAddPictureTxt = (TextView) findViewById(R.id.public_take_photo_add_picture_txt);
        publicTakePhotoTipsTv = (TextView) findViewById(R.id.public_take_photo_tips_tv);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
        reportContentModifyBtn = (Button) findViewById(R.id.report_content_modify_btn);
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmTipTxt = (TextView) findViewById(R.id.report_content_comfirm_tip_txt);
        tvSummary = (TextView) findViewById(R.id.tv_summary);
        reportEdit = (EditText) findViewById(R.id.report_edit);

        reportContentComfirmLl.setVisibility(View.VISIBLE);
        publicTakePhotoAddPictureTxt.setText(mPicDes);
        publicTakePhotoTipsTv.setText(mPicTitleDes);
        reportContentComfirmBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                setUploadData();
            }
        });
    }

    protected void showCursor(boolean isShow) {
        //设置EditText默认不显示光标，不可编辑，点击它，进入编辑状态，光标显示
        if (isShow) {
            reportEdit.setCursorVisible(false);
            reportEdit.setOnClickListener(new OnClickListener() {
                @Override
                public void onClick(View v) {
                    reportEdit.setCursorVisible(true);
                }
            });
        }
    }

    protected void setLisener() {
        publicTakePhotoAddPictureImg.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                if (piclist.size() < mPicSize) {
                    showPictureSelect();
                } else {
                    showMsg(mPicDes);
                }
            }
        });
        publicTakePhotoHzLv.setOnItemClickListener(new AdapterView.OnItemClickListener() {

            @Override
            public void onItemClick(AdapterView<?> parent, View view,
                                    int position, long id) {
                if (position == piclist.size()) {
                    if (piclist.size() < mPicSize) {
                        showPictureSelect();
                    } else {
                        showMsg(mPicDes);
                    }
                } else {
                    showBigImg(position);
                }
            }
        });
    }

    protected void refreshListView() {
        if (reportPicAdapter == null) {
            reportPicAdapter = new ReportPicAdapter(piclist, this);
            publicTakePhotoHzLv.setAdapter(reportPicAdapter);
        }
        if (!piclist.isEmpty()) {
            publicTakePhotoAddPictureTxt.setVisibility(View.GONE);
            publicTakePhotoAddPictureImg.setVisibility(View.GONE);
            publicTakePhotoHzLv.setVisibility(View.VISIBLE);
        } else {
            publicTakePhotoAddPictureTxt.setVisibility(View.VISIBLE);
            publicTakePhotoAddPictureImg.setVisibility(View.VISIBLE);
            publicTakePhotoHzLv.setVisibility(View.GONE);
        }
        if (piclist.size() < mPicSize) {
            publicTakePhotoAddPictureImg.setVisibility(View.VISIBLE);
        } else {
            publicTakePhotoAddPictureImg.setVisibility(View.GONE);
        }
        reportPicAdapter.notifyDataSetChanged();
    }

    /**
     * List点击时会发送些事件，接收到事件后更新详情
     */
    @Subscribe
    public void onEventMainThread(List<String> item) {

    }

    /**
     * 隐藏输入法面板
     *
     * @param activity
     */
    public static void hideInputMethod(Activity activity) {
        if (null == activity) {
            return;
        }
        if (null != activity.getCurrentFocus() && null != activity.getCurrentFocus().getWindowToken()) {
            InputMethodManager imm = (InputMethodManager) activity.getSystemService(Activity.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(activity.getCurrentFocus().getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);
        }
    }

    protected void showPictureSelect() {
        hideInputMethod(this);
        if (null == photoSelectorPop) {
            photoSelectorPop = new PhotoSelectorPop(this, this, pickerMode);
        }
        if (!photoSelectorPop.isShowing()) {
            photoSelectorPop.show(this.findViewById(R.id.title));
        }
    }

    protected void showBigImg(int index) {
        View v3 = getLayoutInflater().inflate(R.layout.picture_popupwindow, null);
        ImageView img = (ImageView) v3.findViewById(R.id.list_item_bigImg);
        Bitmap bitmap;
        if (reportPicAdapter.imageCache.get(piclist.get(index)) == null
                || reportPicAdapter.imageCache.get(piclist.get(index)).get() == null) {
            bitmap = PhotoUtils.revitionImageSize(Files.getPhotoPath() + piclist.get(index));
            reportPicAdapter.imageCache.put(piclist.get(index),
                    new SoftReference<>(bitmap));
        } else {
            bitmap = reportPicAdapter.imageCache.get(piclist.get(index)).get();
        }
        img.setImageBitmap(bitmap);
        pw3 = new PopupWindow(v3, WindowManager.LayoutParams.MATCH_PARENT,
                WindowManager.LayoutParams.MATCH_PARENT, true);
        pw3.setFocusable(true);
        pw3.setBackgroundDrawable(new BitmapDrawable());
        pw3.showAtLocation(this.findViewById(R.id.title), Gravity.BOTTOM, 0, 0);
        img.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                if (pw3 != null && pw3.isShowing()) {
                    pw3.dismiss();
                }
            }
        });
    }

    private int count = 0;
    private Handler handler = new Handler();
    private Runnable runnable = new Runnable() {
        @Override
        public void run() {
            this.update();
            // 间隔100ms
            if (count == 0) {
                handler.postDelayed(this, 100);
            }
        }

        void update() {
            if (!urlLists.isEmpty() && urlLists.size() == piclist.size()) {
                dismissDialog();
                Log.i(TAG, "listImg" + urlLists);
                imgStatus = "成功";
                uploadData();
                count = 1;
                handler.removeCallbacks(runnable);
            }
        }
    };

    protected void setUploadData() {
        if (piclist.isEmpty()) {
            //没有图片，直接提交数据
            imgStatus = "没有资源";
            uploadData();
        } else if (null != handler && null != runnable) {
            handler.postDelayed(runnable, 100);
        }
    }

    protected void uploadData() {

    }

    private int uploadCount = 0;


    /**
     * 图片上传失败处理
     */
    private String uploadFail(final String msg) {
        final String tip = "\n版本：" + DeviceHelper.getVersion(this) + "\t\t工号：" + userInfo.getStaffId() +
                "\n设备：Android " + Build.VERSION.RELEASE + " / " + Build.MODEL;
        urlLists.clear();
        qiniuUrlLists.clear();
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                dismissDialog();
                if (uploadCount == 1) {
                    if (reportType == "PTPD" || reportType == "PTJC") {
                        //如果是兼职督察功能，图片上传失败需直接上传数据
                        imgStatus = "失败，" + msg + tip;
                        uploadData();
                    } else {
                        showTipDialog("提示", "图片上传失败，请重新上传!\n" + msg + tip);
                    }
                    uploadCount = 0;
                }
                Log.e("uploadByFilePath", msg);
            }
        });
        return msg;
    }

    TipDialog mTipDialog;

    protected void showTipDialog(String title, String content) {

        if (mTipDialog == null) {
            mTipDialog = TipDialog.createDialog(this, title);
        }

        mTipDialog.setTitle(title);
        mTipDialog.setContent(content);
        mTipDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                mTipDialog = null;
            }
        });
        if (!mTipDialog.isShowing()) {
            mTipDialog.show();
        }
    }

    /**
     * 七牛上传凭证uploadToken
     */
    private String token;

    private String userId;

    /**
     * 上传图片到七牛
     */
    protected void uploadImg(final Bitmap bitmap) {
        final byte[] image = PhotoUtils.compressBmp2Bytes(bitmap, 100);
        if (userInfo != null) {
            userId = userInfo.getStaffId();
        }
        final String key = PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
        //将图片地址加入集合，图片上传成功则能找到该图片，图片上传失败则找不到图片，服务端使用默认图片显示
        qiniuUrlLists.add(PhotoUtils.getRealUrl(key));
        new Thread(new Runnable() {
            @Override
            public void run() {
                // 如果是第一次获取，获得七牛上传凭证uploadToken
                if (token == null || "".equals(token)) {
                    token = PhotoUtils.getUploadToken();
                }
                Log.d("qiniu_token", token + "");

                if (token != null) {
                    UploadManager uploadManager = new UploadManager();
                    uploadManager.put(image, key, token, new UpCompletionHandler() {
                        @Override
                        public void complete(String arg0, ResponseInfo info, JSONObject response) {
                            getQiNiuResponse(info, response);
                        }
                    }, null);
                } else {
                    uploadFail("\n当前网络访问超时,网络或服务器异常！\n");
                }
            }
        }).start();
        uploadCount = 1;
    }

    /**
     * 上传文件到七牛
     *
     * @param filePath 文件路径
     */
    protected void uploadByFilePath(final String filePath) {
        showDialog();
        //异步上传图片
        new uploadImageAsyncTask().execute(filePath);
    }

    /**
     * 上传音频文件到七牛
     *
     * @param filePath 文件路径
     */
    protected void uploadAudioPath(final String filePath) {
        showDialog();
        //异步上传
        new uploadAudioAsyncTask().execute(filePath);
    }

    /**
     * 七牛图片上传完成后回调
     *
     * @param info     七牛返回信息
     * @param response 返回结果
     */
    private void getQiNiuResponse(ResponseInfo info, JSONObject response) {
        //首先检测上传是否成功
        if (!info.isOK()) {
            uploadFail("\n图片上传请求超时，请稍后再试。\n七牛错误：" + info.error + "\n");
        }
        if (null != response) {
            Log.d("qiniu-url", response.toString());

            String json = response.toString();
            BaseResponse mTokenBean = PhotoUtils.parseTokenData(json);

            // 解析出返回的token
            if (null != mTokenBean && ConstantParams.CONSTANT_PARAMS_0.equals(mTokenBean.retCode)) {
                String url = PhotoUtils.getRealUrl(mTokenBean.retInfo);
                urlLists.add(url);
                Log.d(TAG, "mTokenBean.getRetInfo()=" + mTokenBean.retInfo);
                EventBus.getDefault().post(urlLists);
            } else {
                uploadFail("\n七牛返回状态码:" + mTokenBean.retCode + "错误信息:" + mTokenBean.retInfo + "。\n");
            }
        } else {
            uploadFail("\n未获取到七牛返回信息。\n");
        }
    }

    /**
     * @return 图片名称
     */
    protected String getImageUrl() {
        if (userInfo != null) {
            userId = userInfo.getStaffId();
        }
        return PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }

    @Override
    public void onTakePhoto() {
        picName = DateUtil.format(new Date(), "yyyyMMddHHmmss") + ".jpg";
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            //7.0及其以后版本使用升级后的代码处理
            Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
            //判断是否有相机应用
            if (takePictureIntent.resolveActivity(getPackageManager()) != null) {
                File imagePath = new File(Files.getPhotoPath(), picName);
                Uri photoURI = getUriForFile(this, "com.wgmf.yxgj", imagePath);
                //添加这一句表示对目标应用临时授权该Uri所代表的文件
                takePictureIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);
                takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI);
                PrefTool.setBooleanSave(this, Prefs.PRE_NOT_TO_BACKGROUD, true);
                startActivityForResult(takePictureIntent, MediaParams.PARAMS_1);
            }
        } else {
            //7.0之前还保持原来方案进行处理即可
            Intent cameraintent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
            File f = new File(Files.getPhotoPath(), picName);
            cameraintent.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(f));
            PrefTool.setBooleanSave(this, Prefs.PRE_NOT_TO_BACKGROUD, true);
            if (cameraintent.resolveActivity(getPackageManager()) != null) {
                startActivityForResult(cameraintent, MediaParams.PARAMS_1);
            }
        }
    }

    @Override
    public void onChoosePhoto() {
        Intent intent2 = new Intent(Intent.ACTION_PICK, null);
        intent2.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, "image/*");
        PrefTool.setBooleanSave(this, Prefs.PRE_NOT_TO_BACKGROUD, true);
        startActivityForResult(intent2, MediaParams.PARAMS_2);
    }

    @Override
    public void onTakeAudio() {
        //录音
        SoundRecorder.launchAct(this);
    }


    @Override
    public void onChooseAudio() {
        //选取音频
        Intent intent = new Intent(this, SeleteAudioActivity.class);
        if (mAudioResultList != null) {
            intent.putParcelableArrayListExtra(RESULT_AUDIO_SELECT, mAudioResultList);
        }
        startActivityForResult(intent, MediaParams.PARAMS_5);
    }

    @Override
    public void onCancel() {

    }

    @Override
    public void onDismiss() {

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        PrefTool.setBooleanSave(this, Prefs.PRE_NOT_TO_BACKGROUD, false);
        switch (requestCode) {
            case MediaParams.PARAMS_5:
                if (resultCode == Activity.RESULT_OK) {
                    PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
                    mWakeLock = pm.newWakeLock(PowerManager.SCREEN_DIM_WAKE_LOCK, "SoundRecorder");
                    //选择音频
                    mAudioResultList = data.getParcelableArrayListExtra(ANSWER_AUDIO_SELECT);
                    mAapter = new AudioSelectAdapter(this);
                    //1:查询，0，选择；
                    mAapter.setType(2);
                    mAapter.setData(mAudioResultList);
                    mAapter.setListener(this);
                    mAapter.setDelListener(this);
                    mLvAudio.setAdapter(mAapter);
                    //不让ListView获取焦点,否则一直疯狂刷新日志，导致ListView的item条目点击无效
                    mLvAudio.setFocusable(false);
                }
                break;
            case MediaParams.PARAMS_1:
                // 当选择拍照时调用
                if (resultCode == RESULT_CANCELED) {
                    return;
                } else {
                    piclist.add(picName);
                    refreshListView();
                    uploadImages(picName);
                }
                break;
            case MediaParams.PARAMS_2:
                // 当选择从本地获取图片时
                if (resultCode == Activity.RESULT_OK) {
                    String imgPath;
                    Cursor cursor = getContentResolver().query(data.getData(), null, null, null, null);
                    if (cursor != null && cursor.moveToFirst()) {
                        //安卓7.0以上，4才是路径，但低版本安卓，1是路径。
                        imgPath = cursor.getString(4);
                        //如果不是路径，就再找找。
                        if (!imgPath.contains("/storage/")) {
                            //找个6次应该就差不多了，7、8.。。。后面一般都是null
                            for (int i = 0; i < 7; i++) {
                                if (cursor.getString(i).contains("/storage/")) {
                                    imgPath = cursor.getString(i);
                                    break;
                                }
                            }
                        }
                        cursor.close();
                    } else {
                        imgPath = data.getDataString().replace("file://", "");
                    }
                    String s = DateUtil.format(new Date(), "yyyyMMddHHmmss") + ".jpg";
                    Files.FileCache.copyFile(imgPath, Files.getPhotoPath() + s);
                    piclist.add(s);
                    refreshListView();
                    uploadImages(s);
                }
                break;
            default:
                break;
        }
    }

    public void uploadImages(String picName) {
        Bitmap bitmap = PhotoUtils.copressImage(Files.getPhotoPath() + picName);
        try {
            bitmap = PhotoUtils.setDateBitmap(bitmap);
        } catch (OutOfMemoryError e) {
            Log.e(TAG, "UploadReportPhoto: " + picName + "");
        }
        uploadImg(bitmap);
        if (bitmap != null && !bitmap.isRecycled()) {
            bitmap.recycle();
        }
        System.gc();
    }

    @Override
    public void onSaveInstanceState(Bundle savedInstanceState) {
        super.onSaveInstanceState(savedInstanceState);
        savedInstanceState.putString("picName", picName);
    }

    @Override
    public void onRestoreInstanceState(Bundle savedInstanceState) {
        super.onRestoreInstanceState(savedInstanceState);
        picName = savedInstanceState.getString("picName");
    }

    /**
     * 音频文件显示控件
     */
    protected ListViewForScrollView mLvAudio;
    /**
     * 音频文件资源
     */
    protected ArrayList<AudioBean> mAudioResultList;

    protected AudioSelectAdapter mAapter;

    protected Recorder mRecorder = null;

    @Override
    public void onAudioItemClick(AudioBean data) {
        if (data.isShowProcess()) {
            data.setShowProcess(false);
        } else {
            data.setShowProcess(true);
        }
        mAapter.notifyDataSetChanged();
        if (data.recorder == null) {
            mRecorder = new Recorder(getAudioFile());
            mRecorder.setOnStateChangedListener(this);
            data.recorder = mRecorder;
        }
    }

    @Override
    public void onAudioItemDeleteClick(AudioBean data) {
        int type = mAapter.getType();
        if (type == 2) {
            //只允许一条录音，删除则清空url
            mAudioResultList.clear();
            piclist.clear();
            urlLists.clear();
            qiniuUrlLists.clear();
            mAapter.setData(mAudioResultList);
        }
        mAapter.setListener(this);
        mAapter.setDelListener(this);
        mLvAudio.setAdapter(mAapter);
        mAapter.notifyDataSetChanged();
    }

    private PowerManager.WakeLock mWakeLock;
    // Some error messages are displayed in the UI,
    String mErrorUiMessage = null;
    boolean mSampleInterrupted = false;

    @Override
    public void onStateChanged(int state) {
        if (state == Recorder.PLAYING_STATE) {
            mSampleInterrupted = false;
            mErrorUiMessage = null;
            // we don't want to go to sleep while recording or playing
            mWakeLock.acquire();
        } else {
            if (mWakeLock.isHeld()) {
                mWakeLock.release();
            }
        }
        updateUi();
    }

    private void updateUi() {
        mAapter.notifyDataSetChanged();
    }

    @Override
    public void onError(int error) {
        Resources res = getResources();

        String message = null;
        switch (error) {
            case Recorder.SDCARD_ACCESS_ERROR:
                message = res.getString(R.string.error_sdcard_access);
                break;
            case Recorder.IN_CALL_RECORD_ERROR:
                // update error message to reflect that the recording could not be
                // performed during a call.
            case Recorder.INTERNAL_ERROR:
                message = res.getString(R.string.error_app_internal);
                break;
            default:
                break;
        }
        if (message != null) {
            new AlertDialog.Builder(this)
                    .setTitle(R.string.app_name)
                    .setMessage(message)
                    .setPositiveButton(R.string.button_ok, null)
                    .setCancelable(false)
                    .show();
        }
    }

    class uploadImageAsyncTask extends AsyncTask<String, Void, String> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected String doInBackground(String... params) {
            String filePath = params[0];
            // 如果是第一次获取，获得七牛上传凭证uploadToken
            if (TextUtils.isEmpty(token)) {
                token = PhotoUtils.getUploadToken();
            }
            return filePath;
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(String filePath) {
            super.onPostExecute(filePath);
            if (userInfo != null) {
                userId = userInfo.getStaffId();
            }
            String key = PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
            //将图片地址加入集合，图片上传成功则能找到该图片，图片上传失败则找不到图片，服务端使用默认图片显示
            qiniuUrlLists.add(PhotoUtils.getRealUrl(key));
            Bitmap mBitmap = BitmapFactory.decodeFile(filePath);
            if (mBitmap == null) {
                uploadFail("\n图片有问题，请重新选择！\n");
            }
            byte[] bytes = PhotoUtils.compressBmp2Bytes(mBitmap, 100);//压缩到100KB以下（不用保存到本地，直接把bmp压成字节流传给七牛）

            if (token != null) {
                UploadManager uploadManager = new UploadManager();
                uploadManager.put(bytes, key, token, new UpCompletionHandler() {
                    @Override
                    public void complete(String arg0, ResponseInfo info, JSONObject response) {
                        getQiNiuResponse(info, response);
                    }
                }, null);
            } else {
                uploadFail("\nToken获取失败,网络或服务器异常！\n");
            }
            uploadCount = 1;
        }
    }

    class uploadAudioAsyncTask extends AsyncTask<String, Void, String> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected String doInBackground(String... params) {
            String filePath = params[0];
            // 如果是第一次获取，获得七牛上传凭证uploadToken
            if (TextUtils.isEmpty(token)) {
                token = PhotoUtils.getUploadToken();
            }
            return filePath;
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(String filePath) {
            super.onPostExecute(filePath);
            if (userInfo != null) {
                userId = userInfo.getStaffId();
            }
            String key = PhotoUtils.getFileUrlUUID(shopId, userId, reportType);
            qiniuUrlLists.add(PhotoUtils.getRealUrl(key));
            if (token != null) {
                UploadManager uploadManager = new UploadManager();
                uploadManager.put(filePath, key, token, new UpCompletionHandler() {
                    @Override
                    public void complete(String arg0, ResponseInfo info, JSONObject response) {
                        getQiNiuResponse(info, response);
                    }
                }, null);
            } else {
                uploadFail("\nToken获取失败,网络或服务器异常！\n");
            }
            uploadCount = 1;
        }
    }
}