package com.wgmf.yxgj.utils;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.AsyncTask;
import android.view.KeyEvent;

import java.lang.ref.WeakReference;

public class ViewUtil {

    static ProgressDialog progressDialog;

    // 系统进度框
    public static void showProgress(Context con, String title, String message, final AsyncTask<String, String, String> asyncTask) {
        WeakReference<Context> mARef = new WeakReference<>(con);
        if (getContext(mARef) != null) {
            if (progressDialog == null) {
                progressDialog = new ProgressDialog(getContext(mARef));
            } else {
                progressDialog.dismiss();
                progressDialog = null;
                progressDialog = new ProgressDialog(getContext(mARef));
            }
            progressDialog.setTitle(title);
            progressDialog.setMessage(message);
            progressDialog.setCancelable(false);
            dialogShow(con);
            progressDialog.setOnKeyListener(new DialogInterface.OnKeyListener() {
                @Override
                public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
                    if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN && null != progressDialog) {
                        progressDialog.dismiss();
                        progressDialog = null;
                        // asyncTask.cancel(true);
                    }
                    return false;
                }
            });
        }
    }

    private static void dialogShow(Context con) {
        if (con instanceof Activity) {
            if (!((Activity) con).isFinishing()) {
                progressDialog.show();
            }
        } else {
            progressDialog.show();
        }
    }

    public static Context getContext(WeakReference<Context> mARef) {
        if (mARef != null && mARef.get() != null) {
            return mARef.get();
        } else {
            return null;
        }
    }


    // 系统进度框
    public static void showProgress(Context con, String title, String message) {
        WeakReference<Context> mARef = new WeakReference<>(con);
        if (getContext(mARef) != null) {
            if (progressDialog == null) {
                progressDialog = new ProgressDialog(getContext(mARef));
            } else {
                progressDialog.dismiss();
                progressDialog = null;
                progressDialog = new ProgressDialog(getContext(mARef));
            }
            progressDialog.setTitle(title);
            progressDialog.setMessage(message);
            // progressDialog.setCancelable(false);
            dialogShow(con);
            progressDialog.setOnKeyListener(new DialogInterface.OnKeyListener() {

                @Override
                public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
                    return false;
                }
            });
        }
    }

    public static void showProgress(Context con, String title, String message, boolean isCancelable) {
        showProgress(con, title, message);
        if (null != progressDialog) {
            progressDialog.setCancelable(isCancelable);
        }
    }

    public static void dismissProgress() {
        if (null != progressDialog) {
            progressDialog.dismiss();
            progressDialog = null;
        }
    }

}