package com.wgmf.yxgj.utils.helper;

import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.view.View;
import android.widget.DatePicker;
import android.widget.TextView;
import android.widget.TimePicker;

import com.wgmf.yxgj.base.BaseActivity;

import java.util.Calendar;

/**
 * @author xiep
 */
@SuppressWarnings("all")
public class DialogHelper {
    /**
     * 提示框点击按钮接口
     *
     * @author Administrator
     */
    public interface DialogResult {
        /**
         * 点击按钮执行动作 tag：用来区分多个dialog的点击按钮执行动作
         */
        void onDialogResult(int tag);
    }


    public static void Alert3R(Context ctx, CharSequence title, CharSequence message, View layout, DialogInterface.OnClickListener oclt, DialogInterface.OnClickListener oclt2) {
        AlertDialog.Builder builder = createDialogDIY(ctx, title, message, layout);
        builder.setPositiveButton("取消", oclt2);
        builder.setNegativeButton("确定", oclt);
        builder.create().show();
    }

    private static AlertDialog.Builder createDialogDIY(Context ctx, CharSequence title, CharSequence message, View layout) {
        AlertDialog.Builder builder = new AlertDialog.Builder(ctx);
        builder.setMessage(message);
        builder.setTitle(title);
        builder.setView(layout);
        return builder;
    }


    /**
     * 日期选择控件
     *
     * @param context
     * @param textView 回显控件
     */
    public static void AlertDatePicker(final Context context, final DialogResult dialog, final TextView textView) {
        Calendar c = Calendar.getInstance();
        DatePickerDialog.OnDateSetListener dateListener = new DatePickerDialog.OnDateSetListener() {

            @Override
            public void onDateSet(DatePicker view, int year, int monthOfYear,
                                  int dayOfMonth) {

                String month;
                String day;
                if (monthOfYear + 1 < 10) {
                    month = "0" + (monthOfYear + 1);
                } else {
                    month = "" + (monthOfYear + 1);
                }
                if (dayOfMonth < 10) {
                    day = "0" + dayOfMonth;
                } else {
                    day = "" + dayOfMonth;
                }
                textView.setText(year + "-" + month + "-" + day);
                dialog.onDialogResult(6);
            }
        };
        DatePickerDialog datePickerDialog = new DatePickerDialog(context, android.R.style.Theme_Holo_Light_Panel,
                dateListener, c.get(Calendar.YEAR), c.get(Calendar.MONTH),
                c.get(Calendar.DAY_OF_MONTH));
        // 对话框周围不可点击
        datePickerDialog.setCanceledOnTouchOutside(false);
        datePickerDialog.show();
    }

    /**
     * 时间选择控件
     *
     * @param context
     * @param textView 回显控件
     */
    public static void AlertTimePicker(final BaseActivity context,
                                       final TextView textView) {
        Calendar c = Calendar.getInstance();
        TimePickerDialog.OnTimeSetListener dateListener = new TimePickerDialog.OnTimeSetListener() {
            @Override
            public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
                String hour;
                String minutes;
                if (hourOfDay < 10) {
                    hour = "0" + hourOfDay;
                } else {
                    hour = "" + hourOfDay;
                }
                if (minute < 10) {
                    minutes = "0" + minute;
                } else {
                    minutes = "" + minute;
                }
                textView.setText(hour + ":" + minutes);
            }
        };
        TimePickerDialog timePickerDialog = new TimePickerDialog(context, android.R.style.Theme_Holo_Light_Panel,
                dateListener, c.get(Calendar.HOUR), c.get(Calendar.MINUTE), true);
        // 对话框周围不可点击
        timePickerDialog.setCanceledOnTouchOutside(false);
        timePickerDialog.show();
    }
}