package com.wgmf.yxgj.basewebview.ui;

import android.os.Bundle;
import android.view.View;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.basewebview.R;
import com.wgmf.yxgj.global.Prefs;
import com.xp.arouter.RouterParams;

/**
 * @author XP
 */
@Route(path = RouterParams.URL_HTML5DETAILACTIVITY)
public class HtmlActivity extends BaseParentAct implements HtmlFragment.OnChangeTitleListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_webview_content);
        initTitle();
        initContent();
    }

    private void initContent() {
        if (findViewById(R.id.activity_webview_content_frg) != null) {
            String partTimeStaffName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
            HtmlFragment htmlFragment = new HtmlFragment();
            Bundle htmlBundle = new Bundle();
            htmlBundle.putString("mainUrl", getIntent().getStringExtra("mainUrl"));
            htmlBundle.putString("customHtml", getIntent().getStringExtra("customHtml"));
            htmlBundle.putString("orientation", getIntent().getStringExtra("orientation"));
            htmlBundle.putString("branchUrl", getIntent().getStringExtra("branchUrl"));
            htmlBundle.putString("branchTitle", getIntent().getStringExtra("branchTitle"));
            htmlBundle.putString("partTimeStaffName", partTimeStaffName);
            htmlFragment.setArguments(htmlBundle);
            getSupportFragmentManager().beginTransaction().add(R.id.activity_webview_content_frg, htmlFragment).commit();
        }
    }

    @Override
    public void changeTitle(String title) {
        homeTitleText.setText(title);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }
}