package com.wgmf.yxgj.basewebview.ui;

import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.util.Log;
import android.webkit.CookieManager;
import android.webkit.CookieSyncManager;
import android.webkit.WebResourceError;
import android.webkit.WebResourceRequest;
import android.webkit.WebView;
import android.webkit.WebViewClient;

import com.wgmf.library.global.LocationParams;
import com.wgmf.yxgj.base.BaseParentFra;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.model.CommonUserinfoBean;
import com.xp.arouter.RouterCommonUtil;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

/**
 * HtmlPresenter:
 *
 * @author xiep
 * Date: 17/8/24 15:18
 * Email: xiexiepro@gmail.com
 * Blog: http://XieXiePro.github.io
 */
@SuppressWarnings("all")
public class HtmlPresenter {
    private static final String TAG = "HtmlPresenter";
    private HtmlView htmlView;
    private String mTitle = "活动详情";
    private String webViewUrl;
    private static String branchTitle;
    private static String orientation;

    private static CommonUserinfoBean mCommonUserinfoBean;
    /*  */

    /**
     * WebView超时时间：单位毫秒
     *//*
    private long timeout = 30000;

    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 1:
                    //这里对已经显示出页面且加载超时的情况不做处理
                    if (htmlView != null)
                        loadErrorPage(NetworkParams.URL_TIMEOUT_ERROR);
                    break;
                default:
                    break;
            }
        }
    };*/
    private void loadErrorPage(String url) {
//        htmlView.showError("网页数据加载出错，请稍后再试！");
//        htmlView.loadUrl(url);
    }

    public HtmlPresenter(@NonNull HtmlView htmlView) {
        this.htmlView = htmlView;
    }

    /**
     * 初始化数据
     */
    void initData() {
        String branchUrl = (((BaseParentFra) htmlView)).getArguments().getString("branchUrl");
        orientation = (((BaseParentFra) htmlView)).getArguments().getString("orientation");
        branchTitle = (((BaseParentFra) htmlView)).getArguments().getString("branchTitle");
        String mainUrl = (((BaseParentFra) htmlView)).getArguments().getString("mainUrl");
        String customHtml = (((BaseParentFra) htmlView)).getArguments().getString("customHtml");
        String fileUrl = (((BaseParentFra) htmlView)).getArguments().getString("fileUrl");
        if (null != fileUrl && !"".equals(fileUrl)) {
            webViewUrl = fileUrl;
        } else if (mTitle.equals(branchTitle)) {
            //特殊活动详情页
            webViewUrl = NetworkParams.URL_HOST + customHtml;
        } else if ("标准学习资料".equals(branchTitle)) {
            webViewUrl = branchUrl;
        } else if (null != mainUrl && !"".equals(mainUrl)) {
            if (!mainUrl.contains("http")) {
                mainUrl = "http://" + mainUrl;
            }
            webViewUrl = mainUrl;
        } else {
            webViewUrl = NetworkParams.URL_HOST + branchUrl;
        }
        mCommonUserinfoBean = ((BaseParentFra) htmlView).getUserInfo();
    }

    /**
     * 选择加载页面url方式
     */
    void load() {
        htmlView.showLoadingDialog();
        if (mTitle.equals(branchTitle)) {
            //特殊活动详情页
            htmlView.loadData(webViewUrl);
        } else {
            htmlView.loadUrl(webViewUrl);
        }
    }

    /**
     * 同步cookie
     *
     * @param context htmlActivity
     */
    boolean synCookies(Context context) {

        String lat = LocationParams.Latitude;
        String lng = LocationParams.Longitude;

        String shopName = (((BaseParentFra) htmlView)).getArguments().getString("shopName");
        String shopId = (((BaseParentFra) htmlView)).getArguments().getString("shopId");
        String ymd = (((BaseParentFra) htmlView)).getArguments().getString("ymd");
        String partTimeStaffName = (((BaseParentFra) htmlView)).getArguments().getString("partTimeStaffName");

        if (null != mCommonUserinfoBean) {
            String name;
//            boolean flag = PrefTool.getBooleanPreferences(context, Prefs.PRE_REMENBER_PASS, true);
//            if (flag) {
            name = mCommonUserinfoBean.getName() + "";
//            } else {
//                name = "1111";
//            }
//            PrefTool.setBooleanSave(context, Prefs.PRE_REMENBER_PASS, !flag);
            String regionName = mCommonUserinfoBean.getRegionName() + "";
            String officeName = mCommonUserinfoBean.getOfficeName() + "";
            String staffId = mCommonUserinfoBean.getStaffId() + "";
            String organization = mCommonUserinfoBean.getOrganization() + "";
            String organizationId = mCommonUserinfoBean.getOrganizationId() + "";
            String organizationCode = mCommonUserinfoBean.getOrganizationCode() + "";
            String regionId = mCommonUserinfoBean.getRegionId() + "";
            String officeId = mCommonUserinfoBean.getOfficeId() + "";
            String oeRole = mCommonUserinfoBean.getOeRole() + "";
            String userPostLevel = mCommonUserinfoBean.getUserPostLevel() + "";
            String workCode = mCommonUserinfoBean.getWorkCode() + "";
            String brandList = mCommonUserinfoBean.getBrandListBean() + "";
            Log.e(TAG, brandList);

            CookieSyncManager.createInstance(context);
            CookieManager cookieManager = CookieManager.getInstance();
            cookieManager.setAcceptCookie(true);
            cookieManager.removeSessionCookie();
            try {
                cookieManager.setCookie(NetworkParams.URL_HOST, "name=" + URLEncoder.encode(name, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "organization=" + URLEncoder.encode(organization, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "regionName=" + URLEncoder.encode(regionName, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "officeName=" + URLEncoder.encode(officeName, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "staffId=" + URLEncoder.encode(staffId, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "organizationId=" + URLEncoder.encode(organizationId, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "organizationCode=" + URLEncoder.encode(organizationCode, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "regionId=" + URLEncoder.encode(regionId, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "officeId=" + URLEncoder.encode(officeId, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "oeRole=" + URLEncoder.encode(oeRole, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "userPostLevel=" + URLEncoder.encode(userPostLevel, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "workCode=" + URLEncoder.encode(workCode, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "lat=" + URLEncoder.encode(lat, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "lng=" + URLEncoder.encode(lng, "utf-8"));
                cookieManager.setCookie(NetworkParams.URL_HOST, "brandList=" + URLEncoder.encode(brandList, "utf-8"));

                if (null != shopName && null != shopId && null != ymd) {
                    cookieManager.setCookie(NetworkParams.URL_HOST, "shopName=" + URLEncoder.encode(shopName, "utf-8"));
                    cookieManager.setCookie(NetworkParams.URL_HOST, "shopId=" + URLEncoder.encode(shopId, "utf-8"));
                    cookieManager.setCookie(NetworkParams.URL_HOST, "ymd=" + URLEncoder.encode(ymd, "utf-8"));
                }
                if (null != partTimeStaffName) {
                    cookieManager.setCookie(NetworkParams.URL_HOST, "partTimeStaffName=" + URLEncoder.encode(partTimeStaffName, "utf-8"));
                }
            } catch (UnsupportedEncodingException e) {
                e.printStackTrace();
            }
            // cookies是在HttpClient中获得的cookie
            CookieSyncManager.getInstance().sync();
            return true;
        } else {
            return false;
        }
    }

    /**
     * WebViewClient 加载设置
     *
     * @return WebViewClient
     */
    WebViewClient getWebViewClient(final Context context) {
        WebViewClient webViewClient = new WebViewClient() {
            Intent intent = new Intent();

            @Override
            public boolean shouldOverrideUrlLoading(WebView view, String url) {
                if (url.contains("dimission")) {
                    //dimission.html?staffId=" + staffIds
                    String staffId = getValueByName(url, "staffId");
                    Log.e(TAG, "staffId = " + staffId);
                    Bundle mBundle = new Bundle();
                    mBundle.putLong("branchID", 536L);
                    mBundle.putString("branchTitle", "离职办理");
                    mBundle.putString("operatorId", staffId);
                    RouterCommonUtil.startFunctionActivity(((BaseParentFra) htmlView).getActivity(), 0, 536L, mBundle);
                } else if (url.contains("nativeLink")) {
                    //nativeLink.html?nativeId=" + 536
                    String nativeLink = getValueByName(url, "nativeId");
                    String nativeName = getValueByName(url, "nativeName");
                    Long nativeId = Long.parseLong(nativeLink);
                    String extra = getValueByName(url, "extra");
                    Log.e(TAG, "nativeLink = " + nativeLink);
                    if (nativeId != -1) {
                        Bundle mBundle = new Bundle();
                        mBundle.putLong("branchID", nativeId);
                        mBundle.putString("branchTitle", nativeName);
                        mBundle.putString("extra", extra);
                        RouterCommonUtil.startFunctionActivity(((BaseParentFra) htmlView).getActivity(), 0, nativeId, mBundle);
                    } else {
                        //销毁页面
                        htmlView.finishView();
                    }
                } else if (url.startsWith("tel:")) {
                    intent = new Intent(Intent.ACTION_DIAL, Uri.parse(url));
                    ((BaseParentFra) htmlView).getActivity().startActivity(intent);
                } else {
                    view.loadUrl(url);
                }
                return true;
            }

            @Override
            public void onPageStarted(WebView view, String url, Bitmap favicon) {
                super.onPageStarted(view, url, favicon);
//                setWebViewTimer();
            }

            @Override
            public void onPageFinished(WebView view, String url) {
//                timer.cancel();
//                timer.purge();
                CookieManager cookieManager = CookieManager.getInstance();
                String cookieStr = cookieManager.getCookie(url);
                Log.d(TAG, "branchUrl = " + webViewUrl);
                Log.d(TAG, "Cookies = " + cookieStr);
                String backDiv = "$('.backDiv').hide()";
                String topTitle = "$('.topTitle').hide()";
                view.loadUrl("javascript:" + backDiv);
                view.loadUrl("javascript:" + topTitle);
                super.onPageFinished(view, url);
            }

            @Override
            public void onReceivedError(WebView view, WebResourceRequest request, WebResourceError error) {
                super.onReceivedError(view, request, error);
                // 这里进行无网络或错误处理，具体可以根据errorCode的值进行判断，做更详细的处理。
                loadErrorPage(NetworkParams.URL_ERROR);
            }
        };
        return webViewClient;
    }

    /*private Timer timer;
     *//**
     * 设置WebView超时
     *//*
    private void setWebViewTimer() {
        timer = new Timer();
        TimerTask tt = new TimerTask() {
            @Override
            public void run() {
                *//*
     * 执行超时后的动作
     *//*
                Log.d("testTimeout", "timeout...........");
                Message msg = new Message();
                msg.what = 1;
                mHandler.sendMessage(msg);
                timer.cancel();
                timer.purge();
            }
        };
        timer.schedule(tt, timeout, 1);
    }*/

    /**
     * 获取url参数
     *
     * @param url  html地址
     * @param name ValueName
     * @return url参数
     */
    private String getValueByName(String url, String name) {
        String result = "";
        int index = url.indexOf("?");
        String temp = url.substring(index + 1);
        String[] keyValue = temp.split("\\&");
        for (String str : keyValue) {
            if (str.contains(name)) {
                result = str.replace(name + "=", "");
            }
        }
        return result;
    }
}