package com.wgmf.yxgj.module.business.parttime.model;

import com.wgmf.library.utils.StringUtil;

import java.util.List;

/**
 * 门店信息 {
 * address (string, optional): 门店地址 ,
 * distance (number, optional): 和给定地点的距离 ,
 * forwardRatio (integer, optional): 临期货占比 ,
 * id (string, optional): ID ,
 * lat (number, optional): 纬度 ,
 * lng (number, optional): 经度 ,
 * shopScheduleList (Array[门店排班详情], optional),
 * shopStatusId (string, optional): 店态id ,
 * shopStatusName (string, optional): 店态名 ,
 * storeId (string, optional): 门店ID ,
 * storeName (string, optional): 门店名称
 * adventQty (number, optional): 临期货占比 ,(库存盘点)
 * }
 * 作者：xiep on 2018/3/14 16:16
 * 邮箱：2975837870@qq.com
 */

public class PartTimeShopInfoEntity {
    private String storeId;

    private String storeName;

    private String forwardRatio;

    private String address;

    private String distance;

    private String lng;

    private String lat;

    private String adventQty;

    private String submitTime;

    private String lastMonthSaleCount;

    private List<ShopScheduleListEntity> shopScheduleList;

    public String getStoreId() {
        return storeId;
    }

    public void setStoreId(String storeId) {
        this.storeId = storeId;
    }

    public String getStoreName() {
        return storeName;
    }

    public void setStoreName(String storeName) {
        this.storeName = storeName;
    }

    public String getForwardRatio() {
        return forwardRatio;
    }

    public void setForwardRatio(String forwardRatio) {
        this.forwardRatio = forwardRatio;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public List<ShopScheduleListEntity> getShopScheduleList() {
        return shopScheduleList;
    }

    public void setShopScheduleList(List<ShopScheduleListEntity> shopScheduleList) {
        this.shopScheduleList = shopScheduleList;
    }

    public String getDistance() {
        return distance;
    }

    public void setDistance(String distance) {
        this.distance = distance;
    }

    public String getLng() {
        return lng;
    }

    public void setLng(String lng) {
        this.lng = lng;
    }

    public String getLat() {
        return lat;
    }

    public void setLat(String lat) {
        this.lat = lat;
    }

    public String getAdventQty() {
        return adventQty;
    }

    public void setAdventQty(String adventQty) {
        this.adventQty = adventQty;
    }

    public String getSubmitTime() {
        return submitTime;
    }

    public void setSubmitTime(String submitTime) {
        this.submitTime = submitTime;
    }

    public String getLastMonthSaleCount() {
        return lastMonthSaleCount;
    }

    public void setLastMonthSaleCount(String lastMonthSaleCount) {
        this.lastMonthSaleCount = lastMonthSaleCount;
    }
}