package com.wgmf.yxgj.module.business.parttime.ui;

import android.content.Context;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.ToDaySignListEntity;
import com.wgmf.yxgj.module.business.parttime.model.ToDaySignVoListEntity;

import java.util.List;

/**
 * 兼职督察门店查询
 * 作者：xiep on 2018/3/14 16:28
 * 邮箱：2975837870@qq.com
 */

public class PartTimeScheduleSignAdapter extends BaseAdapter {

    private Context context;
    private List<ToDaySignVoListEntity> mShopScheduleLists;


    PartTimeScheduleSignAdapter(List<ToDaySignVoListEntity> mShopScheduleLists, Context context) {
        this.context = context;
        this.mShopScheduleLists = mShopScheduleLists;
    }

    @Override
    public int getCount() {
        return mShopScheduleLists.isEmpty() ? 0 : mShopScheduleLists.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        View view;
        if (convertView == null) {
            view = View.inflate(context, R.layout.part_time_sign_info_list_item, null);
        } else {
            view = convertView;
        }
        TextView partTimeScheduleInfoName = (TextView) view.findViewById(R.id.part_time_shop_info_sign_name);
        TextView partTimeShopInfoSignIn = (TextView) view.findViewById(R.id.part_time_shop_info_sign_in);
        TextView partTimeShopInfoSignOut = (TextView) view.findViewById(R.id.part_time_shop_info_sign_out);
        partTimeScheduleInfoName.setText(mShopScheduleLists.get(position).getStaffName());
        if (null != mShopScheduleLists.get(position).getToDaySignList() && !mShopScheduleLists.get(position).getToDaySignList().isEmpty()) {
            String partTimeShopInfoSignIns = "";
            String partTimeShopInfoSignOuts = "";
            List<ToDaySignListEntity> toDaySignListEntitys = mShopScheduleLists.get(position).getToDaySignList();
            for (int i = 0; i < toDaySignListEntitys.size(); i++) {
                if (!TextUtils.isEmpty(toDaySignListEntitys.get(i).getSignInTime())) {
                    partTimeShopInfoSignIns += "签到" + (i + 1) + "\t" + toDaySignListEntitys.get(i).getSignInTime();
                }
                if (!TextUtils.isEmpty(toDaySignListEntitys.get(i).getSignOutTime())) {
                    partTimeShopInfoSignOuts += "签退" + (i + 1) + "\t" + toDaySignListEntitys.get(i).getSignOutTime();
                }
                if (i < toDaySignListEntitys.size() - 1) {
                    partTimeShopInfoSignIns = partTimeShopInfoSignIns + "\n";
                    partTimeShopInfoSignOuts = partTimeShopInfoSignOuts + "\n";
                }
            }
            partTimeShopInfoSignIn.setText(partTimeShopInfoSignIns);
            partTimeShopInfoSignOut.setText(partTimeShopInfoSignOuts);
        }
        return view;
    }
}