package com.wgmf.yxgj.module.business.parttime.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeShopInfoEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeShopInfoListEntity;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;
import com.wgmf.yxgj.module.business.parttime.ui.takestock.PartTimeTakeStockLockActivity;
import com.wgmf.yxgj.module.business.parttime.ui.tourshop.PartTimeTourShopCheckActivity;
import com.wgmf.yxgj.publics.service.ToFunctionByResId;
import com.wgmf.yxgj.widgets.EditText.ClearEditText;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

/**
 * 兼职督察门店选择列表
 * 作者：xiep on 2018/3/14 14:14
 * 邮箱：2975837870@qq.com
 */
@Route(path = RouterParams.URL_PARTTIME_SHOPINFO_ACTIVITY)
public class PartTimeShopInfoActivity extends BaseParentAct implements PartTimeShopInfoAdapter.OnItemViewListener {
    /**
     * 0:门店检查，1：盘点
     */
    private int type;
    Long branchID;
    String branchTitle;
    ListViewForScrollView partTimeStockListLv;

    ClearEditText clearEditText;
    Button storeNameQueryBtn;

    TextView partTimeShopInfoProductNum;
    TextView partTimeShopInfoLastCheckTime;
    TextView partTimeShopInfoItemShopSchedulelist;

    List<PartTimeShopInfoEntity> mPartTimeShopInfoEntitys;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.part_time_shop_info_activity);
        initTitle();
        initContent();
        getData();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    protected void initContent() {
        initView();
        mPartTimeShopInfoEntitys = new ArrayList<>();
    }

    private void initView() {
        branchID = getIntent().getLongExtra("branchID", 0);
        partTimeStockListLv = (ListViewForScrollView) findViewById(R.id.part_time_stock_list_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        partTimeStockListLv.setEmptyView(emptyView);

        clearEditText = (ClearEditText) findViewById(R.id.store_name_et);
        storeNameQueryBtn = (Button) findViewById(R.id.store_name_query_btn);
        storeNameQueryBtn.setVisibility(View.GONE);
        clearEditText.setVisibility(View.VISIBLE);
        clearEditText.setHint(R.string.part_time_search_hint_txt);
        clearEditText.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Bundle mBundle = new Bundle();
                mBundle.putLong("branchID", -branchID);
                mBundle.putString("branchTitle", branchTitle);
                RouterCommonUtil.startFunctionActivity(PartTimeShopInfoActivity.this, -9, branchID, mBundle);
            }
        });
        partTimeShopInfoProductNum = (TextView) findViewById(R.id.part_time_shop_info_product_num);
        partTimeShopInfoLastCheckTime = (TextView) findViewById(R.id.part_time_shop_info_last_check_time);
        partTimeShopInfoItemShopSchedulelist = (TextView) findViewById(R.id.part_time_shop_info_item_shop_schedulelist);

        type = ToFunctionByResId.getType(branchID);
        if (type == 1) {
            //显示临期货占比
            partTimeShopInfoProductNum.setVisibility(View.VISIBLE);
        } else {
            partTimeShopInfoProductNum.setVisibility(View.INVISIBLE);
        }
    }

    @Override
    public void onViewListener(PartTimeShopInfoEntity mPartTimeShopInfoEntity) {
        Intent intent = new Intent();
        intent.putExtra("shopId", mPartTimeShopInfoEntity.getStoreId());
//        intent.putExtra("shopId", "0310396");
        intent.putExtra("shopName", mPartTimeShopInfoEntity.getStoreName());
        intent.putExtra("address", mPartTimeShopInfoEntity.getAddress());
        intent.putExtra("distance", mPartTimeShopInfoEntity.getDistance());
        intent.putExtra("storeLongitudes", mPartTimeShopInfoEntity.getLng());
        intent.putExtra("storeLatitudes", mPartTimeShopInfoEntity.getLat());
        intent.putExtra("lastSales", mPartTimeShopInfoEntity.getLastMonthSaleCount());
        if (type == 1) {
            intent.setClass(this, PartTimeTakeStockLockActivity.class);
            startActivity(intent);
        } else if (type == 0) {
            intent.setClass(this, PartTimeTourShopCheckActivity.class);
            startActivity(intent);
        }
    }

    /**
     * GET /partTimeTourShop/getShopInfo 巡店门店搜索
     * final String keyWords, final String city,final String lng,final String lat, final String pageSize,
     */
    private void getData() {
        showDialog();
        String pageNo = ConstantParams.CONSTANT_PARAMS_1;
        String pageSize = ConstantParams.CONSTANT_PARAMS_20;
        String keyWords = clearEditText.getText().toString().trim();
        String city = LocationParams.city;
        String lat = LocationParams.Latitude;
        String lng = LocationParams.Longitude;
        String userName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
        if (type == 0) {
            PartTimeService.getInstance().requestGetShopInfo(NetworkParams.URL_GET_SHOP_INFO, userInfo.getStaffId(), keyWords, city, lng, lat, pageSize, pageNo, userName, this);
        } else {
            PartTimeService.getInstance().requestGetShopInfo(NetworkParams.URL_TAKE_STOCK_GET_SHOP_INFO, userInfo.getStaffId(), keyWords, city, lng, lat, pageSize, pageNo, userName, this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.PartTime.MSG_ON_GET_SHOP_INFO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeShopInfoListEntity mPartTimeShopInfoListEntity = new Gson().fromJson(msg, PartTimeShopInfoListEntity.class);
                        Log.d(TAG, "mPartTimeShopInfoListEntity=" + mPartTimeShopInfoListEntity.toString());
                        mPartTimeShopInfoEntitys.clear();
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mPartTimeShopInfoListEntity.retCode)) {
                            if (mPartTimeShopInfoListEntity.getResult() != null) {
                                if (!mPartTimeShopInfoListEntity.getResult().isEmpty()) {
                                    setData(mPartTimeShopInfoListEntity);
                                }
                            } else {
                                showMsg("没有搜索到相关数据！");
                            }
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    /**
     * 设置排班列表
     *
     * @param mPartTimeShopInfoListEntity 排班门店数据
     */
    private void setData(PartTimeShopInfoListEntity mPartTimeShopInfoListEntity) {
        //添加列表数据
        mPartTimeShopInfoEntitys = mPartTimeShopInfoListEntity.getResult();
        PartTimeShopInfoAdapter partTimeShopInfoAdapter = new PartTimeShopInfoAdapter(mPartTimeShopInfoEntitys, this, this);
        partTimeShopInfoAdapter.setType(type);
        partTimeStockListLv.setAdapter(partTimeShopInfoAdapter);
    }
}