package com.wgmf.yxgj.module.business.parttime.ui;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeShopInfoEntity;
import com.wgmf.yxgj.module.business.parttime.model.ShopScheduleListEntity;

import java.util.List;

/**
 * 兼职督察门店查询
 * 作者：xiep on 2018/3/14 16:28
 * 邮箱：2975837870@qq.com
 */

public class PartTimeShopInfoAdapter extends BaseAdapter {

    private int type;
    private Context context;
    private List<PartTimeShopInfoEntity> mPartTimeShopInfoEntitys;

    private OnItemViewListener listener;

    public interface OnItemViewListener {
        void onViewListener(PartTimeShopInfoEntity mPartTimeShopInfoEntity);
    }

    public int getType() {
        return type;
    }

    public void setType(int type) {
        this.type = type;
    }

    PartTimeShopInfoAdapter(List<PartTimeShopInfoEntity> mPartTimeShopInfoEntitys, Context context, OnItemViewListener listener) {
        this.context = context;
        this.mPartTimeShopInfoEntitys = mPartTimeShopInfoEntitys;
        this.listener = listener;
    }

    @Override
    public int getCount() {
        return mPartTimeShopInfoEntitys.isEmpty() ? 0 : mPartTimeShopInfoEntitys.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        View view;
        if (convertView == null) {
            view = View.inflate(context, R.layout.part_time_shop_info_item_view, null);
        } else {
            view = convertView;
        }
        TextView partTimeShopInfoItemStorename = (TextView) view.findViewById(R.id.part_time_shop_info_item_storename);
        TextView partTimeShopInfoItemSalecount = (TextView) view.findViewById(R.id.part_time_shop_info_item_salecount);

        TextView partTimeShopInfoProductNum = (TextView) view.findViewById(R.id.part_time_shop_info_product_num);
        TextView partTimeShopInfoLastCheckTime = (TextView) view.findViewById(R.id.part_time_shop_info_last_check_time);
        TextView partTimeShopInfoItemShopSchedulelist = (TextView) view.findViewById(R.id.part_time_shop_info_item_shop_schedulelist);

        partTimeShopInfoItemStorename.setText(mPartTimeShopInfoEntitys.get(position).getStoreName());
        partTimeShopInfoLastCheckTime.setText(mPartTimeShopInfoEntitys.get(position).getSubmitTime());
        String partTimeShopInfoItemShopLastMonthSaleCount;
        if (StringUtil.isNotNullAndNotEmpty(mPartTimeShopInfoEntitys.get(position).getLastMonthSaleCount())) {
            partTimeShopInfoItemShopLastMonthSaleCount = "上月销量:" + mPartTimeShopInfoEntitys.get(position).getLastMonthSaleCount() + "万";
            partTimeShopInfoItemSalecount.setText(partTimeShopInfoItemShopLastMonthSaleCount);
            partTimeShopInfoItemSalecount.setVisibility(View.VISIBLE);
        } else {
            partTimeShopInfoItemSalecount.setVisibility(View.GONE);
        }
        //排班
        String partTimeShopInfoItemShopSchedulelistString = "";
        if (null != mPartTimeShopInfoEntitys.get(position).getShopScheduleList() && !mPartTimeShopInfoEntitys.get(position).getShopScheduleList().isEmpty()) {
            List<ShopScheduleListEntity> mPartTimeShopInfoEntity = mPartTimeShopInfoEntitys.get(position).getShopScheduleList();
            for (int i = 0; i < mPartTimeShopInfoEntity.size(); i++) {
                if (TextUtils.isEmpty(mPartTimeShopInfoEntity.get(i).getHughFlag())) {
                    partTimeShopInfoItemShopSchedulelistString = "无";
                    break;
                }
                //循环截取排班时间
                partTimeShopInfoItemShopSchedulelistString += mPartTimeShopInfoEntity.get(i).getHughFlag();
                if (i < mPartTimeShopInfoEntity.size() - 1) {
                    partTimeShopInfoItemShopSchedulelistString = partTimeShopInfoItemShopSchedulelistString + "\n";
                }
            }
        } else {
            partTimeShopInfoItemShopSchedulelistString = "无";
        }
        partTimeShopInfoItemShopSchedulelist.setText(partTimeShopInfoItemShopSchedulelistString);
        //临期货数量
        if (type == 1) {
            if (!TextUtils.isEmpty(mPartTimeShopInfoEntitys.get(position).getAdventQty())) {
                double adventQty = StringUtil.toDouble(mPartTimeShopInfoEntitys.get(position).getAdventQty());
                if (adventQty <= 0.0) {
                    partTimeShopInfoProductNum.setTextColor(ContextCompat.getColor(context, R.color.important_txt_color));
                } else {
                    //如果临期货数大于零，标红
                    partTimeShopInfoProductNum.setTextColor(ContextCompat.getColor(context, R.color.red));
                }
                partTimeShopInfoProductNum.setVisibility(View.VISIBLE);
                partTimeShopInfoProductNum.setText(mPartTimeShopInfoEntitys.get(position).getAdventQty());
            }
        } else {
            partTimeShopInfoProductNum.setVisibility(View.INVISIBLE);
        }
        view.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onViewListener(mPartTimeShopInfoEntitys.get(position));
            }
        });
        return view;
    }
}