package com.wgmf.yxgj.module.business.parttime.ui;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.LocationUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.yxgj.base.BaseParentFra;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeShopScheduleListEntity;
import com.wgmf.yxgj.module.business.parttime.model.ShopScheduleListEntity;
import com.wgmf.yxgj.module.business.parttime.model.ShopScheduleVoListEntity;
import com.wgmf.yxgj.module.business.parttime.model.SignTimeBeanList;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;
import com.xp.arouter.RouterCommonUtil;

import java.util.List;

/**
 * 作者：xiep on 2018/3/19 09:11
 * 邮箱：2975837870@qq.com
 */

public class PartTimeShopScheduleFragment extends BaseParentFra implements View.OnClickListener, WeekTaskCalendar.OnDaySelectListener {
    String shopId;
    String shopName;
    String address;
    String distance;
    String lastSales;

    String lng;
    String lat;

    ListViewForScrollView partTimeScheduleInfoLv;
    ListViewForScrollView partTimeScheduleSignLv;
    LinearLayout  partTimeShopInfoSignLl;
    WeekTaskCalendar weekTaskCalendar;
    TextView partTimeScheduleInfoDateTv;
    MarqueeTextView partTimeShopInfoLastSales;

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initData();
        getData();
    }

    private void initData() {
        shopId = getArguments().getString("shopId");
        shopName = getArguments().getString("shopName");
        address = getArguments().getString("address");
        distance = getArguments().getString("distance");
        lng = getArguments().getString("storeLongitudes");
        lat = getArguments().getString("storeLatitudes");
        lastSales = getArguments().getString("lastSales");
    }

    /**
     * GET /shopSchedule/getFetureShopSchedule 获取门店近七天排班
     */
    private void getData() {
        showDialog();
        PartTimeService.getInstance().requestGetFetureShopSchedule(shopId, this);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.part_time_shop_schedule_fragment, container, false);
        LinearLayout partTimeShopInfoStoreLl = (LinearLayout) view.findViewById(R.id.part_time_shop_info_store_ll);
        MarqueeTextView partTimeShopInfoStoreName = (MarqueeTextView) view.findViewById(R.id.part_time_shop_info_store_name);
        MarqueeTextView partTimeShopInfoStoreAddress = (MarqueeTextView) view.findViewById(R.id.part_time_shop_info_store_address);
        MarqueeTextView partTimeShopInfoStoreDistance = (MarqueeTextView) view.findViewById(R.id.part_time_shop_info_store_distance);
        partTimeShopInfoLastSales = (MarqueeTextView) view.findViewById(R.id.part_time_shop_info_last_sales);
        partTimeScheduleInfoDateTv = (TextView) view.findViewById(R.id.part_time_schedule_info_date_tv);
        partTimeScheduleInfoLv = (ListViewForScrollView) view.findViewById(R.id.part_time_schedule_info_lv);
        weekTaskCalendar = (WeekTaskCalendar) view.findViewById(R.id.part_time_schedule_info_weektaskcalendar);
        partTimeShopInfoSignLl = (LinearLayout) view.findViewById(R.id.part_time_shop_info_sign_ll);
        partTimeScheduleSignLv = (ListViewForScrollView) view.findViewById(R.id.part_time_schedule_sign_info_lv);
        weekTaskCalendar.setOnDaySelectListener(this);
        partTimeShopInfoStoreLl.setOnClickListener(this);
        partTimeShopInfoStoreName.setText(shopName);
        partTimeShopInfoStoreAddress.setText(address);
        if (!StringUtil.isNullOrEmpty(distance)) {
            String text = "距您" + LocationUtil.setDistanceUint(StringUtil.toDouble(distance));
            partTimeShopInfoStoreDistance.setText(text);
        }
        setLastSalesText();
        return view;
    }

    private void setLastSalesText() {
        if (!StringUtil.isNullOrEmpty(lastSales)) {
            String text = "上月销量：" + lastSales + "万";
            partTimeShopInfoLastSales.setText(text);
            partTimeShopInfoLastSales.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.PartTime.MSG_ON_GET_FETURE_SHOP_SCHEDULE) {
                final String msg = result.getInfo();
                if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                    try {
                        //排班信息
                        PartTimeShopScheduleListEntity mPartTimeShopScheduleListEntity = new Gson().fromJson(msg, PartTimeShopScheduleListEntity.class);
                        Log.d(TAG, "mPartTimeShopScheduleListEntity=" + mPartTimeShopScheduleListEntity.toString());
                        if (null != mPartTimeShopScheduleListEntity.getResult()) {
                            //排班数据处理
                            List<ShopScheduleVoListEntity> shopScheduleVoListEntity = mPartTimeShopScheduleListEntity.getResult().getShopScheduleVoList();
                            if (null != shopScheduleVoListEntity && !shopScheduleVoListEntity.isEmpty()) {
                                weekTaskCalendar.setDaysHasThingList(shopScheduleVoListEntity);
                                weekTaskCalendar.setGvListData();
                                weekTaskCalendar.gridViewAdapter.initData();
                                weekTaskCalendar.gridViewAdapter.notifyDataSetChanged();
                            }
                            //打卡数据处理
                            List<SignTimeBeanList> signTimeBeanList = mPartTimeShopScheduleListEntity.getResult().getSignTimeBeanList();
                            if (null != signTimeBeanList && !signTimeBeanList.isEmpty()) {
                                PartTimeScheduleSignInfoAdapter partTimeScheduleSignAdapter = new PartTimeScheduleSignInfoAdapter(signTimeBeanList, getActivity());
                                partTimeScheduleSignLv.setAdapter(partTimeScheduleSignAdapter);
                                partTimeShopInfoSignLl.setVisibility(View.VISIBLE);
                            }
                            //上月销量
                            lastSales = mPartTimeShopScheduleListEntity.getResult().getLastMonthSaleCount();
                            setLastSalesText();
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    } catch (Exception e) {
                        showMsg("服务端排班数据解析规则变化，数据读取失败！");
                    }
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }

    private void toMapActivity() {
        String mainUrl = "http://m.amap.com/navi/?";
        mainUrl = mainUrl + "start=" + LocationParams.Longitude + "," + LocationParams.Latitude;
        mainUrl = mainUrl + "&dest=" + lng + "," + lat;
        mainUrl = mainUrl + "&destName=" + address;
        mainUrl = mainUrl + "&key=" + "9721b93d58c40c76b182cd3ed1196e96";
        Bundle mBundle = new Bundle();
        mBundle.putString("mainUrl", mainUrl);
        RouterCommonUtil.startFunctionActivity(getActivity(), 0, 0L, mBundle);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.part_time_shop_info_store_ll) {
            //进入地图导航
            toMapActivity();
        }
    }

    @Override
    public void onDaySelectListener(ShopScheduleVoListEntity shopScheduleVoListEntity) {
        if (null != shopScheduleVoListEntity) {
            String week = "周" + shopScheduleVoListEntity.getDecodeWeek(shopScheduleVoListEntity.getWeek())
                    + "\n" + shopScheduleVoListEntity.getSchedulingDay();
            partTimeScheduleInfoDateTv.setText(week);
            if (null != shopScheduleVoListEntity.getShopScheduleList() && !shopScheduleVoListEntity.getShopScheduleList().isEmpty()) {
                List<ShopScheduleListEntity> mShopScheduleLists = shopScheduleVoListEntity.getShopScheduleList();
                PartTimeScheduleInfoAdapter partTimeScheduleInfoAdapter = new PartTimeScheduleInfoAdapter(mShopScheduleLists, getActivity());
                partTimeScheduleInfoLv.setAdapter(partTimeScheduleInfoAdapter);
            }
        }
    }
}