package com.wgmf.yxgj.module.business.parttime.ui.takestock;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModelEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTakeStockDetailEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTakeStockImgList;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;
import com.wgmf.yxgj.module.business.parttime.ui.PartTimeShopInfoActivity;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

/**
 * 兼职督察盘点信息录入页
 * 作者：xiep on 2018/3/19 13:49
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class PartTimeTakeStockDetailActivity extends ReportWithPhotoBaseActivity implements ImagePickerLayout.ImagePicker {

    private Integer paperForm;

    private Integer paperCheck;

    private String takeStockId;

    private PartTimeTakeStockDetailAdapter mPartTimeTakeStockDetailAdapter;

    private EditText partTimeRemarkEdt;

    private TextView partTimeScheduleCheckNameEdt;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        queryData();
    }

    @Override
    protected void initData() {
        super.initData();
        //兼职盘点
        reportType = "PTPD";
        //兼职督察盘点默认使用200K
        PrefTool.setIntSave(PartTimeTakeStockDetailActivity.this, Prefs.PRE_IMAGE_SIZE, 200);
    }

    protected void setEmptyView() {
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        publicListViewLv.setEmptyView(emptyView);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText("专柜货品检查");
    }

    @Override
    protected void initContent() {
        super.initContent();
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        takeStockId = getIntent().getStringExtra("takeStockId");
    }

    /**
     * 设置列表头和尾布局
     */
    protected void setListHeadAndFootView() {
        View footView = getLayoutInflater().inflate(R.layout.parttime_report_footer_view, null);
        publicListViewLv.addFooterView(footView);
        View headView = getLayoutInflater().inflate(R.layout.part_time_take_stock_header_view, null);
        publicListViewLv.addHeaderView(headView);
    }

    @Override
    protected void parseFootData() {
        reportContentConfirmBtn = (Button) findViewById(R.id.part_report_content_comfirm_btn);
        publicTakePhotoRootLl = (LinearLayout) findViewById(R.id.public_take_photo_root_ll);
        publicTakePhotoLl = (LinearLayout) findViewById(R.id.public_take_photo_ll);
        publicTakePhotoRootLl.setVisibility(View.VISIBLE);
        publicTakePhotoLl.setVisibility(View.GONE);
        initPictureDisplayView();
        reportContentConfirmBtn.setText("提交");
        //3秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(reportContentConfirmBtn).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                setUploadData();
            }
        });
        LinearLayout parttimeReportTipLl = (LinearLayout) findViewById(R.id.parttime_report_tip_ll);
        parttimeReportTipLl.setVisibility(View.VISIBLE);
        partTimeRemarkEdt = (EditText) findViewById(R.id.part_time_remark_edt);
        partTimeScheduleCheckNameEdt = (TextView) findViewById(R.id.part_time_schedule_check_name_edt);
        String userName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
        partTimeScheduleCheckNameEdt.setText(userName);
        final RadioButton parttimeReportTipYes = (RadioButton) findViewById(R.id.parttime_report_tip_yes);
        final RadioButton parttimeReportTipNo = (RadioButton) findViewById(R.id.parttime_report_tip_no);
        final RadioButton parttimeReportTipYes2 = (RadioButton) findViewById(R.id.parttime_report_tip_yes2);
        final RadioButton parttimeReportTipNo2 = (RadioButton) findViewById(R.id.parttime_report_tip_no2);
        parttimeReportTipYes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //是否有纸质表格 0:没有 1:有 ,
                if (parttimeReportTipYes.isChecked()) {
                    paperForm = 1;
                } else {
                    paperForm = 0;
                }
                radioButtonShow(parttimeReportTipYes, parttimeReportTipNo, paperForm);
            }
        });
        parttimeReportTipNo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                //是否有纸质表格 0:没有 1:有 ,
                if (parttimeReportTipNo.isChecked()) {
                    paperForm = 0;
                } else {
                    paperForm = 1;
                }
                radioButtonShow(parttimeReportTipYes, parttimeReportTipNo, paperForm);
            }
        });
        parttimeReportTipYes2.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //是否有纸质表格 0:没有 1:有 ,
                if (parttimeReportTipYes2.isChecked()) {
                    paperCheck = 1;
                } else {
                    paperCheck = 0;
                }
                radioButtonShow(parttimeReportTipYes2, parttimeReportTipNo2, paperCheck);
            }
        });
        parttimeReportTipNo2.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                //是否有纸质表格 0:没有 1:有 ,
                if (parttimeReportTipNo2.isChecked()) {
                    paperCheck = 0;
                } else {
                    paperCheck = 1;
                }
                radioButtonShow(parttimeReportTipYes2, parttimeReportTipNo2, paperCheck);
            }
        });
        radioButtonShow(parttimeReportTipYes, parttimeReportTipNo, paperForm);
        radioButtonShow(parttimeReportTipYes2, parttimeReportTipNo2, paperCheck);
    }

    private void radioButtonShow(RadioButton rybtn, RadioButton rnbtn, Integer falg) {
        if (falg != null && falg == 1) {
            rybtn.setChecked(true);
            rybtn.setButtonDrawable(R.drawable.square_orange);
            rnbtn.setButtonDrawable(R.drawable.square_gray);
        } else if (falg != null && falg == 0) {
            rnbtn.setChecked(true);
            rybtn.setButtonDrawable(R.drawable.square_gray);
            rnbtn.setButtonDrawable(R.drawable.square_orange);
        }
    }

    private void initPictureDisplayView() {
        idImagePickerContainer = (ImagePickerLayout) findViewById(R.id.id_image_picker_container);
        idImagePickerContainer.setVisibility(View.VISIBLE);
        idImagePickerContainer.setTitle("上传与货品检查相关的图片【选填】");
        idImagePickerContainer.setTip("(最多可上传15张图片)");
        idImagePickerContainer.setImagePicker(this);
        idImagePickerContainer.setSizePhotoNum(3);
        idImagePickerContainer.setMaxPhotoNum(15);
        idImagePickerContainer.setmImageselectList(mImageselectList);
        idImagePickerContainer.setImagePickerView(idImagePickerContainer);
        idImagePickerContainer.setOlnyViewMode(false);
    }

    protected void queryData() {
        List<PartTimeAdventModelEntity> partTimeAdventModelEntitys = (List<PartTimeAdventModelEntity>) getIntent().getSerializableExtra("partTimeAdventModelEntitys");
        mPartTimeTakeStockDetailAdapter = new PartTimeTakeStockDetailAdapter(this, partTimeAdventModelEntitys);
        publicListViewLv.setAdapter(mPartTimeTakeStockDetailAdapter);
    }

    @Override
    protected void setUploadData() {
        List<PartTimeAdventModelEntity> partTimeTourShopDetail = mPartTimeTakeStockDetailAdapter.getPartTimeAdventModelEntity();
        if (null != partTimeTourShopDetail && !partTimeTourShopDetail.isEmpty()) {
            for (PartTimeAdventModelEntity mPartTimeTourShopDetail : partTimeTourShopDetail) {
                if (TextUtils.isEmpty(mPartTimeTourShopDetail.getStockCount())) {
                    ToastUtil.show(this, "还有盘点数据未盘点！");
                    dismissDialog();
                    return;
                }
            }
        }
        if (null == paperForm) {
            ToastUtil.show(this, "请选择门店是否有纸质盘点报表！");
            dismissDialog();
            return;
        }
        if (null == paperCheck) {
            ToastUtil.show(this, "请选择兼职是否检查门店货品！");
            dismissDialog();
            return;
        }
        super.setUploadData();
    }

    /**
     * 上传巡店辅导数据
     */
    @Override
    protected void uploadData() {
        super.uploadData();
        showDialog();
        PartTimeTakeStockDetailEntity partTimeTakeStockDetailEntity = new PartTimeTakeStockDetailEntity();
        partTimeTakeStockDetailEntity.setPartTimeStaffName(partTimeScheduleCheckNameEdt.getText().toString());
        partTimeTakeStockDetailEntity.setPartTimeRemark(partTimeRemarkEdt.getText().toString());
        partTimeTakeStockDetailEntity.setPaperForm(paperForm);
        partTimeTakeStockDetailEntity.setIsCheckGoods(paperCheck);
        partTimeTakeStockDetailEntity.setTakeStockId(takeStockId);
        //图片成功或失败信息
        partTimeTakeStockDetailEntity.setImgStatus(imgStatus);
        List<PartTimeAdventModelEntity> partTimeTourShopDetail = mPartTimeTakeStockDetailAdapter.getPartTimeAdventModelEntity();
        partTimeTakeStockDetailEntity.setPartTimeTakeStockDetailList(partTimeTourShopDetail);
        //设置图片
        if (mImageselectList != null && !mImageselectList.isEmpty()) {
            List<PartTimeTakeStockImgList> partTimeTourShopImgLists = new ArrayList<>();
            for (int i = 0; i < urlLists.size(); i++) {
                PartTimeTakeStockImgList partTimeTakeStockImgList = new PartTimeTakeStockImgList();
                partTimeTakeStockImgList.setImgUrl(urlLists.get(i));
                partTimeTakeStockImgList.setTakeStockId(takeStockId);
                partTimeTourShopImgLists.add(partTimeTakeStockImgList);
            }
            partTimeTakeStockDetailEntity.setPartTimeTakeStockImgList(partTimeTourShopImgLists);
        }
        String content = new Gson().toJson(partTimeTakeStockDetailEntity);
        Log.d(TAG, content);
        PartTimeService.getInstance().requestBatchSavePartTimeTakeStockDetail(content, PartTimeTakeStockDetailActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.PartTime.MSG_ON_BATCH_SAVE_PARTTIME_TAKESTOCK_DETAIL) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                    Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                        dismissDialog();
                        if (imgStatus.contains("失败")) {
                            showTipDialog("提示", mBaseResponse.retInfo + ",图片上传" + imgStatus);
                            return;
                        }
                        ToastUtil.show(this, mBaseResponse.retInfo);
                        //盘点成功，退出到门店列表页
                        Intent logoutIntent = new Intent(PartTimeTakeStockDetailActivity.this, PartTimeShopInfoActivity.class);
                        logoutIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                        startActivity(logoutIntent);
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                } else {
                    ToastUtil.show(this, result.getResultInfo());
                }
                dismissDialog();
            }
        }
    }

    protected void showTipDialog(String title, final String msg) {
        if (!PrefTool.getBooleanPreferences(PartTimeTakeStockDetailActivity.this, Prefs.PRE_DIALOG_SHOWING, false)) {
            PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
            builder.setMessage(msg + "\n点击重报将尝试减小图片质量重新上报，点击确定完成本次上报。");
            builder.setTitle(title);
            builder.setPositiveButton("重报",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            //图片上传不成功，减小大小使用100k
                            PrefTool.setIntSave(PartTimeTakeStockDetailActivity.this, Prefs.PRE_IMAGE_SIZE, 100);
                            PrefTool.setBooleanSave(PartTimeTakeStockDetailActivity.this, Prefs.PRE_DIALOG_SHOWING, false);
                        }
                    });
            builder.setNegativeButton("确定",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            //图片默认大小使用200k
                            PrefTool.setIntSave(PartTimeTakeStockDetailActivity.this, Prefs.PRE_IMAGE_SIZE, 200);
                            PrefTool.setBooleanSave(PartTimeTakeStockDetailActivity.this, Prefs.PRE_DIALOG_SHOWING, false);
                            //盘点成功，退出到门店列表页
                            Intent logoutIntent = new Intent(PartTimeTakeStockDetailActivity.this, PartTimeShopInfoActivity.class);
                            logoutIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                            startActivity(logoutIntent);
                        }
                    });
            if (null != this) {
                builder.create().show();
                PrefTool.setBooleanSave(this, Prefs.PRE_DIALOG_SHOWING, true);
                //设置对话框样式
                builder.setTitleView(Gravity.CENTER, ContextCompat.getColor(this, R.color.important_txt_color));
                builder.setMessageView(Gravity.CENTER, ContextCompat.getColor(this, R.color.important_txt_color));
                builder.setDialogConfirmBtnView(ContextCompat.getColor(this, R.color.normal_color), ContextCompat.getColor(this, R.color.white));
            }
        }
    }

    @Override
    public void setSelectDialog(int selectType,View view) {
        idImagePickerContainer = (ImagePickerLayout) view;
        setSelectDialogListeners(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //拍照处理
                takePhoto(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //相片处理
                getPictrue(idImagePickerContainer);
                hideSelectDialog();
            }
        }, new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                hideSelectDialog();
            }
        });
        showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }
}