package com.wgmf.yxgj.module.business.parttime.ui.takestock;

import android.app.Activity;
import android.content.Context;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModelEntity;
import com.wgmf.yxgj.widgets.EditText.LimitEditText;

import java.util.List;

/**
 * 作者：xiep on 2018/3/19 14:24
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class PartTimeTakeStockDetailAdapter extends BaseAdapter {
    private Context context;
    private List<PartTimeAdventModelEntity> list;

    PartTimeTakeStockDetailAdapter(Context context, List<PartTimeAdventModelEntity> list) {
        this.context = context;
        this.list = list;
    }

    /**
     * 巡店上报实体
     */
    List<PartTimeAdventModelEntity> getPartTimeAdventModelEntity() {
        return list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView takeStockItemProductName;
        TextView takeStockItemProductTag;
        /**
         * 锁定库存数
         */
        TextView takeStockItemLastNum;
        /**
         * 盘点库存数
         */
        LimitEditText takeStockItemProductNum;
        /**
         * 兼职自己填的临期货数
         */
        LimitEditText takeStockAdventQty;
        /**
         * 临期货数备注
         */
        EditText takeStockAdventQtyRemark;
        /**
         * 过期货数
         */
        LimitEditText takeStockOverTimeNum;
        /**
         * 过期货数备注
         */
        EditText takeStockOverTimeNumRemark;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final PartTimeAdventModelEntity data = list.get(position);
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.part_time_take_stock_detail_list_item, null);
            holder.takeStockItemProductName = (TextView) convertView.findViewById(R.id.take_stock_item_product_name);
            holder.takeStockItemProductTag = (TextView) convertView.findViewById(R.id.take_stock_item_product_tag);
            holder.takeStockItemProductNum = (LimitEditText) convertView.findViewById(R.id.take_stock_item_product_num);
            holder.takeStockItemLastNum = (TextView) convertView.findViewById(R.id.take_stock_item_last_num);
            holder.takeStockAdventQtyRemark = (EditText) convertView.findViewById(R.id.part_time_take_stock_date_remark);
            holder.takeStockAdventQty= (LimitEditText) convertView.findViewById(R.id.part_time_take_stock_dates_num);
            holder.takeStockOverTimeNum = (LimitEditText) convertView.findViewById(R.id.part_time_take_stock_dates_over);
            holder.takeStockOverTimeNumRemark = (EditText) convertView.findViewById(R.id.part_time_take_stock_date_over_remark);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        holder.takeStockItemProductNum.setTag(data);
        holder.takeStockAdventQty.setTag(data);
        holder.takeStockAdventQtyRemark.setTag(data);
        holder.takeStockOverTimeNum.setTag(data);
        holder.takeStockOverTimeNumRemark.setTag(data);

        View currentFocus = ((Activity) context).getCurrentFocus();
        if (currentFocus != null) {
            currentFocus.clearFocus();
        }
        holder.takeStockItemProductNum.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (!TextUtils.isEmpty(s)) {
                    PartTimeAdventModelEntity info = (PartTimeAdventModelEntity) holder.takeStockItemProductNum.getTag();
                    info.setStockCount(s.toString());
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        holder.takeStockAdventQty.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (!TextUtils.isEmpty(s)) {
                    PartTimeAdventModelEntity info = (PartTimeAdventModelEntity) holder.takeStockAdventQty.getTag();
                    info.setPartTimeAdventQty(s.toString());
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        holder.takeStockAdventQtyRemark.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (!TextUtils.isEmpty(s)) {
                    PartTimeAdventModelEntity info = (PartTimeAdventModelEntity) holder.takeStockAdventQtyRemark.getTag();
                    info.setRemark(s.toString());
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        holder.takeStockOverTimeNum.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (!TextUtils.isEmpty(s)) {
                    PartTimeAdventModelEntity info = (PartTimeAdventModelEntity) holder.takeStockOverTimeNum.getTag();
                    info.setOverTimeNumber(s.toString());
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        holder.takeStockOverTimeNumRemark.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if (!TextUtils.isEmpty(s)) {
                    PartTimeAdventModelEntity info = (PartTimeAdventModelEntity) holder.takeStockOverTimeNumRemark.getTag();
                    info.setOverTimeRemark(s.toString());
                }
            }

            @Override
            public void afterTextChanged(Editable s) {

            }
        });
        //标题
        holder.takeStockItemProductName.setText(data.getProductName());
        //检查状态
        if ("1".equals(data.getStatus())) {
            holder.takeStockItemProductTag.setVisibility(View.VISIBLE);
        } else {
            holder.takeStockItemProductTag.setVisibility(View.GONE);
        }
        //（上月库存：30；锁定库存：30）
        String text = "（锁定库存：" + data.getStockQty() + "；提示临期货：" + data.getAdventQty() + "）";
        holder.takeStockItemLastNum.setText(text);
        //兼职督察填写盘点数
        holder.takeStockItemProductNum.setText(data.getStockCount());
        //兼职督察填写临期货数
        holder.takeStockAdventQty.setText(data.getPartTimeAdventQty());
        //临期货数备注
        holder.takeStockAdventQtyRemark.setText(data.getRemark());
        //过期货数
        holder.takeStockOverTimeNum.setText(data.getOverTimeNumber());
        //过期货数备注
        holder.takeStockOverTimeNumRemark.setText(data.getOverTimeRemark());
        return convertView;
    }
}