package com.wgmf.yxgj.module.business.parttime.ui.takestock;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.ListView;

import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModeResultlEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModelEntity;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;

import java.io.Serializable;
import java.util.List;

/**
 * 兼职督察盘点信息录入选择页
 * 作者：xiep on 2018/3/19 13:49
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
public class PartTimeTakeStockListActivity extends BaseParentAct {
    String shopId;
    String shopName;
    String takeStockId;

    List<PartTimeAdventModelEntity> mPartTimeAdventModelEntity;
    PartTimeTakeStockListAdapter mPartTimeTourShopReportAdapter;
    ListView partTimeStockListLv;
    Button partTimeTakeStockBtn;
    CheckBox partTimeTakeStockCb;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.part_time_take_stock_list_activity);
        initData();
        initTitle();
        initContent();
    }

    @Override
    protected void onResume() {
        super.onResume();
        queryData();
        partTimeTakeStockCb.setChecked(false);
    }

    private void initData() {
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        takeStockId = getIntent().getStringExtra("takeStockId");
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText("专柜货品检查");
    }

    protected void initContent() {
        partTimeStockListLv = (ListView) findViewById(R.id.part_time_stock_list_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        partTimeStockListLv.setEmptyView(emptyView);
        partTimeTakeStockCb = (CheckBox) findViewById(R.id.part_time_take_stock_cb);
        partTimeTakeStockCb.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                for (PartTimeAdventModelEntity partTimeAdventModelEntity : mPartTimeAdventModelEntity) {
                    partTimeAdventModelEntity.setChoice(isChecked);
                }
                setData(mPartTimeAdventModelEntity);
            }
        });
        partTimeTakeStockBtn = (Button) findViewById(R.id.part_time_take_stock_btn);
        partTimeTakeStockBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //将选中的数据存入数据库
                List<PartTimeAdventModelEntity> partTimeAdventModelEntitys = mPartTimeTourShopReportAdapter.getData();
                if (null != partTimeAdventModelEntitys && !partTimeAdventModelEntitys.isEmpty()) {
                    Intent intent = new Intent();
                    intent.setClass(PartTimeTakeStockListActivity.this, PartTimeTakeStockDetailActivity.class);
                    intent.putExtra("shopId", shopId);
                    intent.putExtra("shopName", shopName);
                    intent.putExtra("takeStockId", takeStockId);
                    intent.putExtra("partTimeAdventModelEntitys", (Serializable) partTimeAdventModelEntitys);
                    startActivity(intent);
                } else {
                    showMsg("请选择盘点产品！");
                }
            }
        });
    }

    protected void queryData() {
        showDialog();
        PartTimeService.getInstance().requestGetPartTimeTakeStockDetail(takeStockId, PartTimeTakeStockListActivity.this);
    }

    private void setData(List<PartTimeAdventModelEntity> mPartTimeAdventModelEntity) {
        partTimeTakeStockBtn.setVisibility(View.VISIBLE);
        mPartTimeTourShopReportAdapter = new PartTimeTakeStockListAdapter(this, mPartTimeAdventModelEntity);
        partTimeStockListLv.setAdapter(mPartTimeTourShopReportAdapter);
        partTimeStockListLv.setOnItemClickListener(null);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.PartTime.MSG_ON_GET_PARTTIME_TAKESTOCK_DETAIL) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    PartTimeAdventModeResultlEntity mPartTimeAdventModelListEntity = new Gson().fromJson(msg, PartTimeAdventModeResultlEntity.class);
                    Log.d(TAG, "mPartTimeResultRespose=" + mPartTimeAdventModelListEntity.toString());
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mPartTimeAdventModelListEntity.retCode)) {
                        if (null != mPartTimeAdventModelListEntity.getResult()) {
                            if (null != mPartTimeAdventModelListEntity.getResult() && !mPartTimeAdventModelListEntity.getResult().isEmpty()) {
                                mPartTimeAdventModelEntity = mPartTimeAdventModelListEntity.getResult();
                                setData(mPartTimeAdventModelEntity);
                            }
                        }
                    }
                    showMsg(mPartTimeAdventModelListEntity.retInfo);
                } else {
                    showMsg(result.getResultInfo());
                }
            }
        }
    }
}