package com.wgmf.yxgj.module.business.parttime.ui.takestock;

import android.content.Context;
import android.support.v4.content.ContextCompat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModelEntity;

import java.util.ArrayList;
import java.util.List;

/**
 * 作者：xiep on 2018/3/19 14:24
 * 邮箱：2975837870@qq.com
 */

public class PartTimeTakeStockListAdapter extends BaseAdapter {
    private Context context;
    private List<PartTimeAdventModelEntity> list;

    PartTimeTakeStockListAdapter(Context context, List<PartTimeAdventModelEntity> list) {
        this.context = context;
        this.list = list;
    }

    /**
     * @return 返回选中数据
     */
    public List<PartTimeAdventModelEntity> getData() {
        List<PartTimeAdventModelEntity> partTimeAdventModelEntitys = new ArrayList<>();
        for (PartTimeAdventModelEntity partTimeAdventModelEntity : list) {
            if (partTimeAdventModelEntity.isChoice()) {
                partTimeAdventModelEntitys.add(partTimeAdventModelEntity);
            }
        }
        return partTimeAdventModelEntitys;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }


    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView takeStockProductName;
        TextView takeStockProductTag;
        TextView takeStockProductNum;
        TextView takeStockProductCb;
        ImageView takeStockItemProductCheckState;
    }

    @SuppressWarnings("all")
    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.part_time_take_stock_list_item, null);
            holder.takeStockProductCb = (TextView) convertView.findViewById(R.id.take_stock_product_cb);
            holder.takeStockProductName = (TextView) convertView.findViewById(R.id.take_stock_product_name);
            holder.takeStockProductTag = (TextView) convertView.findViewById(R.id.take_stock_product_tag);
            holder.takeStockProductNum = (TextView) convertView.findViewById(R.id.take_stock_product_num);
            holder.takeStockItemProductCheckState = (ImageView) convertView.findViewById(R.id.take_stock_item_product_check_state);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final PartTimeAdventModelEntity data = list.get(position);
        //标题
        holder.takeStockProductName.setText(data.getProductName());
        //锁定库存
        holder.takeStockProductTag.setText(data.getStockQty());
        //临期货数量
        holder.takeStockProductNum.setText(data.getAdventQty());

        if ("1".equals(data.getStatus())) {
            //已检查
            holder.takeStockItemProductCheckState.setImageDrawable(ContextCompat.getDrawable(context, R.drawable.check_select_state));
            holder.takeStockItemProductCheckState.setVisibility(View.VISIBLE);
        } else {
            holder.takeStockItemProductCheckState.setVisibility(View.INVISIBLE);
        }

        convertView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                list.get(position).setChoice(!list.get(position).isChoice());
                checkView(position, holder);
            }
        });
        checkView(position, holder);
        return convertView;
    }

    private void checkView(int position, ViewHolder holder) {
        if (list.get(position).isChoice()) {
            holder.takeStockProductCb.setBackgroundResource(R.drawable.square_orange);
        } else {
            holder.takeStockProductCb.setBackgroundResource(R.drawable.square_gray);
        }
    }
}