package com.wgmf.yxgj.module.business.parttime.ui.takestock;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModelEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeAdventModelListEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeResultEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeResultIdEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeResultRespose;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;
import com.wgmf.yxgj.module.business.parttime.ui.PartTimeShopScheduleFragment;
import com.wgmf.yxgj.pop.WarningPop;
import com.xp.arouter.RouterParams;

import java.util.List;

/**
 * 库存盘点锁定
 * 作者：xiep on 2018/3/19 09:09
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_PARTTIME_TAKESTOCK_LOCK_ACTIVITY)
public class PartTimeTakeStockLockActivity extends BaseParentAct implements View.OnClickListener, WarningPop.WarningPopListener {

    String shopId;
    String shopName;
    String staffId;
    String userName;
    /**
     * 库存盘点锁定ID
     */
    String takeStockId;

    ListView partTimeStockListLv;

    Button partTimeLockStockBtn;
    Button partTimeUnlockStockBtn;
    Button partTimeInputStockBtn;
    TextView partTimeInputStockTipsTv;

    TextView partTimeTakeStockStatusTv;
    TextView paperColumnNameTv;
    TextView actualColumnNameTv;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.part_time_take_stock_lock_activity);
        userName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
        initTitle();
        initData();
        initContent();
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText("盘点信息录入");
    }

    private void initContent() {
        partTimeStockListLv = (ListView) findViewById(R.id.part_time_stock_list_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        partTimeStockListLv.setEmptyView(emptyView);
        //加载排班信息
        if (findViewById(R.id.part_time_shop_info_frg) != null) {
            PartTimeShopScheduleFragment partTimeShopScheduleFragment = new PartTimeShopScheduleFragment();
            Bundle partTimeShopScheduleBundle = new Bundle();
            partTimeShopScheduleBundle.putString("shopId", shopId);
            partTimeShopScheduleBundle.putString("shopName", shopName);
            partTimeShopScheduleBundle.putString("address", getIntent().getStringExtra("address"));
            partTimeShopScheduleBundle.putString("distance", getIntent().getStringExtra("distance"));
            partTimeShopScheduleBundle.putString("storeLongitudes", getIntent().getStringExtra("storeLongitudes"));
            partTimeShopScheduleBundle.putString("storeLatitudes", getIntent().getStringExtra("storeLatitudes"));
            partTimeShopScheduleBundle.putString("lastSales", getIntent().getStringExtra("lastSales"));
            partTimeShopScheduleFragment.setArguments(partTimeShopScheduleBundle);
            getSupportFragmentManager().beginTransaction().add(R.id.part_time_shop_info_frg, partTimeShopScheduleFragment).commit();
        }
        partTimeLockStockBtn = (Button) findViewById(R.id.part_time_lock_stock_btn);
        partTimeUnlockStockBtn = (Button) findViewById(R.id.part_time_unlock_stock_btn);
        partTimeInputStockBtn = (Button) findViewById(R.id.part_time_input_stock_btn);
        partTimeInputStockTipsTv = (TextView) findViewById(R.id.part_time_input_stock_tips_tv);
        partTimeLockStockBtn.setOnClickListener(this);
        partTimeUnlockStockBtn.setOnClickListener(this);
        partTimeInputStockBtn.setOnClickListener(this);
        partTimeTakeStockStatusTv = (TextView) findViewById(R.id.part_time_take_stock_status_tv);
        paperColumnNameTv = (TextView) findViewById(R.id.paper_column_name_tv);
        actualColumnNameTv = (TextView) findViewById(R.id.actual_column_name_tv);

        partTimeTakeStockStatusTv.setText("盘点单：未知");
    }

    private void initData() {
        shopName = getIntent().getStringExtra("shopName");
        shopId = getIntent().getStringExtra("shopId");
        staffId = userInfo.getStaffId();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getTakeStockByShopId();//获取门店盘点信息
    }

    /**
     * GET /partTimeTakeStock/getTakeStockByShopId 获取门店盘点信息
     */
    public void getTakeStockByShopId() {
        showDialog();
        //获取门店盘点信息
        PartTimeService.getInstance().requestGetTakeStockByShopId(shopId, userName, this);
    }

    private void getPartTimeTakeStock() {
        showDialog();
        //当天是否锁定库存盘点
        PartTimeService.getInstance().requestGetPartTimeTakeStock(shopId, staffId, userName, this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                //查询门店库存
                case BusinessID.PartTime.MSG_ON_GET_TAKESTOCK_BY_SHOPID: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed() && ConstantParams.CONSTANT_PARAMS_0.equals(result.getResultCode())) {
                        PartTimeAdventModelListEntity mPartTimeAdventModelListEntity = new Gson().fromJson(msg, PartTimeAdventModelListEntity.class);
                        Log.d(TAG, "mPartTimeAdventModelListEntity=" + mPartTimeAdventModelListEntity.toString());
                        if (null != mPartTimeAdventModelListEntity.getResult()) {
                            if (null != mPartTimeAdventModelListEntity.getResult().getStatusStr())
                                partTimeTakeStockStatusTv.setText("盘点单：" + mPartTimeAdventModelListEntity.getResult().getStatusStr());
                            paperColumnNameTv.setText(mPartTimeAdventModelListEntity.getResult().getPaperColumnName());
                            actualColumnNameTv.setText(mPartTimeAdventModelListEntity.getResult().getActualColumnName());
                            List<PartTimeAdventModelEntity> mPartTimeAdventModelEntitys = mPartTimeAdventModelListEntity.getResult().getAdventModelList();
                            if (null != mPartTimeAdventModelEntitys && !mPartTimeAdventModelEntitys.isEmpty()) {
                                PartTimeTakeStockLockAdapter partTimeTakeStockLockAdapter = new PartTimeTakeStockLockAdapter(mPartTimeAdventModelEntitys, this);
                                partTimeStockListLv.setAdapter(partTimeTakeStockLockAdapter);
                                //当天是否锁定库存盘点
                                getPartTimeTakeStock();
                            }
                        }
                    }
                }
                break;
                case BusinessID.PartTime.MSG_ON_GET_PARTTIME_TAKESTOCK: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeResultRespose mBaseResponse = new Gson().fromJson(msg, PartTimeResultRespose.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_1.equals(mBaseResponse.msgCode)) {
                            //没有锁定库存,则显示锁定库存按钮
                            partTimeInputStockTipsTv.setVisibility(View.VISIBLE);
                            partTimeLockStockBtn.setVisibility(View.VISIBLE);
                            partTimeUnlockStockBtn.setVisibility(View.GONE);
                            partTimeInputStockBtn.setVisibility(View.GONE);
                        } else {
                            //已锁定库存，则可进行解锁库存和库存录入工作
                            takeStockId = mBaseResponse.getResult().getTakeStockId();
                            partTimeInputStockTipsTv.setVisibility(View.INVISIBLE);
                            partTimeLockStockBtn.setVisibility(View.GONE);
                            partTimeUnlockStockBtn.setVisibility(View.VISIBLE);
                            partTimeInputStockBtn.setVisibility(View.VISIBLE);
                        }
                        showMsg(result.getResultInfo());
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.PartTime.MSG_ON_SAVE_PARTTIME_TAKESTOCK: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeResultIdEntity mBaseResponse = new Gson().fromJson(msg, PartTimeResultIdEntity.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_1.equals(mBaseResponse.msgCode)) {
                            //没有锁定库存,则显示锁定库存按钮
                            partTimeInputStockTipsTv.setVisibility(View.VISIBLE);
                            partTimeLockStockBtn.setVisibility(View.VISIBLE);
                            partTimeUnlockStockBtn.setVisibility(View.GONE);
                            partTimeInputStockBtn.setVisibility(View.GONE);
                        } else {
                            //已锁定库存，则可进行解锁库存和库存录入工作
                            takeStockId = mBaseResponse.getResult();
                            partTimeInputStockTipsTv.setVisibility(View.INVISIBLE);
                            partTimeLockStockBtn.setVisibility(View.GONE);
                            partTimeUnlockStockBtn.setVisibility(View.VISIBLE);
                            partTimeInputStockBtn.setVisibility(View.VISIBLE);
                        }
                        showMsg(result.getResultInfo());
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.PartTime.MSG_ON_REMOVE_PARTTIME_TAKESTOCK: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            //没有锁定库存,则显示锁定库存按钮
                            partTimeInputStockTipsTv.setVisibility(View.VISIBLE);
                            partTimeLockStockBtn.setVisibility(View.VISIBLE);
                            partTimeUnlockStockBtn.setVisibility(View.GONE);
                            partTimeInputStockBtn.setVisibility(View.GONE);
                        } else {
                            //已锁定库存，则可进行解锁库存和库存录入工作
                            takeStockId = null;
                            partTimeInputStockTipsTv.setVisibility(View.INVISIBLE);
                            partTimeLockStockBtn.setVisibility(View.GONE);
                            partTimeUnlockStockBtn.setVisibility(View.VISIBLE);
                            partTimeInputStockBtn.setVisibility(View.VISIBLE);
                        }
                        showMsg(result.getResultInfo());
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    private void toNextActivity() {
        Intent intent = new Intent();
        intent.setClass(this, PartTimeTakeStockListActivity.class);
        intent.putExtra("shopId", shopId);
        intent.putExtra("shopName", shopName);
        intent.putExtra("takeStockId", takeStockId);
        startActivity(intent);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.part_time_lock_stock_btn) {
            type = 0;
            showWarningPopWindow(type);
        } else if (v.getId() == R.id.part_time_unlock_stock_btn) {
            type = 1;
            showWarningPopWindow(type);
        } else if (v.getId() == R.id.part_time_input_stock_btn) {
            //盘点录入
            toNextActivity();
        }
    }

    /**
     * 弹出跳转选项窗
     */
    private void showWarningPopWindow(int type) {
        WarningPop warningPop = new WarningPop(this, this);
        if (type == 0) {
            warningPop.setTitle("确定锁定库存");
            warningPop.setTips("锁定库存后，需马上开始盘点");
        } else {
            warningPop.setTitle("确定解锁库存");
            warningPop.setTips("解锁库存后，之前锁定的系统库存将会清空，请谨慎使用该功能！");
        }
        if (!warningPop.isShowing()) {
            warningPop.show(this.findViewById(R.id.title));
        }
    }

    int type;

    @Override
    public void warningConfirm() {
        if (type == 0) {
            //锁定库存
            showDialog();
            PartTimeResultEntity partTimeTourShopEntity = new PartTimeResultEntity();
            partTimeTourShopEntity.setPartTimeStaffId(userInfo.getStaffId());
            partTimeTourShopEntity.setPartTimeStaffName(userName);
            partTimeTourShopEntity.setShopId(shopId);
            partTimeTourShopEntity.setShopName(shopName);
            partTimeTourShopEntity.setTakeStockId(takeStockId);

            String content = new Gson().toJson(partTimeTourShopEntity);
            Log.d(TAG, "PartTimeResultEntity: " + content);
            PartTimeService.getInstance().requestSavePartTimeTakeStock(content, this);
        } else {
            //解除锁定
            showDialog();
            PartTimeService.getInstance().requestRemovePartTimeTakeStock(shopId, staffId, userName, this);
        }
    }

    @Override
    public void warningCancel() {

    }
}