package com.wgmf.yxgj.module.business.parttime.ui.tourshop;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicPartTimeTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.parttime.R;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeResultEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeResultIdEntity;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeShopTourResultRespose;
import com.wgmf.yxgj.module.business.parttime.model.PartTimeTourShopModelEntity;
import com.wgmf.yxgj.module.business.parttime.service.PartTimeService;
import com.wgmf.yxgj.module.business.parttime.ui.PartTimeShopScheduleFragment;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterParams;

import java.util.Date;
import java.util.List;

/**
 * 作者：xiep on 2018/3/14 17:07
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_PARTTIME_TOURSHOP_CHECK_ACTIVITY)
public class PartTimeTourShopCheckActivity extends BaseParentAct implements View.OnClickListener, DialogHelper.DialogResult {
    private static final int PART_TIME_SCHEDULE_CHECK_ITEM_0 = 0;
    private static final int PART_TIME_SCHEDULE_CHECK_ITEM_1 = 1;
    private static final int PART_TIME_SCHEDULE_CHECK_ITEM_2 = 2;
    private static final int PART_TIME_SCHEDULE_CHECK_ITEM_3 = 3;
    /**
     * 已提交类型列表
     */
    List<PartTimeTourShopModelEntity> mPartTimeTourShopDetailEntitys;
    /**
     * 是否在岗:0,不在岗；1，在岗
     */
    int onTheJob;
    /**
     * 巡检id
     */
    String tourId;
    /**
     * 检查日期
     */
    String checkDate;
    String shopId;
    String shopName;

    EditText partTimeScheduleCheckRemarkTv;
    TextView partTimeScheduleCheckNameTv;
    TextView partTimeScheduleCheckDateTv;
    TextView partTimeScheduleCheckTimeEndTv;
    TextView partTimeScheduleCheckTimeStartTv;
    LinearLayout partTimeComfirmBtnLl;
    LinearLayout partTimeProjectListInfoLl;
    LinearLayout partTimeScheduleCheckRemarkLl;

    LinearLayout partTimeScheduleCheckItem1Ll;
    LinearLayout partTimeScheduleCheckItem2Ll;
    LinearLayout partTimeScheduleCheckItem3Ll;
    LinearLayout partTimeScheduleCheckItem4Ll;

    TextView partTimeScheduleCheckItem1Tv;
    TextView partTimeScheduleCheckItem2Tv;
    TextView partTimeScheduleCheckItem3Tv;
    TextView partTimeScheduleCheckItem4Tv;

    RadioButton partTimeScheduleCheckOnthejobYesRb;
    RadioButton partTimeScheduleCheckOnthejobNoRb;
    Button partTimeComfirmBtn;
    Button partTimeDeleteBtn;
    Button partTimeConfirmSubmitBtn;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.part_time_tour_shop_check_activity);
        initTitle();
        initData();
        initContent();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getData(checkDate);
    }

    private void initContent() {
        //加载排班信息
        if (findViewById(R.id.part_time_shop_info_frg) != null) {
            PartTimeShopScheduleFragment partTimeShopScheduleFragment = new PartTimeShopScheduleFragment();
            Bundle partTimeShopScheduleBundle = new Bundle();
            partTimeShopScheduleBundle.putString("shopId", shopId);
            partTimeShopScheduleBundle.putString("shopName", shopName);
            partTimeShopScheduleBundle.putString("address", getIntent().getStringExtra("address"));
            partTimeShopScheduleBundle.putString("distance", getIntent().getStringExtra("distance"));
            partTimeShopScheduleBundle.putString("storeLongitudes", getIntent().getStringExtra("storeLongitudes"));
            partTimeShopScheduleBundle.putString("storeLatitudes", getIntent().getStringExtra("storeLatitudes"));
            partTimeShopScheduleBundle.putString("lastSales", getIntent().getStringExtra("lastSales"));
            partTimeShopScheduleFragment.setArguments(partTimeShopScheduleBundle);
            getSupportFragmentManager().beginTransaction().add(R.id.part_time_shop_info_frg, partTimeShopScheduleFragment).commit();
        }
        partTimeScheduleCheckRemarkLl = (LinearLayout) findViewById(R.id.part_time_schedule_check_remark_ll);
        partTimeScheduleCheckRemarkTv = (EditText) findViewById(R.id.part_time_schedule_check_remark_tv);
        partTimeScheduleCheckNameTv = (TextView) findViewById(R.id.part_time_schedule_check_name_tv);
        LinearLayout partTimeScheduleCheckDateLl = (LinearLayout) findViewById(R.id.part_time_schedule_check_date_ll);
        partTimeProjectListInfoLl = (LinearLayout) findViewById(R.id.part_time_project_list_info_ll);

        partTimeScheduleCheckItem1Ll = (LinearLayout) findViewById(R.id.part_time_schedule_check_item_1_ll);
        partTimeScheduleCheckItem2Ll = (LinearLayout) findViewById(R.id.part_time_schedule_check_item_2_ll);
        partTimeScheduleCheckItem3Ll = (LinearLayout) findViewById(R.id.part_time_schedule_check_item_3_ll);
        partTimeScheduleCheckItem4Ll = (LinearLayout) findViewById(R.id.part_time_schedule_check_item_4_ll);
        partTimeScheduleCheckItem1Tv = (TextView) findViewById(R.id.part_time_schedule_check_item_1_tv);
        partTimeScheduleCheckItem2Tv = (TextView) findViewById(R.id.part_time_schedule_check_item_2_tv);
        partTimeScheduleCheckItem3Tv = (TextView) findViewById(R.id.part_time_schedule_check_item_3_tv);
        partTimeScheduleCheckItem4Tv = (TextView) findViewById(R.id.part_time_schedule_check_item_4_tv);
        partTimeScheduleCheckItem1Ll.setOnClickListener(this);
        partTimeScheduleCheckItem2Ll.setOnClickListener(this);
        partTimeScheduleCheckItem3Ll.setOnClickListener(this);
        partTimeScheduleCheckItem4Ll.setOnClickListener(this);

        partTimeComfirmBtnLl = (LinearLayout) findViewById(R.id.part_time_comfirm_btn_ll);
        partTimeComfirmBtn = (Button) findViewById(R.id.part_time_comfirm_btn);
        partTimeDeleteBtn = (Button) findViewById(R.id.part_time_delete_btn);
        partTimeConfirmSubmitBtn = (Button) findViewById(R.id.part_time_confirm_submit_btn);

        partTimeScheduleCheckTimeStartTv = (TextView) findViewById(R.id.part_time_schedule_check_time_start_tv);
        partTimeScheduleCheckTimeEndTv = (TextView) findViewById(R.id.part_time_schedule_check_time_end_tv);
        partTimeScheduleCheckDateTv = (TextView) findViewById(R.id.part_time_schedule_check_date_tv);
        partTimeScheduleCheckOnthejobYesRb = (RadioButton) findViewById(R.id.part_time_schedule_check_onthejob_yes_rb);
        partTimeScheduleCheckOnthejobNoRb = (RadioButton) findViewById(R.id.part_time_schedule_check_onthejob_no_rb);
        partTimeComfirmBtn.setOnClickListener(this);
        partTimeDeleteBtn.setOnClickListener(this);
        partTimeConfirmSubmitBtn.setOnClickListener(this);
        partTimeScheduleCheckDateLl.setOnClickListener(this);
        partTimeScheduleCheckTimeStartTv.setOnClickListener(this);
        partTimeScheduleCheckTimeEndTv.setOnClickListener(this);
        partTimeScheduleCheckDateTv.setText(checkDate);
        String userName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
        partTimeScheduleCheckNameTv.setText(userName);

        partTimeScheduleCheckOnthejobYesRb.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (partTimeScheduleCheckOnthejobYesRb.isChecked()) {
                    //选择在岗
                    onTheJob = 1;
                } else {
                    //选择不在岗
                    onTheJob = 0;
                }
                radioButtonShow(partTimeScheduleCheckOnthejobYesRb, partTimeScheduleCheckOnthejobNoRb, onTheJob);
            }
        });
        partTimeScheduleCheckOnthejobNoRb.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (partTimeScheduleCheckOnthejobNoRb.isChecked()) {
                    //选择不在岗
                    onTheJob = 0;
                } else {
                    //选择在岗
                    onTheJob = 1;
                }
                radioButtonShow(partTimeScheduleCheckOnthejobYesRb, partTimeScheduleCheckOnthejobNoRb, onTheJob);
            }
        });
        radioButtonShow(partTimeScheduleCheckOnthejobYesRb, partTimeScheduleCheckOnthejobNoRb, onTheJob);
        initDateView();
    }

    private void initDateView() {
        partTimeComfirmBtn.setText(R.string.confirm_btn_txt);
        partTimeScheduleCheckTimeStartTv.setText("--:--");
        partTimeScheduleCheckTimeEndTv.setText("--:--");
        partTimeScheduleCheckRemarkTv.setText("");
        partTimeScheduleCheckRemarkTv.setVisibility(View.VISIBLE);
        partTimeDeleteBtn.setVisibility(View.GONE);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    private void radioButtonShow(RadioButton rybtn, RadioButton rnbtn, Integer onTheJob) {
        if (onTheJob == 1) {
            rybtn.setChecked(true);
            rybtn.setTextColor(ContextCompat.getColor(this, R.color.white));
            rybtn.setBackgroundResource(R.drawable.btn_week_check_style);
            rnbtn.setBackgroundResource(R.drawable.btn_gray_style);
            rnbtn.setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            //显示不在岗原因
            partTimeScheduleCheckRemarkLl.setVisibility(View.GONE);
        } else {
            //不在岗
            rnbtn.setChecked(true);
            rnbtn.setTextColor(ContextCompat.getColor(this, R.color.white));
            rnbtn.setBackgroundResource(R.drawable.btn_week_check_style);
            rybtn.setBackgroundResource(R.drawable.btn_gray_style);
            rybtn.setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            //显示不在岗原因
            partTimeScheduleCheckRemarkLl.setVisibility(View.VISIBLE);
        }
    }

    private void initData() {
        checkDate = DateUtil.getDate(new Date());
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText("门店详情");
    }

    /**
     * GET /partTimeTourShop/getPartTimeTourShopCheck 判读该店是否检查过
     * final String checkDate, final String shopId,final String partTimeStaffId,
     */
    private void getData(String checkDate) {
        showDialog();
        String partTimeStaffId = userInfo.getStaffId();
        String partTimeStaffName = PrefTool.getStringPerferences(this, Prefs.PRE_USER_PART_TIME_NAME);
        PartTimeService.getInstance().requestGetPartTimeTourShopCheck(checkDate, shopId, partTimeStaffId, partTimeStaffName, this);
    }

    /**
     * POST /partTimeTourShop/savePartTimeTourShop 保存兼职督查巡店检查
     */
    private void savePartTimeTourShop() {
        showDialog();
        PartTimeResultEntity partTimeTourShopEntity = new PartTimeResultEntity();
        partTimeTourShopEntity.setCheckDate(partTimeScheduleCheckDateTv.getText().toString());
        partTimeTourShopEntity.setCheckTime(partTimeScheduleCheckTimeStartTv.getText().toString() + "-" + partTimeScheduleCheckTimeEndTv.getText().toString());
        if (onTheJob == 0) {
            partTimeTourShopEntity.setRemark(partTimeScheduleCheckRemarkTv.getText().toString());
        } else {
            partTimeTourShopEntity.setRemark("");

        }
        partTimeTourShopEntity.setOnTheJob(onTheJob + "");
        partTimeTourShopEntity.setPartTimeStaffId(userInfo.getStaffId());
        //兼职督察姓名
        partTimeTourShopEntity.setPartTimeStaffName(partTimeScheduleCheckNameTv.getText().toString());
        partTimeTourShopEntity.setShopId(shopId);
        partTimeTourShopEntity.setShopName(shopName);
        partTimeTourShopEntity.setTourId(tourId);

        String content = new Gson().toJson(partTimeTourShopEntity);
        Log.d(TAG, content);
        PartTimeService.getInstance().requestSavePartTimeTourShop(content, this);
    }

    /**
     * 检查数据校验
     *
     * @return 是否通过
     */
    private boolean checkReport() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        if (onTheJob == 0) {
            inputs.add(partTimeScheduleCheckRemarkTv, StaticScheme.Required());
        }
        inputs.add(partTimeScheduleCheckDateTv, StaticScheme.Required());
        inputs.add(partTimeScheduleCheckTimeStartTv, StaticScheme.Required(), ValueScheme.NotEquals("--:--").msgOnFail("未选择检查开始时间"));
        inputs.add(partTimeScheduleCheckTimeEndTv, StaticScheme.Required(), ValueScheme.NotEquals("--:--").msgOnFail("未选择检查结束时间"));

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    public void onDialogResult(int tag) {
        //清除时间
        initDateView();
        //选择检查日期则查询是否保存检查
        showDialog();
        checkDate = partTimeScheduleCheckDateTv.getText().toString();
        getData(checkDate);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.part_time_confirm_submit_btn) {
            back();
        } else if (v.getId() == R.id.part_time_delete_btn) {
            showDialog();
            //作废
            PartTimeService.getInstance().requestcancelTourShop(tourId, this);
        } else if (v.getId() == R.id.part_time_comfirm_btn) {
            if (getString(R.string.modify_btn_txt).equals(partTimeComfirmBtn.getText().toString())) {
                //初始化检查项
                initCheckTypeView();
                //未提交过检查，检查时间，是否在岗，不在岗原因可更改
                initparttimeView();
                partTimeComfirmBtn.setText(R.string.confirm_btn_txt);
                partTimeDeleteBtn.setVisibility(View.GONE);
                partTimeProjectListInfoLl.setVisibility(View.GONE);
            } else {
                //保存兼职督查巡店检查
                if (checkReport()) {
                    savePartTimeTourShop();
                }
            }
        } else if (v.getId() == R.id.part_time_schedule_check_date_ll) {
            //选择检查日期
            DialogHelper.AlertDatePicker(this, PartTimeTourShopCheckActivity.this, partTimeScheduleCheckDateTv);
        } else if (v.getId() == R.id.part_time_schedule_check_time_start_tv) {
            //选择检查开始时间
            DialogHelper.AlertTimePicker(PartTimeTourShopCheckActivity.this, partTimeScheduleCheckTimeStartTv);
        } else if (v.getId() == R.id.part_time_schedule_check_time_end_tv) {
            //选择检查结束时间
            DialogHelper.AlertTimePicker(PartTimeTourShopCheckActivity.this, partTimeScheduleCheckTimeEndTv);
        } else if (v.getId() == R.id.part_time_schedule_check_item_1_ll) {
            //类型 0;员工形象检查 1:专柜卫生及内部陈列检查 2:专柜外部陈列检查 3:专柜服务检查
            toNextActivity(PART_TIME_SCHEDULE_CHECK_ITEM_0, getString(R.string.part_time_schedule_check_item_1));
        } else if (v.getId() == R.id.part_time_schedule_check_item_2_ll) {
            //类型 0;员工形象检查 1:专柜卫生及内部陈列检查 2:专柜外部陈列检查 3:专柜服务检查
            toNextActivity(PART_TIME_SCHEDULE_CHECK_ITEM_1, getString(R.string.part_time_schedule_check_item_2));
        } else if (v.getId() == R.id.part_time_schedule_check_item_3_ll) {
            //类型 0;员工形象检查 1:专柜卫生及内部陈列检查 2:专柜外部陈列检查 3:专柜服务检查
            toNextActivity(PART_TIME_SCHEDULE_CHECK_ITEM_2, getString(R.string.part_time_schedule_check_item_3));
        } else if (v.getId() == R.id.part_time_schedule_check_item_4_ll) {
            //类型 0;员工形象检查 1:专柜卫生及内部陈列检查 2:专柜外部陈列检查 3:专柜服务检查
            toNextActivity(PART_TIME_SCHEDULE_CHECK_ITEM_3, getString(R.string.part_time_schedule_check_item_4));
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.PartTime.MSG_ON_GET_PARTTIME_TOURSHOP_CHECK: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeShopTourResultRespose mPartTimeResultRespose = new Gson().fromJson(msg, PartTimeShopTourResultRespose.class);
                        Log.d(TAG, "mPartTimeResultRespose=" + mPartTimeResultRespose.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mPartTimeResultRespose.msgCode)) {
                            //提交过检查
                            setData(mPartTimeResultRespose);
                        } else {
                            //未提交过检查
                            partTimeComfirmBtnLl.setVisibility(View.VISIBLE);
                            partTimeProjectListInfoLl.setVisibility(View.GONE);
                            partTimeDeleteBtn.setVisibility(View.GONE);
                            partTimeComfirmBtn.setText("确定");
                            partTimeComfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
                            partTimeComfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_nomal));
                            partTimeComfirmBtn.setOnClickListener(this);
                            tourId = "";
                            //初始化日期项
                            initDateView();
                            //初始化检查项
                            initCheckTypeView();
                            //未提交过检查，检查时间，是否在岗，不在岗原因可更改
                            initparttimeView();
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.PartTime.MSG_ON_SAVE_PARTTIME_TOURSHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeResultIdEntity mBaseResponse = new Gson().fromJson(msg, PartTimeResultIdEntity.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            showMsg(mBaseResponse.retInfo);
                            //已确认检查时间，显示检查列表
                            tourId = mBaseResponse.getResult();
                            partTimeProjectListInfoLl.setVisibility(View.VISIBLE);
                            partTimeComfirmBtn.setText(getString(R.string.modify_btn_txt));
                            partTimeDeleteBtn.setVisibility(View.VISIBLE);
                            partTimeComfirmBtnLl.setVisibility(View.VISIBLE);
                            getData(checkDate);
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                case BusinessID.PartTime.MSG_ON_CANCEL_TOUR_SHOP: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        PartTimeResultIdEntity mBaseResponse = new Gson().fromJson(msg, PartTimeResultIdEntity.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            showMsg(mBaseResponse.retInfo);
                            getData(checkDate);
                        } else {
                            showMsg(result.getResultInfo());
                        }
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    private void initparttimeView() {
        partTimeScheduleCheckTimeStartTv.setOnClickListener(this);
        partTimeScheduleCheckTimeEndTv.setOnClickListener(this);
        partTimeScheduleCheckOnthejobYesRb.setClickable(true);
        partTimeScheduleCheckOnthejobYesRb.setFocusable(true);
        partTimeScheduleCheckOnthejobNoRb.setClickable(true);
        partTimeScheduleCheckOnthejobNoRb.setFocusable(true);
        partTimeScheduleCheckRemarkTv.setClickable(true);
        partTimeScheduleCheckRemarkTv.setFocusable(true);
        partTimeScheduleCheckRemarkTv.setEnabled(true);
        partTimeScheduleCheckRemarkTv.requestFocus();
        partTimeScheduleCheckRemarkTv.setFocusableInTouchMode(true);
    }

    private void setData(PartTimeShopTourResultRespose mPartTimeResultRespose) {
        if (null != mPartTimeResultRespose.getResult()) {
            //已确认检查时间，显示检查列表
            partTimeComfirmBtn.setText(getString(R.string.modify_btn_txt));
            partTimeDeleteBtn.setVisibility(View.VISIBLE);
            partTimeComfirmBtnLl.setVisibility(View.VISIBLE);
            partTimeProjectListInfoLl.setVisibility(View.VISIBLE);
            //如果已保存过检查时间
            if (null != mPartTimeResultRespose.getResult().getPartTimeTourShop()) {
                PartTimeResultEntity partTimeResultEntity = mPartTimeResultRespose.getResult().getPartTimeTourShop();
                partTimeScheduleCheckDateTv.setText(partTimeResultEntity.getCheckDate());

                //开始时间和结束时间
                if (!TextUtils.isEmpty(partTimeResultEntity.getCheckTime())) {
                    if (partTimeResultEntity.getCheckTime().length() >= 11) {
                        //--:-- ---:--
                        String startTime = String.valueOf(partTimeResultEntity.getCheckTime().substring(0, 5));
                        String endTime = String.valueOf(partTimeResultEntity.getCheckTime().substring(6, 11));
                        partTimeScheduleCheckTimeStartTv.setText(startTime);
                        partTimeScheduleCheckTimeEndTv.setText(endTime);
                    }
                }
                tourId = partTimeResultEntity.getTourId();
                onTheJob = Integer.valueOf(partTimeResultEntity.getOnTheJob());
                //显示在岗不在岗按钮
                radioButtonShow(partTimeScheduleCheckOnthejobYesRb, partTimeScheduleCheckOnthejobNoRb, onTheJob);
                if (0 != partTimeResultEntity.getReviewStatus()) {
                    partTimeComfirmBtn.setText("已审核");
                    partTimeComfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
                    partTimeComfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_week_normal_style));
                    partTimeComfirmBtn.setOnClickListener(null);
                    //已审核则不能作废
                    partTimeDeleteBtn.setVisibility(View.GONE);
                    partTimeProjectListInfoLl.setVisibility(View.GONE);
                    initPartTimeDataView();
                } else {
                    //显示列表
                    setOnTheJobView(partTimeResultEntity);
                    //如果已保存过检查时间,获取检查类型
                    if (null != mPartTimeResultRespose.getResult().getPartTimeTourShopDetailList() && !mPartTimeResultRespose.getResult().getPartTimeTourShopDetailList().isEmpty()) {
                        mPartTimeTourShopDetailEntitys = mPartTimeResultRespose.getResult().getPartTimeTourShopDetailList();
                        //根据检查类型，显示检查项
                        for (PartTimeTourShopModelEntity mPartTimeTourShopDetailEntity : mPartTimeTourShopDetailEntitys) {
                            setCheckListStatus(mPartTimeTourShopDetailEntity);
                        }
                    }
                }
            }
        }
    }

    private void setOnTheJobView(PartTimeResultEntity partTimeResultEntity) {
        if (StringUtil.isNullOrEmpty(partTimeResultEntity.getRemark())) {
            partTimeScheduleCheckRemarkLl.setVisibility(View.GONE);
            partTimeScheduleCheckRemarkTv.setText("");
        } else {
            partTimeScheduleCheckRemarkLl.setVisibility(View.VISIBLE);
            partTimeScheduleCheckRemarkTv.setText(partTimeResultEntity.getRemark());
        }
        initPartTimeDataView();
        initCheckTypeView();
    }

    private void initCheckTypeView() {
        partTimeScheduleCheckItem1Tv.setText("未提交");
        partTimeScheduleCheckItem2Tv.setText("未提交");
        partTimeScheduleCheckItem3Tv.setText("未提交");
        partTimeScheduleCheckItem4Tv.setText("未提交");
        partTimeScheduleCheckItem1Tv.setTextColor(ContextCompat.getColor(this, R.color.red));
        partTimeScheduleCheckItem2Tv.setTextColor(ContextCompat.getColor(this, R.color.red));
        partTimeScheduleCheckItem3Tv.setTextColor(ContextCompat.getColor(this, R.color.red));
        partTimeScheduleCheckItem4Tv.setTextColor(ContextCompat.getColor(this, R.color.red));
        partTimeScheduleCheckItem1Ll.setOnClickListener(this);
        partTimeScheduleCheckItem2Ll.setOnClickListener(this);
        partTimeScheduleCheckItem3Ll.setOnClickListener(this);
        partTimeScheduleCheckItem4Ll.setOnClickListener(this);

        if (onTheJob == 0 && partTimeScheduleCheckOnthejobNoRb.isChecked()) {
            //不在岗(已选择不在岗)
            partTimeScheduleCheckRemarkLl.setVisibility(View.VISIBLE);
            partTimeScheduleCheckItem1Tv.setText("无需提交");
            partTimeScheduleCheckItem4Tv.setText("无需提交");
            partTimeScheduleCheckItem1Tv.setTextColor(ContextCompat.getColor(this, R.color.black));
            partTimeScheduleCheckItem4Tv.setTextColor(ContextCompat.getColor(this, R.color.black));
            partTimeScheduleCheckItem1Ll.setOnClickListener(null);
            partTimeScheduleCheckItem4Ll.setOnClickListener(null);
        } else if (onTheJob == 1) {
            partTimeScheduleCheckRemarkTv.setText("");
            partTimeScheduleCheckRemarkLl.setVisibility(View.GONE);
            partTimeScheduleCheckItem1Ll.setOnClickListener(this);
            partTimeScheduleCheckItem2Ll.setOnClickListener(this);
            partTimeScheduleCheckItem3Ll.setOnClickListener(this);
            partTimeScheduleCheckItem4Ll.setOnClickListener(this);
        }
    }

    private void initPartTimeDataView() {
        //初始化，检查时间，是否在岗，不在岗原因不可更改
        partTimeScheduleCheckTimeStartTv.setOnClickListener(null);
        partTimeScheduleCheckTimeEndTv.setOnClickListener(null);
        partTimeScheduleCheckOnthejobYesRb.setClickable(false);
        partTimeScheduleCheckOnthejobYesRb.setFocusable(false);
        partTimeScheduleCheckOnthejobNoRb.setClickable(false);
        partTimeScheduleCheckOnthejobNoRb.setFocusable(false);
        partTimeScheduleCheckRemarkTv.setFocusable(false);
        partTimeScheduleCheckRemarkTv.setClickable(false);
        partTimeScheduleCheckRemarkTv.setEnabled(false);
    }

    /**
     * 类型 0;员工形象检查 1:专柜卫生及内部陈列检查 2:专柜外部陈列检查 3:专柜服务检查
     * 提交状态：status 0:未提交，（红色）1:已提交（绿色），员工选择不在岗：1，4，项无需提交，（灰色）不可点击；
     *
     * @param mPartTimeTourShopDetailEntity 检查项状态
     */
    private void setCheckListStatus(PartTimeTourShopModelEntity mPartTimeTourShopDetailEntity) {
        if (PART_TIME_SCHEDULE_CHECK_ITEM_0 == mPartTimeTourShopDetailEntity.getType()) {
            setCheckListItem(partTimeScheduleCheckItem1Tv);
        } else if (PART_TIME_SCHEDULE_CHECK_ITEM_1 == mPartTimeTourShopDetailEntity.getType()) {
            setCheckListItem(partTimeScheduleCheckItem2Tv);
        } else if (PART_TIME_SCHEDULE_CHECK_ITEM_2 == mPartTimeTourShopDetailEntity.getType()) {
            setCheckListItem(partTimeScheduleCheckItem3Tv);
        } else if (PART_TIME_SCHEDULE_CHECK_ITEM_3 == mPartTimeTourShopDetailEntity.getType()) {
            setCheckListItem(partTimeScheduleCheckItem4Tv);
        }
    }

    private void setCheckListItem(TextView tv) {
        tv.setText("已提交");
        tv.setTextColor(ContextCompat.getColor(this, R.color.green));
    }

    private void toNextActivity(int typeID, String typeName) {
        Intent intent = new Intent();
        intent.putExtra("shopId", shopId);
        intent.putExtra("shopName", shopName);
        intent.putExtra("typeID", typeID);
        intent.putExtra("typeName", typeName);
        intent.putExtra("tourId", tourId);
        if (typeID == 3) {
            intent.setClass(this, PartTimeTourShopReportDetailActivity.class);
        } else {
            intent.setClass(this, PartTimeTourShopReportDetailActivity2.class);
        }
        startActivity(intent);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            back();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void back() {
        if (null != mPartTimeTourShopDetailEntitys && !mPartTimeTourShopDetailEntitys.isEmpty()) {
            showConfirmDialog();
        } else {
            super.back();
        }
    }

    private void showConfirmDialog() {
        if (null != mPartTimeTourShopDetailEntitys && !mPartTimeTourShopDetailEntitys.isEmpty() && !TextUtils.isEmpty(tourId)) {
            String message = shopName + "\n";
            message = message + checkDate + "\n";
            message = message + "\n";
            message = message + "已上报项:\n";
            //根据检查类型，显示检查项
            for (PartTimeTourShopModelEntity mPartTimeTourShopDetailEntity : mPartTimeTourShopDetailEntitys) {
                if (PART_TIME_SCHEDULE_CHECK_ITEM_0 == mPartTimeTourShopDetailEntity.getType()) {
                    mPartTimeTourShopDetailEntity.setTypeName(getString(R.string.part_time_schedule_check_item_1));
                } else if (PART_TIME_SCHEDULE_CHECK_ITEM_1 == mPartTimeTourShopDetailEntity.getType()) {
                    mPartTimeTourShopDetailEntity.setTypeName(getString(R.string.part_time_schedule_check_item_2));
                } else if (PART_TIME_SCHEDULE_CHECK_ITEM_2 == mPartTimeTourShopDetailEntity.getType()) {
                    mPartTimeTourShopDetailEntity.setTypeName(getString(R.string.part_time_schedule_check_item_3));
                } else if (PART_TIME_SCHEDULE_CHECK_ITEM_3 == mPartTimeTourShopDetailEntity.getType()) {
                    mPartTimeTourShopDetailEntity.setTypeName(getString(R.string.part_time_schedule_check_item_4));
                }
                message = message + mPartTimeTourShopDetailEntity.getTypeName() + "\n";
            }
            PublicPartTimeTipDialog.Builder builder = new PublicPartTimeTipDialog.Builder(this);
            builder.setMessage(message);
            builder.setTitle("是否完成所有录入?");

            builder.setPositiveButton("继续",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                        }
                    });
            builder.setNegativeButton("确定",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                            PartTimeTourShopCheckActivity.this.finish();
                        }
                    });
            builder.create().show();
        } else {
            showMsg("没有已提交的数据！");
            if (getString(R.string.confirm_btn_txt).equals(partTimeComfirmBtn.getText().toString())) {
                PartTimeTourShopCheckActivity.this.finish();
            }
        }
    }
}