package com.wgmf.yxgj.module.business.reportmodule.ui;

import android.content.Intent;
import android.net.Uri;
import android.os.AsyncTask;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ListViewUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PhotoSelectorPop;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.module.business.reportmodule.R;
import com.wgmf.yxgj.module.business.reportmodule.model.QueryReportEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.QueryReportResultEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportModelInfoEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportModelListEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportModuleOptionEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportShopListEntity;
import com.wgmf.yxgj.module.business.reportmodule.model.ReportStandardDetailEntity;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportModuleService;
import com.wgmf.yxgj.module.business.reportmodule.service.ReportStaticData;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.wgmf.yxgj.widgets.ListView.ListViewForScrollView;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

import static com.wgmf.yxgj.report.ui.ReportBaseDetailActivity.hideInputMethod;

@SuppressWarnings("all")
@Route(path = RouterParams.URL_REPORTMODULEDETAILACTIVITY)
public class ReportModuleDetailActivity extends ReportWithPhotoBaseActivity implements PhotoSelectorPop.PhotoSelectorPopListener, ReportModuleDetailAdapter.LvListener {

    private ListViewForScrollView reportModuleDetailContentLv;
    private ReportModuleDetailAdapter mReportModuleDetailAdapter;
    ReportShopListEntity reportShopListEntity;
    ReportStandardDetailEntity reportStandardDetailEntity;
    List<ReportModelListEntity> reportModelListEntities;
    /**
     * 上报基本信息
     */
    ReportModelInfoEntity reportEntityReportInfo;
    TextView reportStoreTv;
    TextView reportDeadlineTv;
    TextView reportStaffNameTv;
    TextView reportLastTimeTv;
    TextView reportStateTv;
    TextView reportScoreTv;
    TextView reportDetailTv;
    LinearLayout reportLastTimeLl;
    LinearLayout reportStateLl;
    LinearLayout reportScoreLl;
    LinearLayout reportDetailLl;

    String standardId;
    Long branchID;

    LinearLayout starPlanSubmitLl;
    ImageView activityReportModuleDetailIv;

    protected PhotoSelectorPop photoSelectorPop;

    @Override
    public void initTitle() {
        super.initTitle();
        reportShopListEntity = (ReportShopListEntity) getIntent().getSerializableExtra("reportShopListEntity");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void initView() {
        setContentView(R.layout.activity_report_module_detail);
        activityReportModuleDetailIv = (ImageView) findViewById(R.id.activity_report_module_detail_iv);
        reportStoreTv = (TextView) findViewById(R.id.report_store_tv);
        reportDeadlineTv = (TextView) findViewById(R.id.report_deadline_tv);
        reportStaffNameTv = (TextView) findViewById(R.id.report_staff_name_tv);
        reportLastTimeTv = (TextView) findViewById(R.id.report_last_time_tv);
        reportStateTv = (TextView) findViewById(R.id.report_state_tv);
        reportScoreTv = (TextView) findViewById(R.id.report_score_tv);
        reportDetailTv = (TextView) findViewById(R.id.report_detail_tv);
        reportLastTimeLl = (LinearLayout) findViewById(R.id.report_last_time_ll);
        reportStateLl = (LinearLayout) findViewById(R.id.report_state_ll);
        reportScoreLl = (LinearLayout) findViewById(R.id.report_score_ll);
        reportDetailLl = (LinearLayout) findViewById(R.id.report_detail_ll);
        reportModuleDetailContentLv = (ListViewForScrollView) findViewById(R.id.report_module_detail_content_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        reportModuleDetailContentLv.setEmptyView(emptyView);
        starPlanSubmitLl = (LinearLayout) findViewById(R.id.star_plan_submit_ll);
        Button reportModuleDetailSubmitBtn = (Button) findViewById(R.id.report_module_detail_submit_btn);
        reportModuleDetailSubmitBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //1,检查数据
                checkDatas();
            }
        });
    }

    /**
     * 将专项上报查询数据转化为专项上报提交数据上传给服务端
     */
    private void checkDatas() {
        reportStandardDetailEntity = new ReportStandardDetailEntity();
        //获取选项数据
        reportModelListEntities = mReportModuleDetailAdapter.getUploadData();
        //检查数据
        if (!checkUploadDatas()) {
            //如果有未填写数据，退出数据检查循环
            return;
        }
        //校验数据通过上传图片
        checkUploadImages();
        //设置基本数据
        reportStandardDetailEntity.setModelList(reportModelListEntities);
        reportStandardDetailEntity.setStaffId(userInfo.getStaffId());
        reportStandardDetailEntity.setStaffName(userInfo.getName());
        reportStandardDetailEntity.setShopId(shopId);
        reportStandardDetailEntity.setShopName(shopName);
        reportStandardDetailEntity.setStandardId(standardId);
        if (isUpload) {
            //2.如果没有有图片则直接上传数据
            uploadData();
        }
    }

    /**
     * 上传图片
     */
    private void checkUploadImages() {
        for (ReportModelListEntity reportModelListEntity : reportModelListEntities) {
            List<ReportModuleOptionEntity> reportModelOptionsEntities = reportModelListEntity.getOptions();
            //图片非必填时 注意也需要上传图片
            if (reportModelListEntity.getType() == 6) {
                if (null != reportModelListEntity.getStoreImageselectList() && !reportModelListEntity.getStoreImageselectList().isEmpty()) {
                    //2.如果有图片则先上传图片
                    isUpload = false;
                } else {
                    //如果没有图片，即删除的图片，Options置空
                    reportModelListEntity.setOptions(null);
                }
            }
        }
        //如果有图片需上传，开启图片上传线程
        if (!isUpload) {
            new uploadImageAsyncTask().execute();
        }
    }

    private boolean checkUploadDatas() {
        if (null != reportModelListEntities && !reportModelListEntities.isEmpty()) {
            for (ReportModelListEntity reportModelListEntity : reportModelListEntities) {
                List<ReportModuleOptionEntity> reportModelOptionsEntities = reportModelListEntity.getOptions();
                //1,如果该项为必要项，则检查数据是否填写
                if (ReportStaticData.getBoolean(true).equals(reportModelListEntity.isNecessary())) {
                    //填空题、日期答案如果为空，提示未填写必要项
                    if (reportModelListEntity.getType() == 1 || reportModelListEntity.getType() == 2 || reportModelListEntity.getType() == 5) {
                        if (null != reportModelListEntity.getOptions() && !reportModelListEntity.getOptions().isEmpty()) {
                            for (ReportModuleOptionEntity reportModelOptionsEntity : reportModelOptionsEntities) {
                                if (StringUtil.isNullOrEmpty(reportModelOptionsEntity.getValue())) {
                                    dismissDialog();
                                    ToastUtil.show(this, "必填项未填写完整，请检查！");
                                    return false;
                                }
                            }
                        } else {
                            dismissDialog();
                            ToastUtil.show(this, "必填项未填写完整，请检查！");
                            return false;
                        }
                    }
                    //选择题答案如果全为N，提示未填写必要项
                    if (reportModelListEntity.getType() == 3 || reportModelListEntity.getType() == 4) {
                        String answer = null;
                        for (ReportModuleOptionEntity reportModelOptionsEntity : reportModelOptionsEntities) {
                            answer += reportModelOptionsEntity.getIsChecked();
                        }
                        if (null != answer && !answer.contains(ReportStaticData.getBoolean(true))) {
                            dismissDialog();
                            ToastUtil.show(this, "必选项未勾选，请检查！");
                            return false;
                        }
                    }
                    //图片上传题答案检查
                    if (reportModelListEntity.getType() == 6) {
                        if (null == reportModelListEntity.getStoreImageselectList() || reportModelListEntity.getStoreImageselectList().isEmpty()) {
                            dismissDialog();
                            ToastUtil.show(this, "必要项未添加图片，请检查！");
                            return false;
                        }
                    }
                }
            }
        }
        return true;
    }

    /**
     * 上传图片
     */
    private void uploadImages() {
        for (ReportModelListEntity reportModelListEntity : reportModelListEntities) {
            //如果是图片上传
            if (reportModelListEntity.getType() == 6) {
                List<ImageItem> checkImgs = reportModelListEntity.getStoreImageselectList();
                if (null != checkImgs && !checkImgs.isEmpty()) {
                    List<ReportModuleOptionEntity> imgOptions = new ArrayList<>();
                    //先检查图片集合是否为空，不为空则设置图片链接
                    //如果上传图片数量少于图片张数限制
                    if (imgOptions.size() < reportModelListEntity.getImgOrVoiceNum()) {
                        for (int i = 0; i < checkImgs.size(); i++) {
                            if (checkImgs.get(i).getType() == 1) {
                                //如果图片已上传则填写已传图片
                                ReportModuleOptionEntity detailOption = new ReportModuleOptionEntity();
                                detailOption.setType(6);
                                detailOption.setModelId(reportModelListEntity.getModelId());
                                detailOption.setValue(checkImgs.get(i).getImgneturl());
                                imgOptions.add(detailOption);
                            } else if (StringUtil.isNullString(checkImgs.get(i).getImgneturl())) {
                                //如果图片未上传则上传图片,添加位置信息，便于后面找到制定位置图片
                                reportType = "ZXTP" + i + "POS" + reportModelListEntity.getOrderNum();
                                uploadByFilePathBefore(checkImgs.get(i).getImagePath());
                                //上传图片后，将图片类型置为已上传
//                                checkImgs.get(i).setType(1);
                                for (int j = 0; j < qiniuUrlLists.size(); j++) {
                                    if (qiniuUrlLists.get(j).contains(reportType)) {
                                        ReportModuleOptionEntity detailOption = new ReportModuleOptionEntity();
                                        detailOption.setType(6);
                                        detailOption.setModelId(reportModelListEntity.getModelId());
                                        detailOption.setValue(qiniuUrlLists.get(j));
                                        imgOptions.add(detailOption);
                                    }
                                }
                            }
                        }
                    }
                    reportModelListEntity.setOptions(imgOptions);
                }
            }
        }
    }

    /**
     * 是否上传数据
     */
    boolean isUpload = true;

    class uploadImageAsyncTask extends AsyncTask<String, Void, Boolean> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected Boolean doInBackground(String... params) {
            uploadImages();
            return isUpload;
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(Boolean isNotOk) {
            super.onPostExecute(isNotOk);
            if (!isNotOk) {
                if (!isUpload) {
                    if (!qiniuUrlLists.isEmpty()) {
                        showDialog();
                        if (null != handler && null != runnable) {
                            handler.postDelayed(runnable, 100);
                        }
                    } else {
                        //3.图片上传成功，再上传数据
                        uploadData();
                    }
                }
            }
        }
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        String reportStandardDetail = new Gson().toJson(reportStandardDetailEntity);
        Log.d("上传上报配置数据", reportStandardDetail);
        showDialog();
        ReportModuleService.getInstance().requestSaveModuleReport(reportStandardDetail, this);
    }

    @Override
    protected void initContent() {
        showDialog();
        branchID = getIntent().getLongExtra("branchID", 0);
        standardId = getIntent().getStringExtra("standardId");
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
        ReportModuleService.getInstance().requestGetReportStandardModel(standardId, shopId, this);
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }

    @Override
    public void setSelectDialog(int selectType, View view) {
        this.idImagePickerContainer = (ImagePickerLayout) view;
        //图片或视频类型 0:只可拍 1:只可选相册 2:拍照+相册
        if (selectType == 0) {
            //拍照处理
            takePhoto(idImagePickerContainer);
        } else if (selectType == 1) {
            //相片处理
            getPictrue(idImagePickerContainer);
        } else if (selectType == 2) {
            setSelectDialogListeners(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //拍照处理
                    takePhoto(idImagePickerContainer);
                    hideSelectDialog();
                }
            }, new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    //相片处理
                    getPictrue(idImagePickerContainer);
                    hideSelectDialog();
                }
            }, new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    hideSelectDialog();
                }
            });
            showSelectDialog("选择图片", null, "相机拍照", "本地相册", "取消");
        }
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        toPhotoPreviewFragment(i, arrayList);//大图显示
    }

    @Override
    protected void refreshAfterTakePicture(Intent data, ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        super.refreshAfterTakePicture(data, mImageselectList, idImagePickerContainer);
        mReportModuleDetailAdapter.refreshPicture(mImageselectList, idImagePickerContainer);
    }

    @Override
    protected void refreshAfterGetPicture(Intent data, ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        super.refreshAfterGetPicture(data, mImageselectList, idImagePickerContainer);
        mReportModuleDetailAdapter.refreshPicture(idImagePickerContainer.getmImageselectList(), idImagePickerContainer);
    }

    @Override
    public void onTakePhoto() {

    }

    @Override
    public void onChoosePhoto() {

    }

    @Override
    public void showAudioSelect() {
        hideInputMethod(this);
//        if (null == photoSelectorPop) {
//            photoSelectorPop = new PhotoSelectorPop(this, this, MediaParams.PARAMS_6);
//        }
//        if (!photoSelectorPop.isShowing()) {
//            photoSelectorPop.show(this.findViewById(R.id.title));
//        }
        showTipDialog("提示", "音频选择功能维护中...");
    }

    @Override
    public void onTakeAudio() {
        //录音
//        SoundRecorder.launchAct(this);
        showTipDialog("提示", "音频选择功能维护中...");
    }

    @Override
    public void onChooseAudio() {
        //选取音频
//        Intent intent = new Intent(this, SeleteAudioActivity.class);
//        startActivityForResult(intent, MediaParams.PARAMS_5);
        showTipDialog("提示", "音频选择功能维护中...");
    }

    @Override
    public void onCancel() {

    }

    @Override
    public void onDismiss() {

    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.ModuleReport.MSG_ON_SAVE_MODULE_REPORT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            ToastUtil.show(this, result.getResultInfo());
                            this.finish();
                        }
                        ToastUtil.show(this, result.getResultInfo());
                    } else {
                        ToastUtil.show(this, result.getResultInfo());
                    }
                }
                break;
                case BusinessID.ModuleReport.MSG_ON_GET_REPORT_STANDARD_MODEL: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        QueryReportResultEntity queryReportResultEntity = new Gson().fromJson(msg, QueryReportResultEntity.class);
                        Log.d(TAG, "reportModuleEntity" + queryReportResultEntity);
                        if (null != queryReportResultEntity && null != queryReportResultEntity.getResult() && ConstantParams.CONSTANT_PARAMS_0.equals(queryReportResultEntity.retCode)) {
                            setData(queryReportResultEntity.getResult());
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    private void setData(QueryReportEntity queryReportEntity) {
        if (null != queryReportEntity) {
            //设置门店数据
            if (null != queryReportEntity.getReportInfo()) {
                reportEntityReportInfo = queryReportEntity.getReportInfo();
                homeTitleText.setText(reportEntityReportInfo.getReportName());

                reportStoreTv.setText(reportEntityReportInfo.getShopName());
                reportDeadlineTv.setText(reportEntityReportInfo.getDateScope());
                reportStaffNameTv.setText(reportEntityReportInfo.getReportPerson());

                if (StringUtil.isNotNullAndNotEmpty(reportEntityReportInfo.getLastReportTime())) {
                    reportLastTimeTv.setText(reportEntityReportInfo.getLastReportTime());
                    reportLastTimeLl.setVisibility(View.VISIBLE);
                }
                if (StringUtil.isNotNullAndNotEmpty(reportEntityReportInfo.getCheckStatusStr())) {
                    reportStateTv.setText(reportEntityReportInfo.getCheckStatusStr());
                    reportStateLl.setVisibility(View.VISIBLE);
                }
                if (StringUtil.isNotNullAndNotEmpty(reportEntityReportInfo.getCheckScore())) {
                    reportScoreTv.setText(reportEntityReportInfo.getCheckScore());
                    reportScoreLl.setVisibility(View.VISIBLE);
                }
                if (StringUtil.isNotNullAndNotEmpty(reportEntityReportInfo.getCheckRemark())) {
                    reportDetailTv.setText(reportEntityReportInfo.getCheckRemark());
                    reportDetailLl.setVisibility(View.VISIBLE);
                }
                //0:不可用 1:待审核 2:审核通过 3:审核不通过 4:审核不通过再次提交 5:待上报
                if (5 == reportEntityReportInfo.getCheckStatus()) {
                    reportLastTimeLl.setVisibility(View.GONE);
                    reportStateLl.setVisibility(View.GONE);
                    reportScoreLl.setVisibility(View.GONE);
                    reportDetailLl.setVisibility(View.GONE);
                } else if (1 == reportEntityReportInfo.getCheckStatus()) {
                    reportStateLl.setVisibility(View.GONE);
                    reportScoreLl.setVisibility(View.GONE);
                    reportStateTv.setTextColor(ContextCompat.getColor(this, R.color.red));
                } else {
                    reportStateTv.setTextColor(ContextCompat.getColor(this, R.color.green));
                }
            }
            // 设置列表数据
            if (null != queryReportEntity.getModelList() && !queryReportEntity.getModelList().isEmpty()) {
                //将/查询图片数据加载进图片容器数据模型中
                for (ReportModelListEntity data : queryReportEntity.getModelList()) {
                    if (data.getType() == 6) {
                        if (null != data.getOptions() && !data.getOptions().isEmpty()) {
                            ArrayList<ImageItem> mImageselectList = new ArrayList<>();
                            for (int i = 0; i < data.getOptions().size(); i++) {
                                if (!StringUtil.isNullString(data.getOptions().get(i).getValue())) {
                                    ImageItem item = new ImageItem();
                                    item.setImgneturl(data.getOptions().get(i).getValue());
                                    item.setImagePath(data.getOptions().get(i).getValue());
                                    item.setImageId(data.getOptions().get(i).getValue());
                                    item.setUri(Uri.fromFile(new File(data.getOptions().get(i).getValue())));
                                    item.setType(1);
                                    mImageselectList.add(item);
                                }
                            }
                            //将图片数据设置进图片装载容器中
                            data.setStoreImageselectList(mImageselectList);
                        }
                    }
                }
                setReportModuleAdapter(queryReportEntity.getModelList());
            }
            Long branchID = getIntent().getLongExtra("branchID", 0);
            if (590L == branchID || 704L == branchID) {
                // 如果是专项上报功能，显示提交按钮
                starPlanSubmitLl.setVisibility(View.VISIBLE);
            } else {
                // 如果是专项上报查询功能，显示全屏透明遮罩,使页面不可点击
                activityReportModuleDetailIv.setVisibility(View.VISIBLE);
                // 防止点击穿透
                activityReportModuleDetailIv.setClickable(true);
                //3秒钟之内只取一个点击事件，防抖操作
                RxView.clicks(activityReportModuleDetailIv).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
                    @Override
                    public void call(Void aVoid) {
                        showTipDialog("提示", "查询页面，无法修改内容哟！");
                    }
                });
            }
        }
    }

    private void setReportModuleAdapter(List<ReportModelListEntity> modelList) {
        mReportModuleDetailAdapter = new ReportModuleDetailAdapter(this, this, modelList, branchID);
        reportModuleDetailContentLv.setAdapter(mReportModuleDetailAdapter);
        ListViewUtil.setListViewHeight(reportModuleDetailContentLv);
    }
}