package com.wgmf.yxgj.module.business.reportmonthly.service;

import com.wgmf.library.utils.DateUtil;

/**
 * 获取指定年月周数
 *
 * @author XiePing
 */
public class WeekUtils {

    public static int getWeek(String month) {
        // 当月头月尾的周有跨月的情况时，以周二属于哪个月份决定该周的所属月份。
        // 注：周日=0，转化为7

//        month="2016-12";
        try {
            // 1.计算月第一天为周几
            int mNowMonthBegin = DateUtil.dayForWeek(DateUtil
                    .getMonthBegin(month));
            // 2.计算月最后一天为周几
            int mNowMonthEnd = DateUtil.dayForWeek(DateUtil
                    .getMonthEnd(month));
            // 3.计算指定月份天数
            // int currentMonthDays = DateUtil.getCurrentMonthDay();

            int mYear = Integer.parseInt(month.substring(0, 4).trim());
            int mMonth = Integer.parseInt(month.substring(6, 7).trim());
            int currentMonthDays = DateUtil.getDaysByYearMonth(mYear, mMonth - 1);


            // 4.(当月天数-第一周本月所占天数（7-1号周几+1）-本月最后一周余下天数（最后一天周几）)/7 =本月完整周数
            int weekCount = (currentMonthDays - (7 - mNowMonthBegin + 1) - mNowMonthEnd) / 7;
            // 5.如果本月第一天小于等于周二，周数+1
            if (mNowMonthBegin == 0) {
                mNowMonthBegin = 7;
            }
            if (mNowMonthBegin <= 2) {
                weekCount = weekCount + 1;
            }
            // 6.如果本月最后一天大于等于周二，周数+1
            if (mNowMonthEnd == 0) {
                mNowMonthEnd = 7;
            }
            if (mNowMonthEnd >= 2) {
                weekCount = weekCount + 1;
            }
//            System.out.println("查询年月(实际年月+1):" + month);
//            System.out.println("第一天为周:" + mNowMonthBegin);
//            System.out.println("最后一天为周:" + mNowMonthEnd);
//            System.out.println("当月天数:" + currentMonthDays);
//            System.out.println("当月周数:" + weekCount);
            return weekCount;
        } catch (Exception e) {
            return 0;
        }
    }
}
