package com.wgmf.yxgj.module.business.reportproblem.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.module.business.reportproblem.model.OaHandler;

import java.util.List;

class ProblemsRepliesAdapter extends BaseAdapter {
    private Context context;
    private List<OaHandler> list;

    ProblemsRepliesAdapter(Context context, List<OaHandler> list) {
        this.context = context;
        this.list = list;
    }

    @Override
    public int getCount() {
        return list == null ? 0 : list.size();
    }

    @Override
    public OaHandler getItem(int position) {
        if (position >= list.size()) {
            return null;
        } else {
            return list.get(position);
        }
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView reply;
        TextView handler;
        TextView handlerDate;
        TextView pointLine;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.view_query_problems_replies_item, null);
            holder.reply = (TextView) convertView.findViewById(R.id.reply);
            holder.handler = (TextView) convertView.findViewById(R.id.handler);
            holder.handlerDate = (TextView) convertView.findViewById(R.id.handler_date);
            holder.pointLine = (TextView) convertView.findViewById(R.id.point_line);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        OaHandler data = list.get(position);
        holder.reply.setText(data.getReply());
        holder.handler.setText(data.getHandler());
        holder.handlerDate.setText(data.getHandlerDate());
        if (position == list.size()-1) {
            holder.pointLine.setVisibility(View.INVISIBLE);
        } else {
            holder.pointLine.setVisibility(View.VISIBLE);
        }
        return convertView;
    }
}