package com.wgmf.yxgj.module.business.reportproblem.ui;

import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.module.business.reportproblem.model.AOGWorkFlowInfo;
import com.wgmf.yxgj.module.business.reportproblem.model.ResultInfoEntity;
import com.wgmf.yxgj.module.business.reportproblem.service.ReportFeedbackService;
import com.wgmf.yxgj.widgets.PullToRefresh.PullToRefreshListView;
import com.xp.arouter.RouterParams;

import java.util.ArrayList;
import java.util.List;

@Route(path = RouterParams.URL_REPORTPROBLEMERRORQUERYACTIVITY)
public class ReportProblemErrorQueryActivity extends BaseParentAct implements OnClickListener, QueryProblemsErrorListAdapter.ClickListener {
    /**
     * 流程类型： 721到货误差，2181柜子，质量问题 2421，内部投诉2441，本机问题6，3721建议与意见
     */
    private String workFlowId = "";
    private ListView mListView;

    /**
     * 当前选择反馈处理状态位置
     */
    private  int position;

    /**
     * 下标集合
     */
    private List<TextView> textViews;

    /**
     * tab集合
     */
    private List<ImageView> imageViews;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_report_search);
        initTitle();
        initContent();
        initTab();
        initData();
        sendNet(0);
    }

    private void initData() {
        Long branchID = getIntent().getLongExtra("branchID", 0);
        if (branchID == 10066L) {
            workFlowId = "2421";
        } else if (branchID == 10067L) {
            workFlowId = "721";
        } else if (branchID == 10068L) {
            workFlowId = "2181";
        } else if (branchID == 10069L) {
            workFlowId = "2441";
        } else if (branchID == 10070L) {
            workFlowId = "6";
        } else if (branchID == 10071L) {
            workFlowId = "3721";
        }
    }

    private void initTab() {
        textViews.get(0).setTextColor(getResources().getColor(R.color.normal_color));
        imageViews.get(0).setVisibility(View.VISIBLE);
        imageViews.get(0).setImageResource(R.color.normal_color);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        String branchTitle = getIntent().getStringExtra("branchTitle");
        homeTitleText.setText(branchTitle);
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    private void initContent() {
        LinearLayout mReportSearchAll = (LinearLayout) findViewById(R.id.ll_report_search_all);
        LinearLayout mReportSearchNo = (LinearLayout) findViewById(R.id.ll_report_search_no);
        LinearLayout mReportSearchYes = (LinearLayout) findViewById(R.id.ll_report_search_yes);
        /*
         * 声明标题栏的tab
         */
        TextView mReportSearchAllTxt = (TextView) findViewById(R.id.report_search_all_txt);
        TextView mReportSearchNoTxt = (TextView) findViewById(R.id.report_search_no_txt);
        TextView mReportSearchYesTxt = (TextView) findViewById(R.id.report_search_yes_txt);
        mReportSearchAllTxt.setText("全部");
        mReportSearchNoTxt.setText("处理中");
        mReportSearchYesTxt.setText("已处理");
        /*
         * 标题栏的下标
         */
        ImageView mReportSearchAllImg = (ImageView) findViewById(R.id.report_search_all_img);
        ImageView mReportSearchNoImg = (ImageView) findViewById(R.id.report_search_no_img);
        ImageView mReportSearchYesImg = (ImageView) findViewById(R.id.report_search_yes_img);
        mReportSearchAll.setOnClickListener(this);
        mReportSearchNo.setOnClickListener(this);
        mReportSearchYes.setOnClickListener(this);
        // 装载控件到集合
        textViews = new ArrayList<>();
        textViews.add(mReportSearchAllTxt);
        textViews.add(mReportSearchNoTxt);
        textViews.add(mReportSearchYesTxt);
        imageViews = new ArrayList<>();
        imageViews.add(mReportSearchAllImg);
        imageViews.add(mReportSearchNoImg);
        imageViews.add(mReportSearchYesImg);

        PullToRefreshListView ptrlv = (PullToRefreshListView) findViewById(R.id.prsv);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        TextView dataEmpty = (TextView) findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        mListView.setVisibility(View.VISIBLE);
        ptrlv.setVisibility(View.GONE);
    }

    private void setData(List<ResultInfoEntity> resultInfo) {
        QueryProblemsErrorListAdapter  mAdapter = new QueryProblemsErrorListAdapter(resultInfo, ReportProblemErrorQueryActivity.this, ReportProblemErrorQueryActivity.this);
        mListView.setAdapter(mAdapter);
    }

    private void setSelectedItem(int position) {
        for (int i = 0; i < imageViews.size(); i++) {
            imageViews.get(i).setImageResource(R.color.black);
            textViews.get(i).setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            imageViews.get(position).setVisibility(View.GONE);
        }
        imageViews.get(position).setVisibility(View.VISIBLE);
        imageViews.get(position).setImageResource(R.color.normal_color);
        textViews.get(position).setTextColor(ContextCompat.getColor(this, R.color.normal_color));
        textViews.get(position).getPaint().setFakeBoldText(true);
    }

    private void sendNet(int type) {
        showDialog();
        String staffId = userInfo.getStaffId();
        ReportFeedbackService.getInstance().requestGetAOGWorkFlowInfo(staffId, type, workFlowId, 1,ReportProblemErrorQueryActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.ReportFeedback.MSG_ON_GET_AOGWORKFLOW_INFO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        AOGWorkFlowInfo mAOGWorkFlowInfo = new Gson().fromJson(msg, AOGWorkFlowInfo.class);
                        Log.d(TAG, "mAOGWorkFlowInfo=" + mAOGWorkFlowInfo);
                        List<ResultInfoEntity> resultInfoEntity = new ArrayList<>();
                        resultInfoEntity.clear();
                        if (null != mAOGWorkFlowInfo.getResultInfo() && !mAOGWorkFlowInfo.getResultInfo().isEmpty()) {
                            resultInfoEntity.addAll(mAOGWorkFlowInfo.getResultInfo());
                        } else {
                            showMsg(mAOGWorkFlowInfo.retInfo);
                        }
                        setData(resultInfoEntity);
                    } else {
                        if (!TextUtils.isEmpty(msg)) {
                            showMsg(result.getResultInfo());
                        }
                    }
                }
                break;
                case BusinessID.ReportFeedback.MSG_ON_SUBMIT_PJ: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        showMsg(mBaseResponse.retInfo);
                        sendNet(position);
                    } else {
                        showMsg(result.getResultInfo());
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    @Override
    public void onClick(View view) {
        if (view.getId() == R.id.ll_report_search_all) {
            position = 0;
            sendNet(position);
            this.setSelectedItem(position);
        } else if (view.getId() == R.id.ll_report_search_no) {
            position = 1;
            sendNet(position);
            this.setSelectedItem(position);
        } else if (view.getId() == R.id.ll_report_search_yes) {
            position = 2;
            sendNet(position);
            this.setSelectedItem(position);
        }
    }

    @Override
    public void queryProblemsAdapterClick(ResultInfoEntity resultinfoentity) {
        if (resultinfoentity.getPj() < 3 && "".equals(resultinfoentity.getPjContent())) {
            // 一星、二星必须填写建议后才能提交，三星、四星选填；
            showMsg("必须填写建议后才能提交!");
        } else {
            //提交评价
            showDialog();
            String staffId = userInfo.getStaffId();
            ReportFeedbackService.getInstance().requestSubmitPj(staffId, resultinfoentity.getId(), resultinfoentity.getProblemType(), resultinfoentity.getPj(), resultinfoentity.getPjContent(), ReportProblemErrorQueryActivity.this);
        }
    }
}