package com.wgmf.yxgj.module.business.reportproblem.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.github.yoojia.inputs.AndroidNextInputs;
import com.github.yoojia.inputs.StaticScheme;
import com.github.yoojia.inputs.ValueScheme;
import com.google.gson.Gson;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.yxgj.base.BaseCommonAdapter;
import com.wgmf.yxgj.base.ViewHolder;
import com.wgmf.yxgj.basewebview.ui.HtmlActivity;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.PublicEdtDialog;
import com.wgmf.yxgj.dialog.PublicTipDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.MediaParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.model.PickerModel;
import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.module.business.reportproblem.model.ProblemsUploadEntity;
import com.wgmf.yxgj.module.business.reportproblem.model.ProductListEntity;
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadDetailEntity;
import com.wgmf.yxgj.module.business.reportproblem.model.QualityUploadEntity;
import com.wgmf.yxgj.module.business.reportproblem.model.ReportErrorJsonEntity;
import com.wgmf.yxgj.module.business.reportproblem.service.ProblemsType;
import com.wgmf.yxgj.module.business.reportproblem.service.QualityType;
import com.wgmf.yxgj.module.business.reportproblem.service.ReportFeedbackService;
import com.wgmf.yxgj.pop.PickerPop;
import com.wgmf.yxgj.publics.model.BaseSelectorEntity;
import com.wgmf.yxgj.publics.ui.SelectorBaseActivity;
import com.wgmf.yxgj.report.ui.ReportBaseDetailActivity;
import com.wgmf.yxgj.utils.helper.DialogHelper;
import com.wgmf.yxgj.widgets.MMessageDisplay;
import com.xp.arouter.RouterCommonUtil;
import com.xp.arouter.RouterParams;
import com.xp.arouter.model.PCClass;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Random;

/**
 * 反馈直通车/总经理专线
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_REPORTPROBLEMSACTIVITY)
public class ReportProblemsActivity extends ReportBaseDetailActivity implements OnClickListener,
        ReportQuerySelectPop.ReportQuerySelectPopListener, ReportTypeELVSelectPop.ReportTypeSelectPopListener, PickerPop.PickerPopListener {
    /**
     * 选择门店 的返回
     */
    public static final int SELECT_STORE = 3;
    /**
     * 选择产品 的返回
     */
    public static final int SELECT_GOODS = 4;

    /**
     * 给Spinner提供的数据源
     */
    private String[] damageArray = new String[]{"--请选择--", "无破损", "有破损", "严重破损"};
    private String[] complArray = new String[]{"--请选择--", "完整", "不完整"};
    private String[] yesOrNoArray = new String[]{"--请选择--", "是", "否"};
    private String[] signArray = new String[]{"--请选择--", "已备注破损情况", "未备注破损情况"};

    private Long branchID;
    /**
     * 问题小类
     */
    private String cType = "";
    /**
     * 问题小类ID
     */
    private String cTypeId = "";
    /**
     * 问题大类
     */
    private String pType = "";
    /**
     * 问题大类ID
     */
    private String pTypeId = "";

    private ProductListEntity product;
    /**
     * 订单号
     */
    private String orderId;

    private String staffid;

    PickerPop pickerPop;
    ReportQuerySelectPop reportQuerySelectPop;
    ReportTypeELVSelectPop reportTypeELVSelectPop;

    PCClass mReportTypeResultBean;

    TextView reportStore;
    LinearLayout showStore;
    LinearLayout showProblemsType;

    View showLine;
    /**
     * 反馈类型
     */
    TextView reportTypeTv;
    EditText bociNumberInput;
    LinearLayout llBociNumber;
    TextView shouhuoDateShow;
    LinearLayout llShouhuoDate;
    EditText shouhuoPersonShow;
    LinearLayout llShouhuoPerson;
    EditText telephoneShow;
    LinearLayout llTelephoneShow;
    EditText yingshouNumInput;
    LinearLayout llYingshouNum;
    EditText shishouNumInput;
    LinearLayout llShishouNum;
    Spinner packingDamageSpinner;
    LinearLayout llPackingDamage;
    Spinner packingIdComplSpinner;
    LinearLayout llPackingIdCompl;
    Spinner llSignStateSpinner;
    LinearLayout llSignState;
    LinearLayout reportGoodsItemsContainer;
    LinearLayout goodsItemsContainer;
    LinearLayout reportError;
    TextView problemsGuiziNameTv;
    EditText problemsGuiziName;
    EditText problemsGuiziNumber;
    LinearLayout typeGuiziShow;
    TextView problemsTopic;
    LinearLayout typeTopicShow;
    EditText problemsUser;
    EditText problemsPhone;
    LinearLayout typeUserPhoneShow;
    LinearLayout typeDuchaShow;
    /**
     * 意见与建议主题类型
     */
    private int problemsTopicType;

    private TextView reportTypeTipsTv;
    /**
     * 缓存跳转到选择产品页面的TextView
     */
    private TextView selectGoodsView;
    /**
     * 缓存选择产品类型的TextView
     */
    private TextView selectGoodsTypeView;
    /**
     * 缓存选择产品数量的TextView
     */
    private TextView selectGoodsCountView;
    /**
     * 缓存选择产品日期的TextView
     */
    private TextView selectGoodsDateView;
    /**
     * 缓存选择产品日期后两位的TextView
     */
    private TextView selectGoodsDatePvView;

    final int TAG_KEY_UNIT = R.id.report_unit;//单位
    final int TAG_KEY_UNIT2 = R.id.report_unit2;//单位

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        fromTypeSelector();
    }

    @Override
    protected void back() {
        showBackTipDialog();
    }

    /**
     * 确认退出对话框
     */
    public void showBackTipDialog() {
        final PublicTipDialog.Builder builder = new PublicTipDialog.Builder(this);
        builder.setTitle("提示");
        builder.setMessage("确认退出？");
        builder.setNegativeButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
                ProblemsType.setpType(null);
                ProblemsType.setpTypeId(null);
                ProblemsType.setcType(null);
                ProblemsType.setcTypeId(null);
                ReportProblemsActivity.this.finish();
            }
        });
        builder.setPositiveButton("取消", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    @Override
    protected void initData() {
        super.initData();
        //问题上报
        reportType = "FK";
        //可以拍照和从相册中选择图片
        pickerMode = MediaParams.PARAMS_3;
        //最多上传5张图片
        mPicSize = 5;
        mPicDes = "最多只能上传" + mPicSize + "张图片!";
        //问题小类
        cType = ProblemsType.getcType();
        //问题小类ID
        cTypeId = ProblemsType.getcTypeId();
        //问题大类
        pType = ProblemsType.getpType();
        //问题大类ID
        pTypeId = ProblemsType.getpTypeId();
        //创建单号
        createOrderId();
    }


    @Override
    protected void initView() {
        super.initView();
        setContentView(R.layout.activity_report_feedback);
        showStore = (LinearLayout) findViewById(R.id.show_store);
        showProblemsType = (LinearLayout) findViewById(R.id.show_problems_type);
        reportError = (LinearLayout) findViewById(R.id.report_error);
        typeGuiziShow = (LinearLayout) findViewById(R.id.type_guizi_show);
        typeTopicShow = (LinearLayout) findViewById(R.id.type_topic_show);
        llBociNumber = (LinearLayout) findViewById(R.id.ll_boci_number);
        llShouhuoDate = (LinearLayout) findViewById(R.id.ll_shouhuo_date);
        llShouhuoPerson = (LinearLayout) findViewById(R.id.ll_shouhuo_person);
        llTelephoneShow = (LinearLayout) findViewById(R.id.ll_telephone_show);
        llYingshouNum = (LinearLayout) findViewById(R.id.ll_yingshou_num);
        llShishouNum = (LinearLayout) findViewById(R.id.ll_shishou_num);

        reportStore = (TextView) findViewById(R.id.report_store);
        showLine = findViewById(R.id.show_line);
        reportTypeTv = (TextView) findViewById(R.id.report_type_tv);

        bociNumberInput = (EditText) findViewById(R.id.boci_number_input);
        shouhuoDateShow = (TextView) findViewById(R.id.shouhuo_date_show);
        shouhuoPersonShow = (EditText) findViewById(R.id.shouhuo_person_show);
        telephoneShow = (EditText) findViewById(R.id.telephone_show);
        yingshouNumInput = (EditText) findViewById(R.id.yingshou_num_input);

        shishouNumInput = (EditText) findViewById(R.id.shishou_num_input);
        packingDamageSpinner = (Spinner) findViewById(R.id.packing_damage_spinner);
        llPackingDamage = (LinearLayout) findViewById(R.id.ll_packing_damage);
        packingIdComplSpinner = (Spinner) findViewById(R.id.packing_id_compl_spinner);
        llPackingIdCompl = (LinearLayout) findViewById(R.id.ll_packing_id_compl);
        llSignStateSpinner = (Spinner) findViewById(R.id.ll_sign_state_spinner);
        llSignState = (LinearLayout) findViewById(R.id.ll_sign_state);
        reportGoodsItemsContainer = (LinearLayout) findViewById(R.id.report_goods_items_container);
        goodsItemsContainer = (LinearLayout) findViewById(R.id.goods_items_container);
        problemsGuiziNameTv = (TextView) findViewById(R.id.problems_guizi_name_tv);
        problemsGuiziName = (EditText) findViewById(R.id.problems_guizi_name);
        problemsGuiziNumber = (EditText) findViewById(R.id.problems_guizi_number);
        problemsUser = (EditText) findViewById(R.id.problems_user);
        problemsPhone = (EditText) findViewById(R.id.problems_phone);
        typeUserPhoneShow = (LinearLayout) findViewById(R.id.type_user_phone_show);
        typeDuchaShow = (LinearLayout) findViewById(R.id.type_ducha_show);
        problemsTopic = (TextView) findViewById(R.id.problems_topic);
        reportTypeTipsTv = (TextView) findViewById(R.id.report_type_tips_tv);

        showStore.setOnClickListener(this);
        reportError.setOnClickListener(this);
        typeGuiziShow.setOnClickListener(this);
        problemsTopic.setOnClickListener(this);
        // 默认不弹出软键盘
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
    }

    /**
     * 来自问题类型选择列表页
     */
    private void fromTypeSelector() {
        try {
            pType = getIntent().getStringExtra("pType");
            pTypeId = getIntent().getStringExtra("pTypeId");
            reportTypeTv.setText(pType);
        } catch (Exception e1) {
            Log.e(TAG, "initContentView: not from selector type page");
        }
        try {
            boolean hasChilden = getIntent().getBooleanExtra("hasChilden", false);
            if (hasChilden) {
                cType = getIntent().getStringExtra("cType");
                cTypeId = getIntent().getStringExtra("cTypeId");
                reportTypeTv.setText(cType);
            }
        } catch (Exception e2) {
            Log.e(TAG, "initContentView: not from selector type page");
        }
        toDetail();
    }

    @Override
    protected void parseFootData() {
        super.parseFootData();
        showCursor(true);
    }

    @Override
    public void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchID = getIntent().getLongExtra("branchID", 0);
        homeTitleText.setText(branchTitle);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    /**
     * 根据类型上传数据
     */
    private void uploadDataByType() {
        switch (pType) {
            case QualityType.REPORT_TYPE_ZHILIANG:
                uploadQualityProblemsData();
                break;
            case QualityType.REPORT_TYPE_WUCHA:
                uploadErrorsProblemsData();
                break;
            case QualityType.REPORT_TYPE_GUIZI:
                uploadGuiZiProblemsData();
                break;
            case QualityType.REPORT_TYPE_DUCHA:
                uploadDuchaProblemsData();
                break;
            case QualityType.REPORT_TYPE_YIJIAN:
                uploadYiJianProblemsData();
                break;
            default:
                uploadReportProblemsDate();
                break;
        }
    }


    public void selectorStore() {
        Bundle mBundle = new Bundle();
        mBundle.putLong("branchID", branchID);
        mBundle.putString("branchTitle", branchTitle);
        RouterCommonUtil.startFunctionActivityResult(this, -2, branchID, mBundle, SELECT_STORE);
    }

    private void takePhone() {
        Intent intent = new Intent(ReportProblemsActivity.this,
                TelLogisticsActivity.class);
        startActivity(intent);
    }

    public void selectorGoods() {
        if (TextUtils.isEmpty(shopId)) {
            showMsg("请先选择一个门店");
            return;
        }
        Intent intent = new Intent(ReportProblemsActivity.this,
                SelectorProductsActivity.class);
        intent.putExtra("storeid", shopId);
        startActivityForResult(intent, SELECT_GOODS);
    }

    public void selectorGoods(View v) {
        selectGoodsView = (TextView) v;
        selectorGoods();
    }

    public void selectorCount(View v) {
        selectGoodsCountView = (TextView) v;
        showProEdtDialog();
    }

    /**
     * 显示输入产品数量对话框
     */
    private void showProEdtDialog() {
        if (product == null) {
            showMsg("请选择产品");
            return;
        }
        final PublicEdtDialog.Builder builder = new PublicEdtDialog.Builder(this);
        builder.setContent("数量");
        builder.setTitle("选择产品");
        builder.setContentVisibility(true);
        builder.setProUint(product.getName() + "【" + product.getProductUnit() + "】");
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.setNegativeButton(
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        selectGoodsCountView.setText("" + builder.getProNum());
                        dialog.dismiss();
                    }
                });
        builder.create().show();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case SELECT_STORE:
                if (resultCode == SelectorBaseActivity.RESULTCODE) {
                    try {
                        shopId = data
                                .getStringExtra("shopId");
                        String shopName = data
                                .getStringExtra("shopName");
                        reportStore.setText(shopName);
                        createOrderId();//创建单号
                    } catch (Exception e) {
                        Log.e(TAG, "onActivityResult: data.getStringExtra error ");
                    }
                }
                break;
            case SELECT_GOODS:
                if (resultCode == SelectorBaseActivity.RESULTCODE) {
                    product = (ProductListEntity) data
                            .getSerializableExtra(SelectorProductsActivity.activityResultData);
                    if (product != null) {
                        //如果是产品质量问题，就存起来。
                        if (selectGoodsView != null) {
                            //先在之前点击的组件上显示名字。
                            selectGoodsView.setText(product.getName());
                            selectGoodsView.setTag(product.getProductCode());
                            selectGoodsView.setTag(TAG_KEY_UNIT, product.getProductUnit());
                            if (pType.equals(QualityType.REPORT_TYPE_ZHILIANG)) {
                                refreshProductInfoShow();//刷新一下单位显示
                            } else if (pType.equals(QualityType.REPORT_TYPE_WUCHA)) {
                                selectGoodsView.setTag(TAG_KEY_UNIT2, product.getProductUnit());
                                refreshErrorInfoShow();//刷新一下单位显示
                            }
                        }
                    }
                }
                break;
            default:
                break;
        }
    }

    /**
     * 根据选择的产品，遍历所有元素，刷新一下产品信息显示
     * View view = .getChildAt(i);
     */
    private void refreshProductInfoShow() {
        int childNum = reportGoodsItemsContainer.getChildCount();
        for (int index = 0; index < childNum; index++) {
            ZhiLiangChildHolder child = (ZhiLiangChildHolder) reportGoodsItemsContainer.getChildAt(index).getTag();
            child.reportUnit.setText((String) child.reportGoods.getTag(TAG_KEY_UNIT));
        }
    }

    /**
     * 根据选择的产品，遍历所有元素，刷新一下产品信息显示
     * View view = .getChildAt(i);
     */
    private void refreshErrorInfoShow() {
        int childNum = goodsItemsContainer.getChildCount();
        for (int index = 0; index < childNum; index++) {
            WuChaChildHolder child = (WuChaChildHolder) goodsItemsContainer.getChildAt(index).getTag();
            child.reportUnit.setText((String) child.selectGoods.getTag(TAG_KEY_UNIT));
            child.reportUnit2.setText((String) child.selectGoods.getTag(TAG_KEY_UNIT2));
        }
    }

    /**
     * 单号在提交之前生成，提交失败则使用同一个单号，提交成功则生成新的订单号
     * 在此处生成的好处是:保证页面创建出来即生成一个订单号，页面销毁或提交成功返回再进入生成新的订单号
     * 缺点是：时间不是订单提交时间而是进入功能页面时间
     */
    private void createOrderId() {
        if (null != userInfo) {
            staffid = userInfo.getStaffId();
            orderId = (null == shopId ? "" : shopId) + staffid + DateUtil.getFormatCurrentDate("yyMMddHHmmss") + (new Random().nextInt(100));
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.show_store) {
            selectorStore();
        } else if (v.getId() == R.id.show_phone) {
            takePhone();
        } else if (v.getId() == R.id.problems_topic) {
            selectorTopic();
        } else if (v.getId() == R.id.report_goods) {
            selectorGoods();
        }  else if (v.getId() == R.id.shouhuo_date_show) {
            DialogHelper.AlertDatePicker(this, this, shouhuoDateShow);
        }
    }

    /**
     * 产品问题反馈-选择产品生产日期
     *
     * @param v 产品生产日期显示控件
     */
    public void selectorDate(View v) {
        selectGoodsDateView = (TextView) v;
        DialogHelper.AlertDatePicker(this, this, selectGoodsDateView);
    }

    /**
     * 选择生产日期后两位
     */
    public void selectorDatePv(View v) {
        selectGoodsDatePvView = (TextView) v;
        PickerModel pickerModel = new PickerModel();
        String[] minutes = new String[]{
                "A", "B", "C", "D", "E", "F", "G",
                "H", "I", "J", "K", "L", "M", "--", "N",
                "O", "P", "Q", "R", "S", "T",
                "U", "V", "W", "X", "Y", "Z"
        };
        String[] seconds = new String[]{"1", "--", "2"};

        List<String> listMinutes = new ArrayList<>();
        for (String minute : minutes) {
            listMinutes.add(minute);
            pickerModel.setMinutes(listMinutes);
        }
        List<String> listSeconds = new ArrayList<>();
        for (String second : seconds) {
            listSeconds.add(second);
            pickerModel.setSeconds(listSeconds);
        }
        if (null == pickerPop) {
            pickerPop = new PickerPop(this, this, pickerModel);
        }
        if (!pickerPop.isShowing()) {
            pickerPop.show(this.findViewById(R.id.title));
        }
    }

    /**
     * 选择破损类型
     */
    public void selectorDamageType(View v) {
        selectGoodsTypeView = (TextView) v;
        List<String> mFunctionName = new ArrayList<>();
        switch (cType) {
            case QualityType.REPORT_TYPE_ZHILIANG_1:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_1));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_2:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_2));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_3:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_3));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_4:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_4));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_5:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_5));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_6:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_6));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_7:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_7));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_8:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_8));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_9:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_9));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_10:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_10));
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_11:
                mFunctionName = Arrays.asList(getResources().getStringArray(R.array.problemsDamageType_11));
                break;
            default:
                break;
        }
        if (null == reportQuerySelectPop) {
            reportQuerySelectPop = new ReportQuerySelectPop(this, this, mFunctionName);
        }
        if (!reportQuerySelectPop.isShowing()) {
            reportQuerySelectPop.show(this.findViewById(R.id.title));
        }
    }

    @Override
    protected void uploadData() {
        super.uploadData();
        checkReportData();
    }

    private void checkReportData() {
        showDialog();
        if (TextUtils.isEmpty(reportTypeTv.getText().toString())) {
            showMsg("请选择问题类型");
            dismissDialog();
            return;
        }
        switch (pType) {
            case QualityType.REPORT_TYPE_ZHILIANG:
                if (!checkReportZhiLiang()) {
                    dismissDialog();
                    return;
                }
                if (!checkReportDate()) {
                    showMsg("生产日期必须是今日之前（不含今日）!");
                    dismissDialog();
                    return;
                }
                if (piclist == null || piclist.isEmpty()) {
                    showMsg("请选择上传图片");
                    dismissDialog();
                    return;
                }
                break;
            case QualityType.REPORT_TYPE_WUCHA:
                if (!checkReportError()) {
                    dismissDialog();
                    return;
                }
                if (piclist == null || piclist.isEmpty()) {
                    showMsg("请选择上传图片");
                    dismissDialog();
                    return;
                }
                break;
            case QualityType.REPORT_TYPE_GUIZI:
                if (!checkReportGuiZi()) {
                    dismissDialog();
                    return;
                }
                if (piclist == null || piclist.isEmpty()) {
                    showMsg("请选择上传图片");
                    dismissDialog();
                    return;
                }
                break;
            case QualityType.REPORT_TYPE_DUCHA:
                if (!checkReportDucha()) {
                    dismissDialog();
                    return;
                }
                break;
            case QualityType.REPORT_TYPE_YIJIAN:
                if (!checkReportYiJian()) {
                    dismissDialog();
                    return;
                }
                break;
            default:
                break;
        }
        uploadDataByType();
    }

    /**
     * 选择意见与建议主题类型
     */
    private void selectorTopic() {
        List<String> mFunctionName = Arrays.asList(getResources().getStringArray(
                R.array.problemsTopicType));
        if (null == reportQuerySelectPop) {
            reportQuerySelectPop = new ReportQuerySelectPop(this, this, mFunctionName);
        }
        if (!reportQuerySelectPop.isShowing()) {
            reportQuerySelectPop.show(this.findViewById(R.id.title));
        }
    }

    /**
     * 我要找督查
     */
    private void uploadDuchaProblemsData() {
        QualityUploadEntity entity = new QualityUploadEntity();
        entity.setDescription(reportEdit.getText().toString());
        entity.setMobile(problemsPhone.getText().toString());
        entity.setSubmiter(problemsUser.getText().toString());
        entity.setShopName(shopName);
        entity.setTitle(cType);
        entity.setThemeName(pType);

        if (null != qiniuUrlLists) {
            entity.setUrl(qiniuUrlLists);
        }
        String content = new Gson().toJson(entity);
        Log.d(TAG, content);
        ReportFeedbackService.getInstance().createComplaintWorkFlow(staffid, shopId, content, orderId, ReportProblemsActivity.this);
    }

    /**
     * 柜子问题上报
     */
    private void uploadGuiZiProblemsData() {
        QualityUploadEntity entity = new QualityUploadEntity();
        entity.setDescription(reportEdit.getText().toString());
        entity.setCabinetName(problemsGuiziName.getText().toString());
        entity.setCount(problemsGuiziNumber.getText().toString());
        entity.setMobile(problemsPhone.getText().toString());
        entity.setSubmiter(problemsUser.getText().toString());
        entity.setShopName(shopName);
        entity.setTitle(pType);

        if (null != qiniuUrlLists) {
            entity.setUrl(qiniuUrlLists);
        }
        String content = new Gson().toJson(entity);
        Log.d(TAG, content);
        ReportFeedbackService.getInstance().createCabinetWorkFlow(staffid, shopId, orderId, cTypeId, content, ReportProblemsActivity.this);
    }

    /**
     * 意见与建议上报
     */
    private void uploadYiJianProblemsData() {
        QualityUploadEntity entity = new QualityUploadEntity();
        entity.setDescription(reportEdit.getText().toString());
        entity.setMobile(problemsPhone.getText().toString());
        entity.setSubmiter(problemsUser.getText().toString());
        entity.setShopName(shopName);
        entity.setTitle(pType);
        entity.setThemeType(problemsTopicType);

        if (null != qiniuUrlLists) {
            entity.setUrl(qiniuUrlLists);
        }
        String content = new Gson().toJson(entity);
        Log.d(TAG, content);
        ReportFeedbackService.getInstance().createFeedbackWorkFlow(staffid, shopId, orderId, content, ReportProblemsActivity.this);
    }

    /**
     * 提交质量问题数据
     */
    private void uploadQualityProblemsData() {
        QualityUploadEntity entity = new QualityUploadEntity();
        entity.setDescription(reportEdit.getText().toString());
        entity.setMobile(problemsPhone.getText().toString());
        entity.setSubmiter(problemsUser.getText().toString());
        entity.setShopName(shopName);
        entity.setTitle(pType);
        entity.setThemeName(cType);

        if (null != qiniuUrlLists) {
            entity.setUrl(qiniuUrlLists);
        }
        //可扩展的表
        int num = reportGoodsItemsContainer.getChildCount();
        List<QualityUploadDetailEntity> details = new ArrayList<>();
        for (int i = 0; i < num; i++) {
            QualityUploadDetailEntity qualityUploadDetailEntity = new QualityUploadDetailEntity();
            View view = reportGoodsItemsContainer.getChildAt(i);
            ZhiLiangChildHolder holder = (ZhiLiangChildHolder) view.getTag();
            //产品名称
            qualityUploadDetailEntity.setProductName(holder.reportGoods.getText().toString());
            //产品类型
            qualityUploadDetailEntity.setSubCategory(holder.reportDamageTypesTv.getText().toString());
            //产品数量
            qualityUploadDetailEntity.setProductCount(holder.reportCount.getText().toString() + holder.reportUnit.getText().toString());
            //产品编码
            qualityUploadDetailEntity.setProductNo((String) holder.reportGoods.getTag());
            String reportDateStr = holder.reportDatePv.getText().toString();
            if ("无".equals(reportDateStr)) {
                reportDateStr = "xx";
            }
            //产品生产日期
            qualityUploadDetailEntity.setProductionDate(DateUtil.converToString(DateUtil.string2Date(holder.reportDate.getText().toString(), "yy-MM-dd")) + reportDateStr);
            details.add(qualityUploadDetailEntity);
        }
        entity.setDetails(details);
        String content = new Gson().toJson(entity);

        Log.d(TAG, content);
        ReportFeedbackService.getInstance().createQualityFBWorkFlow(staffid, shopId, content, orderId, ReportProblemsActivity.this);
    }

    /**
     * 提交到货误差数据
     */
    private void uploadErrorsProblemsData() {
        ReportErrorJsonEntity entity = new ReportErrorJsonEntity();
        //标题
        entity.setTitle(pType);
        if (null != qiniuUrlLists) {
            entity.setUrl(qiniuUrlLists);
        }
        //写死的表
        entity.getTb1().setMendmc(reportStore.getText().toString());
        entity.getTb1().setPeisbch(bociNumberInput.getText().toString());
        entity.getTb1().setShouhsj(shouhuoDateShow.getText().toString());
        entity.getTb1().setShouhrjlxfs(shouhuoPersonShow.getText().toString());
        entity.getTb1().setLianxfs(telephoneShow.getText().toString());
        entity.getTb1().setYingsjs(yingshouNumInput.getText().toString());
        entity.getTb1().setShisjs(shishouNumInput.getText().toString());
        entity.getTb1().setWaixbzpscd(packingDamageSpinner.getSelectedItemPosition() - 1);
        entity.getTb1().setWaixbssfwz(packingIdComplSpinner.getSelectedItemPosition() - 1);
        entity.getTb1().setWuldqsqk(llSignStateSpinner.getSelectedItemPosition() - 1);
        //可扩展的表
        int num = goodsItemsContainer.getChildCount();
        for (int i = 0; i < num; i++) {
            ReportErrorJsonEntity.Table2Item item = entity.new Table2Item();
            View view = goodsItemsContainer.getChildAt(i);
            WuChaChildHolder holder = (WuChaChildHolder) view.getTag();
            //产品名
            item.setChanpmc(holder.selectGoods.getText().toString());
            //货单数量
            item.setHuodsl(holder.huodan.getText().toString() + (String) holder.selectGoods.getTag(TAG_KEY_UNIT));
            //实收数量
            item.setShifsl(holder.shishou.getText().toString() + (String) holder.selectGoods.getTag(TAG_KEY_UNIT2));
            //短缺情况
            item.setDuanqqk(holder.duanque.getText().toString());
            //是否串货
            item.setShifch(holder.isChuanhao.getSelectedItemPosition() - 1);
            //外箱编码
            item.setWaixbh(holder.boxNum.getText().toString());
            //简短说明
            item.setJiandsm(holder.shuoming.getText().toString());
            //物料代码
            item.setWuldm((String) holder.selectGoods.getTag());
            entity.getTb2list().add(item);
        }
        String content = new Gson().toJson(entity);
        Log.d(TAG, content);
        ReportFeedbackService.getInstance().requestCreateAOGErrWorkFlow(staffid, shopId, content, orderId, ReportProblemsActivity.this);
    }

    /**
     * 生产日期是否为今日之前
     *
     * @return true ：生产日期是今日之前（不含今日）
     */
    private boolean checkReportDate() {
        if (null != selectGoodsDateView) {
            String producedDate = selectGoodsDateView.getText().toString();
            try {
                // 选中的日期
                Date date1 = DateUtil.string2Date(producedDate, "yyyy-MM-dd");
                // 今天
                Date date2 = DateUtil.string2Date(DateUtil.getFormatCurrentDate("yyyy-MM-dd"), "yyyy-MM-dd");
                //今日之前（不含今日）= 今天-选中日期大于0
                if (DateUtil.daysBetween(date1, date2) > 0) {
                    return true;
                }
            } catch (Exception e) {
                Log.e(TAG, "checkReportDate: ", e);
            }
        }
        return false;
    }

    /**
     * 提交问题上报数据
     */
    private void uploadReportProblemsDate() {
        if (null != userInfo) {
            ProblemsUploadEntity mProblemsUploadEntity = new ProblemsUploadEntity();
            mProblemsUploadEntity.setCode1(userInfo.getOrganizationCode());
            mProblemsUploadEntity.setShopId(shopId);
            mProblemsUploadEntity.setContent(reportEdit.getText().toString()
                    .trim());
            mProblemsUploadEntity
                    .setManagerUserId(userInfo.getStaffId());
            mProblemsUploadEntity.setProblemType(pTypeId + "");
            if (pTypeId.equals(ConstantParams.CONSTANT_PARAMS_2)) {
                mProblemsUploadEntity.setProblemQualityTypeId(cTypeId + "");
            }
            if (null != qiniuUrlLists) {
                mProblemsUploadEntity.setUrls(qiniuUrlLists);
            }
            String content = new Gson().toJson(mProblemsUploadEntity);
            Log.d(TAG, content);
            ReportFeedbackService.getInstance().requestSaveQuestion(content, ReportProblemsActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.ReportFeedback.MSG_ON_CREATE_CABINET_WORKFLOW:
                case BusinessID.ReportFeedback.MSG_ON_CREATE_COMPLAINT_WORKFLOW:
                case BusinessID.ReportFeedback.MSG_ON_CREATE_FEEDBACK_WORKFLOW:
                case BusinessID.ReportFeedback.MSG_ON_CREATE_QUALITY_FB_WORKFLOW:
                    //到货误差保存
                case BusinessID.ReportFeedback.MSG_ON_CREATE_AOGERR_WORKFLOW:
                case BusinessID.ReportFeedback.MSG_ON_QUESTION_SAVE_QUESTION: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        Log.d(TAG, "mBaseResponse=" + mBaseResponse.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode) || ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.msgCode)) {
                            cleanData();
                            ReportProblemsActivity.this.finish();
                        }
                    }
                    showMsg(result.getResultInfo());
                }
                break;
                default:
                    break;
            }
        }
    }

    private void cleanData() {
        reportStore.setText("");
        reportTypeTv.setText("");
        reportEdit.setText("");
        piclist.clear();
        refreshListView();
        reportPicAdapter = null;
    }

    /**
     * 初始化 到货误差 组件。
     */
    private void initReportErrorLayout() {
        //收发货日期。
        shouhuoDateShow.setText(DateUtil.format(new Date(), "yyyy-MM-dd"));
        shouhuoDateShow.setOnClickListener(this);
        //Spinner区
        packingDamageSpinner.setAdapter(setSpinnerData(damageArray));
        packingIdComplSpinner.setAdapter(setSpinnerData(complArray));
        llSignStateSpinner.setAdapter(setSpinnerData(signArray));
        if (userInfo != null) {
            shouhuoPersonShow.setText(userInfo.getName());
        }
    }

    @NonNull
    private BaseCommonAdapter<BaseSelectorEntity> setSpinnerData(String[] array) {
        List<BaseSelectorEntity> damageGroup = new ArrayList<>();
        for (int i = 0; i < array.length; i++) {
            BaseSelectorEntity baseSelectorEntity = new BaseSelectorEntity();
            baseSelectorEntity.setSelectorName(array[i]);
            baseSelectorEntity.setSelectorId(i + "");
            damageGroup.add(baseSelectorEntity);
        }
        return new BaseCommonAdapter<BaseSelectorEntity>(
                this, damageGroup) {
            @Override
            public void convert(ViewHolder helper, BaseSelectorEntity item) {
                helper.setText(item.getSelectorName());
                helper.setRightGone(View.GONE);
            }
        };
    }

    @Override
    public void onAdapterItemClick(int position, List<String> mFunctionName) {
        if (QualityType.REPORT_TYPE_ZHILIANG.equals(pType)) {
            if (null != selectGoodsTypeView) {
                selectGoodsTypeView.setText(mFunctionName.get(position));
            }
        } else if (QualityType.REPORT_TYPE_YIJIAN.equals(pType)) {
            problemsTopicType = position;
            problemsTopic.setText(mFunctionName.get(position));
        }
    }

    @Override
    public void onTypeAdapterGroupClick(int groupPosition) {
        try {
            if (null == mReportTypeResultBean.getResultList().get(groupPosition).getResultList()) {
                reportTypeELVSelectPop.dismiss();
                pType = mReportTypeResultBean.getResultList().get(groupPosition).getName();
                pTypeId = mReportTypeResultBean.getResultList().get(groupPosition).getSid() + "";
                reportTypeTv.setText(pType);
                toDetail();
            }
        } catch (Exception e) {
            Log.e(TAG, "onTypeAdapterGroupClick: ");
        }
    }

    @Override
    public void onTypeAdapterChildClick(int groupPosition, int childPosition) {
        pType = mReportTypeResultBean.getResultList().get(groupPosition).getName();
        pTypeId = mReportTypeResultBean.getResultList().get(groupPosition).getSid() + "";
        cType = mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getName();
        cTypeId = mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getSid() + "";
        reportTypeTv.setText(cType);
        toDetail();
    }

    @Override
    public void cancelPickerPop() {
        if (null != selectGoodsDatePvView) {
            selectGoodsDatePvView.setText("无");
        }
    }

    @Override
    public void comfirmPickerPop(String value) {
        if (null != selectGoodsDatePvView) {
            selectGoodsDatePvView.setText(value);
        }
    }

    /**
     * 到货误差  添加子组件。
     * pos  添加到哪个位置。
     */
    private void addWuChaChildToLayout(int pos) {
        final WuChaChildHolder holder = new WuChaChildHolder();
        LinearLayout child = (LinearLayout) getLayoutInflater().inflate(R.layout.goods_item, null);

        holder.selectGoods = (TextView) child.findViewById(R.id.select_goods);
        holder.addBtn = (ImageButton) child.findViewById(R.id.add_goods_item);
        holder.removeBtn = (ImageButton) child.findViewById(R.id.remove_goods_item);
        holder.huodan = (EditText) child.findViewById(R.id.huodan_num_input);
        holder.shishou = (EditText) child.findViewById(R.id.shishou_num_item);
        holder.reportUnit = (TextView) child.findViewById(R.id.report_unit);
        holder.reportUnit2 = (TextView) child.findViewById(R.id.report_unit2);
        holder.duanque = (EditText) child.findViewById(R.id.duanque_input);
        holder.isChuanhao = (Spinner) child.findViewById(R.id.is_chuanhao_spinner);
        holder.boxNum = (EditText) child.findViewById(R.id.box_num_input);
        holder.shuoming = (EditText) child.findViewById(R.id.short_shuoming);

        holder.isChuanhao.setAdapter(setSpinnerData(yesOrNoArray));
        //增删按钮保存其所在的ChildView，到时候点击时就可以直接吊出来remove了。
        holder.addBtn.setTag(child);
        holder.removeBtn.setTag(child);
        child.setTag(holder);
        holder.removeBtn.setImageResource(
                goodsItemsContainer.getChildCount() == 0 ? R.drawable.feedback_minus2 : R.drawable.feedback_minus1);

        /*增加子组件按钮*/
        holder.addBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                //当前点击按钮所在元素的位置。
                int pos = goodsItemsContainer.indexOfChild((LinearLayout) view.getTag());
                int childCount = goodsItemsContainer.getChildCount();
                //如果是第一个元素的按钮。点了之后要把自己的删除按钮也置彩色。
                if (pos == 0 && childCount == 1) {
                    ((WuChaChildHolder) goodsItemsContainer.getChildAt(0).getTag()).removeBtn.setImageResource(R.drawable.feedback_minus1);
                }

                addWuChaChildToLayout(pos + 1);
            }
        });
        /*删除子组件按钮*/
        holder.removeBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                int childCount = goodsItemsContainer.getChildCount();
                if (childCount > 1) {
                    //多于1个才删除当前ChildView。
                    goodsItemsContainer.removeView((LinearLayout) holder.addBtn.getTag());
                }
                if (childCount == 2) {
                    //如果点击的时候已经只剩两个了，那就把仅剩的最后一个的删除按钮置灰。
                    ((WuChaChildHolder) goodsItemsContainer.getChildAt(0).getTag()).removeBtn.setImageResource(R.drawable.feedback_minus2);
                }
            }
        });

        goodsItemsContainer.addView(child, pos);
    }

    /**
     * 产品质量问题  添加子组件。
     * pos  添加到哪个位置。
     */
    private void addZhiLiangChildToLayout(int pos) {
        final ZhiLiangChildHolder holder = new ZhiLiangChildHolder();
        LinearLayout child = (LinearLayout) getLayoutInflater().inflate(R.layout.ll_qback_report_goods_show, null);
        holder.reportGoods = (TextView) child.findViewById(R.id.report_goods);
        holder.reportDamageTypesTv = (TextView) child.findViewById(R.id.report_damage_types_tv);
        holder.reportCount = (TextView) child.findViewById(R.id.report_count);
        holder.reportUnit = (TextView) child.findViewById(R.id.report_unit);
        holder.reportDate = (TextView) child.findViewById(R.id.report_date);
        holder.reportDatePv = (TextView) child.findViewById(R.id.report_date_pv);
        holder.addBtn = (ImageButton) child.findViewById(R.id.add_goods_item);
        holder.removeBtn = (ImageButton) child.findViewById(R.id.remove_goods_item);
        holder.reportDamageTypesLl = (LinearLayout) child.findViewById(R.id.report_damage_types_ll);
        //增删按钮保存其所在的ChildView，到时候点击时就可以直接吊出来remove了。
        holder.addBtn.setTag(child);
        holder.removeBtn.setTag(child);
        child.setTag(holder);
        holder.removeBtn.setImageResource(reportGoodsItemsContainer.getChildCount() == 0 ? R.drawable.feedback_minus2 : R.drawable.feedback_minus1);
        holder.reportDamageTypesLl.setVisibility(View.VISIBLE);
        if (TextUtils.isEmpty(holder.reportGoods.getText().toString())) {
            product = null;
        }
        /*增加子组件按钮*/
        holder.addBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                //当前点击按钮所在元素的位置。
                int pos = reportGoodsItemsContainer.indexOfChild((LinearLayout) view.getTag());
                int childCount = reportGoodsItemsContainer.getChildCount();
                //如果是第一个元素的按钮。点了之后要把自己的删除按钮也置彩色。
                if (pos == 0 && childCount == 1) {
                    ((ZhiLiangChildHolder) reportGoodsItemsContainer.getChildAt(0).getTag()).removeBtn.setImageResource(R.drawable.feedback_minus1);
                }
                addZhiLiangChildToLayout(pos + 1);
            }
        });
        /*删除子组件按钮*/
        holder.removeBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                int childCount = reportGoodsItemsContainer.getChildCount();
                if (childCount > 1) {
                    //多于1个才删除当前ChildView。
                    reportGoodsItemsContainer.removeView((LinearLayout) holder.addBtn.getTag());
                }
                if (childCount == 2) {
                    //如果点击的时候已经只剩两个了，那就把仅剩的最后一个的删除按钮置灰。
                    ((ZhiLiangChildHolder) reportGoodsItemsContainer.getChildAt(0).getTag()).removeBtn.setImageResource(R.drawable.feedback_minus2);
                }
            }
        });
        reportGoodsItemsContainer.addView(child, pos);
    }

    /**
     * 跳转到相应上报页面
     */
    private void toDetail() {
        if (userInfo != null) {
            problemsUser.setText(userInfo.getName());
        }
        reportError.setVisibility(View.GONE);
        typeGuiziShow.setVisibility(View.GONE);
        typeTopicShow.setVisibility(View.GONE);
        typeUserPhoneShow.setVisibility(View.GONE);
        typeDuchaShow.setVisibility(View.GONE);
        showStore.setVisibility(View.VISIBLE);
        reportEdit.setVisibility(View.VISIBLE);
        publicTakePhotoLl.setVisibility(View.VISIBLE);
        reportContentComfirmLl.setVisibility(View.VISIBLE);
        showParentType();
    }

    /**
     * 显示一级类型
     */
    private void showParentType() {
        switch (pType) {
            case QualityType.REPORT_TYPE_ZHILIANG:
                typeUserPhoneShow.setVisibility(View.VISIBLE);
                //如果填充的goods_item为0，说明是第一次显示产品质量问题的layout，那就要构造并初始化，然后添加一个ChildItem。
                if (reportGoodsItemsContainer.getChildCount() == 0) {
                    addZhiLiangChildToLayout(0);
                }
                product = null;
                showChildType();
                break;
            case QualityType.REPORT_TYPE_WUCHA:
                reportError.setVisibility(View.VISIBLE);
                //如果填充的goods_item为0，说明是第一次显示到货误差的layout，那就要构造并初始化，然后添加一个ChildItem。
                if (goodsItemsContainer.getChildCount() == 0) {
                    initReportErrorLayout();
                    addWuChaChildToLayout(0);
                }
                reportEdit.setVisibility(View.GONE);
                product = null;
                break;
            case QualityType.REPORT_TYPE_GUIZI:
                typeGuiziShow.setVisibility(View.VISIBLE);
                typeUserPhoneShow.setVisibility(View.VISIBLE);
                if (ConstantParams.CONSTANT_PARAMS_2.equals(cTypeId)) {
                    problemsGuiziNameTv.setText(R.string.problems_wuliao_name);
                } else {
                    problemsGuiziNameTv.setText(R.string.problems_guizi_name);
                }
                break;
            case QualityType.REPORT_TYPE_WULIU:
                Intent intent = new Intent(ReportProblemsActivity.this,
                        TelLogisticsActivity.class);
                startActivity(intent);
                ReportProblemsActivity.this.finish();
                break;
            case QualityType.REPORT_TYPE_YIJIAN:
                typeUserPhoneShow.setVisibility(View.VISIBLE);
                typeTopicShow.setVisibility(View.VISIBLE);
                break;
            case QualityType.REPORT_TYPE_DUCHA:
                reportEdit.setVisibility(View.GONE);
                publicTakePhotoLl.setVisibility(View.GONE);
                reportContentComfirmLl.setVisibility(View.GONE);
                typeUserPhoneShow.setVisibility(View.VISIBLE);
                reportEdit.setVisibility(View.VISIBLE);
                publicTakePhotoLl.setVisibility(View.VISIBLE);
                reportContentComfirmLl.setVisibility(View.VISIBLE);
                showChildType();
                break;
            case QualityType.REPORT_TYPE_BENJI:
                showStore.setVisibility(View.GONE);
                showChildType();
                break;
            default:
                break;
        }
    }

    /**
     * 显示一级类型
     */
    private void showChildType() {
        reportTypeTipsTv.setVisibility(View.GONE);
        switch (cType) {
            case QualityType.REPORT_TYPE_ZHILIANG_1:
                reportTypeTipsTv.setVisibility(View.VISIBLE);
                reportEdit.setHint(R.string.report_type_zhiliang_1);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_2:
                reportTypeTipsTv.setVisibility(View.VISIBLE);
                reportEdit.setHint(R.string.report_type_zhiliang_2);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_3:
                reportEdit.setHint(R.string.report_type_zhiliang_3);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_4:
                reportEdit.setHint(R.string.report_type_zhiliang_4);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_5:
                reportEdit.setHint(R.string.report_type_zhiliang_5);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_6:
                reportEdit.setHint(R.string.report_type_zhiliang_6);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_7:
                reportEdit.setHint(R.string.report_type_zhiliang_7);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_8:
                reportEdit.setHint(R.string.report_type_zhiliang_8);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_9:
                reportEdit.setHint(R.string.report_type_zhiliang_9);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_10:
                reportEdit.setHint(R.string.report_type_zhiliang_10);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_11:
                reportEdit.setHint(R.string.report_type_zhiliang_11);
                break;
            case QualityType.REPORT_TYPE_ZHILIANG_12:
                //突发事件处理
                toHtml(branchTitle, NetworkParams.PROBLEM_CALL, branchID);
                break;
            case QualityType.REPORT_TYPE_DUCHA_2:
                //打电话投诉
                toHtml(branchTitle, NetworkParams.TELEPHONE_COMPLAINT, branchID);
                break;
            case QualityType.REPORT_TYPE_DUCHA_3:
                //发微信投诉
                toHtml(branchTitle, NetworkParams.WEBCHAT_COMPLAINT, branchID);
                break;
            case QualityType.REPORT_TYPE_BENJI_2:
                //紧急问题处理
                toHtml(branchTitle, NetworkParams.EMERGENCY_CALL, branchID);
                break;
            default:
                break;
        }
    }

    /**
     * 跳转到Html页面
     *
     * @param branchTitle 页面标题
     * @param branchUrl   页面地址
     * @param branchID    功能ID
     */
    private void toHtml(String branchTitle, String branchUrl, long branchID) {
        Intent intent = new Intent(ReportProblemsActivity.this, HtmlActivity.class);
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("branchUrl", branchUrl);
        intent.putExtra("branchID", branchID);
        startActivity(intent);
        ReportProblemsActivity.this.finish();
    }

    /**
     * 到货误差数据校验
     *
     * @return 是否通过
     */
    private boolean checkReportError() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(reportStore, StaticScheme.Required());
        inputs.add(bociNumberInput, StaticScheme.Required());
        inputs.add(shouhuoPersonShow, StaticScheme.Required());
        inputs.add(telephoneShow, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(yingshouNumInput, StaticScheme.Required());
        inputs.add(shishouNumInput, StaticScheme.Required());

        int childNum = goodsItemsContainer.getChildCount();

        for (int i = 0; i < childNum; i++) {
            View view = goodsItemsContainer.getChildAt(i);
            if (((WuChaChildHolder) view.getTag()).isChuanhao.getSelectedItemPosition() == 0) {
                showMsg("请选择 是否串号");
                return false;
            }
            inputs.add(((WuChaChildHolder) view.getTag()).selectGoods, ValueScheme.NotEquals("请选择产品").msgOnFail("未选择产品"));
            inputs.add(((WuChaChildHolder) view.getTag()).huodan, StaticScheme.Required());
            inputs.add(((WuChaChildHolder) view.getTag()).shishou, StaticScheme.Required());
            inputs.add(((WuChaChildHolder) view.getTag()).duanque, StaticScheme.Required());
            inputs.add(((WuChaChildHolder) view.getTag()).boxNum, StaticScheme.Required());
            inputs.add(((WuChaChildHolder) view.getTag()).shuoming, StaticScheme.Required());
        }

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    /**
     * 质量问题数据校验
     *
     * @return 是否通过
     */
    private boolean checkReportZhiLiang() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(reportStore, StaticScheme.Required());
        inputs.add(problemsUser, StaticScheme.Required());
        inputs.add(problemsPhone, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(reportEdit, StaticScheme.Required());
        int childNum = goodsItemsContainer.getChildCount();

        for (int i = 0; i < childNum; i++) {
            View view = reportGoodsItemsContainer.getChildAt(i);
            inputs.add(((ZhiLiangChildHolder) view.getTag()).reportGoods, ValueScheme.NotEquals("请选择产品").msgOnFail("未选择产品"));
            inputs.add(((ZhiLiangChildHolder) view.getTag()).reportCount, StaticScheme.Required(), StaticScheme.Numeric());
            inputs.add(((ZhiLiangChildHolder) view.getTag()).reportDate, StaticScheme.Required());
            inputs.add(((ZhiLiangChildHolder) view.getTag()).reportDatePv, StaticScheme.Required());
        }
        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    /**
     * 柜子问题数据校验
     *
     * @return 是否通过
     */
    private boolean checkReportGuiZi() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(reportStore, StaticScheme.Required());
        inputs.add(problemsGuiziName, StaticScheme.Required());
        inputs.add(problemsGuiziNumber, StaticScheme.Required(), StaticScheme.Numeric());
        inputs.add(problemsUser, StaticScheme.Required());
        inputs.add(problemsPhone, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(reportEdit, StaticScheme.Required());

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    /**
     * 找督察数据校验
     *
     * @return 是否通过
     */
    private boolean checkReportDucha() {
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(problemsUser, StaticScheme.Required());
        inputs.add(problemsPhone, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(reportEdit, StaticScheme.Required());

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    /**
     * 意见与建议校验
     *
     * @return 是否通过
     */
    private boolean checkReportYiJian() {
        //校验框架
        final AndroidNextInputs inputs = new AndroidNextInputs();
        inputs.add(problemsTopic, StaticScheme.Required(), ValueScheme.NotEquals("请选择").msgOnFail("未选择主题类型"));
        inputs.add(problemsUser, StaticScheme.Required());
        inputs.add(problemsPhone, StaticScheme.Required(), StaticScheme.ChineseMobile());
        inputs.add(reportEdit, StaticScheme.Required());

        MMessageDisplay messageDisplay = new MMessageDisplay();
        inputs.setMessageDisplay(messageDisplay);

        if (inputs.test()) {
            // 校验通过
            inputs.clear();
            return true;
        } else {
            showMsg("填写有误，请检查");
            inputs.clear();
            return false;
        }
    }

    @Override
    public void onDestroy() {
        ProblemsType.setpType(null);
        ProblemsType.setpTypeId(null);
        ProblemsType.setcType(null);
        ProblemsType.setcTypeId(null);
        super.onDestroy();
    }
}