package com.wgmf.yxgj.module.business.reportproblem.ui;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportproblem.R;
import com.xp.arouter.model.PCClass;

/**
 * 上报反馈类型选择
 * 作者：xiep on 2017/3/1 09:37
 * 邮箱：2975837870@qq.com
 */

class ReportTypeELVSelectPop implements View.OnClickListener, ExpandableListView.OnChildClickListener, ExpandableListView.OnGroupClickListener {

    private PopupWindow reportQuerySelectPw;

    private View viewParent;

    private ReportTypeListAdapter typeAdapter;

    private ReportTypeSelectPopListener reportTypeSelectPopListener;

    private ExpandableListView problemsTypeElv;

    @Override
    public boolean onChildClick(ExpandableListView expandableListView, View view, int i, int i1, long l) {
        dismiss();
        reportTypeSelectPopListener.onTypeAdapterChildClick(i, i1);
        return false;
    }

    @Override
    public boolean onGroupClick(ExpandableListView expandableListView, View view, int i, long l) {
        reportTypeSelectPopListener.onTypeAdapterGroupClick(i);
        return false;
    }

    public interface ReportTypeSelectPopListener {

        void onTypeAdapterGroupClick(int groupPosition);

        void onTypeAdapterChildClick(int groupPosition, int childPosition);

    }

    public ReportTypeELVSelectPop(final Context context, PCClass mReportTypeResultBean, ReportTypeSelectPopListener reportTypeSelectPopListener) {
        this(context, WindowManager.LayoutParams.MATCH_PARENT, WindowManager.LayoutParams.MATCH_PARENT, mReportTypeResultBean, reportTypeSelectPopListener);
    }

    private ReportTypeELVSelectPop(final Context context, final int width, final int height, PCClass mReportTypeResultBean, ReportTypeSelectPopListener reportTypeSelectPopListener) {
        this.reportTypeSelectPopListener = reportTypeSelectPopListener;

        LayoutInflater inflater = LayoutInflater.from(context);
        viewParent = inflater.inflate(R.layout.view_problems_type_pop, null);

        problemsTypeElv = (ExpandableListView) viewParent.findViewById(R.id.problems_type_elv);
        TextView shopProductHistoryEmptyTv = (TextView) viewParent.findViewById(R.id.shop_history_empty_tv);
        problemsTypeElv.setEmptyView(shopProductHistoryEmptyTv);
        LinearLayout shopHistoryDialogCancelLl = (LinearLayout) viewParent.findViewById(R.id.shop_history_ll);
        ImageView shopHistoryDialogCancelIv = (ImageView) viewParent.findViewById(R.id.shop_history_dialog_cancel_iv);

        typeAdapter = new ReportTypeListAdapter(context, mReportTypeResultBean);
        problemsTypeElv.setAdapter(typeAdapter);

        reportQuerySelectPw = new PopupWindow(viewParent, width, height, true);
        shopHistoryDialogCancelLl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        shopHistoryDialogCancelIv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reportQuerySelectPw.dismiss();
            }
        });
        problemsTypeElv.setOnGroupClickListener(this);
        problemsTypeElv.setOnChildClickListener(this);
//        setListViewHeight(problemsTypeElv);
    }

    public boolean isShowing() {
        return null != reportQuerySelectPw && reportQuerySelectPw.isShowing();
    }

    public void show(View parent) {
        if (null == parent) {
            throw new IllegalArgumentException("StoreDateSelectorPop.showAtLocation parent is null");
        }
        viewParent = parent;
        reportQuerySelectPw.showAtLocation(parent, Gravity.CENTER, 0, 0);
    }

    public void dismiss() {
        if (null != reportQuerySelectPw && reportQuerySelectPw.isShowing()) {
            reportQuerySelectPw.dismiss();
        }
    }

    public void notifyData() {
        if (null != reportQuerySelectPw && reportQuerySelectPw.isShowing()) {
            typeAdapter.notifyDataSetChanged();
        }
        setListViewHeight(problemsTypeElv);
    }

    @Override
    public void onClick(View view) {
        dismiss();
    }


    private void setListViewHeight(ListView listView) {

        ListAdapter listAdapter = listView.getAdapter();

        if (listAdapter == null) {
            return;
        }
        int totalHeight = 0;
        for (int i = 0, len = listAdapter.getCount(); i < len; i++) {
            View listItem = listAdapter.getView(i, null, listView);
            listItem.measure(0, 0);
            totalHeight += listItem.getMeasuredHeight();
        }
        ViewGroup.LayoutParams params = listView.getLayoutParams();
        params.height = totalHeight
                + (listView.getDividerHeight() * (listAdapter.getCount() - 1));
        listView.setLayoutParams(params);
    }
}
