package com.wgmf.yxgj.module.business.reportproblem.ui;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.TextView;

import com.wgmf.yxgj.module.business.reportproblem.R;
import com.xp.arouter.model.PCClass;

/**
 * 作者：dell on 2017/3/23 17:09
 * 邮箱：2975837870@qq.com
 */

class ReportTypeListAdapter extends BaseExpandableListAdapter {
    private Context context;
    private PCClass mReportTypeResultBean;

    ReportTypeListAdapter(Context context, PCClass mReportTypeResultBean) {
        this.context = context;
        this.mReportTypeResultBean = mReportTypeResultBean;
    }

    @Override
    public int getGroupCount() {
        return mReportTypeResultBean.getResultList() != null ? mReportTypeResultBean.getResultList().size() : 0;
    }

    @Override
    public int getChildrenCount(int i) {
        return mReportTypeResultBean.getResultList().get(i).getResultList() != null ? mReportTypeResultBean.getResultList().get(i).getResultList().size() : 0;
    }

    @Override
    public Object getGroup(int i) {
        return mReportTypeResultBean.getResultList();
    }

    @Override
    public Object getChild(int i, int i1) {
        return mReportTypeResultBean.getResultList().get(i).getResultList();
    }

    @Override
    public long getGroupId(int i) {
        return i;
    }

    @Override
    public long getChildId(int i, int i1) {
        return i1;
    }

    @Override
    public boolean hasStableIds() {
        return false;
    }

    @Override
    public View getGroupView(int i, boolean b, View convertView, ViewGroup viewGroup) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.report_type_listview_group_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView
                    .findViewById(R.id.report_type);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        viewHolder.name.setText(mReportTypeResultBean.getResultList().get(i).getName());
        return convertView;
    }

    @Override
    public View getChildView(int i, int i1, boolean b, View convertView, ViewGroup viewGroup) {
        final ViewHolder viewHolder;
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(
                    R.layout.report_type_listview_child_item, null);
            viewHolder = new ViewHolder();
            viewHolder.name = (TextView) convertView
                    .findViewById(R.id.report_type);
            convertView.setTag(viewHolder);
        } else {
            viewHolder = (ViewHolder) convertView.getTag();
        }
        viewHolder.name.setText(mReportTypeResultBean.getResultList().get(i).getResultList().get(i1).getName());
        return convertView;
    }

    @Override
    public boolean isChildSelectable(int i, int i1) {
        return true;
    }

    class ViewHolder {
        TextView name;
    }
}
