package com.wgmf.yxgj.module.business.reportproblem.ui;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ExpandableListView;
import android.widget.ImageView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.google.gson.Gson;
import com.wgmf.library.utils.AssetsUtil;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.module.business.reportproblem.R;
import com.xp.arouter.model.PCClass;
import com.wgmf.yxgj.module.business.reportproblem.service.ProblemsType;
import com.xp.arouter.RouterParams;

import java.util.Arrays;
import java.util.List;

/**
 * 反馈直通车：选择反馈类型列表
 */
@Route(path = RouterParams.URL_SELECTORPROBLEMTYPEACTIVITY)
public class SelectorProblemTypeActivity extends BaseParentAct implements ReportQuerySelectPop.ReportQuerySelectPopListener, ExpandableListView.OnChildClickListener, ExpandableListView.OnGroupClickListener {

    private ReportQuerySelectPop reportQuerySelectPop;

    private PCClass mReportTypeResultBean;

    @Override
    public boolean onChildClick(ExpandableListView expandableListView, View view, int groupPosition, int childPosition, long l) {
        ProblemsType.setpType(mReportTypeResultBean.getResultList().get(groupPosition).getName());
        ProblemsType.setpTypeId(mReportTypeResultBean.getResultList().get(groupPosition).getSid() + "");
        ProblemsType.setcType(mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getName());
        ProblemsType.setcTypeId(mReportTypeResultBean.getResultList().get(groupPosition).getResultList().get(childPosition).getSid() + "");
        ProblemsType.setHasChilden(true);
        toDetail();
        return false;
    }

    @Override
    public boolean onGroupClick(ExpandableListView expandableListView, View view, int groupPosition, long l) {
        try {
            if (null == mReportTypeResultBean.getResultList().get(groupPosition).getResultList()) {
                ProblemsType.setpType(mReportTypeResultBean.getResultList().get(groupPosition).getName());
                ProblemsType.setpTypeId(mReportTypeResultBean.getResultList().get(groupPosition).getSid() + "");
               ProblemsType.setHasChilden(false);
                toDetail();
            }
        } catch (Exception e) {
            Log.e(TAG, "onTypeAdapterGroupClick: ");
        }
        return false;
    }

    private void toDetail() {
        Intent intent = new Intent();
        intent.putExtra("cType", ProblemsType.getcType());
        intent.putExtra("cTypeId", ProblemsType.getcTypeId());
        intent.putExtra("pType", ProblemsType.getpType());
        intent.putExtra("pTypeId", ProblemsType.getpTypeId());
        intent.putExtra("hasChilden", ProblemsType.isHasChilden());
        intent.putExtra("branchID", 66L);
        intent.putExtra("branchTitle", "反馈直通车");
        intent.setClass(this, ReportProblemsActivity.class);
        startActivity(intent);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_selector_problem_type);

        initTitle();

        ExpandableListView problemsTypeElv = (ExpandableListView) findViewById(R.id.problems_type_elv);
        TextView shopProductHistoryEmptyTv = (TextView) findViewById(R.id.shop_history_empty_tv);
        problemsTypeElv.setEmptyView(shopProductHistoryEmptyTv);
        ImageView shopHistoryDialogCancelIv = (ImageView) findViewById(R.id.shop_history_dialog_cancel_iv);
        shopHistoryDialogCancelIv.setVisibility(View.GONE);

        String msg = AssetsUtil.getFromAssets(this, "ReportListVIewData.json");
        mReportTypeResultBean = new Gson().fromJson(msg, PCClass.class);
        ReportTypeListAdapter typeAdapter = new ReportTypeListAdapter(this, mReportTypeResultBean);
        problemsTypeElv.setAdapter(typeAdapter);
        problemsTypeElv.setOnGroupClickListener(this);
        problemsTypeElv.setOnChildClickListener(this);
    }

    @Override
    protected void initTitle() {
        super.initTitle();
        homeTitleText.setText("选择反馈类型");
        homeTitleMore.setText("结果");
        homeTitleMoreLl.setVisibility(View.VISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    @Override
    protected void more() {
        super.more();
        //弹出结果查询选择框
        showProblemQuerySelect();
    }

    private void showProblemQuerySelect() {
        List<String> mFunctionName = Arrays.asList(getResources().getStringArray(
                R.array.problemQueryType));
        if (null == reportQuerySelectPop) {
            reportQuerySelectPop = new ReportQuerySelectPop(this, this, mFunctionName);
        }
        if (!reportQuerySelectPop.isShowing()) {
            reportQuerySelectPop.show(this.findViewById(R.id.title));
        }
    }

    @Override
    public void onAdapterItemClick(int position, List<String> mFunctionName) {
        Intent intent = new Intent();
        intent.putExtra("branchID", 66L + (position + 10000));
        intent.putExtra("branchTitle", mFunctionName.get(position));
        intent.setClass(this, ReportProblemErrorQueryActivity.class);
        startActivity(intent);
    }
}