package com.wgmf.yxgj.module.business.reportproblem.ui.mechanicorder;

import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.module.business.reportproblem.R;
import com.wgmf.yxgj.module.business.reportproblem.model.MachineOrder;
import com.xp.arouter.RouterCommonUtil;

import java.util.List;

public class ReportMechanicOrderListAdapter extends BaseAdapter {

    private Context context;
    private List<MachineOrder> reportModuleItemEntities;

    public ReportMechanicOrderListAdapter(Context context, List<MachineOrder> reportModuleItemEntities) {
        this.context = context;
        this.reportModuleItemEntities = reportModuleItemEntities;
    }

    @Override
    public int getCount() {
        return reportModuleItemEntities == null ? 0 : reportModuleItemEntities.size();
    }

    @Override
    public Object getItem(int position) {
        return position;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    class ViewHolder {
        TextView mechanicOrderShop;
        TextView mechanicOrderReason;
        TextView mechanicOrderPhone;
        TextView mechanicOrderOperate;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup arg2) {
        final ViewHolder holder;
        if (convertView == null) {
            holder = new ViewHolder();
            convertView = LayoutInflater.from(context).inflate(R.layout.mechanic_order_detail_content_list_item, null);
            holder.mechanicOrderShop = (TextView) convertView.findViewById(R.id.mechanic_order_shop);
            holder.mechanicOrderReason = (TextView) convertView.findViewById(R.id.mechanic_order_reason);
            holder.mechanicOrderPhone = (TextView) convertView.findViewById(R.id.mechanic_order_phone);
            holder.mechanicOrderOperate = (TextView) convertView.findViewById(R.id.mechanic_order_operate);
            convertView.setTag(holder);
        } else {
            holder = (ViewHolder) convertView.getTag();
        }
        final MachineOrder data = reportModuleItemEntities.get(position);
        holder.mechanicOrderShop.setText(data.getApplicantShopName());
        holder.mechanicOrderReason.setText(data.getApplyReason());
        holder.mechanicOrderPhone.setVisibility(View.VISIBLE);
        //工单状态 0待处理,1待评价,2已评价
        if ("0".equals(data.getMroStatus())) {
            holder.mechanicOrderOperate.setText(context.getString(R.string.mechanic_order_modify));
        } else if ("1".equals(data.getMroStatus())) {
            holder.mechanicOrderOperate.setText(context.getString(R.string.mechanic_order_evaluate));
        } else if ("2".equals(data.getMroStatus())) {
            holder.mechanicOrderOperate.setText(context.getString(R.string.mechanic_order_check));
        }
        holder.mechanicOrderPhone.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                telPhone(data.getMroOperPhone());
            }
        });
        holder.mechanicOrderOperate.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                toWrite(data.getMroNo(), holder.mechanicOrderOperate.getText().toString());
            }
        });
        return convertView;
    }

    private void toWrite(String mroNo, String title) {
        Bundle mBundle = new Bundle();
        mBundle.putLong("branchID", 597L);
        mBundle.putString("branchTitle", title + "工单");
        mBundle.putString("mroNo", mroNo);
        RouterCommonUtil.startFunctionActivity(context, 0, 597L, mBundle);
    }

    private void telPhone(String work) {
        PrefTool.setBooleanSave(context, Prefs.PRE_NOT_TO_BACKGROUD, true);
        Uri telUri = Uri.parse("tel:" + work);
        Intent dial = new Intent(Intent.ACTION_DIAL, telUri);
        context.startActivity(dial);
    }
}