package com.wgmf.yxgj.module.business.reportrating.ui;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.drawable.AnimationDrawable;
import android.os.Bundle;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.content.ContextCompat;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.global.LocationParams;
import com.wgmf.library.utils.LocationUtil;
import com.wgmf.library.utils.StringUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.base.BaseParentAct;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.dialog.RatingsReportAppraiseEdtDialog;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.NetworkParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.model.MessageExtraEntity;
import com.wgmf.yxgj.model.ShopRatingsRankEntity;
import com.wgmf.yxgj.module.business.reportrating.R;
import com.wgmf.yxgj.module.business.reportrating.model.RatingsDetailQueryEntity;
import com.wgmf.yxgj.module.business.reportrating.model.StoreRatingsRankGroup;
import com.wgmf.yxgj.module.business.reportrating.service.DataService;
import com.wgmf.yxgj.module.business.reportrating.service.RatingsService;
import com.wgmf.yxgj.publics.service.MainService;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.photoview.LocalFloatPhotoPreview;
import com.xp.pro.mocklocationlib.LocationBean;
import com.xp.pro.mocklocationlib.LocationDialog;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

/**
 * 评级上报查询详情页
 * 作者：xiep on 2016/6/12 17:00
 * 邮箱：2975837870@qq.com
 */
@SuppressWarnings("all")
@Route(path = RouterParams.URL_REPORTRATINGSDETAILACTIVITY)
public class QueryRatingsDetailActivity extends BaseParentAct implements QueryRatingsDetailAdapter.PhotoPreview {

    private ListView mListView;

    private LinearLayout reportContentComfirmLl;
    private Button reportContentComfirmBtn;
    private LinearLayout publicTopContentLl;
    private TextView queryRatingsHeaderStore;
    private TextView queryRatingsHeaderLevel;
    private TextView queryRatingsHeaderStatus;

    private ImageView storeRankImg;
    private ImageView storeNameImg;
    private TextView storeNameTv;
    private TextView storeRankTv;
    private LinearLayout storeNmeLl;
    private LinearLayout storeRankLl;

    private String shopApproveFlag;
    private String shopApproveContent;
    private String storeId;
    private String storeName;
    private String shopLevel;
    private String shopRatingFlag;
    private String storeLatitudes;
    private String storeLongitudes;

    private String operatorId;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initData();
        initContent();
        queryListData();
    }

    private void initData() {
        shopApproveFlag = getIntent().getStringExtra("shopApproveFlag");
        shopApproveContent = getIntent().getStringExtra("shopApproveContent");
        storeId = getIntent().getStringExtra("shopId");
        storeName = getIntent().getStringExtra("shopName");
        storeLatitudes = getIntent().getStringExtra("storeLatitudes");
        storeLongitudes = getIntent().getStringExtra("storeLongitudes");
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText("专柜位置上报");
        //如果是测试环境，打开模拟定位选项
        if (NetworkParams.URL_HOST.startsWith("http://test.wgmf.com")) {
            homeTitleMore.setText("使用模拟定位");
            homeTitleMoreLl.setVisibility(View.VISIBLE);
        }
    }

    @Override
    protected void more() {
        super.more();
        initMockLocationData();
        createLocationDialog();
    }

    LocationBean mLocationBean;

    private void initMockLocationData() {
        double latitude;
        double longitude;
        try {
            latitude = StringUtil.toDouble(storeLatitudes);
            longitude = StringUtil.toDouble(storeLongitudes);
        } catch (Exception e) {
            latitude = 0;
            longitude = 0;
        }
        mLocationBean = new LocationBean();
        mLocationBean.setLatitude(latitude);
        mLocationBean.setLongitude(longitude);

        LocationParams.Latitude = String.valueOf(latitude);
        LocationParams.Longitude = String.valueOf(longitude);
        String address = "模拟该门店位置：" + "\n" + "经度：" + longitude + "\n" + "维度：" + latitude + "\n";

        storeNameTv.setText(address);
    }

    /**
     * 创建模拟定位对话框
     */
    private void createLocationDialog() {
        LocationDialog.Builder builder = new LocationDialog.Builder(this);
        builder.setLatitude(mLocationBean.getLatitude());
        builder.setLongitude(mLocationBean.getLongitude());
        builder.setPositiveButton("知道了", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    private void initContent() {
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        //为列表添加空布局
        View emptyView = findViewById(R.id.public_list_view_empty_ll);
        ImageView publicListViewEmptyIv = (ImageView) findViewById(R.id.public_list_view_empty_iv);
        Glide.with(this).load(R.drawable.img_load_fail).asGif().into(publicListViewEmptyIv);
        mListView.setEmptyView(emptyView);
        //为列表添加门店信息布局
        View headerView = getLayoutInflater().inflate(R.layout.query_ratings_list_header_view, null);
        mListView.addHeaderView(headerView);
        headerView.setOnClickListener(null);
        queryRatingsHeaderStore = (TextView) findViewById(R.id.query_ratings_header_store);
        queryRatingsHeaderLevel = (TextView) findViewById(R.id.query_ratings_header_level);
        queryRatingsHeaderStatus = (TextView) findViewById(R.id.query_ratings_header_status);
        //为列表添加审核位置信息布局
        publicTopContentLl = (LinearLayout) findViewById(R.id.public_top_content_ll);
        publicTopContentLl.setBackgroundResource(R.color.white);
        storeNameTv = (TextView) findViewById(R.id.store_name_tv);
        storeNmeLl = (LinearLayout) findViewById(R.id.store_name_ll);
        storeRankLl = (LinearLayout) findViewById(R.id.store_rank_ll);
        storeRankLl.setGravity(Gravity.RIGHT);
        storeRankTv = (TextView) findViewById(R.id.store_rank_tv);
        storeRankImg = (ImageView) findViewById(R.id.store_rank_img);
        storeNameImg = (ImageView) findViewById(R.id.store_name_img);
        //位置重新上报审核功能
        reportContentComfirmLl = (LinearLayout) findViewById(R.id.report_content_confirm_ll);
        reportContentComfirmBtn = (Button) findViewById(R.id.report_content_confirm_btn);
    }

    private void setHeaderData(String storeName, String shopLevel, String shopRatingFlag) {
        queryRatingsHeaderStore.setText(storeName);
        if (!TextUtils.isEmpty(shopLevel)) {
            String text = "综合评分：" + shopLevel;
            queryRatingsHeaderLevel.setText(text);
        }
        if (ConstantParams.CONSTANT_PARAMS_1.equals(shopRatingFlag)) {
            queryRatingsHeaderStatus.setText("待上报");
        } else if (ConstantParams.CONSTANT_PARAMS_2.equals(shopRatingFlag)) {
            queryRatingsHeaderStatus.setText("待审核");
        } else if (ConstantParams.CONSTANT_PARAMS_3.equals(shopRatingFlag)) {
            queryRatingsHeaderStatus.setText("已审核");
        }
    }

    /**
     * 获取位置信息
     *
     * @return 当前位置
     */
    private String getLocation() {
        final AnimationDrawable animationDrawable = new AnimationDrawable();
        animationDrawable.addFrame(getResources().getDrawable(R.drawable.btn_shop_refresh_1), 50);
        animationDrawable.addFrame(getResources().getDrawable(R.drawable.btn_shop_refresh_2), 50);
        animationDrawable.addFrame(getResources().getDrawable(R.drawable.btn_shop_refresh_3), 50);
        animationDrawable.setOneShot(false);
        storeRankImg.setImageDrawable(animationDrawable);
        //开始重新定位动画
        animationDrawable.start();

        new LocationUtil(this, new LocationUtil.OnCallback() {
            @Override
            public void onFinish(String longitude, String latitude,
                                 String address, String city, int code, String error) {
                if (!TextUtils.isEmpty(address)) {
                    //将获取到的位置信息存储到本地
                    Map<String, String> params = new HashMap<>();
                    params.put("lat", LocationParams.Latitude);
                    params.put("lng", LocationParams.Longitude);
                    params.put("address", LocationParams.Address);
                    params.put("city", LocationParams.city);
                    Log.i("当前位置：", params + " Address:" + LocationParams.Address);
                }
                //结束重新定位动画
                animationDrawable.stop();
            }
        });
        return LocationParams.Address;
    }

    /**
     * 根据OE角色执行不同功能
     */
    private void checkOeRole(LinearLayout publicTopContentLl, LinearLayout reportContentComfirmLl, Button reportContentComfirmBtn) {
        //userPostLevel 除4和5以外岗位只需要查看，不需要审核和上报
        if (userInfo != null && (userInfo.getUserPostLevel().equals(ConstantParams.CONSTANT_PARAMS_4) || userInfo.getUserPostLevel().equals(ConstantParams.CONSTANT_PARAMS_5))) {
            publicTopContentLl.setVisibility(View.GONE);
            reportContentComfirmLl.setVisibility(View.VISIBLE);
            reportContentComfirmBtn.setText(R.string.submit_again_btn_txt);
            //经理未审核显示审核按钮
            if (userInfo.getUserPostLevel().equals(ConstantParams.CONSTANT_PARAMS_4) && ConstantParams.CONSTANT_PARAMS_2.equals(shopRatingFlag)) {
                publicTopContentLl.setVisibility(View.VISIBLE);
                reportContentComfirmLl.setVisibility(View.VISIBLE);
                reportContentComfirmBtn.setText(R.string.location_check_btn_txt);
                storeNameImg.setVisibility(View.VISIBLE);
                storeRankImg.setVisibility(View.VISIBLE);

                String location = "当前位置:" + getLocation();
                storeNameTv.setText(location);
                storeRankTv.setText("重新定位");
                storeRankTv.setTextColor(ContextCompat.getColor(this, R.color.normal_color));
            }
        }
        //5秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(reportContentComfirmBtn).throttleFirst(5, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                if (userInfo.getUserPostLevel().equals(ConstantParams.CONSTANT_PARAMS_5)) {
                    //如果是主管查询，进入重新上报页面
                    toReportActivity();
                } else if (userInfo.getUserPostLevel().equals(ConstantParams.CONSTANT_PARAMS_4)) {
                    //如果是经理，当未审核时进入审核逻辑
                    if (ConstantParams.CONSTANT_PARAMS_2.equals(shopRatingFlag)) {
                        //先计算距离，只有当所在位置在门店范围内（3000米）才允许进行意见审批
                        if (checkRange()) {
                            showCheckDialog();
                        } else {
                            showTipDialog();
                        }
                    } else {
                        toReportActivity();
                    }
                }
            }
        });
        storeRankTv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String location = "当前位置:" + getLocation();
                storeNameTv.setText(location);
            }
        });
        //3:已审核，展示审核信息
        String approveContent = "";
        if (ConstantParams.CONSTANT_PARAMS_3.equals(shopRatingFlag)) {
            publicTopContentLl.setVisibility(View.VISIBLE);
            if (!StringUtil.isNullOrEmpty(shopApproveFlag)) {
                if (ConstantParams.CONSTANT_PARAMS_1.equals(shopApproveFlag)) {
                    shopApproveFlag = "同意";
                } else if (ConstantParams.CONSTANT_PARAMS_2.equals(shopApproveFlag)) {
                    shopApproveFlag = "不同意";
                }
                approveContent = shopApproveFlag + "。";
                if (!StringUtil.isNullOrEmpty(shopApproveContent)) {
                    approveContent += shopApproveContent;
                }
                storeNameTv.setText("上级审核意见：");
            } else {
                approveContent = "本门店已由区域经理完成上报！";
                storeRankLl.setGravity(Gravity.CENTER);
                storeNmeLl.setVisibility(View.GONE);
            }
            storeRankTv.setText(approveContent);
            storeNameTv.setTextColor(ContextCompat.getColor(this, R.color.common_txt_color));
            storeRankTv.setTextColor(ContextCompat.getColor(this, R.color.black));
        }
    }

    private void toReportActivity() {
        Intent intent = new Intent(QueryRatingsDetailActivity.this, ReportRatingsDetailActivity.class);
        intent.putExtra("shopId", storeId);
        intent.putExtra("shopName", storeName);
        intent.putExtra("storeLatitudes", storeLatitudes);
        intent.putExtra("storeLongitudes", storeLongitudes);
        startActivity(intent);
        QueryRatingsDetailActivity.this.finish();
    }

    /**
     * 只有当所在位置在门店范围内（3000米）才允许进行意见审批（之前是500米）
     *
     * @return 是否在门店范围内（3000米）true:是
     */
    private boolean checkRange() {
        double distance = LocationUtil.getDistance
                (StringUtil.toDouble(storeLatitudes),
                        StringUtil.toDouble(storeLongitudes),
                        StringUtil.toDouble(LocationParams.Latitude),
                        StringUtil.toDouble(LocationParams.Longitude));

        if (distance <= 3000) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 获取评级上报门店等级信息列表
     */
    private void queryListData() {
        if (null != userInfo) {
            showDialog();
            RatingsService.getInstance().requestQueryRatingsDetail(storeId, QueryRatingsDetailActivity.this);
        }
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.RatingsReport.MSG_ON_QUERY_RATINGSREPORT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        StoreRatingsRankGroup mStoreRatingsRankGroup = new Gson().fromJson(msg, StoreRatingsRankGroup.class);
                        if (null != mStoreRatingsRankGroup) {
                            setHeaderData(storeName, mStoreRatingsRankGroup.getShopLevel(), mStoreRatingsRankGroup.getShopRatingFlag());
                            if (null != mStoreRatingsRankGroup.getStoreRatinsList() && !mStoreRatingsRankGroup.getStoreRatinsList().isEmpty()) {
                                setData(mStoreRatingsRankGroup.getStoreRatinsList());
                            }
                            checkOeRole(publicTopContentLl, reportContentComfirmLl, reportContentComfirmBtn);
                        }
                    } else {
                        showMsg(msg);
                    }
                }
                break;
                case BusinessID.RatingsReport.MSG_ON_APPROVE_RATINGS_REPORT: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                            // 提交成功
                            showMsg(getString(R.string.save_data_success));
                            sendMessageToJPush();
                            QueryRatingsDetailActivity.this.finish();
                        } else {
                            showMsg(mBaseResponse.retInfo);
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    public void setData(List<RatingsDetailQueryEntity> item) {
        List<RatingsDetailQueryEntity> mRatingsDetailQueryListEntity = new ArrayList<>();
        if (null != item) {
            //对数据排序加工，通道项在前
            int j = 0;
            for (int i = 0; i < item.size(); i++) {
                operatorId = item.get(i).getOptions().getUserId();
                shopRatingFlag = item.get(i).getOptions().getShopRatingFlag();
                shopApproveFlag = item.get(i).getOptions().getApproveFlag();
                shopApproveContent = item.get(i).getOptions().getApproveContent();
                for (j = 0; j < DataService.gourpName.length - 1; j++) {
                    if (DataService.gourpName[j].equals(item.get(i).getOptions().getGroupItem())) {
                        mRatingsDetailQueryListEntity.add(item.get(i));
                    }
                }
            }
            int k = 0;
            for (int i = 0; i < item.size(); i++) {
                if ("加减分项".equals(item.get(i).getOptions().getGroupItem())) {
                    if (k > 0) {
                        item.get(i).getOptions().setGroupItem();
                    }
                    mRatingsDetailQueryListEntity.add(item.get(i));
                    k++;
                }
            }
            QueryRatingsDetailAdapter adapter = new QueryRatingsDetailAdapter(QueryRatingsDetailActivity.this, QueryRatingsDetailActivity.this, mRatingsDetailQueryListEntity);
            mListView.setAdapter(adapter);
        }
    }

    /**
     * 显示不在范围内提示框
     */
    private void showTipDialog() {
        String dialogShowTip;
        try {
            double distance = LocationUtil.getDistance
                    (StringUtil.toDouble(storeLatitudes),
                            StringUtil.toDouble(storeLongitudes),
                            StringUtil.toDouble(LocationParams.Latitude),
                            StringUtil.toDouble(LocationParams.Longitude));
            //（OE返回的经纬度XX和XX，本机定位的经纬度XX和XX，相距XXX米）
            dialogShowTip = "(OE返回的经纬度" + storeLongitudes + "和" + storeLatitudes + ",本机定位的经纬度" + LocationParams.Longitude + "和" + LocationParams.Latitude + "相距" + StringUtil.formatDouble(distance, "0.0") + "米)";
        } catch (Exception e) {
            dialogShowTip = "获取定位失败，请重新定位！";
        }

        final RatingsConformTipDialog.Builder builder = new RatingsConformTipDialog.Builder(this);
        builder.setMessage(getString(R.string.dialog_show_tip));
        builder.setMessage2(dialogShowTip);
        builder.setTitle("提示");
        builder.setNegativeButton("我知道了",
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.dismiss();
                    }
                });
        builder.create().show();
    }

    /**
     * 显示审核对话框
     */
    private void showCheckDialog() {
        final RatingsReportAppraiseEdtDialog.Builder builder = new RatingsReportAppraiseEdtDialog.Builder(this);
        builder.setTitle("位置审核");
        builder.setPositiveButton(new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                dialog.dismiss();
            }
        });
        builder.setNegativeButton(
                new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        if (0 == builder.getIsComplete()) {
                            showMsg("请选择位置审核意见");
                            return;
                        }
                        dialog.dismiss();
                        ShopRatingsRankEntity mShopRatingsRankEntity = new ShopRatingsRankEntity();
                        mShopRatingsRankEntity.setStoreId(storeId);
                        mShopRatingsRankEntity.setStoreName(storeName);
                        mShopRatingsRankEntity.setStoreLatitudes(storeLatitudes);
                        mShopRatingsRankEntity.setStoreLongitudes(storeLongitudes);
                        mShopRatingsRankEntity.setShopApproveContent(builder.getNember());
                        mShopRatingsRankEntity.setShopApproveFlag(builder.getIsComplete() + "");
                        appriaseMonthlyReport(mShopRatingsRankEntity);
                    }
                });
        builder.create().show();
    }

    /**
     * 审核数据提交
     *
     * @param listShows 审核数据
     */
    private void appriaseMonthlyReport(ShopRatingsRankEntity listShows) {
        String content = new Gson().toJson(listShows);
        Log.d(TAG, content);
        RatingsService.getInstance().requestApproveRatingsReport(content, QueryRatingsDetailActivity.this);
    }


    /**
     * 推送评级上报JPush消息
     */
    private void sendMessageToJPush() {
        // 接收者类型 （2 指定的 tag ，3 指定的alias，4 广播：对 app_key下的所有用户推送消息）
        String receiverType = ConstantParams.CONSTANT_PARAMS_3;
        String type = ConstantParams.CONSTANT_PARAMS_10;
        String msgTitle = "门店位置审批";
        String msgContent = "门店位置审批有新动态，点击查看！";
        //位置审核提交上级推送消息给下级,下级为该信息上报人
        String recieverStaffId = operatorId;
        //推送发起者是登录人
        String sendStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFFID);

        MessageExtraEntity mMessageExtraEntity = new MessageExtraEntity();
        mMessageExtraEntity.setType(type);
        mMessageExtraEntity.setStoreId(storeId);
        mMessageExtraEntity.setStoreName(storeName);
        mMessageExtraEntity.setStoreLatitudes(storeLatitudes);
        mMessageExtraEntity.setStoreLongitudes(storeLongitudes);
        String extra = new Gson().toJson(mMessageExtraEntity);

        Log.d(TAG, "sendMessageToJPush: " + extra);

        MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, this);
    }

    private LocalFloatPhotoPreview mLocalFloatPhotoPreview;

    @Override
    public void toPhotoPreviewFragment(final int index, final List<ImageItem> images) {
        if (null == mLocalFloatPhotoPreview) {
            mLocalFloatPhotoPreview = new LocalFloatPhotoPreview();
            mLocalFloatPhotoPreview.setCurIndex(index);
            mLocalFloatPhotoPreview.setAllImages(images);
            final FragmentManager fragmentManager = getSupportFragmentManager();
            final FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.setCustomAnimations(R.anim.qz_comm_scale_in, 0);
            transaction.add(android.R.id.content, mLocalFloatPhotoPreview);
            transaction.commitAllowingStateLoss();
        } else {
            removePhotoPreviewFragment();
        }
    }

    /**
     * 移除大图浮层
     *
     * @return
     */
    public boolean removePhotoPreviewFragment() {
        if (null != mLocalFloatPhotoPreview) {
            final FragmentManager fragmentManager = getSupportFragmentManager();
            final FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.setCustomAnimations(0, R.anim.qz_comm_scale_out);
            transaction.remove(mLocalFloatPhotoPreview);
            transaction.commitAllowingStateLoss();
            mLocalFloatPhotoPreview = null;
            return true;
        }
        return false;
    }

    @Override
    public void onBackPressed() {
        if (!isFinishing()) {
            if (!removePhotoPreviewFragment()) {
                super.onBackPressed();
            }
        }
    }
}