package com.wgmf.yxgj.module.business.reportrating.ui;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.alibaba.android.arouter.facade.annotation.Route;
import com.bumptech.glide.Glide;
import com.google.gson.Gson;
import com.jakewharton.rxbinding.view.RxView;
import com.wgmf.library.base.BaseResponse;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.CastingNumbers;
import com.wgmf.library.utils.DateUtil;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.library.utils.tools.PrefTool;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.global.OeRoleParams;
import com.wgmf.yxgj.global.Prefs;
import com.wgmf.yxgj.model.MessageExtraEntity;
import com.wgmf.yxgj.module.business.reportrating.R;
import com.wgmf.yxgj.module.business.reportrating.model.RatingsReportGroupList;
import com.wgmf.yxgj.module.business.reportrating.model.RatingsReportGroupList2;
import com.wgmf.yxgj.module.business.reportrating.model.SaveRatingsReportEntity;
import com.wgmf.yxgj.module.business.reportrating.model.StoreOptionsImagesList2;
import com.wgmf.yxgj.module.business.reportrating.service.DataService;
import com.wgmf.yxgj.module.business.reportrating.service.RatingsService;
import com.wgmf.yxgj.publics.service.MainService;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.xp.arouter.RouterParams;
import com.xp.pro.imagepickerlib.TakePictureActivity;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.global.Params;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

import rx.functions.Action1;

/**
 * 评级上报详情页
 *
 * @author XiePing
 */

@Route(path = RouterParams.URL_REPORTRATINGSDETAILACTIVITY)
public class ReportRatingsDetailActivity extends ReportWithPhotoBaseActivity implements ReportRatingsDetailDataAdapter.LvListener, OnClickListener {

    private List<RatingsReportGroupList> itemlist = new ArrayList<>();
    private List<RatingsReportGroupList> selectlist = new ArrayList<>();
    /**
     * 专柜位置上报项适配器
     */
    private ReportRatingsDetailDataAdapter subjectAdapter;
    /**
     * 专柜位置上报选中项显示适配器
     */
    private ReportRatingsDetailSelectAdapter ratingsSelectAdapter;

    private String storeId;
    private String storeName;
    private String storeLatitudes;
    private String storeLongitudes;

    private TextView scoreTv;

    private TextView storeNameTv;

    private Button publicComfirmBtnTotalRightBtn;

    private LinearLayout publicTopLl;
    LinearLayout publicListViewLoadingLl;

    private boolean showSelect = true;

    public void showPublicDialog() {
        publicListViewLoadingLl = findViewById(R.id.public_list_view_loading_ll);
        ImageView publicDialogLoadingIv = (ImageView) findViewById(R.id.public_list_view_loading_iv);
        Glide.with(this).load(R.drawable.img_loading).asGif().into(publicDialogLoadingIv);
        publicListViewLoadingLl.setVisibility(View.VISIBLE);
        publicListViewLoadingLl.setOnClickListener(null);
        publicComfirmBtnTotalRightBtn.setOnClickListener(null);
        publicComfirmBtnTotalRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_pressed));
    }

    public void dismissPublicDialog() {
        publicListViewLoadingLl.setVisibility(View.GONE);
        //5秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(publicComfirmBtnTotalRightBtn).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                submitRightBtnUpdata();
            }
        });
        publicComfirmBtnTotalRightBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_nomal));
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.public_list_view);
        initTitle();
        initData();
        initContent();
        initRatingsSelectLayout();
    }

    protected void initData() {
        //userPostLevel ==4/经理||==5/主管可上报，如果userPostLevel ==4可审核，除4和5以外岗位只可查询。
        if (userInfo == null || (!ConstantParams.CONSTANT_PARAMS_4.equals(userInfo.getUserPostLevel()) && !ConstantParams.CONSTANT_PARAMS_5.equals(userInfo.getUserPostLevel()))) {
            ToastUtil.show(this, "您没有上报权限！");
            this.finish();
        }
        // 从数据源获取一级和二级标题
        itemlist = DataService.getSubjectItems(this);
        storeId = getIntent().getStringExtra("shopId");
        storeName = getIntent().getStringExtra("shopName");
        storeLatitudes = getIntent().getStringExtra("storeLatitudes");
        storeLongitudes = getIntent().getStringExtra("storeLongitudes");
    }

    @Override
    public void initTitle() {
        super.initTitle();
        homeTitleText.setText("专柜位置上报");
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
    }

    protected void initContent() {
        TextView reportDetailTitle = (TextView) findViewById(R.id.report_detail_title);
        TextView reportDetailDate = (TextView) findViewById(R.id.report_detail_date);
        LinearLayout titleMoreLl = (LinearLayout) findViewById(R.id.title_more_ll);
        titleMoreLl.setVisibility(View.VISIBLE);
        reportDetailTitle.setText(storeName);
        reportDetailDate.setText(DateUtil.getFormatCurrentDate("yyyy-MM-dd"));
        publicTopLl = (LinearLayout) findViewById(R.id.public_top_content_ll);
        publicTopLl.addView(addSelecteView(R.layout.ratings_detail_select_list_view));
        storeNameTv = (TextView) findViewById(R.id.store_name_tv);
        publicTopLl.setOnClickListener(this);
        ListView reportRateLv = (ListView) this.findViewById(R.id.public_list_view_lv);
        TextView emptyTv = (TextView) findViewById(R.id.public_list_view_empty_tv);
        reportRateLv.setEmptyView(emptyTv);
        View headerView = getLayoutInflater().inflate(R.layout.ratings_detail_header_view, null);
        reportRateLv.addHeaderView(headerView);
        subjectAdapter = new ReportRatingsDetailDataAdapter(userInfo.getUserPostLevel(), itemlist, this, this);
        reportRateLv.setAdapter(subjectAdapter);
        parseHeaderData();
        setConfirmView();
    }

    /**
     * @return 动态加载布局
     */
    private View addSelecteView(int layout) {
        LinearLayout.LayoutParams lp = new LinearLayout.LayoutParams(
                ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        LayoutInflater inflater = LayoutInflater.from(this);
        View view = inflater.inflate(layout, null);
        view.setLayoutParams(lp);
        return view;
    }

    private void parseHeaderData() {
        TextView ratingsHearderTv1 = (TextView) findViewById(R.id.ratings_hearder_tv1);
        TextView ratingsHearderTv2 = (TextView) findViewById(R.id.ratings_hearder_tv2);
        TextView ratingsHearderTv3 = (TextView) findViewById(R.id.ratings_hearder_tv3);
        TextView ratingsHearderTv4 = (TextView) findViewById(R.id.ratings_hearder_tv4);

        ratingsHearderTv1.setText("A+≥95分");
        ratingsHearderTv2.setText("85分<=A<95分");
        ratingsHearderTv3.setText("70分<=B<85分");
        ratingsHearderTv4.setText("C<70分");
    }

    private void setConfirmView() {
        LinearLayout publicComfirmBtnTotalLl = (LinearLayout) findViewById(R.id.public_comfirm_btn_total_ll);
        Button publicComfirmBtnTotalLeftBtn = (Button) findViewById(R.id.public_comfirm_btn_total_left_btn);
        publicComfirmBtnTotalRightBtn = (Button) findViewById(R.id.public_comfirm_btn_total_right_btn);
        scoreTv = (TextView) findViewById(R.id.public_comfirm_txt_total_left_btn);
        scoreTv.setText("--");
        publicComfirmBtnTotalLl.setVisibility(View.VISIBLE);
        publicComfirmBtnTotalLeftBtn.setText("综合评分：");
        //5秒钟之内只取一个点击事件，防抖操作
        RxView.clicks(publicComfirmBtnTotalRightBtn).throttleFirst(3, TimeUnit.SECONDS).subscribe(new Action1<Void>() {
            @Override
            public void call(Void aVoid) {
                submitRightBtnUpdata();
            }
        });
    }

    @Override
    public void showSelectValues() {
        publicTopLl.setVisibility(View.VISIBLE);
        if (showSelect) {
            selectlist.clear();
            // 遍历用户选中项目，获取选中项目的信息
            for (RatingsReportGroupList item : itemlist) {
                if (subjectAdapter.getSubjectItemMap().get(item.getOptions().getItemId())) {
                    // 判断条目被选中，则添加到上传集合
                    selectlist.add(item);
                }
            }
            //无内容显示可显示
            if (selectlist.isEmpty()) {
                publicTopLl.setVisibility(View.GONE);
            } else {
                storeNameTv.setText("收起");
            }
        } else {
            selectlist.clear();
            storeNameTv.setText("展开");
        }
        ratingsSelectAdapter.notifyDataSetChanged();
    }

    private void initRatingsSelectLayout() {
        ListView ratingsSelectviewLv = (ListView) findViewById(R.id.ratings_select_view_lv);
        ratingsSelectAdapter = new ReportRatingsDetailSelectAdapter(this, selectlist);
        ratingsSelectviewLv.setAdapter(ratingsSelectAdapter);
    }


    @Override
    public void setSelectDialog(int selectType,View view) {
        //专柜位置上报功能只允许拍照上传
        this.idImagePickerContainer = (ImagePickerLayout) view;
        takePhoto(idImagePickerContainer);
    }

    /**
     * 调用系统拍照
     */
    protected void takePhoto(ImagePickerLayout idImagePickerContainer) {
        Intent intent = new Intent(this, TakePictureActivity.class);
        intent.putExtra("authority", "com.wgmf.yxgj");
        startActivityForResultByAnimation(intent, Params.TAKE_PICTURE);
    }

    @Override
    public void toPhotoPreview(int i, ArrayList<ImageItem> arrayList) {
        toPhotoPreviewFragment(i, arrayList);//大图显示
    }

    @Override
    public void showRank() {
        String shopLevel = "--";
        double totalScore = 0;
        for (int i = 0; i < itemlist.size(); i++) {
            if (subjectAdapter.getSubjectItemMap().get(
                    itemlist.get(i).getOptions().getItemId())) {
                totalScore += itemlist.get(i).getOptions().getPoints();
                shopLevel = DataService.getTotalLevel(totalScore);
            }
        }
        String text = shopLevel + "    " + Html.fromHtml("<font color='#ff5722' >" + CastingNumbers.doRound(totalScore, 1) + "</font>") + "分";
        scoreTv.setText(text);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            if (id == BusinessID.RatingsReport.MSG_ON_SAVE_RATINGS_REPORT) {
                final String msg = result.getInfo();
                if (result.isSuccessed()) {
                    BaseResponse mBaseResponse = new Gson().fromJson(msg, BaseResponse.class);
                    if (ConstantParams.CONSTANT_PARAMS_0.equals(mBaseResponse.retCode)) {
                        // 提交成功
                        ToastUtil.show(ReportRatingsDetailActivity.this, getString(R.string.save_data_success));
                        //如果是主管上报，则给上级推送消息，区域经理上报不推送消息
                        if (ConstantParams.CONSTANT_PARAMS_5.equals(userInfo.getUserPostLevel())) {
                            sendMessageToJPush();
                        }
                        ReportRatingsDetailActivity.this.finish();
                    } else {
                        ToastUtil.show(ReportRatingsDetailActivity.this, mBaseResponse.retInfo);
                    }
                }
            }
        }
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.public_top_content_ll) {
            showSelect = !showSelect;
            showSelectValues();
        } else if (v.getId() == R.id.public_comfirm_btn_total_right_btn) {
            submitRightBtnUpdata();
        }
    }

    List<RatingsReportGroupList2> optionsList = new ArrayList<>();

    private void submitRightBtnUpdata() {
        showPublicDialog();
        String selectValues = "";
        for (RatingsReportGroupList item : itemlist) {
            if (subjectAdapter.getSubjectItemMap().get(item.getOptions().getItemId())) {
                // 判断条目被选中，则添加到上传集合
                selectValues += "" + item.getOptions().getItemId()
                        + "--" + item.getOptions().getName()
                        + "\n";
            }
            if (subjectAdapter.getSubjectItemMap().get(item.getOptions().getItemId())) {
                //如果选中项未添加图片，提示并返回
                if (item.getStoreImageselectList().size() < 1) {
                    dismissPublicDialog();
                    ToastUtil.show(ReportRatingsDetailActivity.this, "选中项必须添加上报图片");
                    return;
                }
            }
        }
        if (selectValues.equals("")) {
            // 未选中任何信息
            dismissPublicDialog();
            ToastUtil.show(ReportRatingsDetailActivity.this, "未选中任何信息");
        } else if (!((selectValues.contains("00")
                || selectValues.contains("01")
                || selectValues.contains("02")
                || selectValues.contains("03")
                || selectValues.contains("04"))
                && (selectValues.contains("10")
                || selectValues.contains("11")
                || selectValues.contains("12")
        ) && (selectValues.contains("20")
                || selectValues.contains("21")
                || selectValues.contains("22")
                || selectValues.contains("23")
        ))) {
            dismissPublicDialog();
            ToastUtil.show(ReportRatingsDetailActivity.this, "未勾选必要项");
        } else {
            showDialog();
            new uploadImageAsyncTask().execute();
        }
        Log.e(TAG, selectValues);
    }

    class uploadImageAsyncTask extends AsyncTask<String, Void, Boolean> {

        //onPreExecute用于异步处理前的操作
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            showDialog();
        }

        //在doInBackground方法中进行异步任务的处理.
        @Override
        protected Boolean doInBackground(String... params) {
            setData();
            return true;
        }

        //onPostExecute用于UI的更新.此方法的参数为doInBackground方法返回的值.
        @Override
        protected void onPostExecute(Boolean bytes) {
            super.onPostExecute(bytes);
        }
    }

    private void setData() {
        SaveRatingsReportEntity saveRatingsReportEntity = new SaveRatingsReportEntity();
        // 遍历用户选中项目，获取选中项目的信息
        for (RatingsReportGroupList item : itemlist) {
            // 门店信息
            if (userInfo != null) {
                item.getOptions().setUserId(userInfo.getStaffId());
                item.getOptions().setStoreId(storeId);
            }
            if (subjectAdapter.getSubjectItemMap().get(item.getOptions().getItemId())) {
                RatingsReportGroupList2 mRatingsReportGroupList2 = new RatingsReportGroupList2();
                List<StoreOptionsImagesList2> checkImgsupdata = new ArrayList<>();
                mRatingsReportGroupList2.setOptions(item.getOptions());
                List<ImageItem> checkImgs = item.getStoreImageselectList();
                if (null != checkImgs && !checkImgs.isEmpty() && checkImgsupdata.size() <= 3 && checkImgs.size() <= 3) {
                    for (int k = 0; k < checkImgs.size(); k++) {
                        //上传图片
                        reportType = checkImgs.get(k).getImageId();
                        uploadByFilePathBefore(checkImgs.get(k).getImagePath());
                        for (int i = 0; i < qiniuUrlLists.size(); i++) {
                            //将上传后的图片地址填充到上传图片集合中
                            if (qiniuUrlLists.get(i).contains(reportType)) {
                                StoreOptionsImagesList2 checkImg = new StoreOptionsImagesList2();
                                checkImg.setUrl(qiniuUrlLists.get(i));
                                checkImgsupdata.add(checkImg);
                                mRatingsReportGroupList2.setStoreOptionsImagesList(checkImgsupdata);
                            }
                        }
                    }
                }
                optionsList.add(mRatingsReportGroupList2);
            }
        }
        saveRatingsReportEntity.setRatingsReportGroupList(optionsList);
        String content = new Gson().toJson(saveRatingsReportEntity);
        Log.d(TAG, content);
        RatingsService.getInstance().requestSaveRatingsReport(content, ReportRatingsDetailActivity.this);
    }


    /**
     * 推送评级上报JPush消息
     */
    private void sendMessageToJPush() {
        // 接收者类型 （2 指定的 tag ，3 指定的alias，4 广播：对 app_key下的所有用户推送消息）
        String receiverType = ConstantParams.CONSTANT_PARAMS_3;
        String type = ConstantParams.CONSTANT_PARAMS_9;
        String msgTitle = "门店位置审批";
        String msgContent = "门店位置审批有新动态，点击查看！";
        //评级上报提交下级推送消息给上级
        String recieverStaffId = PrefTool.getStringPerferences(this, Prefs.PRE_USER_STAFF_LEADERID);
        //推送发起者是登录人
        String sendStaffId = userInfo.getStaffId();

        MessageExtraEntity mMessageExtraEntity = new MessageExtraEntity();
        mMessageExtraEntity.setType(type);
        mMessageExtraEntity.setStoreId(storeId);
        mMessageExtraEntity.setStoreName(storeName);
        mMessageExtraEntity.setStoreLatitudes(storeLatitudes);
        mMessageExtraEntity.setStoreLongitudes(storeLongitudes);
        String extra = new Gson().toJson(mMessageExtraEntity);

        Log.d(TAG, "sendMessageToJPush: " + extra);

        MainService.getInstance().requestSendMessage(sendStaffId, recieverStaffId, receiverType, extra, type, msgTitle, msgContent, this);
    }

    @Override
    protected void refreshAfterTakePicture(Intent data, ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        super.refreshAfterTakePicture(data, mImageselectList, idImagePickerContainer);
        subjectAdapter.refreshAfterTakePicture(mImageselectList, idImagePickerContainer);
    }
}