package com.wgmf.yxgj.bussiness.terminaldisplay.ui;

import android.content.Intent;
import android.os.Bundle;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import com.google.gson.Gson;
import com.wgmf.library.base.ResultData;
import com.wgmf.library.utils.ToastUtil;
import com.wgmf.yxgj.bussiness.terminaldisplay.R;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitMissionEntity;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitMissionResultEntity;
import com.wgmf.yxgj.bussiness.terminaldisplay.model.ExhibitSubmit;
import com.wgmf.yxgj.bussiness.terminaldisplay.service.TerminalDisplayService;
import com.wgmf.yxgj.config.BusinessID;
import com.wgmf.yxgj.global.ConstantParams;
import com.wgmf.yxgj.report.ui.ReportWithPhotoBaseActivity;
import com.wgmf.yxgj.widgets.TextView.MarqueeTextView;
import com.xp.pro.imagepickerlib.bean.ImageItem;
import com.xp.pro.imagepickerlib.widgets.ImagePickerLayout;

import java.util.ArrayList;
import java.util.List;

public class TerminalDisplayDetailActivity extends ReportWithPhotoBaseActivity implements  TerminalDisplayDetailAdapter.LvListener,View.OnClickListener{
    private TerminalDisplayDetailAdapter mAdapter;
    private List<ExhibitSubmit> mSubmitList;
    String branchTitle;
    ListView mListView;
    LinearLayout titleLl;
    MarqueeTextView reportTitle;
    TextView reportDate;
    LinearLayout reportConfirmLl;
    Button reportModifyBtn;
    Button reportConfirmBtn;
    String shopStatus;
    ExhibitMissionEntity mExhibitMissionEntity;
    TextView dataEmpty;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_terminal_display_query);
        initTitle();
        initData();
        initContent();
    }

    @Override
    protected void onResume() {
        super.onResume();
        getData();
    }

    @Override
    protected void initData() {
        super.initData();
        shopId = getIntent().getStringExtra("shopId");
        shopName = getIntent().getStringExtra("shopName");
    }

    @Override
    public void initTitle() {
        super.initTitle();
        branchTitle = getIntent().getStringExtra("branchTitle");
        branchTitle = "督察陈列检查";
        homeTitleMoreLl.setVisibility(View.INVISIBLE);
        homeTitleBackLl.setVisibility(View.VISIBLE);
        homeTitleText.setText(branchTitle);
    }

    public void initContent() {
        titleLl = (LinearLayout) findViewById(R.id.title_more_ll);
        reportTitle = (MarqueeTextView) findViewById(R.id.report_detail_title);
        reportDate = (TextView) findViewById(R.id.report_detail_date);
        reportConfirmLl = (LinearLayout) findViewById(R.id.report_confirm_ll);
        reportModifyBtn = (Button) findViewById(R.id.report_modify_btn);
        reportConfirmBtn = (Button) findViewById(R.id.report_confirm_btn);
        mListView = (ListView) findViewById(R.id.public_list_view_lv);
        dataEmpty = (TextView) findViewById(R.id.public_list_view_empty_tv);
        mListView.setEmptyView(dataEmpty);
        reportTitle.setGravity(Gravity.CENTER);
        reportDate.setVisibility(View.GONE);
        mSubmitList = new ArrayList<>();
        mAdapter = new TerminalDisplayDetailAdapter(mSubmitList,this,this);
        mListView.setAdapter(mAdapter);
    }

    private void toActivity(Class<?> cls, int type) {
        Intent intent = new Intent();
        intent.setClass(this, cls);
        intent.putExtra("shopId", shopId);
        intent.putExtra("shopName", shopName);
        intent.putExtra("shopStatus", shopStatus);
        intent.putExtra("branchTitle", branchTitle);
        intent.putExtra("type", type+"");
        startActivity(intent);
    }
    /**
     * 从网络获取详情数据
     */
    public void getData() {
        showDialog();
        TerminalDisplayService.getInstance().queryMissionByStoreNo(shopId, TerminalDisplayDetailActivity.this);
    }

    @Override
    protected void onBusinessResultAtMainThread(ResultData result) {
        super.onBusinessResultAtMainThread(result);
        dismissDialog();
        if (null != result) {
            final int id = result.taskID;
            switch (id) {
                case BusinessID.TerminalDisplay.MSG_ON_QUERY_MISSION_BY_STORENO: {
                    final String msg = result.getInfo();
                    if (result.isSuccessed()) {
                        ExhibitMissionResultEntity mExhibitMissionResultEntity = new Gson().fromJson(msg, ExhibitMissionResultEntity.class);
                        Log.d(TAG, "mExhibitMissionResultEntity=" + mExhibitMissionResultEntity.toString());
                        if (ConstantParams.CONSTANT_PARAMS_0.equals(mExhibitMissionResultEntity.msgCode)) {
                            if (null != mExhibitMissionResultEntity.getResult()) {
                                mExhibitMissionEntity=  mExhibitMissionResultEntity.getResult();
                                if(null==mExhibitMissionResultEntity.getResult().getSubmitList()||mExhibitMissionResultEntity.getResult().getSubmitList().isEmpty()){
                                    // 新增一条空数据
                                    List<ExhibitSubmit> submitList=new ArrayList<>();
                                    ExhibitSubmit mExhibitSubmit=new ExhibitSubmit();
                                    mExhibitSubmit.setShopStatus(ConstantParams.CONSTANT_PARAMS_1);
                                    mExhibitSubmit.setMissionName(mExhibitMissionResultEntity.getResult().getMissionName());
                                    mExhibitSubmit.setEndTime(mExhibitMissionResultEntity.getResult().getEndTime());
                                    mExhibitSubmit.setUserName(userInfo.getName());
                                    mExhibitSubmit.setUserNo(userInfo.getStaffId());
                                    mExhibitSubmit.setShopId(shopId);
                                    mExhibitSubmit.setShopName(shopName);
                                    mExhibitMissionEntity.setStoreNo(shopId);
                                    mExhibitMissionEntity.setStoreName(shopName);
                                    submitList.add(mExhibitSubmit);
                                    mExhibitMissionResultEntity.getResult().setSubmitList(submitList);
                                }
                                setData(mExhibitMissionResultEntity.getResult());
                            }
                        }else{
                            showTipDialog("提示",mExhibitMissionResultEntity.retInfo);
                        }
                    }
                }
                break;
                default:
                    break;
            }
        }
    }

    // 门店状态, 1待提交、2待审核可修改、3已审核可整改、4可再次整改、5免提交、6已截止

    //1 待提交 清除数据 高亮显示提交按钮
    //2 待审核可修改 取最新一条数据 修改按钮高亮，新增按钮置灰
    //3 已审核可整改 取最新一条数据 修改按钮置灰，新增按钮高亮
    //4 可再次整改 取最新一条数据 修改按钮置灰，新增按钮置灰
    //5 免提交 无按钮
    //6 已截止 无按钮
    private void setData(ExhibitMissionEntity exhibitMissionEntity) {
        titleLl.setVisibility(View.VISIBLE);
        reportTitle.setText(exhibitMissionEntity.getStoreName());
        shopStatus = exhibitMissionEntity.getShopStatus();

        mSubmitList=exhibitMissionEntity.getSubmitList();
        mAdapter = new TerminalDisplayDetailAdapter(mSubmitList,this,this);
        mListView.setAdapter(mAdapter);

        switch (shopStatus) {
            case ConstantParams.CONSTANT_PARAMS_1:// "待提交";
                //如果是待提交直接进入提交页面
                toActivity(TerminalDisplayEditActivity.class,0);
                this.finish();
                break;
            case ConstantParams.CONSTANT_PARAMS_2://"待审核可修改";
            case ConstantParams.CONSTANT_PARAMS_4://"可再次整改";
                reportConfirmLl.setVisibility(View.VISIBLE);
                reportModifyBtn.setVisibility(View.VISIBLE);
                reportConfirmBtn.setVisibility(View.VISIBLE);
                reportModifyBtn.setOnClickListener(null);
                reportConfirmBtn.setOnClickListener(this);
                reportModifyBtn.setText(R.string.add_btn_txt);
                reportConfirmBtn.setText(R.string.modify_btn_txt);
                reportModifyBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
                reportModifyBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_select_image_down));
                reportConfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
                reportConfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_nomal));
                break;
            case ConstantParams.CONSTANT_PARAMS_3:// "已审核可整改";
                reportConfirmLl.setVisibility(View.VISIBLE);
                reportModifyBtn.setVisibility(View.VISIBLE);
                reportConfirmBtn.setVisibility(View.VISIBLE);
                reportModifyBtn.setOnClickListener(this);
                reportConfirmBtn.setOnClickListener(null);
                reportModifyBtn.setText(R.string.add_btn_txt);
                reportConfirmBtn.setText(R.string.modify_btn_txt);
                reportModifyBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
                reportModifyBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_orange_round_fill_nomal));
                reportConfirmBtn.setTextColor(ContextCompat.getColor(this, R.color.white));
                reportConfirmBtn.setBackground(ContextCompat.getDrawable(this, R.drawable.btn_select_image_down));
                break;
            case ConstantParams.CONSTANT_PARAMS_5://"免提交";
                mListView.setVisibility(View.GONE);
                dataEmpty.setVisibility(View.VISIBLE);
                dataEmpty.setText("免提交");
                break;
            case ConstantParams.CONSTANT_PARAMS_6://"已截止";
                reportConfirmLl.setVisibility(View.GONE);
                break;
            default:
                break;
        }
    }

    @Override
    public void setSelectDialog(int selectType,View imagePickerView) {
        ToastUtil.show(this, "查询状态，不可更改图片哟！");
    }

    @Override
    public void toPhotoPreview(int index, ArrayList<ImageItem> mImageselectList) {
        toPhotoPreviewFragment(index, mImageselectList);//大图显示
    }

    @Override
    protected void refreshAfterTakePicture(Intent data, ArrayList<ImageItem> mImageselectList, ImagePickerLayout idImagePickerContainer) {
        super.refreshAfterTakePicture(data, mImageselectList, idImagePickerContainer);
        mAdapter.refreshAfterTakePicture(mImageselectList, idImagePickerContainer);
    }

    @Override
    public void onClick(View v) {
        if (v.getId() == R.id.report_modify_btn) {//新增
            toActivity(TerminalDisplayEditActivity.class,0);
        } else if (v.getId() == R.id.report_confirm_btn) {//修改
            toActivity(TerminalDisplayEditActivity.class,1);
        }
    }
}
